/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ee){for(var e=[],n=0,P=ee.length;n<P;n++)e[n]=Ae[ee[n]];return e};define(Ae[63],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(R,A){const w=Object.create(null);for(const h of R){const O=A(h);let D=w[O];D||(D=w[O]=[]),D.push(h)}return w}e.groupBy=n;function P(R,A){const w=[],h=[];for(const O of R)A.has(O)||w.push(O);for(const O of A)R.has(O)||h.push(O);return{removed:w,added:h}}e.diffSets=P;function C(R,A){const w=[],h=[];for(const[O,D]of R)A.has(O)||w.push(D);for(const[O,D]of A)R.has(O)||h.push(D);return{removed:w,added:h}}e.diffMaps=C;class M{constructor(){this.a=new Map}add(A,w){let h=this.a.get(A);h||(h=new Set,this.a.set(A,h)),h.add(w)}delete(A,w){const h=this.a.get(A);!h||(h.delete(w),h.size===0&&this.a.delete(A))}forEach(A,w){const h=this.a.get(A);!h||h.forEach(w)}}e.SetMap=M}),define(Ae[64],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(R){return(A,w,h)=>{let O=null,D=null;if(typeof h.value=="function"?(O="value",D=h.value):typeof h.get=="function"&&(O="get",D=h.get),!D)throw new Error("not supported");h[O]=R(D,w)}}function P(R,A,w){let h=null,O=null;if(typeof w.value=="function"?(h="value",O=w.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(h="get",O=w.get),!O)throw new Error("not supported");const D=`$memoize$${A}`;w[h]=function(...f){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,f)}),this[D]}}e.memoize=P;function C(R,A,w){return n((h,O)=>{const D=`$debounce$${O}`,f=`$debounce$result$${O}`;return function(...b){this[f]||(this[f]=w?w():void 0),clearTimeout(this[D]),A&&(this[f]=A(this[f],...b),b=[this[f]]),this[D]=setTimeout(()=>{h.apply(this,b),this[f]=w?w():void 0},R)}})}e.debounce=C;function M(R,A,w){return n((h,O)=>{const D=`$throttle$timer$${O}`,f=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...d){if(this[f]||(this[f]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),A&&(this[f]=A(this[f],...d)),this[g])return;const t=this[b]+R;t<=Date.now()?(this[b]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),h.apply(this,[this[f]]),this[f]=w?w():void 0},t-Date.now()))}})}e.throttle=M}),define(Ae[84],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ae[113],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let r=0;const c=i.length;let o="",I=0,s=16,u=0;function v(j){let U=0,$=0;for(;U<j;){const B=i.charCodeAt(r);if(B>=48&&B<=57)$=$*16+B-48;else if(B>=65&&B<=70)$=$*16+B-65+10;else if(B>=97&&B<=102)$=$*16+B-97+10;else break;r++,U++}return U<j&&($=-1),$}function S(j){r=j,o="",I=0,s=16,u=0}function E(){const j=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&h(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&h(i.charCodeAt(r)))for(r++;r<i.length&&h(i.charCodeAt(r));)r++;else return u=3,i.substring(j,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&h(i.charCodeAt(r))){for(r++;r<i.length&&h(i.charCodeAt(r));)r++;U=r}else u=3;return i.substring(j,U)}function W(){let j="",U=r;for(;;){if(r>=c){j+=i.substring(U,r),u=2;break}const $=i.charCodeAt(r);if($===34){j+=i.substring(U,r),r++;break}if($===92){if(j+=i.substring(U,r),r++,r>=c){u=2;break}switch(i.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=v(4);q>=0?j+=String.fromCharCode(q):u=4;break}default:u=5}U=r;continue}if($>=0&&$<=31)if(w($)){j+=i.substring(U,r),u=2;break}else u=6;r++}return j}function X(){if(o="",u=0,I=r,r>=c)return I=c,s=17;let j=i.charCodeAt(r);if(A(j)){do r++,o+=String.fromCharCode(j),j=i.charCodeAt(r);while(A(j));return s=15}if(w(j))return r++,o+=String.fromCharCode(j),j===13&&i.charCodeAt(r)===10&&(r++,o+=`
`),s=14;switch(j){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,o=W(),s=10;case 47:{const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<c&&!w(i.charCodeAt(r));)r++;return o=i.substring(U,r),s=12}if(i.charCodeAt(r+1)===42){r+=2;const $=c-1;let B=!1;for(;r<$;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,u=1),o=i.substring(U,r),s=13}return o+=String.fromCharCode(j),r++,s=16}case 45:if(o+=String.fromCharCode(j),r++,r===c||!h(i.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=E(),s=11;default:for(;r<c&&Y(j);)r++,j=i.charCodeAt(r);if(I!==r){switch(o=i.substring(I,r),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(j),r++,s=16}}function Y(j){if(A(j)||w(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let j;do j=X();while(j>=12&&j<=15);return j}return{setPosition:S,getPosition:()=>r,scan:l?J:X,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>I,getTokenLength:()=>r-I,getTokenError:()=>u}}e.createScanner=R;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function D(i,l){const r=[],c=new Object;let o;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(v,S,E,W){I.value=v,I.offset=S,I.length=E,I.type=W,I.colonOffset=void 0,o=I}try{y(i,{onObjectBegin:(v,S)=>{if(l<=v)throw c;o=void 0,s=l>v,r.push("")},onObjectProperty:(v,S,E)=>{if(l<S||(u(v,S,E,"property"),r[r.length-1]=v,l<=S+E))throw c},onObjectEnd:(v,S)=>{if(l<=v)throw c;o=void 0,r.pop()},onArrayBegin:(v,S)=>{if(l<=v)throw c;o=void 0,r.push(0)},onArrayEnd:(v,S)=>{if(l<=v)throw c;o=void 0,r.pop()},onLiteralValue:(v,S,E)=>{if(l<S||(u(v,S,E,p(v)),l<=S+E))throw c},onSeparator:(v,S,E)=>{if(l<=S)throw c;if(v===":"&&o&&o.type==="property")o.colonOffset=S,s=!1,o=void 0;else if(v===","){const W=r[r.length-1];typeof W=="number"?r[r.length-1]=W+1:(s=!0,r[r.length-1]=""),o=void 0}}})}catch(v){if(v!==c)throw v}return{path:r,previousNode:o,isAtPropertyKey:s,matches:v=>{let S=0;for(let E=0;S<v.length&&E<r.length;E++)if(v[S]===r[E]||v[S]==="*")S++;else if(v[S]!=="**")return!1;return S===v.length}}}e.getLocation=D;function f(i,l=[],r=M.DEFAULT){let c=null,o=[];const I=[];function s(v){Array.isArray(o)?o.push(v):c!==null&&(o[c]=v)}return y(i,{onObjectBegin:()=>{const v={};s(v),I.push(o),o=v,c=null},onObjectProperty:v=>{c=v},onObjectEnd:()=>{o=I.pop()},onArrayBegin:()=>{const v=[];s(v),I.push(o),o=v,c=null},onArrayEnd:()=>{o=I.pop()},onLiteralValue:s,onError:(v,S,E)=>{l.push({error:v,offset:S,length:E})}},r),o[0]}e.parse=f;function b(i,l=[],r=M.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){c.type==="property"&&(c.length=v-c.offset,c=c.parent)}function I(v){return c.children.push(v),v}y(i,{onObjectBegin:v=>{c=I({type:"object",offset:v,length:-1,parent:c,children:[]})},onObjectProperty:(v,S,E)=>{c=I({type:"property",offset:S,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:v,offset:S,length:E,parent:c})},onObjectEnd:(v,S)=>{c.length=v+S-c.offset,c=c.parent,o(v+S)},onArrayBegin:(v,S)=>{c=I({type:"array",offset:v,length:-1,parent:c,children:[]})},onArrayEnd:(v,S)=>{c.length=v+S-c.offset,c=c.parent,o(v+S)},onLiteralValue:(v,S,E)=>{I({type:p(v),offset:S,length:E,parent:c,value:v}),o(S+E)},onSeparator:(v,S,E)=>{c.type==="property"&&(v===":"?c.colonOffset=S:v===","&&o(S))},onError:(v,S,E)=>{l.push({error:v,offset:S,length:E})}},r);const u=c.children[0];return u&&delete u.parent,u}e.parseTree=b;function g(i,l){if(!i)return;let r=i;for(const c of l)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const I of r.children)if(Array.isArray(I.children)&&I.children[0].value===c){r=I.children[1],o=!0;break}if(!o)return}else{const o=c;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=g;function d(i){if(!i.parent||!i.parent.children)return[];const l=d(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.getNodePath=d;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const l=Object.create(null);for(const r of i.children){const c=r.children[1];c&&(l[r.children[0].value]=t(c))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.contains=a;function m(i,l,r=!1){if(a(i,l,r)){const c=i.children;if(Array.isArray(c))for(let o=0;o<c.length&&c[o].offset<=l;o++){const I=m(c[o],l,r);if(I)return I}return i}}e.findNodeAtOffset=m;function y(i,l,r=M.DEFAULT){const c=R(i,!1);function o(Te){return Te?()=>Te(c.getTokenOffset(),c.getTokenLength()):()=>!0}function I(Te){return Te?le=>Te(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const s=o(l.onObjectBegin),u=I(l.onObjectProperty),v=o(l.onObjectEnd),S=o(l.onArrayBegin),E=o(l.onArrayEnd),W=I(l.onLiteralValue),X=I(l.onSeparator),Y=o(l.onComment),J=I(l.onError),j=r&&r.disallowComments,U=r&&r.allowTrailingComma;function $(){for(;;){const Te=c.scan();switch(c.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:j||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(Te){case 12:case 13:j?B(10):Y();break;case 16:B(1);break;case 15:case 14:break;default:return Te}}}function B(Te,le=[],re=[]){if(J(Te),le.length+re.length>0){let V=c.getToken();for(;V!==17;){if(le.indexOf(V)!==-1){$();break}else if(re.indexOf(V)!==-1)break;V=$()}}}function q(Te){const le=c.getTokenValue();return Te?W(le):u(le),$(),!0}function he(){switch(c.getToken()){case 11:{let Te=0;try{Te=JSON.parse(c.getTokenValue()),typeof Te!="number"&&(B(2),Te=0)}catch{B(2)}W(Te);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return $(),!0}function Ee(){return c.getToken()!==10?(B(3,[],[2,5]),!1):(q(!1),c.getToken()===6?(X(":"),$(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function ie(){s(),$();let Te=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(Te||B(4,[],[]),X(","),$(),c.getToken()===2&&U)break}else Te&&B(6,[],[]);Ee()||B(4,[],[2,5]),Te=!0}return v(),c.getToken()!==2?B(7,[2],[]):$(),!0}function ce(){S(),$();let Te=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(Te||B(4,[],[]),X(","),$(),c.getToken()===4&&U)break}else Te&&B(6,[],[]);de()||B(4,[],[4,5]),Te=!0}return E(),c.getToken()!==4?B(8,[4],[]):$(),!0}function de(){switch(c.getToken()){case 3:return ce();case 1:return ie();case 10:return q(!0);default:return he()}}return $(),c.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(c.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=y;function T(i,l){const r=R(i),c=[];let o,I=0,s;do switch(s=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:I!==s&&c.push(i.substring(I,s)),l!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,l)),I=r.getPosition();break}while(o!==17);return c.join("")}e.stripComments=T;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ae[28],Re([1,0]),function(ee,e){"use strict";var n,P,C;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(d,t,a){let m=d.get(t);return m===void 0&&(m=a,d.set(t,m)),m}e.getOrSet=M;function R(d){const t=[];return d.forEach((a,m)=>{t.push(`${m} => ${a}`)}),`Map(${d.size}) {${t.join(", ")}}`}e.mapToString=R;function A(d){const t=[];return d.forEach(a=>{t.push(a)}),`Set(${d.size}) {${t.join(", ")}}`}e.setToString=A;class w{constructor(t,a){this.uri=t,this.value=a}}class h{constructor(t,a){this[n]="ResourceMap",t instanceof h?(this.b=new Map(t.b),this.c=a??h.a):(this.b=new Map,this.c=t??h.a)}set(t,a){return this.b.set(this.c(t),new w(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[m,y]of this.b)t(y.value,y.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}h.a=d=>d.toString(),e.ResourceMap=h;class O{constructor(t,a){this[P]="ResourceSet",!t||typeof t=="function"?this.a=new h(t):(this.a=new h(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((m,y)=>t.call(a,y,y,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var D;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const m=this.a.get(t);if(!!m)return a!==0&&this.j(m,a),m.value}set(t,a,m=0){let y=this.a.get(t);if(y)y.value=a,m!==0&&this.j(y,m);else{switch(y={key:t,value:a,next:void 0,previous:void 0},m){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(t,y),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const m=this.e;let y=this.b;for(;y;){if(a?t.bind(a)(y.value,y.key,this):t(y.value,y.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const T={value:m.key,done:!1};return m=m.next,T}else return{value:void 0,done:!0}}};return y}values(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const T={value:m.value,done:!1};return m=m.next,T}else return{value:void 0,done:!0}}};return y}entries(){const t=this,a=this.e;let m=this.b;const y={[Symbol.iterator](){return y},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const T={value:[m.key,m.value],done:!1};return m=m.next,T}else return{value:void 0,done:!0}}};return y}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,m=this.size;for(;a&&m>t;)this.a.delete(a.key),a=a.next,m--;this.b=a,this.d=m,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,m=t.previous;if(!a||!m)throw new Error("Invalid list");a.previous=m,m.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const m=t.next,y=t.previous;t===this.c?(y.next=void 0,this.c=y):(m.previous=y,y.next=m),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const m=t.next,y=t.previous;t===this.b?(m.previous=void 0,this.b=m):(m.previous=y,y.next=m),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,m)=>{t.push([m,a])}),t}fromJSON(t){this.clear();for(const[a,m]of t)this.set(a,m)}}e.LinkedMap=f;class b extends f{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b;class g{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let a=this.a.get(t)||0;return a===0?!1:(a--,a===0?this.a.delete(t):this.a.set(t,a),!0)}has(t){return this.a.has(t)}}e.CounterSet=g}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ae[114],Re([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(we,ve){for(var Ce=0;Ce<ve.length;Ce++){var se=ve[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(we,se.key,se)}}function n(we,ve,Ce){return ve&&e(we.prototype,ve),Ce&&e(we,Ce),Object.defineProperty(we,"prototype",{writable:!1}),we}function P(we,ve){if(!!we){if(typeof we=="string")return C(we,ve);var Ce=Object.prototype.toString.call(we).slice(8,-1);if(Ce==="Object"&&we.constructor&&(Ce=we.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(we);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return C(we,ve)}}function C(we,ve){(ve==null||ve>we.length)&&(ve=we.length);for(var Ce=0,se=new Array(ve);Ce<ve;Ce++)se[Ce]=we[Ce];return se}function M(we,ve){var Ce=typeof Symbol<"u"&&we[Symbol.iterator]||we["@@iterator"];if(Ce)return(Ce=Ce.call(we)).next.bind(Ce);if(Array.isArray(we)||(Ce=P(we))||ve&&we&&typeof we.length=="number"){Ce&&(we=Ce);var se=0;return function(){return se>=we.length?{done:!0}:{done:!1,value:we[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=R();function A(we){ee.defaults=we}var w=/[&<>"']/,h=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ve){return f[ve]};function g(we,ve){if(ve){if(w.test(we))return we.replace(h,b)}else if(O.test(we))return we.replace(D,b);return we}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(we){return we.replace(d,function(ve,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function m(we,ve){we=typeof we=="string"?we:we.source,ve=ve||"";var Ce={replace:function(ae,Z){return Z=Z.source||Z,Z=Z.replace(a,"$1"),we=we.replace(ae,Z),Ce},getRegex:function(){return new RegExp(we,ve)}};return Ce}var y=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(we,ve,Ce){if(we){var se;try{se=decodeURIComponent(t(Ce)).replace(y,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!T.test(Ce)&&(Ce=o(ve,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var i={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(we,ve){i[" "+we]||(l.test(we)?i[" "+we]=we+"/":i[" "+we]=v(we,"/",!0)),we=i[" "+we];var Ce=we.indexOf(":")===-1;return ve.substring(0,2)==="//"?Ce?ve:we.replace(r,"$1")+ve:ve.charAt(0)==="/"?Ce?ve:we.replace(c,"$1")+ve:we+ve}var I={exec:function(){}};function s(we){for(var ve=1,Ce,se;ve<arguments.length;ve++){Ce=arguments[ve];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(we[se]=Ce[se])}return we}function u(we,ve){var Ce=we.replace(/\|/g,function(Z,k,F){for(var H=!1,x=k;--x>=0&&F[x]==="\\";)H=!H;return H?"|":" |"}),se=Ce.split(/ \|/),ae=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;ae<se.length;ae++)se[ae]=se[ae].trim().replace(/\\\|/g,"|");return se}function v(we,ve,Ce){var se=we.length;if(se===0)return"";for(var ae=0;ae<se;){var Z=we.charAt(se-ae-1);if(Z===ve&&!Ce)ae++;else if(Z!==ve&&Ce)ae++;else break}return we.slice(0,se-ae)}function S(we,ve){if(we.indexOf(ve[1])===-1)return-1;for(var Ce=we.length,se=0,ae=0;ae<Ce;ae++)if(we[ae]==="\\")ae++;else if(we[ae]===ve[0])se++;else if(we[ae]===ve[1]&&(se--,se<0))return ae;return-1}function E(we){we&&we.sanitize&&!we.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(we,ve){if(ve<1)return"";for(var Ce="";ve>1;)ve&1&&(Ce+=we),ve>>=1,we+=we;return Ce+we}function X(we,ve,Ce,se){var ae=ve.href,Z=ve.title?g(ve.title):null,k=we[1].replace(/\\([\[\]])/g,"$1");if(we[0].charAt(0)!=="!"){se.state.inLink=!0;var F={type:"link",raw:Ce,href:ae,title:Z,text:k,tokens:se.inlineTokens(k)};return se.state.inLink=!1,F}return{type:"image",raw:Ce,href:ae,title:Z,text:g(k)}}function Y(we,ve){var Ce=we.match(/^(\s+)(?:```)/);if(Ce===null)return ve;var se=Ce[1];return ve.split(`
`).map(function(ae){var Z=ae.match(/^\s+/);if(Z===null)return ae;var k=Z[0];return k.length>=se.length?ae.slice(se.length):ae}).join(`
`)}var J=function(){function we(Ce){this.options=Ce||ee.defaults}var ve=we.prototype;return ve.space=function(se){var ae=this.rules.block.newline.exec(se);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ve.code=function(se){var ae=this.rules.block.code.exec(se);if(ae){var Z=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},ve.fences=function(se){var ae=this.rules.block.fences.exec(se);if(ae){var Z=ae[0],k=Y(Z,ae[3]||"");return{type:"code",raw:Z,lang:ae[2]?ae[2].trim():ae[2],text:k}}},ve.heading=function(se){var ae=this.rules.block.heading.exec(se);if(ae){var Z=ae[2].trim();if(/#$/.test(Z)){var k=v(Z,"#");(this.options.pedantic||!k||/ $/.test(k))&&(Z=k.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ve.hr=function(se){var ae=this.rules.block.hr.exec(se);if(ae)return{type:"hr",raw:ae[0]}},ve.blockquote=function(se){var ae=this.rules.block.blockquote.exec(se);if(ae){var Z=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ve.list=function(se){var ae=this.rules.block.list.exec(se);if(ae){var Z,k,F,H,x,te,pe,ke,ue,De,Se,$e,He=ae[1].trim(),et=He.length>1,Xe={type:"list",raw:"",ordered:et,start:et?+He.slice(0,-1):"",loose:!1,items:[]};He=et?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=et?He:"[*+-]");for(var tt=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&($e=!1,!(!(ae=tt.exec(se))||this.rules.block.hr.test(se)));){if(Z=ae[0],se=se.substring(Z.length),ke=ae[2].split(`
`,1)[0],ue=se.split(`
`,1)[0],this.options.pedantic?(H=2,Se=ke.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,Se=ke.slice(H),H+=ae[1].length),te=!1,!ke&&/^ *$/.test(ue)&&(Z+=ue+`
`,se=se.substring(ue.length+1),$e=!0),!$e)for(var rt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Me=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(De=se.split(`
`,1)[0],ke=De,this.options.pedantic&&(ke=ke.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(ke)||Q.test(ke)||rt.test(ke)||Me.test(se)));){if(ke.search(/[^ ]/)>=H||!ke.trim())Se+=`
`+ke.slice(H);else if(!te)Se+=`
`+ke;else break;!te&&!ke.trim()&&(te=!0),Z+=De+`
`,se=se.substring(De.length+1)}Xe.loose||(pe?Xe.loose=!0:/\n *\n *$/.test(Z)&&(pe=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(Se),k&&(F=k[0]!=="[ ] ",Se=Se.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!k,checked:F,loose:!1,text:Se}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=Se.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(x=0;x<_;x++){this.lexer.state.top=!1,Xe.items[x].tokens=this.lexer.blockTokens(Xe.items[x].text,[]);var be=Xe.items[x].tokens.filter(function(ze){return ze.type==="space"}),We=be.every(function(ze){for(var Qe=ze.raw.split(""),Ye=0,Ge=M(Qe),at;!(at=Ge()).done;){var Dt=at.value;if(Dt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Xe.loose&&be.length&&We&&(Xe.loose=!0,Xe.items[x].loose=!0)}return Xe}},ve.html=function(se){var ae=this.rules.block.html.exec(se);if(ae){var Z={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]);Z.type="paragraph",Z.text=k,Z.tokens=this.lexer.inline(k)}return Z}},ve.def=function(se){var ae=this.rules.block.def.exec(se);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var Z=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ae[0],href:ae[2],title:ae[3]}}},ve.table=function(se){var ae=this.rules.block.table.exec(se);if(ae){var Z={type:"table",header:u(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ae[0];var k=Z.align.length,F,H,x,te;for(F=0;F<k;F++)/^ *-+: *$/.test(Z.align[F])?Z.align[F]="right":/^ *:-+: *$/.test(Z.align[F])?Z.align[F]="center":/^ *:-+ *$/.test(Z.align[F])?Z.align[F]="left":Z.align[F]=null;for(k=Z.rows.length,F=0;F<k;F++)Z.rows[F]=u(Z.rows[F],Z.header.length).map(function(pe){return{text:pe}});for(k=Z.header.length,H=0;H<k;H++)Z.header[H].tokens=this.lexer.inline(Z.header[H].text);for(k=Z.rows.length,H=0;H<k;H++)for(te=Z.rows[H],x=0;x<te.length;x++)te[x].tokens=this.lexer.inline(te[x].text);return Z}}},ve.lheading=function(se){var ae=this.rules.block.lheading.exec(se);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ve.paragraph=function(se){var ae=this.rules.block.paragraph.exec(se);if(ae){var Z=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:Z,tokens:this.lexer.inline(Z)}}},ve.text=function(se){var ae=this.rules.block.text.exec(se);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ve.escape=function(se){var ae=this.rules.inline.escape.exec(se);if(ae)return{type:"escape",raw:ae[0],text:g(ae[1])}},ve.tag=function(se){var ae=this.rules.inline.tag.exec(se);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):g(ae[0]):ae[0]}},ve.link=function(se){var ae=this.rules.inline.link.exec(se);if(ae){var Z=ae[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var k=v(Z.slice(0,-1),"\\");if((Z.length-k.length)%2===0)return}else{var F=S(ae[2],"()");if(F>-1){var H=ae[0].indexOf("!")===0?5:4,x=H+ae[1].length+F;ae[2]=ae[2].substring(0,F),ae[0]=ae[0].substring(0,x).trim(),ae[3]=""}}var te=ae[2],pe="";if(this.options.pedantic){var ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);ke&&(te=ke[1],pe=ke[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(Z)?te=te.slice(1):te=te.slice(1,-1)),X(ae,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ve.reflink=function(se,ae){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var k=(Z[2]||Z[1]).replace(/\s+/g," ");if(k=ae[k.toLowerCase()],!k||!k.href){var F=Z[0].charAt(0);return{type:"text",raw:F,text:F}}return X(Z,k,Z[0],this.lexer)}},ve.emStrong=function(se,ae,Z){Z===void 0&&(Z="");var k=this.rules.inline.emStrong.lDelim.exec(se);if(!!k&&!(k[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=k[1]||k[2]||"";if(!F||F&&(Z===""||this.rules.inline.punctuation.exec(Z))){var H=k[0].length-1,x,te,pe=H,ke=0,ue=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,ae=ae.slice(-1*se.length+H);(k=ue.exec(ae))!=null;)if(x=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!x){if(te=x.length,k[3]||k[4]){pe+=te;continue}else if((k[5]||k[6])&&H%3&&!((H+te)%3)){ke+=te;continue}if(pe-=te,!(pe>0)){if(te=Math.min(te,te+pe+ke),Math.min(H,te)%2){var De=se.slice(1,H+k.index+te);return{type:"em",raw:se.slice(0,H+k.index+te+1),text:De,tokens:this.lexer.inlineTokens(De)}}var Se=se.slice(2,H+k.index+te-1);return{type:"strong",raw:se.slice(0,H+k.index+te+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}}}}},ve.codespan=function(se){var ae=this.rules.inline.code.exec(se);if(ae){var Z=ae[2].replace(/\n/g," "),k=/[^ ]/.test(Z),F=/^ /.test(Z)&&/ $/.test(Z);return k&&F&&(Z=Z.substring(1,Z.length-1)),Z=g(Z,!0),{type:"codespan",raw:ae[0],text:Z}}},ve.br=function(se){var ae=this.rules.inline.br.exec(se);if(ae)return{type:"br",raw:ae[0]}},ve.del=function(se){var ae=this.rules.inline.del.exec(se);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ve.autolink=function(se,ae){var Z=this.rules.inline.autolink.exec(se);if(Z){var k,F;return Z[2]==="@"?(k=g(this.options.mangle?ae(Z[1]):Z[1]),F="mailto:"+k):(k=g(Z[1]),F=k),{type:"link",raw:Z[0],text:k,href:F,tokens:[{type:"text",raw:k,text:k}]}}},ve.url=function(se,ae){var Z;if(Z=this.rules.inline.url.exec(se)){var k,F;if(Z[2]==="@")k=g(this.options.mangle?ae(Z[0]):Z[0]),F="mailto:"+k;else{var H;do H=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(H!==Z[0]);k=g(Z[0]),Z[1]==="www."?F="http://"+k:F=k}return{type:"link",raw:Z[0],text:k,href:F,tokens:[{type:"text",raw:k,text:k}]}}},ve.inlineText=function(se,ae){var Z=this.rules.inline.text.exec(se);if(Z){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]:k=g(this.options.smartypants?ae(Z[0]):Z[0]),{type:"text",raw:Z[0],text:k}}},we}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=s({},j),j.gfm=s({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=s({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=m(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=m(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=m(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=m(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=m(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=m(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=m(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=m(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=m(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=m(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=s({},U),U.pedantic=s({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=s({},U.normal,{escape:m(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=m(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=s({},U.gfm,{br:m(U.br).replace("{2,}","*").getRegex(),text:m(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(we){return we.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(we){var ve="",Ce,se,ae=we.length;for(Ce=0;Ce<ae;Ce++)se=we.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var q=function(){function we(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ee.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:j.normal,inline:U.normal};this.options.pedantic?(se.block=j.pedantic,se.inline=U.pedantic):this.options.gfm&&(se.block=j.gfm,this.options.breaks?se.inline=U.breaks:se.inline=U.gfm),this.tokenizer.rules=se}we.lex=function(se,ae){var Z=new we(ae);return Z.lex(se)},we.lexInline=function(se,ae){var Z=new we(ae);return Z.inlineTokens(se)};var ve=we.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ve.blockTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(pe,ke,ue){return ke+"    ".repeat(ue.length)});for(var k,F,H,x;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(k=pe.call({lexer:Z},se,ae))?(se=se.substring(k.raw.length),ae.push(k),!0):!1}))){if(k=this.tokenizer.space(se)){se=se.substring(k.raw.length),k.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(k);continue}if(k=this.tokenizer.code(se)){se=se.substring(k.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+k.raw,F.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(k);continue}if(k=this.tokenizer.fences(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.heading(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.hr(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.blockquote(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.list(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.html(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.def(se)){se=se.substring(k.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+k.raw,F.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.lheading(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,ke=se.slice(1),ue=void 0;Z.options.extensions.startBlock.forEach(function(De){ue=De.call({lexer:this},ke),typeof ue=="number"&&ue>=0&&(pe=Math.min(pe,ue))}),pe<1/0&&pe>=0&&(H=se.substring(0,pe+1))}(),this.state.top&&(k=this.tokenizer.paragraph(H))){F=ae[ae.length-1],x&&F.type==="paragraph"?(F.raw+=`
`+k.raw,F.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(k),x=H.length!==se.length,se=se.substring(k.raw.length);continue}if(k=this.tokenizer.text(se)){se=se.substring(k.raw.length),F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=`
`+k.raw,F.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(k);continue}if(se){var te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ae},ve.inline=function(se,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:se,tokens:ae}),ae},ve.inlineTokens=function(se,ae){var Z=this;ae===void 0&&(ae=[]);var k,F,H,x=se,te,pe,ke;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(x))!=null;)ue.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(x))!=null;)x=x.slice(0,te.index)+"["+W("a",te[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(x))!=null;)x=x.slice(0,te.index)+"++"+x.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(pe||(ke=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Se){return(k=Se.call({lexer:Z},se,ae))?(se=se.substring(k.raw.length),ae.push(k),!0):!1}))){if(k=this.tokenizer.escape(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.tag(se)){se=se.substring(k.raw.length),F=ae[ae.length-1],F&&k.type==="text"&&F.type==="text"?(F.raw+=k.raw,F.text+=k.text):ae.push(k);continue}if(k=this.tokenizer.link(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(k.raw.length),F=ae[ae.length-1],F&&k.type==="text"&&F.type==="text"?(F.raw+=k.raw,F.text+=k.text):ae.push(k);continue}if(k=this.tokenizer.emStrong(se,x,ke)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.codespan(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.br(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.del(se)){se=se.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.autolink(se,B)){se=se.substring(k.raw.length),ae.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(se,B))){se=se.substring(k.raw.length),ae.push(k);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Se=1/0,$e=se.slice(1),He=void 0;Z.options.extensions.startInline.forEach(function(et){He=et.call({lexer:this},$e),typeof He=="number"&&He>=0&&(Se=Math.min(Se,He))}),Se<1/0&&Se>=0&&(H=se.substring(0,Se+1))}(),k=this.tokenizer.inlineText(H,$)){se=se.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(ke=k.raw.slice(-1)),pe=!0,F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=k.raw,F.text+=k.text):ae.push(k);continue}if(se){var De="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},n(we,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),we}(),he=function(){function we(Ce){this.options=Ce||ee.defaults}var ve=we.prototype;return ve.code=function(se,ae,Z){var k=(ae||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(se,k);F!=null&&F!==se&&(Z=!0,se=F)}return se=se.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+g(k,!0)+'">'+(Z?se:g(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:g(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,ae,Z,k){if(this.options.headerIds){var F=this.options.headerPrefix+k.slug(Z);return"<h"+ae+' id="'+F+'">'+se+"</h"+ae+`>
`}return"<h"+ae+">"+se+"</h"+ae+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,ae,Z){var k=ae?"ol":"ul",F=ae&&Z!==1?' start="'+Z+'"':"";return"<"+k+F+`>
`+se+"</"+k+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ae+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,ae){var Z=ae.header?"th":"td",k=ae.align?"<"+Z+' align="'+ae.align+'">':"<"+Z+">";return k+se+("</"+Z+`>
`)},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,ae,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var k='<a href="'+g(se)+'"';return ae&&(k+=' title="'+ae+'"'),k+=">"+Z+"</a>",k},ve.image=function(se,ae,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var k='<img src="'+se+'" alt="'+Z+'"';return ae&&(k+=' title="'+ae+'"'),k+=this.options.xhtml?"/>":">",k},ve.text=function(se){return se},we}(),Ee=function(){function we(){}var ve=we.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,ae,Z){return""+Z},ve.image=function(se,ae,Z){return""+Z},ve.br=function(){return""},we}(),ie=function(){function we(){this.seen={}}var ve=we.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,ae){var Z=se,k=0;if(this.seen.hasOwnProperty(Z)){k=this.seen[se];do k++,Z=se+"-"+k;while(this.seen.hasOwnProperty(Z))}return ae||(this.seen[se]=k,this.seen[Z]=0),Z},ve.slug=function(se,ae){ae===void 0&&(ae={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,ae.dryrun)},we}(),ce=function(){function we(Ce){this.options=Ce||ee.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new ie}we.parse=function(se,ae){var Z=new we(ae);return Z.parse(se)},we.parseInline=function(se,ae){var Z=new we(ae);return Z.parseInline(se)};var ve=we.prototype;return ve.parse=function(se,ae){ae===void 0&&(ae=!0);var Z="",k,F,H,x,te,pe,ke,ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_=se.length;for(k=0;k<_;k++){if(Se=se[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Se.type]&&(Q=this.options.extensions.renderers[Se.type].call({parser:this},Se),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Se.type))){Z+=Q||"";continue}switch(Se.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(Se.tokens),Se.depth,t(this.parseInline(Se.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(Se.text,Se.lang,Se.escaped);continue}case"table":{for(ue="",ke="",x=Se.header.length,F=0;F<x;F++)ke+=this.renderer.tablecell(this.parseInline(Se.header[F].tokens),{header:!0,align:Se.align[F]});for(ue+=this.renderer.tablerow(ke),De="",x=Se.rows.length,F=0;F<x;F++){for(pe=Se.rows[F],ke="",te=pe.length,H=0;H<te;H++)ke+=this.renderer.tablecell(this.parseInline(pe[H].tokens),{header:!1,align:Se.align[H]});De+=this.renderer.tablerow(ke)}Z+=this.renderer.table(ue,De);continue}case"blockquote":{De=this.parse(Se.tokens),Z+=this.renderer.blockquote(De);continue}case"list":{for($e=Se.ordered,He=Se.start,et=Se.loose,x=Se.items.length,De="",F=0;F<x;F++)tt=Se.items[F],rt=tt.checked,Me=tt.task,Xe="",tt.task&&(it=this.renderer.checkbox(rt),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Xe+=it),Xe+=this.parse(tt.tokens,et),De+=this.renderer.listitem(Xe,Me,rt);Z+=this.renderer.list(De,$e,He);continue}case"html":{Z+=this.renderer.html(Se.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(Se.tokens));continue}case"text":{for(De=Se.tokens?this.parseInline(Se.tokens):Se.text;k+1<_&&se[k+1].type==="text";)Se=se[++k],De+=`
`+(Se.tokens?this.parseInline(Se.tokens):Se.text);Z+=ae?this.renderer.paragraph(De):De;continue}default:{var be='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return Z},ve.parseInline=function(se,ae){ae=ae||this.renderer;var Z="",k,F,H,x=se.length;for(k=0;k<x;k++){if(F=se[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(H=this.options.extensions.renderers[F.type].call({parser:this},F),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){Z+=H||"";continue}switch(F.type){case"escape":{Z+=ae.text(F.text);break}case"html":{Z+=ae.html(F.text);break}case"link":{Z+=ae.link(F.href,F.title,this.parseInline(F.tokens,ae));break}case"image":{Z+=ae.image(F.href,F.title,F.text);break}case"strong":{Z+=ae.strong(this.parseInline(F.tokens,ae));break}case"em":{Z+=ae.em(this.parseInline(F.tokens,ae));break}case"codespan":{Z+=ae.codespan(F.text);break}case"br":{Z+=ae.br();break}case"del":{Z+=ae.del(this.parseInline(F.tokens,ae));break}case"text":{Z+=ae.text(F.text);break}default:{var te='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return Z},we}();function de(we,ve,Ce){if(typeof we>"u"||we===null)throw new Error("marked(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");if(typeof ve=="function"&&(Ce=ve,ve=null),ve=s({},de.defaults,ve||{}),E(ve),Ce){var se=ve.highlight,ae;try{ae=q.lex(we,ve)}catch(x){return Ce(x)}var Z=function(te){var pe;if(!te)try{ve.walkTokens&&de.walkTokens(ae,ve.walkTokens),pe=ce.parse(ae,ve)}catch(ke){te=ke}return ve.highlight=se,te?Ce(te):Ce(null,pe)};if(!se||se.length<3||(delete ve.highlight,!ae.length))return Z();var k=0;de.walkTokens(ae,function(x){x.type==="code"&&(k++,setTimeout(function(){se(x.text,x.lang,function(te,pe){if(te)return Z(te);pe!=null&&pe!==x.text&&(x.text=pe,x.escaped=!0),k--,k===0&&Z()})},0))}),k===0&&Z();return}function F(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(x.message+"",!0)+"</pre>";throw x}try{var H=q.lex(we,ve);if(ve.walkTokens){if(ve.async)return Promise.all(de.walkTokens(H,ve.walkTokens)).then(function(){return ce.parse(H,ve)}).catch(F);de.walkTokens(H,ve.walkTokens)}return ce.parse(H,ve)}catch(x){F(x)}}de.options=de.setOptions=function(we){return s(de.defaults,we),A(de.defaults),de},de.getDefaults=R,de.defaults=ee.defaults,de.use=function(){for(var we=arguments.length,ve=new Array(we),Ce=0;Ce<we;Ce++)ve[Ce]=arguments[Ce];var se=s.apply(void 0,[{}].concat(ve)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},Z;ve.forEach(function(k){if(k.extensions&&(Z=!0,k.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var x=ae.renderers?ae.renderers[H.name]:null;x?ae.renderers[H.name]=function(){for(var te=arguments.length,pe=new Array(te),ke=0;ke<te;ke++)pe[ke]=arguments[ke];var ue=H.renderer.apply(this,pe);return ue===!1&&(ue=x.apply(this,pe)),ue}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),k.renderer&&function(){var H=de.defaults.renderer||new he,x=function(ke){var ue=H[ke];H[ke]=function(){for(var De=arguments.length,Se=new Array(De),$e=0;$e<De;$e++)Se[$e]=arguments[$e];var He=k.renderer[ke].apply(H,Se);return He===!1&&(He=ue.apply(H,Se)),He}};for(var te in k.renderer)x(te);se.renderer=H}(),k.tokenizer&&function(){var H=de.defaults.tokenizer||new J,x=function(ke){var ue=H[ke];H[ke]=function(){for(var De=arguments.length,Se=new Array(De),$e=0;$e<De;$e++)Se[$e]=arguments[$e];var He=k.tokenizer[ke].apply(H,Se);return He===!1&&(He=ue.apply(H,Se)),He}};for(var te in k.tokenizer)x(te);se.tokenizer=H}(),k.walkTokens){var F=de.defaults.walkTokens;se.walkTokens=function(H){var x=[];return x.push(k.walkTokens.call(this,H)),F&&(x=x.concat(F.call(this,H))),x}}Z&&(se.extensions=ae),de.setOptions(se)})},de.walkTokens=function(we,ve){for(var Ce=[],se=function(){var F=Z.value;switch(Ce=Ce.concat(ve.call(de,F)),F.type){case"table":{for(var H=M(F.header),x;!(x=H()).done;){var te=x.value;Ce=Ce.concat(de.walkTokens(te.tokens,ve))}for(var pe=M(F.rows),ke;!(ke=pe()).done;)for(var ue=ke.value,De=M(ue),Se;!(Se=De()).done;){var $e=Se.value;Ce=Ce.concat(de.walkTokens($e.tokens,ve))}break}case"list":{Ce=Ce.concat(de.walkTokens(F.items,ve));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[F.type]?de.defaults.extensions.childTokens[F.type].forEach(function(He){Ce=Ce.concat(de.walkTokens(F[He],ve))}):F.tokens&&(Ce=Ce.concat(de.walkTokens(F.tokens,ve)))}},ae=M(we),Z;!(Z=ae()).done;)se();return Ce},de.parseInline=function(we,ve){if(typeof we>"u"||we===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");ve=s({},de.defaults,ve||{}),E(ve);try{var Ce=q.lexInline(we,ve);return ve.walkTokens&&de.walkTokens(Ce,ve.walkTokens),ce.parseInline(Ce,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(se.message+"",!0)+"</pre>";throw se}},de.Parser=ce,de.parser=ce.parse,de.Renderer=he,de.TextRenderer=Ee,de.Lexer=q,de.lexer=q.lex,de.Tokenizer=J,de.Slugger=ie,de.parse=de;var Te=de.options,le=de.setOptions,re=de.use,V=de.walkTokens,L=de.parseInline,K=de,me=ce.parse,Ie=q.lex;ee.Lexer=q,ee.Parser=ce,ee.Renderer=he,ee.Slugger=ie,ee.TextRenderer=Ee,ee.Tokenizer=J,ee.getDefaults=R,ee.lexer=Ie,ee.marked=de,ee.options=Te,ee.parse=K,ee.parseInline=L,ee.parser=me,ee.setOptions=le,ee.use=re,ee.walkTokens=V,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ae[115],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,w,h){return Math.min(Math.max(A,w),h)}e.clamp=n;function P(A,w){return(w+A%w)%w}e.rot=P;class C{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=C;class M{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class R{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const h=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function ee(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function R(w){M.push(w,Date.now())}function A(){const w=[];for(let h=0;h<M.length;h+=2)w.push({name:M[h],startTime:M[h+1]});return w}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(C+R.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function n(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=n(P))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var P in n)(typeof exports=="object"?exports:ee)[P]=n[P]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function n(P){if(e[P])return e[P].exports;var C=e[P]={i:P,l:!1,exports:{}};return ee[P].call(C.exports,C,C.exports,n),C.l=!0,C.exports}return n.m=ee,n.c=e,n.d=function(P,C,M){n.o(P,C)||Object.defineProperty(P,C,{enumerable:!0,get:M})},n.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},n.t=function(P,C){if(1&C&&(P=n(P)),8&C||4&C&&typeof P=="object"&&P&&P.__esModule)return P;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:P}),2&C&&typeof P!="string")for(var R in P)n.d(M,R,function(A){return P[A]}.bind(null,R));return M},n.n=function(P){var C=P&&P.__esModule?function(){return P.default}:function(){return P};return n.d(C,"a",C),C},n.o=function(P,C){return Object.prototype.hasOwnProperty.call(P,C)},n.p="",n(n.s=0)}([function(ee,e,n){(function(P){var C;e=ee.exports=re,C=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],w=e.src=[],h=0,O=h++;w[O]="0|[1-9]\\d*";var D=h++;w[D]="[0-9]+";var f=h++;w[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=h++;w[b]="("+w[O]+")\\.("+w[O]+")\\.("+w[O]+")";var g=h++;w[g]="("+w[D]+")\\.("+w[D]+")\\.("+w[D]+")";var d=h++;w[d]="(?:"+w[O]+"|"+w[f]+")";var t=h++;w[t]="(?:"+w[D]+"|"+w[f]+")";var a=h++;w[a]="(?:-("+w[d]+"(?:\\."+w[d]+")*))";var m=h++;w[m]="(?:-?("+w[t]+"(?:\\."+w[t]+")*))";var y=h++;w[y]="[0-9A-Za-z-]+";var T=h++;w[T]="(?:\\+("+w[y]+"(?:\\."+w[y]+")*))";var p=h++,i="v?"+w[b]+w[a]+"?"+w[T]+"?";w[p]="^"+i+"$";var l="[v=\\s]*"+w[g]+w[m]+"?"+w[T]+"?",r=h++;w[r]="^"+l+"$";var c=h++;w[c]="((?:<|>)?=?)";var o=h++;w[o]=w[D]+"|x|X|\\*";var I=h++;w[I]=w[O]+"|x|X|\\*";var s=h++;w[s]="[v=\\s]*("+w[I]+")(?:\\.("+w[I]+")(?:\\.("+w[I]+")(?:"+w[a]+")?"+w[T]+"?)?)?";var u=h++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[T]+"?)?)?";var v=h++;w[v]="^"+w[c]+"\\s*"+w[s]+"$";var S=h++;w[S]="^"+w[c]+"\\s*"+w[u]+"$";var E=h++;w[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=h++;w[W]="(?:~>?)";var X=h++;w[X]="(\\s*)"+w[W]+"\\s+",A[X]=new RegExp(w[X],"g");var Y=h++;w[Y]="^"+w[W]+w[s]+"$";var J=h++;w[J]="^"+w[W]+w[u]+"$";var j=h++;w[j]="(?:\\^)";var U=h++;w[U]="(\\s*)"+w[j]+"\\s+",A[U]=new RegExp(w[U],"g");var $=h++;w[$]="^"+w[j]+w[s]+"$";var B=h++;w[B]="^"+w[j]+w[u]+"$";var q=h++;w[q]="^"+w[c]+"\\s*("+l+")$|^$";var he=h++;w[he]="^"+w[c]+"\\s*("+i+")$|^$";var Ee=h++;w[Ee]="(\\s*)"+w[c]+"\\s*("+l+"|"+w[s]+")",A[Ee]=new RegExp(w[Ee],"g");var ie=h++;w[ie]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var ce=h++;w[ce]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var de=h++;w[de]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)C(Te,w[Te]),A[Te]||(A[Te]=new RegExp(w[Te]));function le(ue,De){if(ue instanceof re)return ue;if(typeof ue!="string"||ue.length>M||!(De?A[r]:A[p]).test(ue))return null;try{return new re(ue,De)}catch{return null}}function re(ue,De){if(ue instanceof re){if(ue.loose===De)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(ue,De);C("SemVer",ue,De),this.loose=De;var Se=ue.trim().match(De?A[r]:A[p]);if(!Se)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<R)return He}return $e}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=le,e.valid=function(ue,De){var Se=le(ue,De);return Se?Se.version:null},e.clean=function(ue,De){var Se=le(ue.trim().replace(/^[=v]+/,""),De);return Se?Se.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(ue){return C("SemVer.compare",this.version,this.loose,ue),ue instanceof re||(ue=new re(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},re.prototype.compareMain=function(ue){return ue instanceof re||(ue=new re(ue,this.loose)),L(this.major,ue.major)||L(this.minor,ue.minor)||L(this.patch,ue.patch)},re.prototype.comparePre=function(ue){if(ue instanceof re||(ue=new re(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var De=0;do{var Se=this.prerelease[De],$e=ue.prerelease[De];if(C("prerelease compare",De,Se,$e),Se===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Se===void 0)return-1;if(Se!==$e)return L(Se,$e)}while(++De)},re.prototype.inc=function(ue,De){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,De,Se,$e){typeof Se=="string"&&($e=Se,Se=void 0);try{return new re(ue,Se).inc(De,$e).version}catch{return null}},e.diff=function(ue,De){if(we(ue,De))return null;var Se=le(ue),$e=le(De);if(Se.prerelease.length||$e.prerelease.length){for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in Se)if((He==="major"||He==="minor"||He==="patch")&&Se[He]!==$e[He])return He},e.compareIdentifiers=L;var V=/^[0-9]+$/;function L(ue,De){var Se=V.test(ue),$e=V.test(De);return Se&&$e&&(ue=+ue,De=+De),Se&&!$e?-1:$e&&!Se?1:ue<De?-1:ue>De?1:0}function K(ue,De,Se){return new re(ue,Se).compare(new re(De,Se))}function me(ue,De,Se){return K(ue,De,Se)>0}function Ie(ue,De,Se){return K(ue,De,Se)<0}function we(ue,De,Se){return K(ue,De,Se)===0}function ve(ue,De,Se){return K(ue,De,Se)!==0}function Ce(ue,De,Se){return K(ue,De,Se)>=0}function se(ue,De,Se){return K(ue,De,Se)<=0}function ae(ue,De,Se,$e){var He;switch(De){case"===":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),He=ue===Se;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof Se=="object"&&(Se=Se.version),He=ue!==Se;break;case"":case"=":case"==":He=we(ue,Se,$e);break;case"!=":He=ve(ue,Se,$e);break;case">":He=me(ue,Se,$e);break;case">=":He=Ce(ue,Se,$e);break;case"<":He=Ie(ue,Se,$e);break;case"<=":He=se(ue,Se,$e);break;default:throw new TypeError("Invalid operator: "+De)}return He}function Z(ue,De){if(ue instanceof Z){if(ue.loose===De)return ue;ue=ue.value}if(!(this instanceof Z))return new Z(ue,De);C("comparator",ue,De),this.loose=De,this.parse(ue),this.semver===k?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ue,De){return L(De,ue)},e.major=function(ue,De){return new re(ue,De).major},e.minor=function(ue,De){return new re(ue,De).minor},e.patch=function(ue,De){return new re(ue,De).patch},e.compare=K,e.compareLoose=function(ue,De){return K(ue,De,!0)},e.rcompare=function(ue,De,Se){return K(De,ue,Se)},e.sort=function(ue,De){return ue.sort(function(Se,$e){return e.compare(Se,$e,De)})},e.rsort=function(ue,De){return ue.sort(function(Se,$e){return e.rcompare(Se,$e,De)})},e.gt=me,e.lt=Ie,e.eq=we,e.neq=ve,e.gte=Ce,e.lte=se,e.cmp=ae,e.Comparator=Z;var k={};function F(ue,De){if(ue instanceof F)return ue.loose===De?ue:new F(ue.raw,De);if(ue instanceof Z)return new F(ue.value,De);if(!(this instanceof F))return new F(ue,De);if(this.loose=De,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function H(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function x(ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_){return((De=H(Se)?"":H($e)?">="+Se+".0.0":H(He)?">="+Se+"."+$e+".0":">="+De)+" "+(tt=H(rt)?"":H(Me)?"<"+(+rt+1)+".0.0":H(it)?"<"+rt+"."+(+Me+1)+".0":Q?"<="+rt+"."+Me+"."+it+"-"+Q:"<="+tt)).trim()}function te(ue,De){for(var Se=0;Se<ue.length;Se++)if(!ue[Se].test(De))return!1;if(De.prerelease.length){for(Se=0;Se<ue.length;Se++)if(C(ue[Se].semver),ue[Se].semver!==k&&ue[Se].semver.prerelease.length>0){var $e=ue[Se].semver;if($e.major===De.major&&$e.minor===De.minor&&$e.patch===De.patch)return!0}return!1}return!0}function pe(ue,De,Se){try{De=new F(De,Se)}catch{return!1}return De.test(ue)}function ke(ue,De,Se,$e){var He,et,Xe,tt,rt;switch(ue=new re(ue,$e),De=new F(De,$e),Se){case">":He=me,et=se,Xe=Ie,tt=">",rt=">=";break;case"<":He=Ie,et=Ce,Xe=me,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ue,De,$e))return!1;for(var Me=0;Me<De.set.length;++Me){var it=De.set[Me],Q=null,_=null;if(it.forEach(function(be){be.semver===k&&(be=new Z(">=0.0.0")),Q=Q||be,_=_||be,He(be.semver,Q.semver,$e)?Q=be:Xe(be.semver,_.semver,$e)&&(_=be)}),Q.operator===tt||Q.operator===rt||(!_.operator||_.operator===tt)&&et(ue,_.semver)||_.operator===rt&&Xe(ue,_.semver))return!1}return!0}Z.prototype.parse=function(ue){var De=this.loose?A[q]:A[he],Se=ue.match(De);if(!Se)throw new TypeError("Invalid comparator: "+ue);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new re(Se[2],this.loose):this.semver=k},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ue){return C("Comparator.test",ue,this.loose),this.semver===k||(typeof ue=="string"&&(ue=new re(ue,this.loose)),ae(ue,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ue,De){if(!(ue instanceof Z))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new F(ue.value,De),pe(this.value,Se,De);if(ue.operator==="")return Se=new F(this.value,De),pe(ue.semver,Se,De);var $e=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),et=this.semver.version===ue.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),tt=ae(this.semver,"<",ue.semver,De)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),rt=ae(this.semver,">",ue.semver,De)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return $e||He||et&&Xe||tt||rt},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(ue){var De=this.loose;ue=ue.trim(),C("range",ue,De);var Se=De?A[ce]:A[ie];ue=ue.replace(Se,x),C("hyphen replace",ue),ue=ue.replace(A[Ee],"$1$2$3"),C("comparator trim",ue,A[Ee]),ue=(ue=(ue=ue.replace(A[X],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var $e=De?A[q]:A[he],He=ue.split(" ").map(function(et){return function(Xe,tt){return C("comp",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,_){C("caret",Q,_);var be=_?A[B]:A[$];return Q.replace(be,function(We,ze,Qe,Ye,Ge){var at;return C("caret",Q,We,ze,Qe,Ye,Ge),H(ze)?at="":H(Qe)?at=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(Ye)?at=ze==="0"?">="+ze+"."+Qe+".0 <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+".0 <"+(+ze+1)+".0.0":Ge?(C("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=ze==="0"?Qe==="0"?">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+Qe+"."+(+Ye+1):">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+"."+Ye+Ge+" <"+(+ze+1)+".0.0"):(C("no pr"),at=ze==="0"?Qe==="0"?">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+Qe+"."+(+Ye+1):">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+(+Qe+1)+".0":">="+ze+"."+Qe+"."+Ye+" <"+(+ze+1)+".0.0"),C("caret return",at),at})}(it,Me)}).join(" ")}(Xe,tt),C("caret",Xe),Xe=function(rt,Me){return rt.trim().split(/\s+/).map(function(it){return function(Q,_){var be=_?A[J]:A[Y];return Q.replace(be,function(We,ze,Qe,Ye,Ge){var at;return C("tilde",Q,We,ze,Qe,Ye,Ge),H(ze)?at="":H(Qe)?at=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(Ye)?at=">="+ze+"."+Qe+".0 <"+ze+"."+(+Qe+1)+".0":Ge?(C("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),at=">="+ze+"."+Qe+"."+Ye+Ge+" <"+ze+"."+(+Qe+1)+".0"):at=">="+ze+"."+Qe+"."+Ye+" <"+ze+"."+(+Qe+1)+".0",C("tilde return",at),at})}(it,Me)}).join(" ")}(Xe,tt),C("tildes",Xe),Xe=function(rt,Me){return C("replaceXRanges",rt,Me),rt.split(/\s+/).map(function(it){return function(Q,_){Q=Q.trim();var be=_?A[S]:A[v];return Q.replace(be,function(We,ze,Qe,Ye,Ge,at){C("xRange",Q,We,ze,Qe,Ye,Ge,at);var Dt=H(Qe),Tt=Dt||H(Ye),It=Tt||H(Ge);return ze==="="&&It&&(ze=""),Dt?We=ze===">"||ze==="<"?"<0.0.0":"*":ze&&It?(Tt&&(Ye=0),It&&(Ge=0),ze===">"?(ze=">=",Tt?(Qe=+Qe+1,Ye=0,Ge=0):It&&(Ye=+Ye+1,Ge=0)):ze==="<="&&(ze="<",Tt?Qe=+Qe+1:Ye=+Ye+1),We=ze+Qe+"."+Ye+"."+Ge):Tt?We=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":It&&(We=">="+Qe+"."+Ye+".0 <"+Qe+"."+(+Ye+1)+".0"),C("xRange return",We),We})}(it,Me)}).join(" ")}(Xe,tt),C("xrange",Xe),Xe=function(rt,Me){return C("replaceStars",rt,Me),rt.trim().replace(A[de],"")}(Xe,tt),C("stars",Xe),Xe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(et){return!!et.match($e)})),He=He.map(function(et){return new Z(et,De)})},F.prototype.intersects=function(ue,De){if(!(ue instanceof F))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function($e){return ue.set.some(function(He){return He.every(function(et){return $e.intersects(et,De)})})})})},e.toComparators=function(ue,De){return new F(ue,De).set.map(function(Se){return Se.map(function($e){return $e.value}).join(" ").trim().split(" ")})},F.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new re(ue,this.loose));for(var De=0;De<this.set.length;De++)if(te(this.set[De],ue))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ue,De,Se){var $e=null,He=null;try{var et=new F(De,Se)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==-1||(He=new re($e=Xe,Se)))}),$e},e.minSatisfying=function(ue,De,Se){var $e=null,He=null;try{var et=new F(De,Se)}catch{return null}return ue.forEach(function(Xe){et.test(Xe)&&($e&&He.compare(Xe)!==1||(He=new re($e=Xe,Se)))}),$e},e.validRange=function(ue,De){try{return new F(ue,De).range||"*"}catch{return null}},e.ltr=function(ue,De,Se){return ke(ue,De,"<",Se)},e.gtr=function(ue,De,Se){return ke(ue,De,">",Se)},e.outside=ke,e.prerelease=function(ue,De){var Se=le(ue,De);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(ue,De,Se){return ue=new F(ue,Se),De=new F(De,Se),ue.intersects(De)},e.coerce=function(ue){if(ue instanceof re)return ue;if(typeof ue!="string")return null;var De=ue.match(A[E]);return De==null?null:le((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,n(1))},function(ee,e){var n,P,C=ee.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(t){if(n===setTimeout)return setTimeout(t,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{P=typeof clearTimeout=="function"?clearTimeout:R}catch{P=R}})();var w,h=[],O=!1,D=-1;function f(){O&&w&&(O=!1,w.length?h=w.concat(h):D=-1,h.length&&b())}function b(){if(!O){var t=A(f);O=!0;for(var a=h.length;a;){for(w=h,h=[];++D<a;)w&&w[D].run();D=-1,a=h.length}w=null,O=!1,function(m){if(P===clearTimeout)return clearTimeout(m);if((P===R||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(m);try{P(m)}catch{try{return P.call(null,m)}catch{return P.call(this,m)}}}(t)}}function g(t,a){this.fun=t,this.array=a}function d(){}C.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)a[m-1]=arguments[m];h.push(new g(t,a)),h.length!==1||O||A(b)},g.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[116],Re([1,0,10,6]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(T){const p=T;return p?typeof p.read=="function":!1}e.isReadable=C;function M(T){const p=T;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function R(T){const p=T;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=R;function A(T,p){return new w(T,p)}e.newWriteableStream=A;class w{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,n.onUnexpectedError)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let l;switch(p){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(i);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(T,p){const i=[];let l;for(;(l=T.read())!==null;)i.push(l);return p(i)}e.consumeReadable=h;function O(T,p,i){const l=[];let r;for(;(r=T.read())!==null&&l.length<i;)l.push(r);return r===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return T.read()}}}e.peekReadable=O;function D(T,p){return new Promise((i,l)=>{const r=[];f(T,{onData:c=>{p&&r.push(c)},onError:c=>{p?l(c):i(void 0)},onEnd:()=>{i(p?p(r):void 0)}})})}e.consumeStream=D;function f(T,p){let i=!1;return T.on("error",l=>{i||p.onError(l)}),T.on("end",()=>{i||p.onEnd()}),T.on("data",l=>{i||p.onData(l)}),(0,P.toDisposable)(()=>i=!0)}e.listenStream=f;function b(T,p){return new Promise((i,l)=>{const r=new P.DisposableStore,c=[],o=u=>{if(c.push(u),c.length>p)return r.dispose(),T.pause(),i({stream:T,buffer:c,ended:!1})},I=u=>l(u),s=()=>i({stream:T,buffer:c,ended:!0});r.add((0,P.toDisposable)(()=>T.removeListener("error",I))),T.on("error",I),r.add((0,P.toDisposable)(()=>T.removeListener("end",s))),T.on("end",s),r.add((0,P.toDisposable)(()=>T.removeListener("data",o))),T.on("data",o)})}e.peekStream=b;function g(T,p){const i=A(p);return i.end(T),i}e.toStream=g;function d(){const T=A(()=>{throw new Error("not supported")});return T.end(),T}e.emptyStream=d;function t(T){let p=!1;return{read:()=>p?null:(p=!0,T)}}e.toReadable=t;function a(T,p,i){const l=A(i);return f(T,{onData:r=>l.write(p.data(r)),onError:r=>l.error(p.error?p.error(r):r),onEnd:()=>l.end()}),l}e.transform=a;function m(T,p,i){let l=!1;return{read:()=>{const r=p.read();return l?r:(l=!0,r!==null?i([T,r]):T)}}}e.prefixedReadable=m;function y(T,p,i){let l=!1;const r=A(i);return f(p,{onData:c=>l?r.write(c):(l=!0,r.write(i([T,c]))),onError:c=>r.error(c),onEnd:()=>{l||(l=!0,r.write(T)),r.end()}}),r}e.prefixedStream=y}),define(Ae[25],Re([1,0,116]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let C,M;class R{static alloc(u){return P?new R(Buffer.allocUnsafe(u)):new R(new Uint8Array(u))}static wrap(u){return P&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new R(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&P?new R(Buffer.from(u)):(C||(C=new TextEncoder),new R(C.encode(u)))}static fromByteArray(u){const v=R.alloc(u.length);for(let S=0,E=u.length;S<E;S++)v.buffer[S]=u[S];return v}static concat(u,v){if(typeof v>"u"){v=0;for(let W=0,X=u.length;W<X;W++)v+=u[W].byteLength}const S=R.alloc(v);let E=0;for(let W=0,X=u.length;W<X;W++){const Y=u[W];S.set(Y,E),E+=Y.byteLength}return S}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=R.alloc(this.byteLength);return u.set(this),u}toString(){return P?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(u,v){return new R(this.buffer.subarray(u,v))}set(u,v){if(u instanceof R)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return h(this.buffer,u)}writeUInt32BE(u,v){O(this.buffer,u,v)}readUInt32LE(u){return D(this.buffer,u)}writeUInt32LE(u,v){f(this.buffer,u,v)}readUInt8(u){return b(this.buffer,u)}writeUInt8(u,v){g(this.buffer,u,v)}}e.VSBuffer=R;function A(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=A;function w(s,u,v){s[v+0]=u&255,u=u>>>8,s[v+1]=u&255}e.writeUInt16LE=w;function h(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=h;function O(s,u,v){s[v+3]=u,u=u>>>8,s[v+2]=u,u=u>>>8,s[v+1]=u,u=u>>>8,s[v]=u}e.writeUInt32BE=O;function D(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=D;function f(s,u,v){s[v+0]=u&255,u=u>>>8,s[v+1]=u&255,u=u>>>8,s[v+2]=u&255,u=u>>>8,s[v+3]=u&255}e.writeUInt32LE=f;function b(s,u){return s[u]}e.readUInt8=b;function g(s,u,v){s[v]=u}e.writeUInt8=g;function d(s){return n.consumeReadable(s,u=>R.concat(u))}e.readableToBuffer=d;function t(s){return n.toReadable(s)}e.bufferToReadable=t;function a(s){return n.consumeStream(s,u=>R.concat(u))}e.streamToBuffer=a;async function m(s){return s.ended?R.concat(s.buffer):R.concat([...s.buffer,await a(s.stream)])}e.bufferedStreamToBuffer=m;function y(s){return n.toStream(s,u=>R.concat(u))}e.bufferToStream=y;function T(s){return n.transform(s,{data:u=>typeof u=="string"?R.fromString(u):R.wrap(u)},u=>R.concat(u))}e.streamToBufferReadableStream=T;function p(s){return n.newWriteableStream(u=>R.concat(u),s)}e.newWriteableBufferStream=p;function i(s,u){return n.prefixedReadable(s,u,v=>R.concat(v))}e.prefixedBufferReadable=i;function l(s,u){return n.prefixedStream(s,u,v=>R.concat(v))}e.prefixedBufferStream=l;function r(s){let u=0,v=0,S=0;const E=new Uint8Array(Math.floor(s.length/4*3)),W=Y=>{switch(v){case 3:E[S++]=u|Y,v=0;break;case 2:E[S++]=u|Y>>>2,u=Y<<6,v=3;break;case 1:E[S++]=u|Y>>>4,u=Y<<4,v=2;break;default:u=Y<<2,v=1}};for(let Y=0;Y<s.length;Y++){const J=s.charCodeAt(Y);if(J>=65&&J<=90)W(J-65);else if(J>=97&&J<=122)W(J-97+26);else if(J>=48&&J<=57)W(J-48+52);else if(J===43||J===45)W(62);else if(J===47||J===95)W(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${s[Y]}`)}}const X=S;for(;v>0;)W(0);return R.wrap(E).slice(0,X)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:s},u=!0,v=!1){const S=v?o:c;let E="";const W=s.byteLength%3;let X=0;for(;X<s.byteLength-W;X+=3){const Y=s[X+0],J=s[X+1],j=s[X+2];E+=S[Y>>>2],E+=S[(Y<<4|J>>>4)&63],E+=S[(J<<2|j>>>6)&63],E+=S[j&63]}if(W===1){const Y=s[X+0];E+=S[Y>>>2],E+=S[Y<<4&63],u&&(E+="==")}else if(W===2){const Y=s[X+0],J=s[X+1];E+=S[Y>>>2],E+=S[(Y<<4|J>>>4)&63],E+=S[J<<2&63],u&&(E+="=")}return E}e.encodeBase64=I}),define(Ae[117],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ae[39],Re([1,0,85]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(R){function A(w){return w&&typeof w=="object"&&typeof w.id=="string"}R.isThemeColor=A})(P=e.ThemeColor||(e.ThemeColor={}));function C(R){return{id:R}}e.themeColorFromId=C;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function w(m){const y=A.exec(m.id);if(!y)return w(n.Codicon.error);const[,T,p]=y,i=["codicon","codicon-"+T];return p&&i.push("codicon-modifier-"+p.substring(1)),i}R.asClassNameArray=w;function h(m){return w(m).join(" ")}R.asClassName=h;function O(m){return"."+w(m).join(".")}R.asCSSSelector=O;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||P.isThemeColor(m.color))}R.isThemeIcon=D;const f=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(m){const y=f.exec(m);if(!y)return;const[,T]=y;return{id:T}}R.fromString=b;function g(m){return{id:m}}R.fromId=g;function d(m,y){let T=m.id;const p=T.lastIndexOf("~");return p!==-1&&(T=T.substring(0,p)),y&&(T=`${T}~${y}`),{id:T}}R.modify=d;function t(m){const y=m.id.lastIndexOf("~");if(y!==-1)return m.id.substring(y+1)}R.getModifier=t;function a(m,y){return m.id===y.id&&m.color?.id===y.color?.id}R.isEqual=a})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ae[35],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(C){return n.test(C)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(A){for(let w=0;w<A.length;w++)A[w]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,h="";return h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+="-",h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h+=R[M[w++]],h}}()}),define(Ae[118],Re([1,0,16,35]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function C(A){return{id:(0,P.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=C;function M(A,w,h){return{id:(0,P.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:w,data:h}),value:void 0}}e.createFileDataTransferItem=M;class R{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,h){const O=this.a.get(w);O?O.push(h):this.a.set(this.b(w),[h])}replace(w,h){this.a.set(this.b(w),[h])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,h]of this.a.entries())for(const O of h)yield[w,O]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[h,O]of this.entries())w(O,h)}b(w){return w.toLowerCase()}}e.VSDataTransfer=R,e.UriList=Object.freeze({create:A=>(0,n.distinct)(A.map(w=>w.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(w=>!w.startsWith("#"))})}),define(Ae[119],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[120],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class P{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let w=0,h=A.notIn.length;w<h;w++)switch(A.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,w){if(A.getTokenCount()===0)return!0;const h=A.findTokenIndexAtOffset(w-2),O=A.getStandardTokenType(h);return this.isOK(O)}g(A,w){for(let h=A;h<=w;h++){const O=String.fromCharCode(h);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=P;class C{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of A)M(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),M(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),M(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),M(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&M(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=C;function M(R,A,w){R.has(A)?R.get(A).push(w):R.set(A,[w])}}),define(Ae[121],Re([11,12]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ae[122],Re([11,12]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ae[123],Re([1,0,122]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,C=P*60,M=C*24,R=M*7,A=M*30,w=M*365;function h(D,f,b,g){typeof D!="number"&&(D=D.getTime());const d=Math.round((new Date().getTime()-D)/1e3);if(d<-30)return(0,n.localize)(0,null,h(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,n.localize)(1,null);let t;return d<P?(t=d,f?t===1?b?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):b?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?b?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):b?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):d<C?(t=Math.floor(d/P),f?t===1?b?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):b?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?b?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):b?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):d<M?(t=Math.floor(d/C),f?t===1?b?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):b?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?b?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):b?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):d<R?(t=Math.floor(d/M),f?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):d<A?(t=Math.floor(d/R),f?t===1?b?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):b?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?b?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):b?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):d<w?(t=Math.floor(d/A),f?t===1?b?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):b?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?b?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):b?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(d/w),f?t===1?b?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):b?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?b?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):b?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=h;function O(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ae[124],Re([11,12]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ae[40],Re([1,0,16,9,124]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(D,f){return f&&(D.stack||D.stacktrace)?C.localize(0,null,A(D),R(D.stack)||R(D.stacktrace)):A(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function A(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function w(D=null,f=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const b=n.coalesce(D),g=w(b[0],f);return b.length>1?C.localize(4,null,g,b.length):g}if(P.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,f);if(b.exception)return M(b.exception,f)}return D.stack?M(D,f):D.message?D.message:C.localize(5,null)}e.toErrorMessage=w;function h(D){const f=D;return f instanceof Error&&Array.isArray(f.actions)}e.isErrorWithActions=h;function O(D,f){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=f,b}e.createErrorWithActions=O}),define(Ae[125],Re([1,0,86,19]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new n.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,v,S=!1){const E=u||"",W=v||"",X=C.value.collator.compare(E,W);return C.value.collatorIsNumeric&&X===0&&E!==W?E<W?-1:1:X}e.compareFileNames=A;function w(u,v){const S=M.value.collator;return u=u||"",v=v||"",T(S,u,v)}e.compareFileNamesDefault=w;function h(u,v){const S=M.value.collator;return u=u||"",v=v||"",r(u,v)||T(S,u,v)}e.compareFileNamesUpper=h;function O(u,v){const S=M.value.collator;return u=u||"",v=v||"",l(u,v)||T(S,u,v)}e.compareFileNamesLower=O;function D(u,v){return u=u||"",v=v||"",u===v?0:u<v?-1:1}e.compareFileNamesUnicode=D;function f(u,v){const[S,E]=m(u),[W,X]=m(v);let Y=C.value.collator.compare(E,X);if(Y===0){if(C.value.collatorIsNumeric&&E!==X)return E<X?-1:1;if(Y=C.value.collator.compare(S,W),C.value.collatorIsNumeric&&Y===0&&S!==W)return S<W?-1:1}return Y}e.compareFileExtensions=f;function b(u,v){u=u||"",v=v||"";const S=y(u),E=y(v),W=M.value.collator,X=R.value.collator;return T(X,S,E)||T(W,u,v)}e.compareFileExtensionsDefault=b;function g(u,v){u=u||"",v=v||"";const S=y(u),E=y(v),W=M.value.collator,X=R.value.collator;return T(X,S,E)||r(u,v)||T(W,u,v)}e.compareFileExtensionsUpper=g;function d(u,v){u=u||"",v=v||"";const S=y(u),E=y(v),W=M.value.collator,X=R.value.collator;return T(X,S,E)||l(u,v)||T(W,u,v)}e.compareFileExtensionsLower=d;function t(u,v){u=u||"",v=v||"";const S=y(u).toLowerCase(),E=y(v).toLowerCase();return S!==E?S<E?-1:1:u!==v?u<v?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function m(u,v=!1){const S=u?a.exec(u):[];let E=[S&&S[1]||"",S&&S[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function y(u){const v=u?a.exec(u):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function T(u,v,S){const E=u.compare(v,S);return E!==0?E:v.length!==S.length?v.length<S.length?-1:1:0}function p(u){const v=u.charAt(0);return v.toLocaleUpperCase()!==v}function i(u){const v=u.charAt(0);return v.toLocaleLowerCase()!==v}function l(u,v){return p(u)&&i(v)?-1:i(u)&&p(v)?1:0}function r(u,v){return i(u)&&p(v)?-1:p(u)&&i(v)?1:0}function c(u,v,S=!1){return S||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase()),u===v?0:u<v?-1:1}function o(u,v,S=!1){const E=u.split(P.sep),W=v.split(P.sep),X=E.length-1,Y=W.length-1;let J,j;for(let U=0;;U++){if(J=X===U,j=Y===U,J&&j)return A(E[U],W[U],S);if(J)return-1;if(j)return 1;const $=c(E[U],W[U],S);if($!==0)return $}}e.comparePaths=o;function I(u,v,S){const E=u.toLowerCase(),W=v.toLowerCase(),X=s(u,v,S);if(X)return X;const Y=E.endsWith(S),J=W.endsWith(S);if(Y!==J)return Y?-1:1;const j=A(E,W);return j!==0?j:E.localeCompare(W)}e.compareAnything=I;function s(u,v,S){const E=u.toLowerCase(),W=v.toLowerCase(),X=E.startsWith(S),Y=W.startsWith(S);if(X!==Y)return X?-1:1;if(X&&Y){if(E.length<W.length)return-1;if(E.length>W.length)return 1}return 0}e.compareByPrefix=s}),define(Ae[65],Re([1,0,19]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const D=(0,n.extname)(O),f=P[D.toLowerCase()];return f!==void 0?f:R(O)}e.getMediaOrTextMime=M;function R(O){const D=(0,n.extname)(O);return C[D.toLowerCase()]}e.getMediaMime=R;function A(O){for(const D in C)if(C[D]===O)return D}e.getExtensionForMimeType=A;const w=/^(.+)\/(.+?)(;.+)?$/;function h(O,D){const f=w.exec(O);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:D?void 0:O}e.normalizeMimeType=h}),define(Ae[126],Re([1,0,5,6,121]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends P.Disposable{constructor(f,b="",g="",d=!0,t){super(),this.h=this.D(new n.Emitter),this.onDidChange=this.h.event,this.u=!0,this.j=f,this.m=b,this.q=g,this.u=d,this.z=t}get id(){return this.j}get label(){return this.m}set label(f){this.C(f)}C(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.q}set class(f){this.G(f)}G(f){this.q!==f&&(this.q=f,this.h.fire({class:f}))}get enabled(){return this.u}set enabled(f){this.H(f)}H(f){this.u!==f&&(this.u=f,this.h.fire({enabled:f}))}get checked(){return this.w}set checked(f){this.I(f)}I(f){this.w!==f&&(this.w=f,this.h.fire({checked:f}))}async run(f,b){this.z&&await this.z(f)}}e.Action=M;class R extends P.Disposable{constructor(){super(...arguments),this.f=this.D(new n.Emitter),this.onWillRun=this.f.event,this.h=this.D(new n.Emitter),this.onDidRun=this.h.event}async run(f,b){if(!f.enabled)return;this.f.fire({action:f});let g;try{await this.k(f,b)}catch(d){g=d}this.h.fire({action:f,error:g})}async k(f,b){await f.run(b)}}e.ActionRunner=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let b=[];for(const g of f)g.length&&(b.length?b=[...b,new A,...g]:b=g);return b}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class w{get actions(){return this.a}constructor(f,b,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=b,this.class=d,this.a=g}async run(){}}e.SubmenuAction=w;class h extends M{constructor(){super(h.ID,C.localize(0,null),void 0,!1)}}h.ID="vs.actions.empty",e.EmptySubmenuAction=h;function O(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.toAction=O}),define(Ae[41],Re([1,0,19,20,13,9]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(o){return o===47||o===92}e.isPathSeparator=R;function A(o){return o.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function w(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function h(o,I=n.posix.sep){if(!o)return"";const s=o.length,u=o.charCodeAt(0);if(R(u)){if(R(o.charCodeAt(1))&&!R(o.charCodeAt(2))){let S=3;const E=S;for(;S<s&&!R(o.charCodeAt(S));S++);if(E!==S&&!R(o.charCodeAt(S+1))){for(S+=1;S<s;S++)if(R(o.charCodeAt(S)))return o.slice(0,S+1).replace(/[\\/]/g,I)}}return I}else if(a(u)&&o.charCodeAt(1)===58)return R(o.charCodeAt(2))?o.slice(0,2)+I:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<s;v++)if(R(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=h;function O(o){if(!P.isWindows||!o||o.length<5)return!1;let I=o.charCodeAt(0);if(I!==92||(I=o.charCodeAt(1),I!==92))return!1;let s=2;const u=s;for(;s<o.length&&(I=o.charCodeAt(s),I!==92);s++);return!(u===s||(I=o.charCodeAt(s+1),isNaN(I)||I===92))}e.isUNC=O;const D=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(o,I=P.isWindows){const s=I?D:f;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||I&&b.test(o)||o==="."||o===".."||I&&o[o.length-1]==="."||I&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=g;function d(o,I,s){const u=o===I;return!s||u?u:!o||!I?!1:(0,C.equalsIgnoreCase)(o,I)}e.isEqual=d;function t(o,I,s,u=n.sep){if(o===I)return!0;if(!o||!I||I.length>o.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(o,I))return!1;if(I.length===o.length)return!0;let S=I.length;return I.charAt(I.length-1)===u&&S--,o.charAt(S)===u}return I.charAt(I.length-1)!==u&&(I+=u),o.indexOf(I)===0}e.isEqualOrParent=t;function a(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=a;function m(o,I){return P.isWindows&&o.endsWith(":")&&(o+=n.sep),(0,n.isAbsolute)(o)||(o=(0,n.join)(I,o)),o=(0,n.normalize)(o),P.isWindows?(o=(0,C.rtrim)(o,n.sep),o.endsWith(":")&&(o+=n.sep)):(o=(0,C.rtrim)(o,n.sep),o||(o=n.sep)),o}e.sanitizeFilePath=m;function y(o){const I=(0,n.normalize)(o);return P.isWindows?o.length>3?!1:T(I)&&(o.length===2||I.charCodeAt(2)===92):I===n.posix.sep}e.isRootOrDriveLetter=y;function T(o,I=P.isWindows){return I?a(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=T;function p(o){return T(o)?o[0]:void 0}e.getDriveLetter=p;function i(o,I,s){return I.length>o.length?-1:o===I?0:(s&&(o=o.toLowerCase(),I=I.toLowerCase()),o.indexOf(I))}e.indexOfPath=i;function l(o){const I=o.split(":");let s,u,v;for(const S of I){const E=Number(S);(0,M.isNumber)(E)?u===void 0?u=E:v===void 0&&(v=E):s=s?[s,S].join(":"):S}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(o,I,s=8){let u="";for(let S=0;S<s;S++)u+=r.charAt(Math.floor(Math.random()*r.length));let v;return I?v=`${I}-${u}`:v=u,o?(0,n.join)(o,v):v}e.randomPath=c}),define(Ae[127],Re([1,0,28,13]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(k,F){for(let H=0,x=Z.length;H<x;H++){const te=Z[H](k,F);if(te)return te}return null}}e.or=C,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,k,F){if(!F||F.length<k.length)return null;let H;return Z?H=P.startsWithIgnoreCase(F,k):H=F.indexOf(k)===0,H?k.length>0?[{start:0,end:k.length}]:[]:null}function R(Z,k){const F=k.toLowerCase().indexOf(Z.toLowerCase());return F===-1?null:[{start:F,end:F+Z.length}]}e.matchesContiguousSubString=R;function A(Z,k){return w(Z.toLowerCase(),k.toLowerCase(),0,0)}e.matchesSubString=A;function w(Z,k,F,H){if(F===Z.length)return[];if(H===k.length)return null;if(Z[F]===k[H]){let x=null;return(x=w(Z,k,F+1,H+1))?a({start:H,end:H+1},x):null}return w(Z,k,F,H+1)}function h(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function D(Z){return 48<=Z&&Z<=57}function f(Z){return Z===32||Z===9||Z===10||Z===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>b.add(Z.charCodeAt(0)));function g(Z){return f(Z)||b.has(Z)}function d(Z,k){return Z===k||g(Z)&&g(k)}function t(Z){return h(Z)||O(Z)||D(Z)}function a(Z,k){return k.length===0?k=[Z]:Z.end===k[0].start?k[0].start=Z.start:k.unshift(Z),k}function m(Z,k){for(let F=k;F<Z.length;F++){const H=Z.charCodeAt(F);if(O(H)||D(H)||F>0&&!t(Z.charCodeAt(F-1)))return F}return Z.length}function y(Z,k,F,H){if(F===Z.length)return[];if(H===k.length)return null;if(Z[F]!==k[H].toLowerCase())return null;{let x=null,te=H+1;for(x=y(Z,k,F+1,H+1);!x&&(te=m(k,te))<k.length;)x=y(Z,k,F+1,te),te++;return x===null?null:a({start:H,end:H+1},x)}}function T(Z){let k=0,F=0,H=0,x=0,te=0;for(let Se=0;Se<Z.length;Se++)te=Z.charCodeAt(Se),O(te)&&k++,h(te)&&F++,t(te)&&H++,D(te)&&x++;const pe=k/Z.length,ke=F/Z.length,ue=H/Z.length,De=x/Z.length;return{upperPercent:pe,lowerPercent:ke,alphaPercent:ue,numericPercent:De}}function p(Z){const{upperPercent:k,lowerPercent:F}=Z;return F===0&&k>.6}function i(Z){const{upperPercent:k,lowerPercent:F,alphaPercent:H,numericPercent:x}=Z;return F>.2&&k<.8&&H>.6&&x<.2}function l(Z){let k=0,F=0,H=0,x=0;for(let te=0;te<Z.length;te++)H=Z.charCodeAt(te),O(H)&&k++,h(H)&&F++,f(H)&&x++;return(k===0||F===0)&&x===0?Z.length<=30:k<=5}function r(Z,k){if(!k||(k=k.trim(),k.length===0)||!l(Z)||k.length>60)return null;const F=T(k);if(!i(F)){if(!p(F))return null;k=k.toLowerCase()}let H=null,x=0;for(Z=Z.toLowerCase();x<k.length&&(H=y(Z,k,0,x))===null;)x=m(k,x+1);return H}e.matchesCamelCase=r;function c(Z,k,F=!1){if(!k||k.length===0)return null;let H=null,x=0;for(Z=Z.toLowerCase(),k=k.toLowerCase();x<k.length&&(H=o(Z,k,0,x,F))===null;)x=I(k,x+1);return H}e.matchesWords=c;function o(Z,k,F,H,x){if(F===Z.length)return[];if(H===k.length)return null;if(d(Z.charCodeAt(F),k.charCodeAt(H))){let te=null,pe=H+1;if(te=o(Z,k,F+1,H+1,x),!x)for(;!te&&(pe=I(k,pe))<k.length;)te=o(Z,k,F+1,pe,x),pe++;return te?Z.charCodeAt(F)!==k.charCodeAt(H)?te:a({start:H,end:H+1},te):null}else return null}function I(Z,k){for(let F=k;F<Z.length;F++)if(g(Z.charCodeAt(F))||F>0&&g(Z.charCodeAt(F-1)))return F;return Z.length}const s=C(e.matchesPrefix,r,R),u=C(e.matchesPrefix,r,A),v=new n.LRUCache(1e4);function S(Z,k,F=!1){if(typeof Z!="string"||typeof k!="string")return null;let H=v.get(Z);H||(H=new RegExp(P.convertSimple2RegExpPattern(Z),"i"),v.set(Z,H));const x=H.exec(k);return x?[{start:x.index,end:x.index+x[0].length}]:F?u(Z,k):s(Z,k)}e.matchesFuzzy=S;function E(Z,k){const F=me(Z,Z.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?X(F):null}e.matchesFuzzy2=E;function W(Z,k,F,H,x,te){const pe=Math.min(13,Z.length);for(;F<pe;F++){const ke=me(Z,k,F,H,x,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,te]}e.anyScore=W;function X(Z){if(typeof Z>"u")return[];const k=[],F=Z[1];for(let H=Z.length-1;H>1;H--){const x=Z[H]+F,te=k[k.length-1];te&&te.end===x?te.end=x+1:k.push({start:x,end:x+1})}return k}e.createMatches=X;const Y=128;function J(){const Z=[],k=[];for(let F=0;F<=Y;F++)k[F]=0;for(let F=0;F<=Y;F++)Z.push(k.slice(0));return Z}function j(Z){const k=[];for(let F=0;F<=Z;F++)k[F]=0;return k}const U=j(2*Y),$=j(2*Y),B=J(),q=J(),he=J(),Ee=!1;function ie(Z,k,F,H,x){function te(ke,ue,De=" "){for(;ke.length<ue;)ke=De+ke;return ke}let pe=` |   |${H.split("").map(ke=>te(ke,3)).join("|")}
`;for(let ke=0;ke<=F;ke++)ke===0?pe+=" |":pe+=`${k[ke-1]}|`,pe+=Z[ke].slice(0,x+1).map(ue=>te(ue.toString(),3)).join("|")+`
`;return pe}function ce(Z,k,F,H){Z=Z.substr(k),F=F.substr(H),console.log(ie(q,Z,Z.length,F,F.length)),console.log(ie(he,Z,Z.length,F,F.length)),console.log(ie(B,Z,Z.length,F,F.length))}function de(Z,k){if(k<0||k>=Z.length)return!1;const F=Z.codePointAt(k);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(F)}}function Te(Z,k){if(k<0||k>=Z.length)return!1;switch(Z.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function le(Z,k,F){return k[Z]!==F[Z]}function re(Z,k,F,H,x,te,pe=!1){for(;k<F&&x<te;)Z[k]===H[x]&&(pe&&(U[k]=x),k+=1),x+=1;return k===F}e.isPatternInWord=re;var V;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(V||(V={}));var L;(function(Z){Z.Default=[-100,0];function k(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}Z.isDefault=k})(L=e.FuzzyScore||(e.FuzzyScore={}));class K{constructor(k,F){this.firstMatchCanBeWeak=k,this.boostFullMatch=F}}K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=K;function me(Z,k,F,H,x,te,pe=K.default){const ke=Z.length>Y?Y:Z.length,ue=H.length>Y?Y:H.length;if(F>=ke||te>=ue||ke-F>ue-te||!re(k,F,ke,x,te,ue,!0))return;Ie(ke,ue,F,te,k,x);let De=1,Se=1,$e=F,He=te;const et=[!1];for(De=1,$e=F;$e<ke;De++,$e++){const it=U[$e],Q=$[$e],_=$e+1<ke?$[$e+1]:ue;for(Se=it-te+1,He=it;He<_;Se++,He++){let be=Number.MIN_SAFE_INTEGER,We=!1;He<=Q&&(be=we(Z,k,$e,F,H,x,He,ue,te,B[De-1][Se-1]===0,et));let ze=0;be!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=be+q[De-1][Se-1]);const Qe=He>it,Ye=Qe?q[De][Se-1]+(B[De][Se-1]>0?-5:0):0,Ge=He>it+1&&B[De][Se-1]>0,at=Ge?q[De][Se-2]+(B[De][Se-2]>0?-5:0):0;if(Ge&&(!Qe||at>=Ye)&&(!We||at>=ze))q[De][Se]=at,he[De][Se]=3,B[De][Se]=0;else if(Qe&&(!We||Ye>=ze))q[De][Se]=Ye,he[De][Se]=2,B[De][Se]=0;else if(We)q[De][Se]=ze,he[De][Se]=1,B[De][Se]=B[De-1][Se-1]+1;else throw new Error("not possible")}}if(Ee&&ce(Z,F,H,te),!et[0]&&!pe.firstMatchCanBeWeak)return;De--,Se--;const Xe=[q[De][Se],te];let tt=0,rt=0;for(;De>=1;){let it=Se;do{const Q=he[De][it];if(Q===3)it=it-2;else if(Q===2)it=it-1;else break}while(it>=1);tt>1&&k[F+De-1]===x[te+Se-1]&&!le(it+te-1,H,x)&&tt+1>B[De][it]&&(it=Se),it===Se?tt++:tt=1,rt||(rt=it),De--,Se=it-1,Xe.push(Se)}ue===ke&&pe.boostFullMatch&&(Xe[0]+=2);const Me=rt-ke;return Xe[0]-=Me,Xe}e.fuzzyScore=me;function Ie(Z,k,F,H,x,te){let pe=Z-1,ke=k-1;for(;pe>=F&&ke>=H;)x[pe]===te[ke]&&($[pe]=ke,pe--),ke--}function we(Z,k,F,H,x,te,pe,ke,ue,De,Se){if(k[F]!==te[pe])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return pe===F-H?$e=Z[F]===x[pe]?7:5:le(pe,x,te)&&(pe===0||!le(pe-1,x,te))?($e=Z[F]===x[pe]?7:5,He=!0):de(te,pe)&&(pe===0||!de(te,pe-1))?$e=5:(de(te,pe-1)||Te(te,pe-1))&&($e=5,He=!0),$e>1&&F===H&&(Se[0]=!0),He||(He=le(pe,x,te)||de(te,pe-1)||Te(te,pe-1)),F===H?pe>ue&&($e-=He?3:5):De?$e+=He?2:0:$e+=He?0:1,pe+1===ke&&($e-=He?3:5),$e}function ve(Z,k,F,H,x,te,pe){return se(Z,k,F,H,x,te,!0,pe)}e.fuzzyScoreGracefulAggressive=ve;function Ce(Z,k,F,H,x,te,pe){return se(Z,k,F,H,x,te,!1,pe)}e.fuzzyScoreGraceful=Ce;function se(Z,k,F,H,x,te,pe,ke){let ue=me(Z,k,F,H,x,te,ke);if(ue&&!pe)return ue;if(Z.length>=3){const De=Math.min(7,Z.length-1);for(let Se=F+1;Se<De;Se++){const $e=ae(Z,Se);if($e){const He=me($e,$e.toLowerCase(),F,H,x,te,ke);He&&(He[0]-=3,(!ue||He[0]>ue[0])&&(ue=He))}}}return ue}function ae(Z,k){if(k+1>=Z.length)return;const F=Z[k],H=Z[k+1];if(F!==H)return Z.slice(0,k)+H+F+Z.slice(k+2)}}),define(Ae[128],Re([1,0,127,13,39]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function w(a){return a.replace(A,(m,y)=>y?m:`\\${m}`)}e.escapeIcons=w;const h=new RegExp(`\\\\${R.source}`,"g");function O(a){return a.replace(h,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=O;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function f(a){return a.indexOf(M)===-1?a:a.replace(D,(m,y,T,p)=>T?m:y||p||"")}e.stripIcons=f;function b(a){return a?a.replace(/\$\((.*?)\)/g,(m,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=b;const g=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){g.lastIndex=0;let m="";const y=[];let T=0;for(;;){const p=g.lastIndex,i=g.exec(a),l=a.substring(p,i?.index);if(l.length>0){m+=l;for(let r=0;r<l.length;r++)y.push(T)}if(!i)break;T+=i[0].length}return{text:m,iconOffsets:y}}e.parseLabelWithIcons=d;function t(a,m,y=!1){const{text:T,iconOffsets:p}=m;if(!p||p.length===0)return(0,n.matchesFuzzy)(a,T,y);const i=(0,P.ltrim)(T," "),l=T.length-i.length,r=(0,n.matchesFuzzy)(a,i,y);if(r)for(const c of r){const o=p[c.start+l]+l;c.start+=o,c.end+=o}return r}e.matchesFuzzyIconAware=t}),define(Ae[29],Re([1,0,13]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(P||(P={})),function(C){const M="error",R="warning",A="warn",w="info",h="ignore";function O(f){return f?n.equalsIgnoreCase(M,f)?C.Error:n.equalsIgnoreCase(R,f)||n.equalsIgnoreCase(A,f)?C.Warning:n.equalsIgnoreCase(w,f)?C.Info:C.Ignore:C.Ignore}C.fromValue=O;function D(f){switch(f){case C.Error:return M;case C.Warning:return R;case C.Info:return w;default:return h}}C.toString=D}(P||(P={})),e.default=P}),define(Ae[48],Re([1,0,16,13]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const g=b.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.StringIterator=C;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,P.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,P.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class R{constructor(b=!0,g=!0){this.f=b,this.g=g}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let g=b.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,P.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,P.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var A;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(b,g){this.f=b,this.g=g,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,P.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,P.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,P.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,P.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(O||(O={}));class D{static forUris(b=()=>!1,g=()=>!1){return new D(new w(b,g))}static forPaths(b=!1){return new D(new R(void 0,!b))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,g){if(g){const d=g.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t,b)}else{const d=b.slice(0);(0,n.shuffle)(d);for(const t of d)this.set(t[0],t[1])}}set(b,g){const d=this.b.reset(b);let t;this.c||(this.c=new h,this.c.segment=d.value());const a=[];for(t=this.c;;){const y=d.cmp(t.segment);if(y>0)t.left||(t.left=new h,t.left.segment=d.value()),a.push([-1,t]),t=t.left;else if(y<0)t.right||(t.right=new h,t.right.segment=d.value()),a.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new h,t.mid.segment=d.value()),a.push([0,t]),t=t.mid;else break}const m=t.value;t.value=g,t.key=b;for(let y=a.length-1;y>=0;y--){const T=a[y][1];T.updateHeight();const p=T.balanceFactor();if(p<-1||p>1){const i=a[y][0],l=a[y+1][0];if(i===1&&l===1)a[y][1]=T.rotateLeft();else if(i===-1&&l===-1)a[y][1]=T.rotateRight();else if(i===1&&l===-1)T.right=a[y+1][1]=a[y+1][1].rotateRight(),a[y][1]=T.rotateLeft();else if(i===-1&&l===1)T.left=a[y+1][1]=a[y+1][1].rotateLeft(),a[y][1]=T.rotateRight();else throw new Error;if(y>0)switch(a[y-1][0]){case-1:a[y-1][1].left=a[y][1];break;case 1:a[y-1][1].right=a[y][1];break;case 0:a[y-1][1].mid=a[y][1];break}else this.c=a[0][1]}}return m}get(b){return this.d(b)?.value}d(b){const g=this.b.reset(b);let d=this.c;for(;d;){const t=g.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(b){const g=this.d(b);return!(g?.value===void 0&&g?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,g){const d=this.b.reset(b),t=[];let a=this.c;for(;a;){const m=d.cmp(a.segment);if(m>0)t.push([-1,a]),a=a.left;else if(m<0)t.push([1,a]),a=a.right;else if(d.hasNext())d.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(g?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const m=this.f(a.right);if(m.key){const{key:y,value:T,segment:p}=m;this.e(m.key,!1),a.key=y,a.value=T,a.segment=p}}else{const m=a.left??a.right;if(t.length>0){const[y,T]=t[t.length-1];switch(y){case-1:T.left=m;break;case 0:T.mid=m;break;case 1:T.right=m;break}}else this.c=m}for(let m=t.length-1;m>=0;m--){const y=t[m][1];y.updateHeight();const T=y.balanceFactor();if(T>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),t[m][1]=y.rotateLeft()):T<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),t[m][1]=y.rotateRight()),m>0)switch(t[m-1][0]){case-1:t[m-1][1].left=t[m][1];break;case 1:t[m-1][1].right=t[m][1];break;case 0:t[m-1][1].mid=t[m][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const g=this.b.reset(b);let d=this.c,t;for(;d;){const a=g.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(g.hasNext())g.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(b){return this.g(b,!1)}g(b,g){const d=this.b.reset(b);let t=this.c;for(;t;){const a=d.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):g?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[g,d]of this)b(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const g=[];return this.j(b,g),g[Symbol.iterator]()}j(b,g){!b||(b.left&&this.j(b.left,g),b.value&&g.push([b.key,b.value]),b.mid&&this.j(b.mid,g),b.right&&this.j(b.right,g))}_isBalanced(){const b=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:b(g.left)&&b(g.right)};return b(this.c)}}e.TernarySearchTree=D}),define(Ae[66],Re([1,0,25,13,2]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(h){return JSON.stringify(h,A)}e.stringify=M;function R(h){let O=JSON.parse(h);return O=w(O),O}e.parse=R;function A(h,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,P.regExpFlags)(O)}:O}function w(h,O=0){if(!h||O>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let D=0;D<h.length;++D)h[D]=w(h[D],O+1);else for(const D in h)Object.hasOwnProperty.call(h,D)&&(h[D]=w(h[D],O+1))}return h}e.revive=w}),define(Ae[15],Re([1,0,10,20,2]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${M.vscodeRemoteResource}`}set(O,D,f){this.a[O]=D,this.b[O]=f}setConnectionToken(O,D){this.c[O]=D}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(t){return n.onUnexpectedError(t),O}const D=O.authority;let f=this.a[D];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const b=this.b[D],g=this.c[D];let d=`path=${encodeURIComponent(O.path)}`;return typeof g=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),C.URI.from({scheme:P.isWeb?this.d:M.vscodeRemoteResource,authority:`${f}:${b}`,path:this.f,query:d})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const D=this.b(O,ee);return this.uriToBrowserUri(D)}uriToBrowserUri(O){return O.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===M.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${M.vscodeFileResource}://${A.a}`)?O.with({scheme:M.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const D=this.b(O,ee);return this.uriToFileUri(D)}uriToFileUri(O){return O.scheme===M.vscodeFileResource?O.with({scheme:M.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,D){return C.URI.isUri(O)?O:C.URI.parse(D.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var w;(function(h){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(O.get("3"));const D="vscode-coi";function f(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:C.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const t=d?.get(D);if(!!t)return O.get(t)}h.getHeadersFromQuery=f;function b(g,d,t){if(!globalThis.crossOriginIsolated)return;const a=d&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(D,a):g[D]=a}h.addSearchParam=b})(w=e.COI||(e.COI={}))}),define(Ae[22],Re([1,0,41,15,19,20,13,2]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=w;class h{constructor(g){this.a=g}compare(g,d,t=!1){return g===d?0:(0,R.compare)(this.getComparisonKey(g,t),this.getComparisonKey(d,t))}isEqual(g,d,t=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,t)===this.getComparisonKey(d,t)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,t=!1){if(g.scheme===d.scheme){if(g.scheme===P.Schemas.file)return n.isEqualOrParent(w(g),w(d),this.a(g))&&g.query===d.query&&(t||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return n.isEqualOrParent(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(t||g.fragment===d.fragment)}return!1}joinPath(g,...d){return A.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return C.posix.basename(g.path)}extname(g){return C.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===P.Schemas.file?d=A.URI.file(C.dirname(w(g))).path:(d=C.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===P.Schemas.file?d=A.URI.file(C.normalize(w(g))).path:d=C.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===P.Schemas.file){const m=C.relative(w(g),w(d));return M.isWindows?n.toSlashes(m):m}let t=g.path||"/";const a=d.path||"/";if(this.a(g)){let m=0;for(const y=Math.min(t.length,a.length);m<y&&!(t.charCodeAt(m)!==a.charCodeAt(m)&&t.charAt(m).toLowerCase()!==a.charAt(m).toLowerCase());m++);t=a.substr(0,m)+t.substr(m)}return C.posix.relative(t,a)}resolvePath(g,d){if(g.scheme===P.Schemas.file){const t=A.URI.file(C.resolve(w(g),d));return g.with({authority:t.authority,path:t.path})}return d=n.toPosixPath(d),g.with({path:C.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,R.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=C.sep){if(g.scheme===P.Schemas.file){const t=w(g);return t.length>n.getRoot(t).length&&t[t.length-1]===d}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=C.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=C.sep){let t=!1;if(g.scheme===P.Schemas.file){const a=w(g);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===d}else{d="/";const a=g.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(b=>b.scheme===P.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new h(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,g){const d=[];for(let t=0;t<b.length;t++){const a=g(b[t]);b.some((m,y)=>y===t?!1:(0,e.isEqualOrParent)(a,g(m)))||d.push(b[t])}return d}e.distinctParents=O;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(y=>{const[T,p]=y.split(":");T&&p&&t.set(T,p)});const m=d.path.substring(0,d.path.indexOf(";"));return m&&t.set(b.META_DATA_MIME,m),t}b.parseMetaData=g})(D=e.DataUri||(e.DataUri={}));function f(b,g,d){if(g){let t=b.path;return t&&t[0]!==C.posix.sep&&(t=C.posix.sep+t),b.with({scheme:d,authority:g,path:t})}return b.with({scheme:d})}e.toLocalResource=f}),define(Ae[17],Re([1,0,21,10,5,6,22,20,117]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(re){return!!re&&typeof re.then=="function"}e.isThenable=h;function O(re){const V=new n.CancellationTokenSource,L=re(V.token),K=new Promise((me,Ie)=>{const we=V.token.onCancellationRequested(()=>{we.dispose(),V.dispose(),Ie(new P.CancellationError)});Promise.resolve(L).then(ve=>{we.dispose(),V.dispose(),me(ve)},ve=>{we.dispose(),V.dispose(),Ie(ve)})});return new class{cancel(){V.cancel()}then(me,Ie){return K.then(me,Ie)}catch(me){return this.then(void 0,me)}finally(me){return K.finally(me)}}}e.createCancelablePromise=O;function D(re,V,L){return new Promise((K,me)=>{const Ie=V.onCancellationRequested(()=>{Ie.dispose(),K(L)});re.then(K,me).finally(()=>Ie.dispose())})}e.raceCancellation=D;function f(re,V){return new Promise((L,K)=>{const me=V.onCancellationRequested(()=>{me.dispose(),K(new P.CancellationError)});re.then(L,K).finally(()=>me.dispose())})}e.raceCancellationError=f;async function b(re){let V=-1;const L=re.map((me,Ie)=>me.then(we=>(V=Ie,we))),K=await Promise.race(L);return re.forEach((me,Ie)=>{Ie!==V&&me.cancel()}),K}e.raceCancellablePromises=b;function g(re,V,L){let K;const me=setTimeout(()=>{K?.(void 0),L?.()},V);return Promise.race([re.finally(()=>clearTimeout(me)),new Promise(Ie=>K=Ie)])}e.raceTimeout=g;function d(re){return new Promise((V,L)=>{const K=re();h(K)?K.then(V,L):V(K)})}e.asPromise=d;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(V){if(this.a){if(this.d=V,!this.b){const L=()=>{this.b=null;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(L,L).then(K)})}return new Promise((L,K)=>{this.b.then(L,K)})}return this.a=V(),new Promise((L,K)=>{this.a.then(me=>{this.a=null,L(me)},me=>{this.a=null,K(me)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.Sequencer=a;class m{constructor(){this.a=new Map}queue(V,L){const me=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(L).finally(()=>{this.a.get(V)===me&&this.a.delete(V)});return this.a.set(V,me),me}}e.SequencerByKey=m;const y=(re,V)=>{let L=!0;const K=setTimeout(()=>{L=!1,V()},re);return{isTriggered:()=>L,dispose:()=>{clearTimeout(K),L=!1}}},T=re=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,re())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class p{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,L=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((me,Ie)=>{this.d=me,this.f=Ie}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=L===w.MicrotaskDelay?T(K):y(L,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(V){this.a=new p(V),this.b=new t}trigger(V,L){return this.a.trigger(()=>this.b.queue(V),L)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class l{constructor(){this.a=!1,this.b=new Promise((V,L)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=l;class r extends l{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(re,V){return V?new Promise((L,K)=>{const me=setTimeout(()=>{Ie.dispose(),L()},re),Ie=V.onCancellationRequested(()=>{clearTimeout(me),Ie.dispose(),K(new P.CancellationError)})}):O(L=>c(re,L))}e.timeout=c;function o(re,V=0){const L=setTimeout(re,V);return(0,M.toDisposable)(()=>clearTimeout(L))}e.disposableTimeout=o;function I(re){const V=[];let L=0;const K=re.length;function me(){return L<K?re[L++]():null}function Ie(we){we!=null&&V.push(we);const ve=me();return ve?ve.then(Ie):Promise.resolve(V)}return Promise.resolve(null).then(Ie)}e.sequence=I;function s(re,V=K=>!!K,L=null){let K=0;const me=re.length,Ie=()=>{if(K>=me)return Promise.resolve(L);const we=re[K++];return Promise.resolve(we()).then(Ce=>V(Ce)?Promise.resolve(Ce):Ie())};return Ie()}e.first=s;function u(re,V=K=>!!K,L=null){if(re.length===0)return Promise.resolve(L);let K=re.length;const me=()=>{K=-1;for(const Ie of re)Ie.cancel?.()};return new Promise((Ie,we)=>{for(const ve of re)ve.then(Ce=>{--K>=0&&V(Ce)?(me(),Ie(Ce)):K===0&&Ie(L)}).catch(Ce=>{--K>=0&&(me(),we(Ce))})})}e.firstParallel=u;class v{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((L,K)=>{this.f.push({factory:V,c:L,e:K}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const L=V.factory();L.then(V.c,V.e),L.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=v;class S extends v{constructor(){super(1)}}e.Queue=S;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const V=new Ee;return this.b.add(V),V.p}d(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,L=R.extUri){const K=L.getComparisonKey(V);let me=this.a.get(K);return me||(me=new S,C.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(K),this.f()}),this.a.set(K,me)),me}f(){!this.d()||this.g()}g(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class W{constructor(V,L){this.a=-1,typeof V=="function"&&typeof L=="number"&&this.setIfNotSet(V,L)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,L){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},L)}setIfNotSet(V,L){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},L))}}e.TimeoutTimer=W;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,L){this.cancel(),this.a=setInterval(()=>{V()},L)}}e.IntervalTimer=X;class Y{constructor(V,L){this.b=-1,this.a=V,this.d=L,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Y;class J{constructor(V,L){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.a=V,this.b=L,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=J;class j extends Y{constructor(V,L){super(V,L),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=j;class U extends M.Disposable{constructor(V,L){super(),this.g=V,this.h=L,this.a=[],this.b=this.D(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const L of V)this.a.push(L);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,A.setTimeout0)(()=>{if(V)return;const L=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(re,V)=>{const L=requestIdleCallback(re,typeof V=="number"?{timeout:V}:void 0);let K=!1;return{dispose(){K||(K=!0,cancelIdleCallback(L))}}}}();class ${constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(L){this.g=L}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function B(re,V,L){let K;for(let me=0;me<L;me++)try{return await re()}catch(Ie){K=Ie,await c(V)}throw K}e.retry=B;class q{hasPending(V){return this.a?typeof V=="number"?this.a.taskId===V:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(V,L,K){return this.a={taskId:V,cancel:()=>K?.(),promise:L},L.then(()=>this.d(V),()=>this.d(V)),L}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this.b)this.b.run=V;else{let L,K;const me=new Promise((Ie,we)=>{L=Ie,K=we});this.b={run:V,promise:me,promiseResolve:L,promiseReject:K}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=q;class he{constructor(V,L=()=>Date.now()){this.d=V,this.f=L,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.IntervalCounter=he;class Ee{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((V,L)=>{this.a=V,this.b=L})}complete(V){return new Promise(L=>{this.a(V),this.f=!0,L()})}error(V){return new Promise(L=>{this.b(V),this.d=!0,L()})}cancel(){new Promise(V=>{this.b(new P.CancellationError),this.d=!0,V()})}}e.DeferredPromise=Ee;var ie;(function(re){async function V(K){let me;const Ie=await Promise.all(K.map(we=>we.then(ve=>ve,ve=>{me||(me=ve)})));if(typeof me<"u")throw me;return Ie}re.settled=V;function L(K){return new Promise(async(me,Ie)=>{try{await K(me,Ie)}catch(we){Ie(we)}})}re.withAsyncBody=L})(ie=e.Promises||(e.Promises={}));var ce;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ce||(ce={}));class de{static fromArray(V){return new de(L=>{L.emitMany(V)})}static fromPromise(V){return new de(async L=>{L.emitMany(await V)})}static fromPromises(V){return new de(async L=>{await Promise.all(V.map(async K=>L.emitOne(await K)))})}static merge(V){return new de(async L=>{await Promise.all(V.map(async K=>{for await(const me of K)L.emitOne(me)}))})}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const L={emitOne:K=>this.g(K),emitMany:K=>this.h(K),reject:K=>this.k(K)};try{await Promise.resolve(V(L)),this.j()}catch(K){this.k(K)}finally{L.emitOne=void 0,L.emitMany=void 0,L.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(V,L){return new de(async K=>{for await(const me of V)K.emitOne(L(me))})}map(V){return de.map(this,V)}static filter(V,L){return new de(async K=>{for await(const me of V)L(me)&&K.emitOne(me)})}filter(V){return de.filter(this,V)}static coalesce(V){return de.filter(V,L=>!!L)}coalesce(){return de.coalesce(this)}static async toPromise(V){const L=[];for await(const K of V)L.push(K);return L}toPromise(){return de.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}de.EMPTY=de.fromArray([]),e.AsyncIterableObject=de;class Te extends de{constructor(V,L){super(L),this.l=V}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Te;function le(re){const V=new n.CancellationTokenSource,L=re(V.token);return new Te(V,async K=>{const me=V.token.onCancellationRequested(()=>{me.dispose(),V.dispose(),K.reject(new P.CancellationError)});try{for await(const Ie of L){if(V.token.isCancellationRequested)return;K.emitOne(Ie)}me.dispose(),V.dispose()}catch(Ie){me.dispose(),V.dispose(),K.reject(Ie)}})}e.createCancelableAsyncIterable=le}),define(Ae[36],Re([1,0,16,17,41,28,19,20,13]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",D="[^/\\\\]",f=/\//g;function b(he,Ee){switch(he){case 0:return"";case 1:return`${D}*?`;default:return`(?:${O}|${D}+${O}${Ee?`|${O}${D}+`:""})*?`}}function g(he,Ee){if(!he)return[];const ie=[];let ce=!1,de=!1,Te="";for(const le of he){switch(le){case Ee:if(!ce&&!de){ie.push(Te),Te="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":de=!0;break;case"]":de=!1;break}Te+=le}return Te&&ie.push(Te),ie}e.splitGlobAware=g;function d(he){if(!he)return"";let Ee="";const ie=g(he,e.GLOB_SPLIT);if(ie.every(ce=>ce===e.GLOBSTAR))Ee=".*";else{let ce=!1;ie.forEach((de,Te)=>{if(de===e.GLOBSTAR){if(ce)return;Ee+=b(2,Te===ie.length-1)}else{let le=!1,re="",V=!1,L="";for(const K of de){if(K!=="}"&&le){re+=K;continue}if(V&&(K!=="]"||!L)){let me;K==="-"?me=K:(K==="^"||K==="!")&&!L?me="^":K===e.GLOB_SPLIT?me="":me=(0,w.escapeRegExpCharacters)(K),L+=me;continue}switch(K){case"{":le=!0;continue;case"[":V=!0;continue;case"}":{Ee+=`(?:${g(re,",").map(we=>d(we)).join("|")})`,le=!1,re="";break}case"]":{Ee+="["+L+"]",V=!1,L="";break}case"?":Ee+=D;continue;case"*":Ee+=b(1);continue;default:Ee+=(0,w.escapeRegExpCharacters)(K)}}Te<ie.length-1&&(ie[Te+1]!==e.GLOBSTAR||Te+2<ie.length)&&(Ee+=O)}ce=de===e.GLOBSTAR})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,T=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),l=function(){return!1},r=function(){return null};function c(he,Ee){if(!he)return r;let ie;typeof he!="string"?ie=he.pattern:ie=he,ie=ie.trim();const ce=`${ie}_${!!Ee.trimForExclusions}`;let de=i.get(ce);if(de)return o(de,he);let Te;return t.test(ie)?de=s(ie.substr(4),ie):(Te=a.exec(I(ie,Ee)))?de=u(Te[1],ie):(Ee.trimForExclusions?y:m).test(ie)?de=v(ie,Ee):(Te=T.exec(I(ie,Ee)))?de=S(Te[1].substr(1),ie,!0):(Te=p.exec(I(ie,Ee)))?de=S(Te[1],ie,!1):de=E(ie),i.set(ce,de),o(de,he)}function o(he,Ee){if(typeof Ee=="string")return he;const ie=function(ce,de){return(0,C.isEqualOrParent)(ce,Ee.base,!A.isLinux)?he((0,w.ltrim)(ce.substr(Ee.base.length),R.sep),de):null};return ie.allBasenames=he.allBasenames,ie.allPaths=he.allPaths,ie.basenames=he.basenames,ie.patterns=he.patterns,ie}function I(he,Ee){return Ee.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function s(he,Ee){return function(ie,ce){return typeof ie=="string"&&ie.endsWith(he)?Ee:null}}function u(he,Ee){const ie=`/${he}`,ce=`\\${he}`,de=function(le,re){return typeof le!="string"?null:re?re===he?Ee:null:le===he||le.endsWith(ie)||le.endsWith(ce)?Ee:null},Te=[he];return de.basenames=Te,de.patterns=[Ee],de.allBasenames=Te,de}function v(he,Ee){const ie=B(he.slice(1,-1).split(",").map(re=>c(re,Ee)).filter(re=>re!==r),he),ce=ie.length;if(!ce)return r;if(ce===1)return ie[0];const de=function(re,V){for(let L=0,K=ie.length;L<K;L++)if(ie[L](re,V))return he;return null},Te=ie.find(re=>!!re.allBasenames);Te&&(de.allBasenames=Te.allBasenames);const le=ie.reduce((re,V)=>V.allPaths?re.concat(V.allPaths):re,[]);return le.length&&(de.allPaths=le),de}function S(he,Ee,ie){const ce=R.sep===R.posix.sep,de=ce?he:he.replace(f,R.sep),Te=R.sep+de,le=R.posix.sep+he;let re;return ie?re=function(V,L){return typeof V=="string"&&(V===de||V.endsWith(Te)||!ce&&(V===he||V.endsWith(le)))?Ee:null}:re=function(V,L){return typeof V=="string"&&(V===de||!ce&&V===he)?Ee:null},re.allPaths=[(ie?"*/":"./")+he],re}function E(he){try{const Ee=new RegExp(`^${d(he)}$`);return function(ie){return Ee.lastIndex=0,typeof ie=="string"&&Ee.test(ie)?he:null}}catch{return r}}function W(he,Ee,ie){return!he||typeof Ee!="string"?!1:X(he)(Ee,void 0,ie)}e.match=W;function X(he,Ee={}){if(!he)return l;if(typeof he=="string"||Y(he)){const ie=c(he,Ee);if(ie===r)return l;const ce=function(de,Te){return!!ie(de,Te)};return ie.allBasenames&&(ce.allBasenames=ie.allBasenames),ie.allPaths&&(ce.allPaths=ie.allPaths),ce}return U(he,Ee)}e.parse=X;function Y(he){const Ee=he;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.isRelativePattern=Y;function J(he){return he.allBasenames||[]}e.getBasenameTerms=J;function j(he){return he.allPaths||[]}e.getPathTerms=j;function U(he,Ee){const ie=B(Object.getOwnPropertyNames(he).map(re=>$(re,he[re],Ee)).filter(re=>re!==r)),ce=ie.length;if(!ce)return r;if(!ie.some(re=>!!re.requiresSiblings)){if(ce===1)return ie[0];const re=function(K,me){let Ie;for(let we=0,ve=ie.length;we<ve;we++){const Ce=ie[we](K,me);if(typeof Ce=="string")return Ce;(0,P.isThenable)(Ce)&&(Ie||(Ie=[]),Ie.push(Ce))}return Ie?(async()=>{for(const we of Ie){const ve=await we;if(typeof ve=="string")return ve}return null})():null},V=ie.find(K=>!!K.allBasenames);V&&(re.allBasenames=V.allBasenames);const L=ie.reduce((K,me)=>me.allPaths?K.concat(me.allPaths):K,[]);return L.length&&(re.allPaths=L),re}const de=function(re,V,L){let K,me;for(let Ie=0,we=ie.length;Ie<we;Ie++){const ve=ie[Ie];ve.requiresSiblings&&L&&(V||(V=(0,R.basename)(re)),K||(K=V.substr(0,V.length-(0,R.extname)(re).length)));const Ce=ve(re,V,K,L);if(typeof Ce=="string")return Ce;(0,P.isThenable)(Ce)&&(me||(me=[]),me.push(Ce))}return me?(async()=>{for(const Ie of me){const we=await Ie;if(typeof we=="string")return we}return null})():null},Te=ie.find(re=>!!re.allBasenames);Te&&(de.allBasenames=Te.allBasenames);const le=ie.reduce((re,V)=>V.allPaths?re.concat(V.allPaths):re,[]);return le.length&&(de.allPaths=le),de}function $(he,Ee,ie){if(Ee===!1)return r;const ce=c(he,ie);if(ce===r)return r;if(typeof Ee=="boolean")return ce;if(Ee){const de=Ee.when;if(typeof de=="string"){const Te=(le,re,V,L)=>{if(!L||!ce(le,re))return null;const K=de.replace("$(basename)",()=>V),me=L(K);return(0,P.isThenable)(me)?me.then(Ie=>Ie?he:null):me?he:null};return Te.requiresSiblings=!0,Te}}return ce}function B(he,Ee){const ie=he.filter(re=>!!re.basenames);if(ie.length<2)return he;const ce=ie.reduce((re,V)=>{const L=V.basenames;return L?re.concat(L):re},[]);let de;if(Ee){de=[];for(let re=0,V=ce.length;re<V;re++)de.push(Ee)}else de=ie.reduce((re,V)=>{const L=V.patterns;return L?re.concat(L):re},[]);const Te=function(re,V){if(typeof re!="string")return null;if(!V){let K;for(K=re.length;K>0;K--){const me=re.charCodeAt(K-1);if(me===47||me===92)break}V=re.substr(K)}const L=ce.indexOf(V);return L!==-1?de[L]:null};Te.basenames=ce,Te.patterns=de,Te.allBasenames=ce;const le=he.filter(re=>!re.basenames);return le.push(Te),le}function q(he,Ee){return(0,n.equals)(he,Ee,(ie,ce)=>typeof ie=="string"&&typeof ce=="string"?ie===ce:typeof ie!="string"&&typeof ce!="string"?ie.base===ce.base&&ie.pattern===ce.pattern:!1)}e.patternsEquals=q}),define(Ae[87],Re([1,0,10,128,22,13,2]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(a="",m=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(a,m=0){return this.value+=f(this.supportThemeIcons?(0,P.escapeIcons)(a):a).replace(/([ \t]+)/g,(y,T)=>"&nbsp;".repeat(T.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,m){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(a,m,y){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(a),")"),y&&(this.value+=` "${this.c(this.c(y,'"'),")")}"`),this.value+=")",this}c(a,m){const y=new RegExp((0,M.escapeRegExpCharacters)(m),"g");return a.replace(y,(T,p)=>a.charAt(p-1)!=="\\"?`\\${T}`:T)}}e.MarkdownString=w;function h(t){return O(t)?!t.value:Array.isArray(t)?t.every(h):!0}e.isEmptyMarkdownString=h;function O(t){return t instanceof w?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function D(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,C.isEqual)(R.URI.from(t.baseUri),R.URI.from(a.baseUri)))}e.markdownStringEqual=D;function f(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function b(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function d(t){const a=[],m=t.split("|").map(T=>T.trim());t=m[0];const y=m[1];if(y){const T=/height=(\d+)/.exec(y),p=/width=(\d+)/.exec(y),i=T?T[1]:"",l=p?p[1]:"",r=isFinite(parseInt(l)),c=isFinite(parseInt(i));r&&a.push(`width="${l}"`),c&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=d}),define(Ae[88],Re([1,0,16,41,19,20,22,13]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(r,c){const{os:o,tildify:I,relative:s}=c;if(s){const S=h(r,s,o);if(typeof S=="string")return S}let u=r.fsPath;if(o===1&&!M.isWindows?u=u.replace(/\//g,"\\"):o!==1&&M.isWindows&&(u=u.replace(/\\/g,"/")),o!==1&&I?.userHome){const S=I.userHome.fsPath;let E;r.scheme!==I.userHome.scheme&&r.path.startsWith(C.posix.sep)?E=I.userHome.with({path:r.path}).fsPath:E=r.fsPath,u=f(E,S,o)}return(o===1?C.win32:C.posix).normalize(O(u,o===1))}e.getPathLabel=w;function h(r,c,o){const I=o===1?C.win32:C.posix,s=o===3?R.extUri:R.extUriIgnorePathCase,u=c.getWorkspace(),v=(0,n.firstOrDefault)(u.folders);if(!v)return;r.scheme!==v.uri.scheme&&r.path.startsWith(C.posix.sep)&&(r=v.uri.with({path:r.path}));const S=c.getWorkspaceFolder(r);if(!S)return;let E;if(s.isEqual(S.uri,r)?E="":E=s.relativePath(S.uri,r)??"",E&&(E=I.normalize(E)),u.folders.length>1&&!c.noPrefix){const W=S.name?S.name:s.basenameOrAuthority(S.uri);E=E?`${W} \u2022 ${E}`:W}return E}function O(r,c=M.isWindows){return(0,P.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let D=Object.create(null);function f(r,c,o=M.OS){if(o===1||!r||!c)return r;let I=D.original===c?D.normalized:void 0;I||(I=c,M.isWindows&&(I=(0,P.toSlashes)(I)),I=`${(0,A.rtrim)(I,C.posix.sep)}${C.posix.sep}`,D={original:c,normalized:I});let s=r;return M.isWindows&&(s=(0,P.toSlashes)(s)),(o===3?s.startsWith(I):(0,A.startsWithIgnoreCase)(s,I))?`~/${s.substr(I.length)}`:r}e.tildify=f;function b(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=b;const g="\u2026",d="\\\\",t="~";function a(r,c=C.sep){const o=new Array(r.length);let I=!1;for(let s=0;s<r.length;s++){const u=r[s];if(u===""){o[s]=`.${c}`;continue}if(!u){o[s]=u;continue}I=!0;let v="",S=u;S.indexOf(d)===0?(v=S.substr(0,S.indexOf(d)+d.length),S=S.substr(S.indexOf(d)+d.length)):S.indexOf(c)===0?(v=S.substr(0,S.indexOf(c)+c.length),S=S.substr(S.indexOf(c)+c.length)):S.indexOf(t)===0&&(v=S.substr(0,S.indexOf(t)+t.length),S=S.substr(S.indexOf(t)+t.length));const E=S.split(c);for(let W=1;I&&W<=E.length;W++)for(let X=E.length-W;I&&X>=0;X--){I=!1;let Y=E.slice(X,X+W).join(c);for(let J=0;!I&&J<r.length;J++)if(J!==s&&r[J]&&r[J].indexOf(Y)>-1){const j=X+W===E.length,U=X>0&&r[J].indexOf(c)>-1?c+Y:Y,$=r[J].endsWith(U);I=!j||$}if(!I){let J="";(E[0].endsWith(":")||v!=="")&&(X===1&&(X=0,W++,Y=E[0]+c+Y),X>0&&(J=E[0]+c),J=v+J),X>0&&(J=J+g+c),J=J+Y,X+W<E.length&&(J=J+c+g),o[s]=J}}I&&(o[s]=u)}return o}e.shorten=a;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function y(r,c=Object.create(null)){const o=[];let I=!1,s="";for(const u of r)if(u==="$"||I&&u==="{")s&&o.push({value:s,type:m.TEXT}),s="",I=!0;else if(u==="}"&&I){const v=c[s];if(typeof v=="string")v.length&&o.push({value:v,type:m.VARIABLE});else if(v){const S=o[o.length-1];(!S||S.type!==m.SEPARATOR)&&o.push({value:v.label,type:m.SEPARATOR})}s="",I=!1}else s+=u;return s&&!I&&o.push({value:s,type:m.TEXT}),o.filter((u,v)=>{if(u.type===m.SEPARATOR){const S=o[v-1],E=o[v+1];return[S,E].every(W=>W&&(W.type===m.VARIABLE||W.type===m.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=y;function T(r,c){return M.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=T;function p(r,c){return M.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(r){const c=r.indexOf("/")!==-1?C.posix:C.win32,o=c.basename(r),I=c.dirname(r);return o.length?{name:o,parentPath:I}:{name:I,parentPath:""}}e.splitName=l}),define(Ae[129],Re([1,0,25,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(D){return D.toJSON()}class M{constructor(f){this.a=f}transformIncoming(f){const b=this.a.transformIncoming(f);return b===f?f:C(P.URI.from(b))}transformOutgoing(f){const b=this.a.transformOutgoing(f);return b===f?f:C(P.URI.from(b))}transformOutgoingURI(f){const b=this.a.transformOutgoing(f);return b===f?f:P.URI.from(b)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,f,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof P.URI)return f.transformOutgoing(D);for(const g in D)if(Object.hasOwnProperty.call(D,g)){const d=R(D[g],f,b+1);d!==null&&(D[g]=d)}}return null}function A(D,f){const b=R(D,f,0);return b===null?D:b}e.transformOutgoingURIs=A;function w(D,f,b,g){if(!D||g>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?P.URI.revive(f.transformIncoming(D)):f.transformIncoming(D);if(D instanceof n.VSBuffer)return null;for(const d in D)if(Object.hasOwnProperty.call(D,d)){const t=w(D[d],f,b,g+1);t!==null&&(D[d]=t)}}return null}function h(D,f){const b=w(D,f,!1,0);return b===null?D:b}e.transformIncomingURIs=h;function O(D,f){const b=w(D,f,!0,0);return b===null?D:b}e.transformAndReviveIncomingURIs=O}),define(Ae[130],Re([1,0,36,19]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(M,R,A,w,h,O){if(Array.isArray(M)){let D=0;for(const f of M){const b=C(f,R,A,w,h,O);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return w?M==="*"?5:M===A?10:0:0;if(M){const{language:D,pattern:f,scheme:b,hasAccessToAllModels:g,notebookType:d}=M;if(!w&&!g)return 0;d&&h&&(R=h);let t=0;if(b)if(b===R.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===A)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(d)if(d===O)t=10;else if(d==="*"&&O!==void 0)t=Math.max(t,5);else return 0;if(f){let a;if(typeof f=="string"?a=f:a={...f,base:(0,P.normalize)(f.base)},a===R.fsPath||(0,n.match)(a,R.fsPath))t=10;else return 0}return t}else return 0}}e.score=C}),define(Ae[89],Re([1,0,25,20]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function M(D){for(let f=0,b=D.length;f<b;f+=4){const g=D[f+0],d=D[f+1],t=D[f+2],a=D[f+3];D[f+0]=a,D[f+1]=t,D[f+2]=d,D[f+3]=g}}function R(D){const f=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return P.isLittleEndian()||M(f),n.VSBuffer.wrap(f)}function A(D){const f=D.buffer;if(P.isLittleEndian()||M(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const b=new Uint8Array(f.byteLength);return b.set(f),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function w(D){const f=new Uint32Array(h(D));let b=0;if(f[b++]=D.id,D.type==="full")f[b++]=1,f[b++]=D.data.length,f.set(D.data,b),b+=D.data.length;else{f[b++]=2,f[b++]=D.deltas.length;for(const g of D.deltas)f[b++]=g.start,f[b++]=g.deleteCount,g.data?(f[b++]=g.data.length,f.set(g.data,b),b+=g.data.length):f[b++]=0}return R(f)}e.encodeSemanticTokensDto=w;function h(D){let f=0;if(f+=1+1,D.type==="full")f+=1+D.data.length;else{f+=1,f+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(f+=b.data.length)}return f}function O(D){const f=A(D);let b=0;const g=f[b++];if(f[b++]===1){const m=f[b++],y=f.subarray(b,b+m);return b+=m,{id:g,type:"full",data:y}}const t=f[b++],a=[];for(let m=0;m<t;m++){const y=f[b++],T=f[b++],p=f[b++];let i;p>0&&(i=f.subarray(b,b+p),b+=p),a[m]={start:y,deleteCount:T,data:i}}return{id:g,type:"delta",deltas:a}}e.decodeSemanticTokensDto=O}),define(Ae[131],Re([11,12]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ae[132],Re([1,0,131,20,133,16,23,119]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=h;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class D{constructor(_,be,We,ze){this.id=_,this.name=be,this.defaultValue=We,this.schema=ze}applyUpdate(_,be){return b(_,be)}compute(_,be,We){return We}}class f{constructor(_,be){this.newValue=_,this.didChange=be}}e.ApplyUpdateResult=f;function b(Q,_){if(typeof Q!="object"||typeof _!="object"||!Q||!_)return new f(_,Q!==_);if(Array.isArray(Q)||Array.isArray(_)){const We=Array.isArray(Q)&&Array.isArray(_)&&M.equals(Q,_);return new f(_,!We)}let be=!1;for(const We in _)if(_.hasOwnProperty(We)){const ze=b(Q[We],_[We]);ze.didChange&&(Q[We]=ze.newValue,be=!0)}return new f(Q,be)}class g{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,be){return b(_,be)}validate(_){return this.defaultValue}}class d{constructor(_,be,We,ze){this.id=_,this.name=be,this.defaultValue=We,this.schema=ze}applyUpdate(_,be){return b(_,be)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,be,We){return We}}function t(Q,_){return typeof Q>"u"?_:Q==="false"?!1:Boolean(Q)}e.boolean=t;class a extends d{constructor(_,be,We,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=We),super(_,be,We,ze)}validate(_){return t(_,this.defaultValue)}}function m(Q,_,be,We){if(typeof Q>"u")return _;let ze=parseInt(Q,10);return isNaN(ze)?_:(ze=Math.max(be,ze),ze=Math.min(We,ze),ze|0)}e.clampedInt=m;class y extends d{static clampedInt(_,be,We,ze){return m(_,be,We,ze)}constructor(_,be,We,ze,Qe,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=We,Ye.minimum=ze,Ye.maximum=Qe),super(_,be,We,Ye),this.minimum=ze,this.maximum=Qe}validate(_){return y.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class T extends d{static clamp(_,be,We){return _<be?be:_>We?We:_}static float(_,be){if(typeof _=="number")return _;if(typeof _>"u")return be;const We=parseFloat(_);return isNaN(We)?be:We}constructor(_,be,We,ze,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=We),super(_,be,We,Qe),this.validationFn=ze}validate(_){return this.validationFn(T.float(_,this.defaultValue))}}class p extends d{static string(_,be){return typeof _!="string"?be:_}constructor(_,be,We,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=We),super(_,be,We,ze)}validate(_){return p.string(_,this.defaultValue)}}function i(Q,_,be){return typeof Q!="string"||be.indexOf(Q)===-1?_:Q}e.stringSet=i;class l extends d{constructor(_,be,We,ze,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=ze,Qe.default=We),super(_,be,We,Qe),this.c=ze}validate(_){return i(_,this.defaultValue,this.c)}}class r extends D{constructor(_,be,We,ze,Qe,Ye,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Qe,Ge.default=ze),super(_,be,We,Ge),this.c=Qe,this.d=Ye}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function c(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,be,We){return We===0?_.accessibilitySupport:We}}class I extends D{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:n.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{insertSpace:t(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(Q){switch(Q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function E(Q){switch(Q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class W extends g{constructor(){super(135)}compute(_,be,We){const ze=["monaco-editor"];return be.get(36)&&ze.push(be.get(36)),_.extraEditorClassName&&ze.push(_.extraEditorClassName),be.get(70)==="default"?ze.push("mouse-default"):be.get(70)==="copy"&&ze.push("mouse-copy"),be.get(105)&&ze.push("showUnused"),be.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class X extends a{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(_,be,We){return We&&_.emptySelectionClipboard}}class Y extends D{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:n.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:n.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{cursorMoveOnType:t(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":i(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":i(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(be.loop,this.defaultValue.loop)}}}class J extends D{constructor(){super(48,"fontLigatures",J.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?J.OFF:_==="true"?J.ON:_:Boolean(_)?J.ON:J.OFF}}J.OFF='"liga" off, "calt" off',J.ON='"liga" on, "calt" on',e.EditorFontLigatures=J;class j extends D{constructor(){super(51,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?j.OFF:_==="true"?j.TRANSLATE:_:Boolean(_)?j.TRANSLATE:j.OFF}compute(_,be,We){return _.fontInfo.fontVariationSettings}}j.OFF="normal",j.TRANSLATE="translate",e.EditorFontVariations=j;class U extends g{constructor(){super(47)}compute(_,be,We){return _.fontInfo}}class $ extends d{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(_){const be=T.float(_,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:T.clamp(be,6,100)}compute(_,be,We){return _.fontInfo.fontSize}}class B extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(y.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class q extends D{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...be},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...be},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...be},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:We,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:We,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:We,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:We,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:We,description:n.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{multiple:i(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??i(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??i(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??i(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??i(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??i(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends D{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:_.above,description:n.localize(45,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),delay:y.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:t(be.sticky,this.defaultValue.sticky),above:t(be.above,this.defaultValue.above)}}}var Ee;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(Ee=e.RenderMinimap||(e.RenderMinimap={}));class ie extends g{constructor(){super(138)}compute(_,be,We){return ie.computeLayout(be,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const be=_.height/_.lineHeight,We=Math.floor(_.paddingTop/_.lineHeight);let ze=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(ze=Math.max(ze,be-1));const Qe=(We+_.viewLineCount+ze)/(_.pixelRatio*_.height),Ye=Math.floor(_.viewLineCount/Qe);return{typicalViewportLineCount:be,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:ze,desiredRatio:Qe,minimapLineCount:Ye}}static c(_,be){const We=_.outerWidth,ze=_.outerHeight,Qe=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=be.stableMinimapLayoutInput,Ge=Ye&&_.outerHeight===Ye.outerHeight&&_.lineHeight===Ye.lineHeight&&_.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&_.pixelRatio===Ye.pixelRatio&&_.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&_.paddingTop===Ye.paddingTop&&_.paddingBottom===Ye.paddingBottom&&_.minimap.enabled===Ye.minimap.enabled&&_.minimap.side===Ye.minimap.side&&_.minimap.size===Ye.minimap.size&&_.minimap.showSlider===Ye.minimap.showSlider&&_.minimap.renderCharacters===Ye.minimap.renderCharacters&&_.minimap.maxColumn===Ye.minimap.maxColumn&&_.minimap.scale===Ye.minimap.scale&&_.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&_.isViewportWrapping===Ye.isViewportWrapping,at=_.lineHeight,Dt=_.typicalHalfwidthCharacterWidth,Tt=_.scrollBeyondLastLine,It=_.minimap.renderCharacters;let Et=Qe>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Mt=_.minimap.maxColumn,zt=_.minimap.size,Xt=_.minimap.side,ht=_.verticalScrollbarWidth,gt=_.viewLineCount,Ot=_.remainingWidth,Ut=_.isViewportWrapping,Lt=It?2:3;let pt=Math.floor(Qe*ze);const Ct=pt/Qe;let Pt=!1,$t=!1,Ke=Lt*Et,Wt=Et/Qe,Pe=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:xe,extraLinesBeforeFirstLine:ot,extraLinesBeyondLastLine:ft,desiredRatio:mt,minimapLineCount:lt}=ie.computeContainedMinimapLineCount({viewLineCount:gt,scrollBeyondLastLine:Tt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:ze,lineHeight:at,pixelRatio:Qe});if(gt/lt>1)Pt=!0,$t=!0,Et=1,Ke=1,Wt=Et/Qe;else{let bt=!1,kt=Et+1;if(zt==="fit"){const Ht=Math.ceil((ot+gt+ft)*Ke);Ut&&Ge&&Ot<=be.stableFitRemainingWidth?(bt=!0,kt=be.stableFitMaxMinimapScale):bt=Ht>pt}if(zt==="fill"||bt){Pt=!0;const Ht=Et;Ke=Math.min(at*Qe,Math.max(1,Math.floor(1/mt))),Ut&&Ge&&Ot<=be.stableFitRemainingWidth&&(kt=be.stableFitMaxMinimapScale),Et=Math.min(kt,Math.max(1,Math.floor(Ke/Lt))),Et>Ht&&(Pe=Math.min(2,Et/Ht)),Wt=Et/Qe/Pe,pt=Math.ceil(Math.max(xe,ot+gt+ft)*Ke),Ut?(be.stableMinimapLayoutInput=_,be.stableFitRemainingWidth=Ot,be.stableFitMaxMinimapScale=Et):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const Le=Math.floor(Mt*Wt),fe=Math.min(Le,Math.max(0,Math.floor((Ot-ht-2)*Wt/(Dt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let G=Math.floor(Qe*fe);const Oe=G/Qe;G=Math.floor(G*Pe);const Be=It?1:2,Ze=Xt==="left"?0:We-fe-ht;return{renderMinimap:Be,minimapLeft:Ze,minimapWidth:fe,minimapHeightIsEditorHeight:Pt,minimapIsSampling:$t,minimapScale:Et,minimapLineHeight:Ke,minimapCanvasInnerWidth:G,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:Ct}}static computeLayout(_,be){const We=be.outerWidth|0,ze=be.outerHeight|0,Qe=be.lineHeight|0,Ye=be.lineNumbersDigitCount|0,Ge=be.typicalHalfwidthCharacterWidth,at=be.maxDigitWidth,Dt=be.pixelRatio,Tt=be.viewLineCount,It=_.get(130),Et=It==="inherit"?_.get(129):It,Mt=Et==="inherit"?_.get(125):Et,zt=_.get(128),Xt=be.isDominatedByLongLines,ht=_.get(54),gt=_.get(64).renderType!==0,Ot=_.get(65),Ut=_.get(99),Lt=_.get(80),pt=_.get(69),Ct=_.get(97),Pt=Ct.verticalScrollbarSize,$t=Ct.verticalHasArrows,Ke=Ct.arrowSize,Wt=Ct.horizontalScrollbarSize,Pe=_.get(40),Le=_.get(104)!=="never";let fe=_.get(62);Pe&&Le&&(fe+=16);let G=0;if(gt){const ai=Math.max(Ye,Ot);G=Math.round(ai*at)}let Oe=0;ht&&(Oe=Qe);let Be=0,Ze=Be+Oe,xe=Ze+G,ot=xe+fe;const ft=We-Oe-G-fe;let mt=!1,lt=!1,ct=-1;Et==="inherit"&&Xt?(mt=!0,lt=!0):Mt==="on"||Mt==="bounded"?lt=!0:Mt==="wordWrapColumn"&&(ct=zt);const bt=ie.c({outerWidth:We,outerHeight:ze,lineHeight:Qe,typicalHalfwidthCharacterWidth:Ge,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:Lt.top,paddingBottom:Lt.bottom,minimap:pt,verticalScrollbarWidth:Pt,viewLineCount:Tt,remainingWidth:ft,isViewportWrapping:lt},be.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(Be+=bt.minimapWidth,Ze+=bt.minimapWidth,xe+=bt.minimapWidth,ot+=bt.minimapWidth);const kt=ft-bt.minimapWidth,Ht=Math.max(1,Math.floor((kt-Pt-2)/Ge)),Nt=$t?Ke:0;return lt&&(ct=Math.max(1,Ht),Mt==="bounded"&&(ct=Math.min(ct,zt))),{width:We,height:ze,glyphMarginLeft:Be,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:G,decorationsLeft:xe,decorationsWidth:fe,contentLeft:ot,contentWidth:kt,minimap:bt,viewportColumn:Ht,isWordWrapMinified:mt,isViewportWrapping:lt,wrappingColumn:ct,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Wt,overviewRuler:{top:Nt,width:Pt,height:ze-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=ie;class ce extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(_){return i(_,"simple",["simple","advanced"])}compute(_,be,We){return be.get(2)===2?"advanced":We}}class de extends D{constructor(){const _={enabled:!0};super(61,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:n.localize(49,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}class Te extends D{constructor(){const _={enabled:!1,maxLineCount:5};super(109,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),maxLineCount:y.clampedInt(be.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends D{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:n.localize(59,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:i(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(be.fontFamily,this.defaultValue.fontFamily),padding:t(be.padding,this.defaultValue.padding)}}}class re extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):y.clampedInt(_,this.defaultValue,0,1e3)}compute(_,be,We){return We<0?y.clampedInt(-We*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class V extends T{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>T.clamp(_,0,150),{markdownDescription:n.localize(60,null)})}compute(_,be,We){return _.fontInfo.lineHeight}}class L extends D{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:_.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:n.localize(71,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),autohide:t(be.autohide,this.defaultValue.autohide),size:i(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(be.side,this.defaultValue.side,["right","left"]),showSlider:i(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(be.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(be.scale,1,1,3),maxColumn:y.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function K(Q){return Q==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{top:y.clampedInt(be.top,0,0,1e3),bottom:y.clampedInt(be.bottom,0,0,1e3)}}}class Ie extends D{constructor(){const _={enabled:!0,cycle:!0};super(81,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:n.localize(75,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),cycle:t(be.cycle,this.defaultValue.cycle)}}}class we extends g{constructor(){super(136)}compute(_,be,We){return _.pixelRatio}}class ve extends D{constructor(){const _={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:be,default:_.strings,description:n.localize(79,null)},comments:{anyOf:be,default:_.comments,description:n.localize(80,null)},other:{anyOf:be,default:_.other,description:n.localize(81,null)}},default:_,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Dt=_?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!_||typeof _!="object")return this.defaultValue;const{other:be,comments:We,strings:ze}=_,Qe=["on","inline","off"];let Ye,Ge,at;return typeof be=="boolean"?Ye=be?"on":"off":Ye=i(be,this.defaultValue.other,Qe),typeof We=="boolean"?Ge=We?"on":"off":Ge=i(We,this.defaultValue.comments,Qe),typeof ze=="boolean"?at=ze?"on":"off":at=i(ze,this.defaultValue.strings,Qe),{other:Ye,comments:Ge,strings:at}}}var Ce;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ce=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(_){let be=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(be=4,We=_):_==="interval"?be=3:_==="relative"?be=2:_==="on"?be=1:be=0),{renderType:be,renderFn:We}}}function ae(Q){const _=Q.get(92);return _==="editable"?Q.get(86):_!=="on"}e.filterValidationDecorations=ae;class Z extends D{constructor(){const _=[],be={type:"number",description:n.localize(88,null)};super(96,"rulers",_,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:_,description:n.localize(90,null)})}validate(_){if(Array.isArray(_)){const be=[];for(const We of _)if(typeof We=="number")be.push({column:y.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const ze=We;be.push({column:y.clampedInt(ze.column,0,0,1e4),color:ze.color})}return be.sort((We,ze)=>We.column-ze.column),be}return this.defaultValue}}function k(Q,_){if(typeof Q!="string")return _;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends D{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:n.localize(101,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_,We=y.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=y.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:k(be.vertical,this.defaultValue.vertical),horizontal:k(be.horizontal,this.defaultValue.horizontal),useShadows:t(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:y.clampedInt(be.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:y.clampedInt(be.verticalSliderSize,ze,0,1e3),scrollByPage:t(be.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:n.localize(108,null)}})}applyUpdate(_,be){let We=!1;be.allowedCharacters&&_&&(R.equals(_.allowedCharacters,be.allowedCharacters)||(_={..._,allowedCharacters:be.allowedCharacters},We=!0)),be.allowedLocales&&_&&(R.equals(_.allowedLocales,be.allowedLocales)||(_={..._,allowedLocales:be.allowedLocales},We=!0));const ze=super.applyUpdate(_,be);return We?new f(ze.newValue,!0):ze}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{nonBasicASCII:ke(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ke(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ke(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,be){if(typeof _!="object"||!_)return be;const We={};for(const[ze,Qe]of Object.entries(_))Qe===!0&&(We[ze]=!0);return We}}class x extends D{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),mode:i(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(be.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class te extends D{constructor(){const _={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{enabled:t(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class pe extends D{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:_.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:_.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:_.highlightActiveIndentation,description:n.localize(128,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{bracketPairs:ke(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ke(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:ke(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ke(Q,_,be){const We=be.indexOf(Q);return We===-1?_:be[We]}class ue extends D{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:_.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:_.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const be=_;return{insertMode:i(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(be.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(be.showIcons,this.defaultValue.showIcons),showStatusBar:t(be.showStatusBar,this.defaultValue.showStatusBar),preview:t(be.preview,this.defaultValue.preview),previewMode:i(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(be.showMethods,this.defaultValue.showMethods),showFunctions:t(be.showFunctions,this.defaultValue.showFunctions),showConstructors:t(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(be.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(be.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(be.showFields,this.defaultValue.showFields),showVariables:t(be.showVariables,this.defaultValue.showVariables),showClasses:t(be.showClasses,this.defaultValue.showClasses),showStructs:t(be.showStructs,this.defaultValue.showStructs),showInterfaces:t(be.showInterfaces,this.defaultValue.showInterfaces),showModules:t(be.showModules,this.defaultValue.showModules),showProperties:t(be.showProperties,this.defaultValue.showProperties),showEvents:t(be.showEvents,this.defaultValue.showEvents),showOperators:t(be.showOperators,this.defaultValue.showOperators),showUnits:t(be.showUnits,this.defaultValue.showUnits),showValues:t(be.showValues,this.defaultValue.showValues),showConstants:t(be.showConstants,this.defaultValue.showConstants),showEnums:t(be.showEnums,this.defaultValue.showEnums),showEnumMembers:t(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(be.showKeywords,this.defaultValue.showKeywords),showWords:t(be.showWords,this.defaultValue.showWords),showColors:t(be.showColors,this.defaultValue.showColors),showFiles:t(be.showFiles,this.defaultValue.showFiles),showReferences:t(be.showReferences,this.defaultValue.showReferences),showFolders:t(be.showFolders,this.defaultValue.showFolders),showTypeParameters:t(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(be.showSnippets,this.defaultValue.showSnippets),showUsers:t(be.showUsers,this.defaultValue.showUsers),showIssues:t(be.showIssues,this.defaultValue.showIssues)}}}class De extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Se;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));class $e extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,be,We){return be.get(2)===2?0:We}}class He extends g{constructor(){super(139)}compute(_,be,We){const ze=be.get(138);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class et extends D{constructor(){const _={enabled:!0};super(33,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:n.localize(183,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:t(_.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?tt:P.isLinux?rt:Xe,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var it;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Me(new o),accessibilityPageSize:Me(new y(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Me(new p(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Me(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Me(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Me(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Me(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Me(new a(10,"automaticLayout",!1)),autoSurround:Me(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Me(new te),bracketPairGuides:Me(new pe),stickyTabStops:Me(new a(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Me(new a(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Me(new p(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Me(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Me(new a(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Me(new y(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Me(new a(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Me(new I),contextmenu:Me(new a(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Me(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Me(new l(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Me(new r(25,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:n.localize(222,null)})),cursorSurroundingLines:Me(new y(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Me(new l(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Me(new y(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Me(new a(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(31,"domReadOnly",!1)),dragAndDrop:Me(new a(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Me(new X),dropIntoEditor:Me(new et),stickyScroll:Me(new Te),experimentalWhitespaceRendering:Me(new l(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Me(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new T(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Me(new Y),fixedOverflowWidgets:Me(new a(39,"fixedOverflowWidgets",!1)),folding:Me(new a(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Me(new l(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Me(new a(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Me(new a(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Me(new y(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Me(new a(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Me(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Me(new U),fontLigatures2:Me(new J),fontSize:Me(new $),fontWeight:Me(new B),fontVariations:Me(new j),formatOnPaste:Me(new a(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Me(new a(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Me(new a(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Me(new q),hideCursorInOverviewRuler:Me(new a(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Me(new he),inDiffEditor:Me(new a(58,"inDiffEditor",!1)),letterSpacing:Me(new T(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>T.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Me(new de),lineDecorationsWidth:Me(new re),lineHeight:Me(new V),lineNumbers:Me(new se),lineNumbersMinChars:Me(new y(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Me(new a(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Me(new l(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Me(new L),mouseStyle:Me(new l(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new T(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Me(new a(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Me(new a(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Me(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],K,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Me(new l(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Me(new y(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Me(new a(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Me(new a(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Me(new y(79,"overviewRulerLanes",3,0,3)),padding:Me(new me),parameterHints:Me(new Ie),peekWidgetDefaultFocus:Me(new l(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Me(new a(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Me(new ve),quickSuggestionsDelay:Me(new y(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Me(new a(86,"readOnly",!1)),renameOnType:Me(new a(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Me(new a(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Me(new l(89,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Me(new l(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Me(new l(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Me(new y(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Me(new Z),scrollbar:Me(new F),scrollBeyondLastColumn:Me(new y(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Me(new a(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Me(new a(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Me(new a(101,"selectionClipboard",!0,{description:n.localize(283,null),included:P.isLinux})),selectionHighlight:Me(new a(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Me(new a(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Me(new a(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Me(new a(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Me(new le),snippetSuggestions:Me(new l(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Me(new De),smoothScrolling:Me(new a(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Me(new y(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ue),inlineSuggest:Me(new x),suggestFontSize:Me(new y(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new y(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Me(new l(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Me(new l(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Me(new y(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new H),unusualLineTerminators:Me(new l(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Me(new a(121,"useShadowDOM",!0)),useTabStops:Me(new a(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Me(new l(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Me(new p(124,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Me(new l(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Me(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new y(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Me(new l(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new W),pixelRatio:Me(new we),tabFocusMode:Me(new a(137,"tabFocusMode",!1,{markdownDescription:n.localize(323,null)})),layoutInfo:Me(new ie),wrappingInfo:Me(new He),wrappingIndent:Me(new $e),wrappingStrategy:Me(new ce)}}),define(Ae[134],Re([11,12]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[135],Re([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[136],Re([11,12]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[137],Re([11,12]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[138],Re([11,12]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[139],Re([11,12]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ae[140],Re([11,12]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ae[141],Re([11,12]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[142],Re([11,12]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ae[143],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[144],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[145],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[146],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[147],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[148],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[149],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[150],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[151],Re([11,12]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[152],Re([11,12]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ae[153],Re([11,12]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ae[154],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[155],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[156],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[157],Re([11,12]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[158],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[159],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[160],Re([11,12]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[161],Re([1,0,10,136]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(C=e.TokenType||(e.TokenType={}));function M(...h){switch(h.length){case 1:return(0,P.localize)(0,null,h[0]);case 2:return(0,P.localize)(1,null,h[0],h[1]);case 3:return(0,P.localize)(2,null,h[0],h[1],h[2]);default:return}}const R=(0,P.localize)(3,null),A=(0,P.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const D=this.d,f=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:f};this.g.push({offset:D,lexeme:f,additionalInfo:O}),this.f.push(b)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const D=this.c.substring(this.d,this.e),f=w.b.get(D);f?this.k(f):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,D=!1,f=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(A);return}const g=this.c.charCodeAt(O);if(D)D=!1;else if(g===47&&!f){O++;break}else g===91?f=!0:g===92?D=!0:g===93&&(f=!1);O++}for(;O<this.c.length&&w.a.has(this.c.charCodeAt(O));)O++;this.e=O;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}w.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0))),w.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=w}),define(Ae[162],Re([1,0,22,29,138,263]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function w(a){return a=a.trim(),a==="*"||R.test(a)}e.isValidVersionStr=w;function h(a){if(!w(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=a.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=h;function O(a){if(!a)return null;const m=a.majorBase,y=a.majorMustEqual,T=a.minorBase;let p=a.minorMustEqual;const i=a.patchBase;let l=a.patchMustEqual;a.hasCaret&&(m===0||(p=!1),l=!1);let r=0;if(a.preRelease){const c=A.exec(a.preRelease);if(c){const[,o,I,s]=c;r=Date.UTC(Number(o),Number(I)-1,Number(s))}}return{majorBase:m,majorMustEqual:y,minorBase:T,minorMustEqual:p,patchBase:i,patchMustEqual:l,isMinimum:a.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function D(a,m,y){let T;typeof a=="string"?T=O(h(a)):T=a;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let i;if(typeof y=="string"?i=O(h(y)):i=y,!T||!i)return!1;const l=T.majorBase,r=T.minorBase,c=T.patchBase;let o=i.majorBase,I=i.minorBase,s=i.patchBase;const u=i.notBefore;let v=i.majorMustEqual,S=i.minorMustEqual,E=i.patchMustEqual;return i.isMinimum?l>o?!0:l<o?!1:r>I?!0:r<I||p&&p<u?!1:c>=s:(l===1&&o===0&&(!v||!S||!E)&&(o=1,I=0,s=0,v=!0,S=!1,E=!1),l<o?!1:l>o?!v:r<I?!1:r>I?!S:c<s?!1:c>s?!E:!(p&&p<u))}e.isValidVersion=D;function f(a,m,y,T,p){const i=[];if(typeof T.publisher<"u"&&typeof T.publisher!="string")return i.push([P.default.Error,C.localize(0,null)]),i;if(typeof T.name!="string")return i.push([P.default.Error,C.localize(1,null,"name")]),i;if(typeof T.version!="string")return i.push([P.default.Error,C.localize(2,null,"version")]),i;if(!T.engines)return i.push([P.default.Error,C.localize(3,null,"engines")]),i;if(typeof T.engines.vscode!="string")return i.push([P.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof T.extensionDependencies<"u"&&!t(T.extensionDependencies))return i.push([P.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof T.activationEvents<"u"){if(!t(T.activationEvents))return i.push([P.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof T.main>"u"&&typeof T.browser>"u")return i.push([P.default.Error,C.localize(7,null,"activationEvents","main")]),i}if(typeof T.extensionKind<"u"&&typeof T.main>"u"&&i.push([P.default.Warning,C.localize(8,null,"extensionKind")]),typeof T.main<"u"){if(typeof T.main!="string")return i.push([P.default.Error,C.localize(9,null,"main")]),i;{const c=(0,n.joinPath)(y,T.main);(0,n.isEqualOrParent)(c,y)||i.push([P.default.Warning,C.localize(10,null,c.path,y.path)])}if(typeof T.activationEvents>"u")return i.push([P.default.Error,C.localize(11,null,"activationEvents","main")]),i}if(typeof T.browser<"u"){if(typeof T.browser!="string")return i.push([P.default.Error,C.localize(12,null,"browser")]),i;{const c=(0,n.joinPath)(y,T.browser);(0,n.isEqualOrParent)(c,y)||i.push([P.default.Warning,C.localize(13,null,c.path,y.path)])}if(typeof T.activationEvents>"u")return i.push([P.default.Error,C.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(T.version))return i.push([P.default.Error,C.localize(15,null)]),i;const l=[];if(!b(a,m,T,p,l))for(const c of l)i.push([P.default.Error,c]);return i}e.validateExtensionManifest=f;function b(a,m,y,T,p){return T||typeof y.main>"u"&&typeof y.browser>"u"?!0:d(a,m,y.engines.vscode,p)}e.isValidExtensionVersion=b;function g(a,m,y){return a==="*"||d(m,y,a)}e.isEngineValid=g;function d(a,m,y,T=[]){const p=O(h(y));if(!p)return T.push(C.localize(16,null,y)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return T.push(C.localize(17,null,y)),!1}else if(!p.majorMustEqual)return T.push(C.localize(18,null,y)),!1;return D(a,m,p)?!0:(T.push(C.localize(19,null,a,y)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let m=0,y=a.length;m<y;m++)if(typeof a[m]!="string")return!1;return!0}}),define(Ae[67],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(C,M=[],R=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=n}),define(Ae[68],Re([1,0,67]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var C;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function M(A,w,h){w instanceof n.SyncDescriptor||(w=new n.SyncDescriptor(w,[],Boolean(h))),P.push([A,w])}e.registerSingleton=M;function R(){return P}e.getSingletonServiceDescriptors=R}),define(Ae[163],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class P{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const A=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(R);A.outgoing.set(w.key,w),w.incoming.set(A.key,A)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let A=this.a.get(R);return A||(A=new n(R,M),this.a.set(R,A)),A}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,A]of this.a)M.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const A=new Set([M]),w=this.c(R,A);if(w)return w}}c(M,R){for(const[A,w]of M.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const h=this.c(w,R);if(h)return h;R.delete(A)}}}e.Graph=P}),define(Ae[3],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function P(R,A,w){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:w}):(A[n.DI_DEPENDENCIES]=[{id:R,index:w}],A[n.DI_TARGET]=A)}function C(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(w,h,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(A,w,O)};return A.toString=()=>R,n.serviceIds.set(R,A),A}e.createDecorator=C;function M(R){return R}e.refineServiceDecorator=M}),define(Ae[42],Re([1,0,9,2,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationOverrides=M;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=R;var A;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function h(t,a){const m=Object.create(null);for(const y in t)O(m,y,t[y],a);return m}e.toValuesTree=h;function O(t,a,m,y){const T=a.split("."),p=T.pop();let i=t;for(let l=0;l<T.length;l++){const r=T[l];let c=i[r];switch(typeof c){case"undefined":c=i[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${a} as ${T.slice(0,l+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[p]=m}catch{y(`Ignoring ${a} as ${T.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${a} as ${T.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=O;function D(t,a){const m=a.split(".");f(t,m)}e.removeFromValueTree=D;function f(t,a){const m=a.shift();if(a.length===0){delete t[m];return}if(Object.keys(t).indexOf(m)!==-1){const y=t[m];typeof y=="object"&&!Array.isArray(y)&&(f(y,a),Object.keys(y).length===0&&delete t[m])}}function b(t,a,m){function y(i,l){let r=i;for(const c of l){if(typeof r!="object"||r===null)return;r=r[c]}return r}const T=a.split("."),p=y(t,T);return typeof p>"u"?m:p}e.getConfigurationValue=b;function g(t,a,m){Object.keys(a).forEach(y=>{y!=="__proto__"&&(y in t?n.isObject(t[y])&&n.isObject(a[y])?g(t[y],a[y],m):m&&(t[y]=a[y]):t[y]=a[y])})}e.merge=g;function d(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ae[31],Re([1,0,20,13,161,3,135]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",n.isMacintosh),A.set("isLinux",n.isLinux),A.set("isWindows",n.isWindows),A.set("isWeb",n.isWeb),A.set("isMacNative",n.isMacintosh&&!n.isWeb),A.set("isEdge",n.isEdge),A.set("isFirefox",n.isFirefox),A.set("isChrome",n.isChrome),A.set("isSafari",n.isSafari);const w=Object.prototype.hasOwnProperty;var h;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));class O{static false(){return o.INSTANCE}static true(){return I.INSTANCE}static has(L){return s.create(L)}static equals(L,K){return u.create(L,K)}static notEquals(L,K){return E.create(L,K)}static regex(L,K){return $.create(L,K)}static in(L,K){return v.create(L,K)}static notIn(L,K){return S.create(L,K)}static not(L){return W.create(L)}static and(...L){return he.create(L,null,!0)}static or(...L){return Ee.create(L,null,!0)}static greater(L,K){return Y.create(L,K)}static greaterEquals(L,K){return J.create(L,K)}static smaller(L,K){return j.create(L,K)}static smallerEquals(L,K){return U.create(L,K)}static deserialize(L){if(!!L)return this.c(L)}static c(L){const K=L.split("||");return Ee.create(K.map(me=>this.d(me)),null,!0)}static d(L){const K=L.split("&&");return he.create(K.map(me=>this.f(me)),null,!0)}static f(L){if(L=L.trim(),L.indexOf("!=")>=0){const K=L.split("!=");return E.create(K[0].trim(),this.g(K[1]))}if(L.indexOf("==")>=0){const K=L.split("==");return u.create(K[0].trim(),this.g(K[1]))}if(L.indexOf("=~")>=0){const K=L.split("=~");return $.create(K[0].trim(),this.h(K[1]))}if(L.indexOf(" not in ")>=0){const K=L.split(" not in ");return S.create(K[0].trim(),this.g(K[1]))}if(L.indexOf(" in ")>=0){const K=L.split(" in ");return v.create(K[0].trim(),this.g(K[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const K=L.split(">=");return J.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const K=L.split(">");return Y.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const K=L.split("<=");return U.create(K[0].trim(),K[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const K=L.split("<");return j.create(K[0].trim(),K[1].trim())}return/^\!\s*/.test(L)?W.create(L.substr(1).trim()):s.create(L)}static g(L){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const K=/^'([^']*)'$/.exec(L);return K?K[1].trim():L}static h(L){if((0,P.isFalsyOrWhitespace)(L))return null;const K=L.indexOf("/"),me=L.lastIndexOf("/");if(K===me||K<0)return null;const Ie=L.slice(K+1,me),we=L[me+1]==="i"?"i":"";try{return new RegExp(Ie,we)}catch{return null}}}e.ContextKeyExpr=O;const D={regexParsingWithErrorRecovery:!0};class f extends Error{}const b=(0,R.localize)(0,null),g=(0,R.localize)(1,null),d=(0,R.localize)(2,null),t=(0,R.localize)(3,null),a=(0,R.localize)(4,null),m=(0,R.localize)(5,null),y=(0,R.localize)(6,null),T=(0,R.localize)(7,null),p=(0,R.localize)(8,null);class i{get lexingErrors(){return this.c.errors}get parsingErrors(){return this.g}constructor(L=D){this.h=L,this.c=new C.Scanner,this.d=[],this.f=0,this.g=[]}parse(L){if(L===""){this.g.push({message:b,offset:0,lexeme:"",additionalInfo:g});return}this.d=this.c.reset(L).scan(),this.f=0,this.g=[];try{const K=this.k();if(!this.C()){const me=this.B(),Ie=me.type===17?y:void 0;throw this.g.push({message:m,offset:me.offset,lexeme:C.Scanner.getLexeme(me),additionalInfo:Ie}),new f}return K}catch(K){if(!(K instanceof f))throw K;return}}k(){return this.l()}l(){const L=[this.o()];for(;this.w(16);){const K=this.o();L.push(K)}return L.length===1?L[0]:O.or(...L)}o(){const L=[this.s()];for(;this.w(15);){const K=this.s();L.push(K)}return L.length===1?L[0]:O.and(...L)}s(){if(this.w(2)){const L=this.B();switch(L.type){case 17:return this.x(),O.not(L.lexeme);case 11:return this.x(),O.false();case 12:return this.x(),O.true();default:throw this.z("CONTEXT | true | false",L,d)}}return this.t()}t(){const L=this.B();switch(L.type){case 11:return this.x(),O.true();case 12:return this.x(),O.false();case 0:{this.x();const K=this.k();return this.y(1,a),K}case 17:{const K=L.lexeme;if(this.x(),this.w(9)){const Ie=this.B();if(!this.h.regexParsingWithErrorRecovery){if(this.x(),Ie.type!==10)throw this.z("REGEX",Ie);const we=Ie.lexeme,ve=we.lastIndexOf("/"),Ce=ve===we.length-1?void 0:we.substring(ve+1);let se;try{se=new RegExp(we.substring(1,ve),Ce)}catch{throw this.z("REGEX",Ie)}return $.create(K,se)}switch(Ie.type){case 10:case 19:{const we=[Ie.lexeme];this.x();let ve=this.B(),Ce=0;for(let F=0;F<Ie.lexeme.length;F++)Ie.lexeme.charCodeAt(F)===40?Ce++:Ie.lexeme.charCodeAt(F)===41&&Ce--;for(;!this.C()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:Ce++;break;case 1:Ce--;break;case 10:case 18:for(let F=0;F<ve.lexeme.length;F++)ve.lexeme.charCodeAt(F)===40?Ce++:Ie.lexeme.charCodeAt(F)===41&&Ce--}if(Ce<0)break;we.push(C.Scanner.getLexeme(ve)),this.x(),ve=this.B()}const se=we.join(""),ae=se.lastIndexOf("/"),Z=ae===se.length-1?void 0:se.substring(ae+1);let k;try{k=new RegExp(se.substring(1,ae),Z)}catch{throw this.z("REGEX",Ie)}return O.regex(K,k)}case 18:{const we=Ie.lexeme;this.x();let ve=null;if(!(0,P.isFalsyOrWhitespace)(we)){const Ce=we.indexOf("/"),se=we.lastIndexOf("/");if(Ce!==se&&Ce>=0){const ae=we.slice(Ce+1,se),Z=we[se+1]==="i"?"i":"";try{ve=new RegExp(ae,Z)}catch{throw this.z("REGEX",Ie)}}}if(ve===null)throw this.z("REGEX",Ie);return $.create(K,ve)}default:throw this.z("REGEX",this.B())}}if(this.w(14)){this.y(13,t);const Ie=this.u();return O.notIn(K,Ie)}switch(this.B().type){case 3:{this.x();const Ie=this.u();if(this.v().type===18)return O.equals(K,Ie);switch(Ie){case"true":return O.has(K);case"false":return O.not(K);default:return O.equals(K,Ie)}}case 4:{this.x();const Ie=this.u();if(this.v().type===18)return O.notEquals(K,Ie);switch(Ie){case"true":return O.not(K);case"false":return O.has(K);default:return O.notEquals(K,Ie)}}case 5:return this.x(),j.create(K,this.u());case 6:return this.x(),U.create(K,this.u());case 7:return this.x(),Y.create(K,this.u());case 8:return this.x(),J.create(K,this.u());case 13:return this.x(),O.in(K,this.u());default:return O.has(K)}}case 20:throw this.g.push({message:T,offset:L.offset,lexeme:"",additionalInfo:p}),new f;default:throw this.z(`true | false | CONTEXT 
	| CONTEXT '=~' REGEX 
	| CONTEXT ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.B())}}u(){const L=this.B();switch(L.type){case 17:case 18:return this.x(),L.lexeme;case 11:return this.x(),"true";case 12:return this.x(),"false";case 13:return this.x(),"in";default:return""}}v(){return this.d[this.f-1]}w(L){return this.A(L)?(this.x(),!0):!1}x(){return this.C()||this.f++,this.v()}y(L,K){if(this.A(L))return this.x();throw this.z(K,this.B())}z(L,K,me){const Ie=(0,R.localize)(9,null,L,C.Scanner.getLexeme(K)),we=K.offset,ve=C.Scanner.getLexeme(K);return this.g.push({message:Ie,offset:we,lexeme:ve,additionalInfo:me}),new f}A(L){return this.B().type===L}B(){return this.d[this.f]}C(){return this.B().type===20}}e.Parser=i;function l(V){const L=new i({regexParsingWithErrorRecovery:!1});return V.map(K=>(L.parse(K),L.lexingErrors.length>0?L.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,R.localize)(10,null,me.additionalInfo):(0,R.localize)(11,null),offset:me.offset,length:me.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=l;function r(V,L){const K=V?V.substituteConstants():void 0,me=L?L.substituteConstants():void 0;return!K&&!me?!0:!K||!me?!1:K.equals(me)}e.expressionsAreEqualWithConstantSubstitution=r;function c(V,L){return V.cmp(L)}class o{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return I.INSTANCE}}o.INSTANCE=new o,e.ContextKeyFalseExpr=o;class I{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return o.INSTANCE}}I.INSTANCE=new I,e.ContextKeyTrueExpr=I;class s{static create(L,K=null){const me=A.get(L);return typeof me=="boolean"?me?I.INSTANCE:o.INSTANCE:new s(L,K)}constructor(L,K){this.key=L,this.c=K,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?I.INSTANCE:o.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=s;class u{static create(L,K,me=null){if(typeof K=="boolean")return K?s.create(L,me):W.create(L,me);const Ie=A.get(L);return typeof Ie=="boolean"?K===(Ie?"true":"false")?I.INSTANCE:o.INSTANCE:new u(L,K,me)}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const K=L?"true":"false";return this.d===K?I.INSTANCE:o.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class v{static create(L,K){return new v(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:de(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const K=L.getValue(this.f),me=L.getValue(this.d);return Array.isArray(K)?K.includes(me):typeof me=="string"&&typeof K=="object"&&K!==null?w.call(K,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=v;class S{static create(L,K){return new S(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=11,this.c=v.create(L,K)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=S;class E{static create(L,K,me=null){if(typeof K=="boolean")return K?W.create(L,me):s.create(L,me);const Ie=A.get(L);return typeof Ie=="boolean"?K===(Ie?"true":"false")?o.INSTANCE:I.INSTANCE:new E(L,K,me)}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const K=L?"true":"false";return this.d===K?o.INSTANCE:I.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=E;class W{static create(L,K=null){const me=A.get(L);return typeof me=="boolean"?me?o.INSTANCE:I.INSTANCE:new W(L,K)}constructor(L,K){this.c=L,this.d=K,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?o.INSTANCE:I.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=s.create(this.c,this)),this.d}}e.ContextKeyNotExpr=W;function X(V,L){if(typeof V=="string"){const K=parseFloat(V);isNaN(K)||(V=K)}return typeof V=="string"||typeof V=="number"?L(V):o.INSTANCE}class Y{static create(L,K,me=null){return X(K,Ie=>new Y(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=Y;class J{static create(L,K,me=null){return X(K,Ie=>new J(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=J;class j{static create(L,K,me=null){return X(K,Ie=>new j(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=j;class U{static create(L,K,me=null){return X(K,Ie=>new U(L,Ie,me))}constructor(L,K,me){this.c=L,this.d=K,this.f=me,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=U;class ${static create(L,K){return new $(L,K)}constructor(L,K){this.d=L,this.f=K,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const K=this.f?this.f.source:"",me=L.f?L.f.source:"";return K<me?-1:K>me?1:0}equals(L){if(L.type===this.type){const K=this.f?this.f.source:"",me=L.f?L.f.source:"";return this.d===L.d&&K===me}return!1}substituteConstants(){return this}evaluate(L){const K=L.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.ContextKeyRegexExpr=$;class B{static create(L){return new B(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new B(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=B;function q(V){let L=null;for(let K=0,me=V.length;K<me;K++){const Ie=V[K].substituteConstants();if(V[K]!==Ie&&L===null){L=[];for(let we=0;we<K;we++)L[we]=V[we]}L!==null&&(L[K]=Ie)}return L===null?V:L}class he{static create(L,K,me){return he.d(L,K,me)}constructor(L,K){this.expr=L,this.c=K,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let K=0,me=this.expr.length;K<me;K++){const Ie=c(this.expr[K],L.expr[K]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].equals(L.expr[K]))return!1;return!0}return!1}substituteConstants(){const L=q(this.expr);return L===this.expr?this:he.create(L,this.c,!1)}evaluate(L){for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].evaluate(L))return!1;return!0}static d(L,K,me){const Ie=[];let we=!1;for(const ve of L)if(!!ve){if(ve.type===1){we=!0;continue}if(ve.type===0)return o.INSTANCE;if(ve.type===6){Ie.push(...ve.expr);continue}Ie.push(ve)}if(Ie.length===0&&we)return I.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(c);for(let ve=1;ve<Ie.length;ve++)Ie[ve-1].equals(Ie[ve])&&(Ie.splice(ve,1),ve--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const ve=Ie[Ie.length-1];if(ve.type!==9)break;Ie.pop();const Ce=Ie.pop(),se=Ie.length===0,ae=Ee.create(ve.expr.map(Z=>he.create([Z,Ce],null,me)),null,se);ae&&(Ie.push(ae),Ie.sort(c))}if(Ie.length===1)return Ie[0];if(me){for(let ve=0;ve<Ie.length;ve++)for(let Ce=ve+1;Ce<Ie.length;Ce++)if(Ie[ve].negate().equals(Ie[Ce]))return o.INSTANCE;if(Ie.length===1)return Ie[0]}return new he(Ie,K)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const K of this.expr)L.push(...K.keys());return L}map(L){return new he(this.expr.map(K=>K.map(L)),null)}negate(){if(!this.c){const L=[];for(const K of this.expr)L.push(K.negate());this.c=Ee.create(L,this,!0)}return this.c}}class Ee{static create(L,K,me){return Ee.d(L,K,me)}constructor(L,K){this.expr=L,this.c=K,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let K=0,me=this.expr.length;K<me;K++){const Ie=c(this.expr[K],L.expr[K]);if(Ie!==0)return Ie}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let K=0,me=this.expr.length;K<me;K++)if(!this.expr[K].equals(L.expr[K]))return!1;return!0}return!1}substituteConstants(){const L=q(this.expr);return L===this.expr?this:Ee.create(L,this.c,!1)}evaluate(L){for(let K=0,me=this.expr.length;K<me;K++)if(this.expr[K].evaluate(L))return!0;return!1}static d(L,K,me){let Ie=[],we=!1;if(L){for(let ve=0,Ce=L.length;ve<Ce;ve++){const se=L[ve];if(!!se){if(se.type===0){we=!0;continue}if(se.type===1)return I.INSTANCE;if(se.type===9){Ie=Ie.concat(se.expr);continue}Ie.push(se)}}if(Ie.length===0&&we)return o.INSTANCE;Ie.sort(c)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let ve=1;ve<Ie.length;ve++)Ie[ve-1].equals(Ie[ve])&&(Ie.splice(ve,1),ve--);if(Ie.length===1)return Ie[0];if(me){for(let ve=0;ve<Ie.length;ve++)for(let Ce=ve+1;Ce<Ie.length;Ce++)if(Ie[ve].negate().equals(Ie[Ce]))return I.INSTANCE;if(Ie.length===1)return Ie[0]}return new Ee(Ie,K)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const K of this.expr)L.push(...K.keys());return L}map(L){return new Ee(this.expr.map(K=>K.map(L)),null)}negate(){if(!this.c){const L=[];for(const K of this.expr)L.push(K.negate());for(;L.length>1;){const K=L.shift(),me=L.shift(),Ie=[];for(const we of re(K))for(const ve of re(me))Ie.push(he.create([we,ve],null,!1));L.unshift(Ee.create(Ie,null,!1))}this.c=Ee.create(L,this,!0)}return this.c}}class ie extends s{static all(){return ie.d.values()}constructor(L,K,me){super(L,null),this.f=K,typeof me=="object"?ie.d.push({...me,key:L}):me!==!0&&ie.d.push({key:L,description:me,type:K!=null?typeof K:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return u.create(this.key,L)}notEqualsTo(L){return E.create(this.key,L)}}ie.d=[],e.RawContextKey=ie,e.IContextKeyService=(0,M.createDecorator)("contextKeyService");function ce(V,L){return V<L?-1:V>L?1:0}function de(V,L,K,me){return V<K?-1:V>K?1:L<me?-1:L>me?1:0}function Te(V,L){if(V.type===0||L.type===1)return!0;if(V.type===9)return L.type===9?le(V.expr,L.expr):!1;if(L.type===9){for(const K of L.expr)if(Te(V,K))return!0;return!1}if(V.type===6){if(L.type===6)return le(L.expr,V.expr);for(const K of V.expr)if(Te(K,L))return!0;return!1}return V.equals(L)}e.implies=Te;function le(V,L){let K=0,me=0;for(;K<V.length&&me<L.length;){const Ie=V[K].cmp(L[me]);if(Ie<0)return!1;Ie===0&&K++,me++}return K===V.length}function re(V){return V.type===9?V.expr:[V]}}),define(Ae[164],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ae[90],Re([1,0,137,3]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function R(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function A(a,m){return m==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function w(a,m,y){return A(m,y)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===y?!0:h(y).includes(a)}e.isTargetPlatformCompatible=w;function h(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function O(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=O;var D;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var f;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var b;(function(a){a.Install="install",a.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var g;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var d;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class t extends Error{constructor(m,y){super(m),this.code=y,this.name=y}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Ae[43],Re([1,0,48,19,13,9,2,139,3,20,15]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function D(ie){return ie.create===!0}e.isFileOpenForWriteOptions=D;var f;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(f=e.FileType||(e.FileType={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var g;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(ie){return!!(ie.capabilities&2)}e.hasReadWriteCapability=d;function t(ie){return!!(ie.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(ie){return!!(ie.capabilities&32768)}e.hasFileCloneCapability=a;function m(ie){return!!(ie.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function y(ie){return!!(ie.capabilities&16)}e.hasFileReadStreamCapability=y;function T(ie){return d(ie)?!!(ie.capabilities&16384):!1}e.hasFileAtomicReadCapability=T;var p;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(ce,de){const Te=new i(ce.toString(),de);return c(Te,de),Te}constructor(ce,de){super(ce),this.code=de}}e.FileSystemProviderError=i;function l(ie,ce){return i.create(ie,ce)}e.createFileSystemProviderError=l;function r(ie){return ie||l((0,A.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function c(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.markAsFileSystemProviderError=c;function o(ie){if(!ie)return p.Unknown;if(ie instanceof i)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return p.Unknown;switch(ce[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=o;function I(ie){if(ie instanceof W)return ie.fileOperationResult;switch(o(ie)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=I;var s;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(ce,de,Te){this.resource=ce,this.operation=de,this.target=Te}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=u;var v;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class S{constructor(ce,de){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Te=new Map;for(const le of ce){const re=Te.get(le.type);switch(re?re.push([le.resource,le]):Te.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,re]of Te)switch(le){case 1:this.a=n.TernarySearchTree.forUris(()=>de),this.a.fill(re);break;case 0:this.b=n.TernarySearchTree.forUris(()=>de),this.b.fill(re);break;case 2:this.c=n.TernarySearchTree.forUris(()=>de),this.c.fill(re);break}}contains(ce,...de){return this.d(ce,{includeChildren:!1},...de)}affects(ce,...de){return this.d(ce,{includeChildren:!0},...de)}d(ce,de,...Te){if(!ce)return!1;const le=Te.length>0;return!!((!le||Te.includes(1))&&(this.a?.get(ce)||de.includeChildren&&this.a?.findSuperstr(ce))||(!le||Te.includes(0))&&(this.b?.get(ce)||de.includeChildren&&this.b?.findSuperstr(ce))||(!le||Te.includes(2))&&(this.c?.findSubstr(ce)||de.includeChildren&&this.c?.findSuperstr(ce)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function E(ie,ce,de){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==P.sep&&(ce+=P.sep),de?(0,C.startsWithIgnoreCase)(ie,ce):ie.indexOf(ce)===0)}e.isParent=E;class W extends Error{constructor(ce,de,Te){super(ce),this.fileOperationResult=de,this.options=Te}}e.FileOperationError=W;class X extends W{constructor(ce,de,Te,le){super(ce,de,le),this.fileOperationResult=de,this.size=Te}}e.TooLargeFileOperationError=X;class Y extends W{constructor(ce,de,Te){super(ce,2,Te),this.stat=de}}e.NotModifiedSinceFileOperationError=Y;var J;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ie[ie.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.etag=U;async function $(ie,ce){if(!ce.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(de=>{const Te=ce.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===ie.scheme&&le.added&&(Te.dispose(),de())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(ce){return(0,M.isNumber)(ce)||(ce=0),ce<B.KB?(0,A.localize)(1,null,ce.toFixed(0)):ce<B.MB?(0,A.localize)(2,null,(ce/B.KB).toFixed(2)):ce<B.GB?(0,A.localize)(3,null,(ce/B.MB).toFixed(2)):ce<B.TB?(0,A.localize)(4,null,(ce/B.GB).toFixed(2)):(0,A.localize)(5,null,(ce/B.TB).toFixed(2))}}B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB,e.ByteSize=B;var q;(function(ie){ie[ie.IA32=0]="IA32",ie[ie.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function he(ie){return{maxFileSize:ie===0?300*B.MB:16*B.GB,maxHeapSize:ie===0?700*B.MB:2*700*B.MB}}e.getPlatformFileLimits=he;function Ee(ie){const ce=typeof ie=="string"||ie?.scheme===O.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===O.Schemas.file?1024*B.MB:ce?10*B.MB:h.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=Ee}),define(Ae[69],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...C){this.a=new Map;for(const[M,R]of C)this.set(M,R)}set(C,M){const R=this.a.get(C);return this.a.set(C,M),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=n}),define(Ae[165],Re([1,0,17,10,6,67,163,3,69,166]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class f{constructor(t=new w.ServiceCollection,a=!1,m,y=O){this.f=t,this.g=a,this.h=m,this.i=y,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=y?m?._globalGraph??new R.Graph(T=>T):void 0}createChild(t){return new f(t,this.g,this,this.i)}invokeFunction(t,...a){const m=g.traceInvocation(this.i,t);let y=!1;try{return t({get:p=>{if(y)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(p,m);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...a)}finally{y=!0,m.stop()}}createInstance(t,...a){let m,y;return t instanceof M.SyncDescriptor?(m=g.traceCreation(this.i,t.ctor),y=this.j(t.ctor,t.staticArguments.concat(a),m)):(m=g.traceCreation(this.i,t),y=this.j(t,a,m)),m.stop(),y}j(t,a=[],m){const y=A._util.getServiceDependencies(t).sort((i,l)=>i.index-l.index),T=[];for(const i of y){const l=this.m(i.id,m);l||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),T.push(l)}const p=y.length>0?y[0].index:a.length;if(a.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${a.length} static arguments`);const i=p-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,p)}return Reflect.construct(t,a.concat(T))}k(t,a){if(this.f.get(t)instanceof M.SyncDescriptor)this.f.set(t,a);else if(this.h)this.h.k(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const a=this.f.get(t);return!a&&this.h?this.h.l(t):a}m(t,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const m=this.l(t);return m instanceof M.SyncDescriptor?this.q(t,m,a.branch(t,!0)):(a.branch(t,!1),m)}q(t,a,m){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,a,m)}finally{this.o.delete(t)}}r(t,a,m){const y=new R.Graph(i=>i.id.toString());let T=0;const p=[{id:t,desc:a,_trace:m}];for(;p.length;){const i=p.pop();if(y.lookupOrInsertNode(i),T++>1e3)throw new D(y);for(const l of A._util.getServiceDependencies(i.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),r instanceof M.SyncDescriptor){const c={id:l.id,desc:r,_trace:i._trace.branch(l.id,!0)};y.insertEdge(i,c),p.push(c)}}}for(;;){const i=y.roots();if(i.length===0){if(!y.isEmpty())throw new D(y);break}for(const{data:l}of i){if(this.l(l.id)instanceof M.SyncDescriptor){const c=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,c)}y.removeNode(l)}}return this.l(t)}s(t,a,m=[],y,T){if(this.f.get(t)instanceof M.SyncDescriptor)return this.t(t,a,m,y,T);if(this.h)return this.h.s(t,a,m,y,T);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(t,a,m=[],y,T){if(y){const p=new f(void 0,this.g,this,this.i);p.c=String(t);const i=new Map,l=new n.IdleValue(()=>{const r=p.j(a,m,T);for(const[c,o]of i){const I=r[c];if(typeof I=="function")for(const s of o)I.apply(r,s)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!l.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let s=i.get(c);return s||(s=new h.LinkedList,i.set(c,s)),(v,S,E)=>{const W=s.push([v,S,E]);return(0,C.toDisposable)(W)}}if(c in r)return r[c];const o=l.value;let I=o[c];return typeof I!="function"||(I=I.bind(o),r[c]=I),I},set(r,c,o){return l.value[c]=o,!0},getPrototypeOf(r){return a.prototype}})}else return this.j(a,m,T)}u(t,a){if(a&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=f;var b;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(b||(b={}));class g{static traceInvocation(t,a){return t?new g(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(t,a){return t?new g(1,a.name):g.c}constructor(t,a){this.type=t,this.name=a,this.g=Date.now(),this.h=[]}branch(t,a){const m=new g(3,t.toString());return this.h.push([t,a,m]),m}stop(){const t=Date.now()-this.g;g.f+=t;let a=!1;function m(T,p){const i=[],l=new Array(T+1).join("	");for(const[r,c,o]of p.h)if(c&&o){a=!0,i.push(`${l}CREATES -> ${r}`);const I=m(T+1,o);I&&i.push(I)}else i.push(`${l}uses -> ${r}`);return i.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(t>2||a)&&g.all.add(y.join(`
`))}}g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0,e.Trace=g}),define(Ae[14],Re([1,0,40,5,91,6,28,20,22,9,2,31,3]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function b(){return new Date().toISOString()}function g(v){return(0,h.isNumber)(v)}e.isLogLevel=g;var d;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function t(v,S,E){switch(S){case d.Trace:v.trace(E);break;case d.Debug:v.debug(E);break;case d.Info:v.info(E);break;case d.Warning:v.warn(E);break;case d.Error:v.error(E);break;case d.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=t;function a(v,S=!1){let E="";for(let W=0;W<v.length;W++){let X=v[W];if(X instanceof Error&&(X=(0,n.toErrorMessage)(X,S)),typeof X=="object")try{X=JSON.stringify(X)}catch{}E+=(W>0?" ":"")+X}return E}class m extends M.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.D(new P.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==d.Off&&this.b<=S}}e.AbstractLogger=m;class y extends m{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...E){this.f(d.Trace)&&this.g(d.Trace,a([S,...E],!0))}debug(S,...E){this.f(d.Debug)&&this.g(d.Debug,a([S,...E]))}info(S,...E){this.f(d.Info)&&this.g(d.Info,a([S,...E]))}warn(S,...E){this.f(d.Warning)&&this.g(d.Warning,a([S,...E]))}error(S,...E){if(this.f(d.Error))if(S instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=S.stack,this.g(d.Error,a(W))}else this.g(d.Error,a([S,...E]))}flush(){}}e.AbstractMessageLogger=y;class T extends m{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.g=!A.isWindows}trace(S,...E){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}debug(S,...E){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}info(S,...E){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,S,...E):console.log(`[main ${b()}]`,S,...E))}warn(S,...E){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,S,...E):console.warn(`[main ${b()}]`,S,...E))}error(S,...E){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,S,...E):console.error(`[main ${b()}]`,S,...E))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class p extends m{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S)}trace(S,...E){this.f(d.Trace)&&console.log("%cTRACE","color: #888",S,...E)}debug(S,...E){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",S,...E)}info(S,...E){this.f(d.Info)&&console.log("%c INFO","color: #33f",S,...E)}warn(S,...E){this.f(d.Warning)&&console.log("%c WARN","color: #993",S,...E)}error(S,...E){this.f(d.Error)&&console.log("%c  ERR","color: #f33",S,...E)}dispose(){}flush(){}}e.ConsoleLogger=p;class i extends m{constructor(S,E=e.DEFAULT_LOG_LEVEL){super(),this.g=S,this.setLevel(E)}trace(S,...E){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(S),...E])}debug(S,...E){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(S),...E])}info(S,...E){this.f(d.Info)&&this.g.log(d.Info,[this.h(S),...E])}warn(S,...E){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(S),...E])}error(S,...E){this.f(d.Error)&&this.g.log(d.Error,[this.h(S),...E])}h(S){return typeof S=="string"?S:(0,n.toErrorMessage)(S,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class l extends m{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const E of this.g)E.setLevel(S);super.setLevel(S)}trace(S,...E){for(const W of this.g)W.trace(S,...E)}debug(S,...E){for(const W of this.g)W.debug(S,...E)}info(S,...E){for(const W of this.g)W.info(S,...E)}warn(S,...E){for(const W of this.g)W.warn(S,...E)}error(S,...E){for(const W of this.g)W.error(S,...E)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.MultiplexLogger=l;class r extends M.Disposable{constructor(S,E,W){if(super(),this.h=S,this.j=E,this.b=new R.ResourceMap,this.c=this.D(new P.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.D(new P.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.D(new P.Emitter),this.onDidChangeVisibility=this.g.event,W)for(const X of W)this.b.set(X.resource,{logger:void 0,info:X})}k(S){return(0,h.isString)(S)?[...this.b.values()].find(E=>E.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,E){const W=this.l(S),X=(0,h.isString)(S)?S:E?.id??(0,C.hash)(W.toString()).toString(16);let Y=this.b.get(W)?.logger;const J=E?.logLevel==="always"?d.Trace:E?.logLevel;Y||(Y=this.m(W,J??this.getLogLevel(W)??this.h,{...E,id:X}));const j={logger:Y,info:{resource:W,id:X,logLevel:J,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(W,j),Y}l(S){return(0,h.isString)(S)?(0,w.joinPath)(this.j,`${S}.log`):S}setLogLevel(S,E){if(O.URI.isUri(S)){const W=S,X=E,Y=this.b.get(W);Y&&X!==Y.info.logLevel&&(Y.info.logLevel=X===this.h?void 0:X,Y.logger?.setLevel(X),this.b.set(Y.info.resource,Y),this.f.fire([W,X]))}else{this.h=S;for(const[W,X]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,E){const W=this.k(S);W&&E!==!W.info.hidden&&(W.info.hidden=!E,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,E]))}getLogLevel(S){let E;return S&&(E=this.b.get(S)?.info.logLevel),E??this.h}registerLogger(S){const E=this.b.get(S.resource);E?E.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const E=this.b.get(S);E&&(E.logger&&E.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class c{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(S){}getLevel(){return d.Info}trace(S,...E){}debug(S,...E){}info(S,...E){}warn(S,...E){}error(S,...E){}critical(S,...E){}dispose(){}flush(){}}e.NullLogger=c;class o extends c{}e.NullLogService=o;function I(v){if(v.verbose)return d.Trace;if(typeof v.logLevel=="string"){const S=u(v.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function s(v){switch(v){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=s;function u(v){switch(v){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new D.RawContextKey("logLevel",s(d.Info))}),define(Ae[167],Re([1,0,6,14]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends n.Disposable{constructor(R,A=[]){super(),this.a=new P.MultiplexLogger([R,...A]),this.D(R.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.LogService=C}),define(Ae[92],Re([1,0,29,140,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var R;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function h(g,d){return d-g}w.compare=h;const O=Object.create(null);O[w.Error]=(0,P.localize)(0,null),O[w.Warning]=(0,P.localize)(1,null),O[w.Info]=(0,P.localize)(2,null);function D(g){return O[g]||""}w.toString=D;function f(g){switch(g){case n.default.Error:return w.Error;case n.default.Warning:return w.Warning;case n.default.Info:return w.Info;case n.default.Ignore:return w.Hint}}w.fromSeverity=f;function b(g){switch(g){case w.Error:return n.default.Error;case w.Warning:return n.default.Warning;case w.Info:return n.default.Info;case w.Hint:return n.default.Ignore}}w.toSeverity=b}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(w){const h="";function O(f){return D(f,!0)}w.makeKey=O;function D(f,b){const g=[h];return f.source?g.push(f.source.replace("\xA6","\\\xA6")):g.push(h),f.code?typeof f.code=="string"?g.push(f.code.replace("\xA6","\\\xA6")):g.push(f.code.value.replace("\xA6","\\\xA6")):g.push(h),f.severity!==void 0&&f.severity!==null?g.push(R.toString(f.severity)):g.push(h),f.message&&b?g.push(f.message.replace("\xA6","\\\xA6")):g.push(h),f.startLineNumber!==void 0&&f.startLineNumber!==null?g.push(f.startLineNumber.toString()):g.push(h),f.startColumn!==void 0&&f.startColumn!==null?g.push(f.startColumn.toString()):g.push(h),f.endLineNumber!==void 0&&f.endLineNumber!==null?g.push(f.endLineNumber.toString()):g.push(h),f.endColumn!==void 0&&f.endColumn!==null?g.push(f.endColumn.toString()):g.push(h),g.push(h),g.join("\xA6")}w.makeKeyOptionalMessage=D})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(Ae[168],Re([1,0,5,29,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,C.createDecorator)("notificationService");var M;(function(h){h[h.WORKSPACE=0]="WORKSPACE",h[h.PROFILE=1]="PROFILE",h[h.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(h){h[h.OFF=0]="OFF",h[h.SILENT=1]="SILENT",h[h.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new w,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class w{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=w}),define(Ae[93],Re([1,0,13,2,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService");function M(h,O){return P.URI.isUri(h)?(0,n.equalsIgnoreCase)(h.scheme,O):(0,n.startsWithIgnoreCase)(h,O+":")}e.matchesScheme=M;function R(h,...O){return O.some(D=>M(h,D))}e.matchesSomeScheme=R;function A(h,O){return h.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function w(h){let O;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(h.fragment);return D&&(O={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},h=h.with({fragment:""})),{selection:O,uri:h}}e.extractSelection=w}),define(Ae[169],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(ee,e,n,P){var C=arguments.length,M=C<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,n):P,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ee,e,n,P);else for(var A=ee.length-1;A>=0;A--)(R=ee[A])&&(M=(C<3?R(M):C>3?R(e,n,M):R(e,n))||M);return C>3&&M&&Object.defineProperty(e,n,M),M},Ve=this&&this.__param||function(ee,e){return function(n,P){e(n,P,ee)}};define(Ae[170],Re([1,0,17,21,6,3]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var R;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}A.None=Object.freeze({report(){}}),e.Progress=A;let w=class extends C.Disposable{constructor(D,f){super(),this.a=new n.DeferredPromise,f.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.D((0,C.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};w=je([Ve(1,e.IProgressService)],w),e.UnmanagedProgress=w;class h extends C.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.D(new C.DisposableStore)}start(D){this.stop();const f=++this.a,b=new P.CancellationTokenSource;return this.f=setTimeout(()=>{f===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,C.toDisposable)(()=>b.cancel())),this.b.add((0,C.toDisposable)(()=>this.c?this.c.done():void 0)),{id:f,token:b.token,stop:()=>this.h(f),isCurrent:()=>this.a===f}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=h,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ae[30],Re([1,0,49,9]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(R,A){n.ok(P.isString(R)),n.ok(P.isObject(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new C}),define(Ae[70],Re([1,0,5,30]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,h){this.a[C(w)]=h,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;P.Registry.add(e.Extensions.JSONContribution,R)}),define(Ae[94],Re([1,0,16,5,9,134,42,70,30]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=w.Registry.as(A.Extensions.JSONContribution);class f{constructor(){this.h=new Set,this.i=new P.Emitter,this.onDidSchemaChange=this.i.event,this.j=new P.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const r=new Set;this.n(i,l,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const l=new Set;this.o(i,l),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const r=new Set;this.o(l,r),this.n(i,!1,r),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const r=[];for(const{overrides:c,source:o}of i)for(const I in c)if(l.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const s=this.a.get(I),u=s?.valuesSources??new Map;if(o)for(const W of Object.keys(c[I]))u.set(W,o);const v={...s?.value||{},...c[I]};this.a.set(I,{source:o,value:v,valuesSources:u});const S=(0,R.getLanguageTagSettingPlainKey)(I),E={type:"object",default:v,description:M.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:C.isString(o)?void 0:o,defaultValueSource:o};r.push(...d(I)),this.d[I]=E,this.b.properties[I]=E}else{this.a.set(I,{value:c[I],source:o});const s=this.d[I];s&&(this.w(I,s),this.r(I,s))}this.m(r)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:r,source:c}of i)for(const o in r){const I=this.a.get(o),s=C.isString(c)?c:c?.id,u=C.isString(I?.source)?I?.source:I?.source?.id;if(s===u)if(l.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}}this.u()}deltaConfiguration(i){let l=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,r){i.forEach(c=>{this.p(c,l,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(i,l){const r=c=>{if(c.properties)for(const o in c.properties){l.add(o);const I=this.d[o];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[o],this.s(o,c.properties[o])}c.allOf?.forEach(o=>r(o))};for(const c of i){r(c);const o=this.c.indexOf(c);o!==-1&&this.c.splice(o,1)}}p(i,l=!0,r,c,o=3,I){o=C.isUndefinedOrNull(i.scope)?o:i.scope;const s=i.properties;if(s)for(const v in s){const S=s[v];if(l&&y(v,S)){delete s[v];continue}if(S.source=r,S.defaultDefaultValue=s[v].default,this.w(v,S),e.OVERRIDE_PROPERTY_REGEX.test(v)?S.scope=void 0:(S.scope=C.isUndefinedOrNull(S.scope)?o:S.scope,S.restricted=C.isUndefinedOrNull(S.restricted)?!!c?.includes(v):S.restricted),s[v].hasOwnProperty("included")&&!s[v].included){this.f[v]=s[v],delete s[v];continue}else this.d[v]=s[v],s[v].policy?.name&&this.e.set(s[v].policy.name,v);!s[v].deprecationMessage&&s[v].markdownDeprecationMessage&&(s[v].deprecationMessage=s[v].markdownDeprecationMessage),I.add(v)}const u=i.allOf;if(u)for(const v of u)this.p(v,l,r,c,o,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=r=>{const c=r.properties;if(c)for(const I in c)this.r(I,c[I]);r.allOf?.forEach(l)};l(i)}r(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,r),e.allSettings.properties[l]=r,e.applicationSettings.properties[l]=r,e.machineSettings.properties[l]=r,e.machineOverridableSettings.properties[l]=r,e.windowSettings.properties[l]=r,e.resourceSettings.properties[l]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,l){const r=this.a.get(i);let c=r?.value,o=r?.source;C.isUndefined(c)&&(c=l.defaultDefaultValue,o=void 0),C.isUndefined(c)&&(c=a(l.type)),l.default=c,l.defaultValueSource=o}}const b="\\[([^\\]]+)\\]",g=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=g.exec(p);for(;l?.length;){const r=l[1].trim();r&&i.push(r),l=g.exec(p)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=d;function t(p){return p.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=t;function a(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const m=new f;w.Registry.add(e.Extensions.Configuration,m);function y(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):i.policy?.name&&m.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,p,i.policy?.name,m.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=y;function T(){const p=[],i=m.getConfigurationProperties();for(const l of Object.keys(i))p.push([l,i[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=T}),define(Ae[171],Re([1,0,16,5,113,6,28,23,9,2,42,94,30]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(l){return Object.isFrozen(l)?l:A.deepFreeze(l)}class g{constructor(r={},c=[],o=[],I){this.b=r,this.c=c,this.d=o,this.raw=I,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof g)return c;const o=new d("");return o.parseRaw(c),o.configurationModel});this.f=r.reduce((c,o)=>o===c?o:c.merge(o),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const o=this.rawConfiguration.getValue(r),I=c?this.rawConfiguration.getOverrideValue(r,c):void 0,s=c?this.rawConfiguration.override(c).getValue(r):o;return{value:o,override:I,merged:s}}getOverrideValue(r,c){const o=this.i(c);return o?r?(0,O.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const o of this.overrides)o.identifiers.includes(r)&&c.push(...o.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return n.distinct(r)}override(r){let c=this.a.get(r);return c||(c=this.g(r),this.a.set(r,c)),c}merge(...r){const c=A.deepClone(this.contents),o=A.deepClone(this.overrides),I=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of r)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(c,u.contents);for(const v of u.overrides){const[S]=o.filter(E=>n.equals(E.identifiers,v.identifiers));S?(this.h(S.contents,v.contents),S.keys.push(...v.keys),S.keys=n.distinct(S.keys)):o.push(A.deepClone(v))}for(const v of u.keys)I.indexOf(v)===-1&&I.push(v)}return new g(c,I,o,s.every(u=>u instanceof g)?void 0:s)}g(r){const c=this.i(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const o={};for(const I of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let s=this.contents[I];const u=c[I];u&&(typeof s=="object"&&typeof u=="object"?(s=A.deepClone(s),this.h(s,u)):s=u),o[I]=s}return new g(o,this.keys,this.overrides)}h(r,c){for(const o of Object.keys(c)){if(o in r&&w.isObject(r[o])&&w.isObject(c[o])){this.h(r[o],c[o]);continue}r[o]=A.deepClone(c[o])}}i(r){let c=null,o=null;const I=s=>{s&&(o?this.h(o,s):o=A.deepClone(s))};for(const s of this.overrides)n.equals(s.identifiers,[r])?c=s.contents:s.identifiers.includes(r)&&I(s.contents);return I(c),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.j(r,c,!0)}setValue(r,c){this.j(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,O.removeFromValueTree)(this.contents,r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(o=>n.equals(o.identifiers,(0,D.overrideIdentifiersFromKey)(r))),1))}j(r,c,o){(0,O.addToValueTree)(this.contents,r,c,I=>console.error(I)),o=o||this.keys.indexOf(r)===-1,o&&this.keys.push(r),D.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,D.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],I=>console.error(I))})}}e.ConfigurationModel=g;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!w.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:o,keys:I,overrides:s,restricted:u,hasExcludedProperties:v}=this.h(r,c);this.b=new g(o,I,s,v?[r]:void 0),this.c=u||[]}g(r){let c={},o=null,I=[];const s=[],u=[];function v(E){Array.isArray(I)?I.push(E):o!==null&&(I[o]=E)}const S={onObjectBegin:()=>{const E={};v(E),s.push(I),I=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{I=s.pop()},onArrayBegin:()=>{const E=[];v(E),s.push(I),I=E,o=null},onArrayEnd:()=>{I=s.pop()},onLiteralValue:v,onError:(E,W,X)=>{u.push({error:E,offset:W,length:X})}};if(r)try{C.visit(r,S),c=I[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return c}h(r,c){const o=f.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),I=this.i(r,o,!0,c);r=I.raw;const s=(0,O.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),u=Object.keys(r),v=this.j(r,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:s,keys:u,overrides:v,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}i(r,c,o,I){let s=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const u={},v=[];for(const S in r)if(D.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const E=this.i(r[S],c,!1,I);u[S]=E.raw,s=s||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=c[S],W=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(S),(W===void 0||I.scopes===void 0||I.scopes.includes(W))&&!(I.skipRestricted&&E?.restricted)?u[S]=r[S]:s=!0}return{raw:u,restricted:v,hasExcludedProperties:s}}j(r,c){const o=[];for(const I of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(I)){const s={};for(const u in r[I])s[u]=r[I][u];o.push({identifiers:(0,D.overrideIdentifiersFromKey)(I),keys:Object.keys(s),contents:(0,O.toValuesTree)(s,c)})}return o}}e.ConfigurationModelParser=d;class t extends M.Disposable{constructor(r,c,o,I){super(),this.f=r,this.g=c,this.h=I,this.c=this.D(new P.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.D(this.h.watch(o.dirname(this.f))),this.D(this.h.watch(this.f)),this.D(P.Event.any(P.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),P.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(r,c,o,I,s,u,v,S,E,W,X,Y,J){this.a=r,this.b=c,this.c=o,this.overrideIdentifiers=I,this.d=s,this.f=u,this.g=v,this.h=S,this.i=E,this.j=W,this.k=X,this.l=Y,this.m=J}get value(){return b(this.c)}n(r,c,o){const I=r.inspect(c,o);return{get value(){return b(I.value)},get override(){return b(I.override)},get merged(){return b(I.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(r,c,o,I,s=new g,u=new g,v=new R.ResourceMap,S=new g,E=new R.ResourceMap){this.c=r,this.d=c,this.f=o,this.g=I,this.h=s,this.i=u,this.j=v,this.l=S,this.m=E,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(r,c,o){return this.q(r,c,o).getValue(r)}updateValue(r,c,o={}){let I;o.resource?(I=this.m.get(o.resource),I||(I=new g,this.m.set(o.resource,I))):I=this.l,c===void 0?I.removeValue(r):I.setValue(r,c),o.resource||(this.a=null)}inspect(r,c,o){const I=this.q(r,c,o),s=this.u(c.resource,o),u=c.resource?this.m.get(c.resource)||this.l:this.l,v=new Set;for(const S of I.overrides)for(const E of S.identifiers)I.getOverrideValue(r,E)!==void 0&&v.add(E);return new a(r,c,I.getValue(r),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,s||void 0,u)}keys(r){const c=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.j.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const o=[];if(!c){const{added:I,updated:s,removed:u}=p(this.c,r);c=[...I,...s,...u]}for(const I of c)for(const s of(0,D.overrideIdentifiersFromKey)(I)){const u=this.c.getKeysForOverrideIdentifier(s),v=r.getKeysForOverrideIdentifier(s),S=[...v.filter(E=>u.indexOf(E)===-1),...u.filter(E=>v.indexOf(E)===-1),...u.filter(E=>!A.equals(this.c.override(s).getValue(E),r.override(s).getValue(E)))];o.push([s,S])}return this.updateDefaultConfiguration(r),{keys:c,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:o,removed:I}=p(this.d,r),s=[...c,...o,...I];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:o,removed:I,overrides:s}=p(this.applicationConfiguration,r),u=[...c,...o,...I];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:o,removed:I,overrides:s}=p(this.localUserConfiguration,r),u=[...c,...o,...I];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:o,removed:I,overrides:s}=p(this.remoteUserConfiguration,r),u=[...c,...o,...I];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:o,removed:I,overrides:s}=p(this.workspaceConfiguration,r),u=[...c,...o,...I];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(r,c){const o=this.p.get(r),{added:I,updated:s,removed:u,overrides:v}=p(o,c),S=[...I,...s,...u];return(S.length||!o)&&this.updateFolderConfiguration(r,c),{keys:S,overrides:v}}compareAndDeleteFolderConfiguration(r){const c=this.p.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:I,removed:s,overrides:u}=p(c,void 0);return{keys:[...o,...I,...s],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,c,o){let I=this.r(c,o);return c.overrideIdentifier&&(I=I.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(I=I.merge(this.d)),I}r({resource:r},c){let o=this.s();if(c&&r){const I=c.getFolder(r);I&&(o=this.t(I.uri)||o);const s=this.m.get(r);s&&(o=o.merge(s))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let c=this.b.get(r);if(!c){const o=this.s(),I=this.j.get(r);I?(c=o.merge(I),this.b.set(r,c)):c=o}return c}u(r,c){if(c&&r){const o=c.getFolder(r);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,c)=>{const{contents:o,overrides:I,keys:s}=this.j.get(c);return r.push([c,{contents:o,overrides:I,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.i.keys.forEach(c=>r.add(c)),this.j.forEach(c=>c.keys.forEach(o=>r.add(o))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}w(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.i.getKeysForOverrideIdentifier(r).forEach(o=>c.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(I=>c.add(I))),[...c.values()]}static parse(r){const c=this.x(r.defaults),o=this.x(r.policy),I=this.x(r.application),s=this.x(r.user),u=this.x(r.workspace),v=r.folders.reduce((S,E)=>(S.set(h.URI.revive(E[0]),this.x(E[1])),S),new R.ResourceMap);return new m(c,o,I,s,new g,u,v,new g,new R.ResourceMap)}static x(r){return new g(r.contents,r.keys,r.overrides)}}e.Configuration=m;function y(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,c=new Map;for(const I of l)I.keys.forEach(s=>r.add(s)),I.overrides.forEach(([s,u])=>{const v=(0,R.getOrSet)(c,s,new Set);u.forEach(S=>v.add(S))});const o=[];return c.forEach((I,s)=>o.push([s,[...I.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=y;class T{constructor(r,c,o,I){this.change=r,this.f=c,this.g=o,this.h=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of r.keys)this.affectedKeys.add(s);for(const[,s]of r.overrides)for(const u of s)this.affectedKeys.add(u);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(r,c){const o=this.a+r,I=this.d.indexOf(o);if(I<0)return!1;const s=I+o.length;if(s>=this.d.length)return!1;const u=this.d.charCodeAt(s);if(u!==this.b&&u!==this.c)return!1;if(c){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,S=this.g.getValue(r,c,this.h);return!A.equals(v,S)}return!0}}e.ConfigurationChangeEvent=T;function p(l,r){const{added:c,removed:o,updated:I}=i(r?.rawConfiguration,l?.rawConfiguration),s=[],u=l?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const S=v.filter(E=>!u.includes(E));for(const E of S)s.push([E,r.getKeysForOverrideIdentifier(E)])}if(l){const S=u.filter(E=>!v.includes(E));for(const E of S)s.push([E,l.getKeysForOverrideIdentifier(E)])}if(r&&l){for(const S of u)if(v.includes(S)){const E=i({contents:l.getOverrideValue(void 0,S)||{},keys:l.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});s.push([S,[...E.added,...E.removed,...E.updated]])}}return{added:c,removed:o,updated:I,overrides:s}}function i(l,r){const c=l?r?l.keys.filter(s=>r.keys.indexOf(s)===-1):[...l.keys]:[],o=r?l?r.keys.filter(s=>l.keys.indexOf(s)===-1):[...r.keys]:[],I=[];if(l&&r){for(const s of r.keys)if(l.keys.indexOf(s)!==-1){const u=(0,O.getConfigurationValue)(r.contents,s),v=(0,O.getConfigurationValue)(l.contents,s);A.equals(u,v)||I.push(s)}}return{added:c,removed:o,updated:I}}}),define(Ae[95],Re([1,0,10,3]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof M&&w._code===C.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof M&&w._code===C.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof M&&w._code===C.NoResolverFound}static isHandled(w){return w instanceof M&&w.isHandled}constructor(w,h=C.Unknown,O){super(w),this._message=w,this._code=h,this._detail=O,this.isHandled=h===C.NotAvailable&&O===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function R(A){const w=A.indexOf("+");return w===-1?A:A.substring(0,w)}e.getRemoteAuthorityPrefix=R}),define(Ae[50],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=P;function C(h){if(!h)return;const O=h.indexOf("+");return O<0?h:h.substr(0,O)}e.getRemoteName=C;function M(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=M;function R(h){const{host:O,port:D}=w(h);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:D}}e.parseAuthorityWithPort=R;function A(h,O){let{host:D,port:f}=w(h);return typeof f>"u"&&(f=O),{host:D,port:f}}e.parseAuthorityWithOptionalPort=A;function w(h){const O=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const D=h.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const f=h.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:h,port:void 0}}}),define(Ae[24],Re([1,0,13,3,50]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var A;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const m=typeof t=="string"?t:t.value,y=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(m,y)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=w;class h{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const a of t)this.add(a)}add(t){this.c.add(w.toKey(t))}delete(t){return this.c.delete(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}}e.ExtensionIdentifierSet=h;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(w.toKey(t))}get(t){return this.c.get(w.toKey(t))}has(t){return this.c.has(w.toKey(t))}set(t,a){this.c.set(w.toKey(t),a)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function D(d){return f(d)}e.isApplicationScopedExtension=D;function f(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function g(d,t){if(t){const a=`onResolveRemoteAuthority:${(0,C.getRemoteName)(t)}`;return!!d.activationEvents?.includes(a)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ae[96],Re([1,0,10,24]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const w of R){const h=this.readActivationEvents(w);h.length>0&&(A[P.ExtensionIdentifier.toKey(w.identifier)]=h)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return A;for(const w in R.contributes){const h=this.a.get(w);if(!h)continue;const O=R.contributes[w],D=Array.isArray(O)?O:[O];try{h(D,A)}catch(f){(0,n.onUnexpectedError)(f)}}return A}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ae[172],Re([1,0,20,51,2,35]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(h){if(n.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function A(h,O,D,f,b,g,d,t,a,m){const y=Object.create(null);y["common.machineId"]=d,y.sessionID=(0,M.generateUuid)()+Date.now(),y.commitHash=b,y.version=g,y["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,n.PlatformToString)(n.platform),y["common.nodePlatform"]=P.platform,y["common.nodeArch"]=f,y["common.product"]=m||"desktop",t&&(y["common.msftInternal"]=t);let T=0;const p=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>T++,enumerable:!0}}),n.isLinuxSnap&&(y["common.snap"]="true");const i=R(D);i&&(y["common.platformDetail"]=i);try{const l=await h.readFile(C.URI.file(a));y["common.source"]=l.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=A;function w(h){const O=P.env.USERDNSDOMAIN;if(!O)return!1;const D=O.toLowerCase();return h.some(f=>D===f)}e.verifyMicrosoftInternalDomain=w}),define(Ae[173],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(P=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ae[52],Re([1,0,23,9,5,42,50,172,173]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(o){this.value=o}}e.TelemetryTrustedValue=h;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,I){return Promise.resolve(void 0)}publicLog2(o,I){return this.publicLog(o,I)}publicLogError(o,I){return Promise.resolve(void 0)}publicLogError2(o,I){return this.publicLogError(o,I)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class D{async publicLog(o,I,s){}async publicLogError(o,I,s){}}e.NullEndpointTelemetryService=D,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(c,o){return C.Event.debounce(o.onDidChangeConfiguration,(s,u)=>{const v=s?new Set([...s.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:v}},1e3,!0)(s=>{s.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=f;function b(c,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!c.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=b;function g(c,o){return!(o.isBuilt||o.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=g;function d(c){const o=c.getValue(w.TELEMETRY_SETTING_ID),I=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||I===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function t(c){const o={},I={},s={};y(c,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const v=s[u];typeof v=="number"?I[u]=v:typeof v=="boolean"?I[u]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${v.length}`),o[u]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(o[u]=v)}return{properties:o,measurements:I}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(c){if(!c)return"none";const o=(0,R.getRemoteName)(c);return a.has(o)?o:"other"}e.cleanRemoteAuthority=m;function y(c,o,I=0,s){if(!!c)for(const u of Object.getOwnPropertyNames(c)){const v=c[u],S=s?s+u:u;Array.isArray(v)?o[S]=(0,n.safeStringify)(v):v instanceof Date?o[S]=v.toISOString():(0,P.isObject)(v)?I<2?y(v,o,I+1,S+"."):o[S]=(0,n.safeStringify)(v):o[S]=v}}function T(c,o){const I=c.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(I)||s}e.isInternalTelemetry=T;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p;function i(c,o){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let I=c;const s=[];for(const E of o)for(;;){const W=E.exec(c);if(!W)break;s.push([W.index,E.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(I="";;){const E=v.exec(c);if(!E)break;const W=s.some(([X,Y])=>E.index<Y&&X<v.lastIndex);!u.test(E[0])&&!W&&(I+=c.substring(S,E.index)+"<REDACTED: user-file-path>",S=v.lastIndex)}return S<c.length&&(I+=c.substr(S)),I}function l(c){if(!c)return c;const o=c.toLowerCase(),I=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of I)if(s.regex.test(o))return`<REDACTED: ${s.label}>`;return c}function r(c,o){return(0,n.cloneAndChange)(c,I=>{if(I instanceof h)return I.value;if(typeof I=="string"){let s=I.replaceAll("%20"," ");s=i(s,o);for(const u of o)s=s.replace(u,"");return s=l(s),s}})}e.cleanData=r}),define(Ae[174],Re([1,0,13,90,24,20,2,10,51,52]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,n.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=O;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(c){const o=c.manifest?c.manifest.version:c.version,I=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new f(c.identifier,o,I)}static parse(c){const o=D.exec(c);return o&&o[1]&&o[2]?new f({id:o[1]},o[2],o[4]||void 0):null}constructor(c,o,I="undefined"){this.version=o,this.targetPlatform=I,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof f?O(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=f;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const c=b.exec(r);return c&&c[1]?[t(c[1]),c[2]]:[t(r),void 0]}e.getIdAndVersion=g;function d(r,c){return`${r}.${c}`}e.getExtensionId=d;function t(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(r,c){return t(d(r??C.UNDEFINED_PUBLISHER,c))}e.getGalleryExtensionId=a;function m(r,c){const o=[],I=s=>{for(const u of o)if(u.some(v=>O(c(v),c(s))))return u;return null};for(const s of r){const u=I(s);u?u.push(s):o.push([s])}return o}e.groupByExtension=m;function y(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function T(r){return{id:new h.TelemetryTrustedValue(r.identifier.id),name:new h.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function p(r,c){const o=[],I=c.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const s=I.shift();if(s&&o.every(u=>!O(u.identifier,{id:s}))){const u=r.filter(v=>O(v.identifier,{id:s}));u.length===1&&(o.push(u[0]),I.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=p;async function i(r,c){if(!M.isLinux)return!1;let o;try{o=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){c.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,c){const o=await i(r,c),I=(0,P.getTargetPlatform)(o?"alpine":M.platform,w.arch);return c.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=l}),define(Ae[175],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=n;function P(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=P;function C(R){return Array.from(R.entries()).map(A=>[A[0],n(A[1].map)])}e.serializeEnvironmentVariableCollections=C;function M(R){return new Map(R.map(A=>[A[0],{map:P(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ae[176],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,R=5){const A=M(w=>{const h=typeof w=="string"?w:w.data;let O=this.a.get(C);if(O){O.data.push(h);return}const D=setTimeout(()=>this.flushBuffer(C),R);O={data:[h],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),A.dispose()}},this.a.set(C,O)});return A}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ae[177],Re([1,0,17,85,39,5,9,2,141,70,30]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var D;(function(T){function p(i,l){let r=i.defaults;for(;C.ThemeIcon.isThemeIcon(r);){const c=g.getIcon(r.id);if(!c)return;r=c.defaults}return r}T.getDefinition=p})(D=e.IconContribution||(e.IconContribution={}));var f;(function(T){function p(l){return{weight:l.weight,style:l.style,src:l.src.map(r=>({format:r.format,location:r.location.toString()}))}}T.toJSONObject=p;function i(l){const r=c=>(0,R.isString)(c)?c:void 0;if(l&&Array.isArray(l.src)&&l.src.every(c=>(0,R.isString)(c.format)&&(0,R.isString)(c.location)))return{weight:r(l.weight),style:r(l.style),src:l.src.map(c=>({format:c.format,location:A.URI.parse(c.location)}))}}T.fromJSONObject=i})(f=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,i,l,r){const c=this.b[p];if(c){if(l&&!c.description){c.description=l,this.d.properties[p].markdownDescription=`${l} $(${p})`;const s=this.e.enum.indexOf(p);s!==-1&&(this.e.enumDescriptions[s]=l),this.a.fire()}return c}const o={id:p,description:l,defaults:i,deprecationMessage:r};this.b[p]=o;const I={$ref:"#/definitions/icons"};return r&&(I.deprecationMessage=r),l&&(I.markdownDescription=`${l}: $(${p})`),this.d.properties[p]=I,this.e.enum.push(p),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,i){const l=this.f[p];return l||(this.f[p]=i,this.a.fire(),i)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,o)=>c.id.localeCompare(o.id),i=c=>{for(;C.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(c=>this.b[c]);for(const c of r.filter(o=>!!o.description).sort(p))l.push(`|<i class="${i(c)}"></i>|${c.id}|${C.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const c of r.filter(o=>!C.ThemeIcon.isThemeIcon(o.defaults)).sort(p))l.push(`|<i class="${i(c)}"></i>|${c.id}|`);return l.join(`
`)}}const g=new b;O.Registry.add(e.Extensions.IconContribution,g);function d(T,p,i,l){return g.registerIcon(T,p,i,l)}e.registerIcon=d;function t(){return g}e.getIconRegistry=t;function a(){const T=(0,P.getCodiconFontCharacters)();for(const p in T){const i="\\"+T[p].toString(16);g.registerIcon(p,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const m=O.Registry.as(h.Extensions.JSONContribution);m.registerSchema(e.iconsSchemaId,g.getIconSchema());const y=new n.RunOnceScheduler(()=>m.notifySchemaChanged(e.iconsSchemaId),200);g.onDidChange(()=>{y.isScheduled()||y.schedule()}),e.widgetClose=d("widget-close",P.Codicon.close,(0,w.localize)(2,null)),e.gotoPreviousLocation=d("goto-previous-location",P.Codicon.arrowUp,(0,w.localize)(3,null)),e.gotoNextLocation=d("goto-next-location",P.Codicon.arrowDown,(0,w.localize)(4,null)),e.syncing=C.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(Ae[178],Re([1,0,5,42,3,14]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=D;function f(d,t,a,m){if(a===1)return!1;if(a===2&&D(t)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(y?.length===4&&parseInt(y[1])>=18)return!1}return d<1024}e.isPortPrivileged=f;class b{constructor(t,a,m){this.remoteAddress=t,this.localAddress=a,this.b=m,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let g=class{constructor(t,a){this.i=t,this.j=a,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],a=Array.from(this.d.values());for(const m of a){const y=Array.from(m.values());for(const T of y){const p=await T.value;p&&t.push(p)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:a}of t.values())await a.then(m=>m?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,a,m,y,T){this.o(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:m,privacy:y,protocol:T,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(D(t)||O(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const m=this.q(t,a);if(m)return++m.refcount,m.value}openTunnel(t,a,m,y,T,p=!1,i,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${T}.`),!t)return;if(a||(a="localhost"),y||(y=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(t,a,m,y,T,p,i,l);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(c);return(c.tunnelRemoteHost!==a||c.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.d.get(t.tunnelRemoteHost);if(a){const m=a.get(t.tunnelRemotePort);m&&(m.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,m))}}}}async n(t,a,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const y=m.value.then(async T=>{T&&(await T.dispose(!0),this.b.fire({host:T.tunnelRemoteHost,port:T.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(a),y}}async closeTunnel(t,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const m=this.d.get(t);if(m&&m.has(a)){const y=m.get(a);y.refcount=0,await this.n(t,a,y)}}o(t,a,m){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(a,{refcount:1,value:m})}async p(t,a){const m=this.d.get(t);m&&(await m.get(a)||m.delete(a),m.size===0&&this.d.delete(t))}q(t,a){const m=[t];O(t)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):D(t)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const y=m.map(T=>this.d.get(T));for(const T of y){const p=T?.get(a);if(p)return p}}canTunnel(t){return!!h(t)}s(t,a,m,y,T,p,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${y}.`);const l=m;this.h.add(l);const r=y===void 0?m:y,c={elevationRequired:T?this.isPortPrivileged(r):!1},o={remoteAddress:{host:a,port:m},localAddressPort:y,privacy:p,public:p?p!==A.Private:void 0,protocol:i},I=t.forwardPort(o,c);return I?(this.o(a,m,I),I.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),I}};g=je([Ve(0,M.ILogService),Ve(1,P.IConfigurationService)],g),e.AbstractTunnelService=g}),define(Ae[179],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var P;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(P=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ae[180],Re([1,0,15]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(w){return w.scheme!==n.Schemas.file&&w.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=P;function C(w){if(w.folders.length)return w.folders.every(h=>P(h.uri))?w.folders[0].uri:void 0;if(w.configuration&&P(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=C;function M(w){return C(w)?.scheme}e.getVirtualWorkspaceScheme=M;function R(w){return C(w)?.authority}e.getVirtualWorkspaceAuthority=R;function A(w){return C(w)!==void 0}e.isVirtualWorkspace=A}),define(Ae[53],Re([1,0,142,19,48,22,2,3,15]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function h(c){const o=c;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=h;function O(c){return typeof c?.id=="string"&&!h(c)&&!f(c)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(c,o){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,P.basename)(c)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=c;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=D;function f(c){const o=c;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=f;function b(c){const o=c;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const I=c;if(I?.configPath)return{id:I.id,configPath:R.URI.revive(I.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=b;var g;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(c){const o=c;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function t(c){const o=c;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(o,I,s,u,v){this.h=o,this.j=s,this.k=u,this.l=v,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=I}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class m{constructor(o,I){this.raw=I,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,M.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function y(c){return new m({uri:c,index:0,name:(0,M.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function T(c,o){return M.extUriBiasedIgnorePathCase.isEqualOrParent(c,o.untitledWorkspacesHome)}e.isUntitledWorkspace=T;function p(c){let o;return R.URI.isUri(c)?o=c:o=c.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(c){return c.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function l(c,o){return!T(c,o)&&!p(c)}e.isSavedWorkspace=l;function r(c){return(typeof c=="string"?(0,P.extname)(c):(0,M.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ae[54],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Ae[37],Re([1,0,15,22,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new P.ExtUri(A=>{const w=this.b.get(A.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(A,w){w===null?this.b.delete(A.scheme):this.b.set(A.scheme,w)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ae[181],Re([1,0,145,14,167,27]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends C.LogService{constructor(w,h,O){const D=O.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",f=O.remote.isRemote?(0,n.localize)(0,null):w?(0,n.localize)(1,null):(0,n.localize)(2,null);super(h.createLogger(D,{name:f}))}};R=je([Ve(1,P.ILoggerService),Ve(2,M.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(Ae[182],Re([1,0,17]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(R,A,w){this.h=new Map,this.a=R,this.b=A,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(h=>(this.f=h,this)),this.g=this.c.onDidChangeStorage(h=>{h.shared===this.b&&h.key===this.a&&(this.f=h.value)}),this.i=new n.RunOnceScheduler(()=>{const h=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of h.values())O.complete()}catch(O){for(const D of h.values())D.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,A){let w=this.f[R];return typeof w>"u"&&(w=A),w}update(R,A){this.f[R]=A;const w=this.h.get(R);if(w!==void 0)return w.p;const h=new n.DeferredPromise;return this.h.set(R,h),this.i.isScheduled()||this.i.schedule(),h.p}dispose(){this.g.dispose()}}e.ExtensionMemento=P;class C extends P{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,A){super(R.identifier.value,!0,A),this.j=R}}e.ExtensionGlobalMemento=C}),define(Ae[183],Re([1,0,5,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(R){this.c=R,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,A,w,h){const D=this.c.getNotebookDocument(P.URI.revive(R)).acceptModelChanged(A.value,w,h);this.b.fire(D)}$acceptDirtyStateChanged(R,A){this.c.getNotebookDocument(P.URI.revive(R)).acceptDirty(A)}$acceptModelSaved(R){const A=this.c.getNotebookDocument(P.URI.revive(R));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(Ae[18],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class P{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=P});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[184],Re([1,0,24,5]),function(ee,e,n,P){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,w){C.set(this,void 0),this.b=new P.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),Je(this,C,w,"f"),Ne(this,C,"f").onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(A){return Ne(this,C,"f").get(this.a,A)}store(A,w){return Ne(this,C,"f").store(this.a,A,w)}delete(A){return Ne(this,C,"f").delete(this.a,A)}}e.ExtensionSecrets=M,C=new WeakMap}),define(Ae[71],Re([1,0,3,178,5,18]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(w){function h(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:D.protocol}}w.fromApiTunnel=h;function O(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==P.TunnelPrivacyId.ConstantPrivate&&D.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}w.fromServiceTunnel=O})(R=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=class{constructor(h){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(h){return h}async openTunnel(h,O){}async getTunnels(){return[]}async setTunnelFactory(h){return{dispose:()=>{}}}registerPortsAttributesProvider(h,O){return{dispose:()=>{}}}async $providePortAttributes(h,O,D,f,b){return[]}async $forwardPort(h,O){}async $closeTunnel(h){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=je([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ae[55],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class P{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=P}),define(Ae[185],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(w){let h=this.buffers.indexOf(w);return h<0&&(h=this.buffers.length,this.buffers.push(w)),h}}function C(A,w){if(w.serializeBuffersForPostMessage){const h=new P,O=(b,g)=>{if(g instanceof ArrayBuffer){const d=h.add(g);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(g)){const d=M(g);if(d){const t=h.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},D=JSON.stringify(A,O),f=h.buffers.map(b=>{const g=new Uint8Array(b);return n.VSBuffer.wrap(g)});return{message:D,buffers:f}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=C;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(A,w){const h=w.map(f=>{const b=new ArrayBuffer(f.byteLength);return new Uint8Array(b).set(f.buffer),b}),O=w.length?(f,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:d}=g,t=h[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(A,O),arrayBuffers:h}}e.deserializeWebviewMessage=R}),define(Ae[97],Re([1,0,152,9,2,6,3,30,43,15,40,126,29]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function d(le){const re=le;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.isEditorPaneWithSelection=d;function t(le,re,V){for(const L of V.visibleEditorPanes)if(L.group.id===re&&le.matches(L.input))return L.getViewState()}e.findViewStateForEditor=t;function a(le){if(u(le))return!1;const re=le;return C.URI.isUri(re?.resource)}e.isResourceEditorInput=a;function m(le){if(u(le))return!1;const re=le;return re?.original!==void 0&&re.modified!==void 0}e.isResourceDiffEditorInput=m;function y(le){if(u(le)||m(le))return!1;const re=le;return re?.primary!==void 0&&re.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function T(le){if(u(le))return!1;const re=le;return re?re.resource===void 0||re.resource.scheme===h.Schemas.untitled||re.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=T;const p=/Untitled-\d+/;function i(le){return le.scheme===h.Schemas.untitled&&le.path.length>1&&!p.test(le.path)}e.isUntitledWithAssociatedResource=i;function l(le){if(u(le))return!1;const re=le;return C.URI.isUri(re?.base?.resource)&&C.URI.isUri(re?.input1?.resource)&&C.URI.isUri(re?.input2?.resource)&&C.URI.isUri(re?.result?.resource)}e.isResourceMergeEditorInput=l;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(re,V){let L=this.a.get(re);return L||(L={source:re,label:V},this.a.set(re,L)),L.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.SaveSourceRegistry=new o;var I;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends M.Disposable{}e.AbstractEditorInput=s;function u(le){return le instanceof s}e.isEditorInput=u;function v(le){const re=le;return C.URI.isUri(re?.preferredResource)}function S(le){const re=le;return u(re?.primary)&&u(re?.secondary)}e.isSideBySideEditorInput=S;function E(le){const re=le;return u(re?.modified)&&u(re?.original)}e.isDiffEditorInput=E;function W(le,re,V,L,K){return Te(L,[(0,D.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const me={...V,limits:{size:Number.MAX_VALUE}};le.openEditor(re,me)}}),(0,D.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.createTooLargeFileError=W;function X(le){return u(le?.editor)}e.isEditorInputWithOptions=X;function Y(le){const re=le;return X(le)&&re?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Y;function J(le){const re=le;return typeof re?.groupId=="number"&&u(re.editor)}e.isEditorIdentifier=J;var j;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class B{getOriginalUri(re,V){if(!re)return;if(l(re))return e.EditorResourceAccessor.getOriginalUri(re.result,V);if(V?.supportSideBySide){const{primary:K,secondary:me}=this.a(re);if(K&&me){if(V?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===$.ANY)return this.getOriginalUri(K,{filterByScheme:V.filterByScheme})??this.getOriginalUri(me,{filterByScheme:V.filterByScheme});re=V.supportSideBySide===$.PRIMARY?K:me}}if(m(re)||y(re)||l(re))return;const L=v(re)?re.preferredResource:re.resource;return!L||!V||!V.filterByScheme?L:this.b(L,V.filterByScheme)}a(re){return S(re)||y(re)?{primary:re.primary,secondary:re.secondary}:E(re)||m(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,V){if(!re)return;if(l(re))return e.EditorResourceAccessor.getCanonicalUri(re.result,V);if(V?.supportSideBySide){const{primary:K,secondary:me}=this.a(re);if(K&&me){if(V?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===$.ANY)return this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:V.filterByScheme});re=V.supportSideBySide===$.PRIMARY?K:me}}if(m(re)||y(re)||l(re))return;const L=re.resource;return!L||!V||!V.filterByScheme?L:this.b(L,V.filterByScheme)}b(re,V){if(Array.isArray(V)){if(V.some(L=>re.scheme===L))return re}else if(V===re.scheme)return re}}e.EditorResourceAccessor=new B;var q;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(q=e.CloseDirection||(e.CloseDirection={}));class he{constructor(){this.c=new Map,this.d=new Map}start(re){const V=this.a=re.get(R.IInstantiationService);for(const[L,K]of this.c)this.e(L,K,V);this.c.clear()}e(re,V,L){const K=L.createInstance(V);this.d.set(re,K)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,P.assertIsDefined)(this.b)}registerEditorSerializer(re,V){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,V,this.a):this.c.set(re,V),(0,M.toDisposable)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new he);async function Ee(le,re,V){return!le||!le.length?[]:await Promise.all(le.map(async L=>{const K=C.URI.revive(L.fileUri);if(!K){V.info("Cannot resolve the path because it is not valid.",L);return}if(!await re.canHandleResource(K)){V.info("Cannot resolve the path because it cannot be handled",L);return}let Ie=L.exists,we=L.type;if(typeof Ie!="boolean"||typeof we!="number")try{we=(await re.stat(K)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Ie=!0}catch(Ce){V.error(Ce),Ie=!1}if(!Ie&&L.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",L);return}if(we===w.FileType.Directory){V.info("Cannot resolve the path because it is a directory",L);return}const ve={...L.options,pinned:!0};return Ie?{resource:K,options:ve}:{resource:K,options:ve,forceUntitled:!0}}))}e.pathsToEditors=Ee;var ie;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(ie=e.EditorsOrder||(e.EditorsOrder={}));function ce(le){const re=le;if(!re)return!1;const V=re;if(V.modified)return ce(V.modified);const L=re;return!!(L.contributionsState&&L.viewState&&Array.isArray(L.cursorState))}e.isTextEditorViewState=ce;function de(le){return(0,O.isErrorWithActions)(le)}e.isEditorOpenError=de;function Te(le,re,V){const L=(0,O.createErrorWithActions)(le,re);return L.forceMessage=V?.forceMessage,L.forceSeverity=V?.forceSeverity,L.allowDialog=V?.allowDialog,L}e.createEditorOpenError=Te}),define(Ae[186],Re([1,0,5,153,3,6,28,30,16,63,23,85,177]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",D.Codicon.window,(0,P.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var g;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function d(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=d;class t extends M.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.D(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,w.flatten)([...this.g.values()])}registerViewContainer(c,o,I){const s=this.get(c.id);if(s)return s;const u=c;return u.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,R.getOrSet)(this.g,o,[]).push(u),I?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:o}),u}deregisterViewContainer(c){for(const o of this.g.keys()){const I=this.g.get(o),s=I?.indexOf(c);if(s!==-1){I?.splice(s,1),I.length===0&&this.g.delete(o),this.f.fire({viewContainer:c,viewContainerLocation:o});return}}}get(c){return this.all.filter(o=>o.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(I=>I?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(o=>this.getViewContainerLocation(o)===c)}}A.Registry.add(b.ViewContainersRegistry,new t);var a;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function m(r,c){const o=r.group??a.More,I=c.group??a.More;return o!==I?o.localeCompare(I):(r.order??5)-(c.order??5)}class y extends M.Disposable{constructor(){super(...arguments),this.c=this.D(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.D(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.D(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.D(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new h.SetMap}registerViews(c,o){this.registerViews2([{views:c,viewContainer:o}])}registerViews2(c){c.forEach(({views:o,viewContainer:I})=>this.l(o,I)),this.c.fire(c)}deregisterViews(c,o){const I=this.m(c,o);I.length&&this.f.fire({views:I,viewContainer:o})}moveViews(c,o){for(const I of this.j.keys())if(I!==o){const s=this.m(c,I);s.length&&(this.l(s,o),this.g.fire({views:s,from:I,to:o}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const o of this.i){const I=(this.j.get(o)||[]).filter(s=>s.id===c)[0];if(I)return I}return null}getViewContainer(c){for(const o of this.i)if((this.j.get(o)||[]).filter(s=>s.id===c)[0])return o;return null}registerViewWelcomeContent(c,o){return this.k.add(c,o),this.h.fire(c),(0,M.toDisposable)(()=>{this.k.delete(c,o),this.h.fire(c)})}registerViewWelcomeContent2(c,o){const I=new Map;for(const[s,u]of o)this.k.add(c,u),I.set(s,(0,M.toDisposable)(()=>{this.k.delete(c,u),this.h.fire(c)}));return this.h.fire(c),I}getViewWelcomeContent(c){const o=[];return this.k.forEach(c,I=>o.push(I)),o.sort(m)}l(c,o){let I=this.j.get(o);I||(I=[],this.j.set(o,I),this.i.push(o));for(const s of c){if(this.getView(s.id)!==null)throw new Error((0,P.localize)(1,null,s.id));I.push(s)}}m(c,o){const I=this.j.get(o);if(!I)return[];const s=[],u=[];for(const v of I)c.includes(v)?s.push(v):u.push(v);return s.length&&(u.length?this.j.set(o,u):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),s}}A.Registry.add(b.ViewsRegistry,new y),e.IViewsService=(0,C.createDecorator)("viewsService"),e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var T;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(T=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,o){this.c=!1,this.d=!1,(0,O.mixin)(this,c),this.d=!!o,this.resolve=async I=>{if(o&&!this.c){const s=await o(I);s&&(this.tooltip=this.tooltip??s.tooltip,this.command=this.command??s.command)}I.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class l extends Error{constructor(c){super((0,P.localize)(2,null,c))}}e.NoTreeViewError=l}),define(Ae[187],Re([1,0,5,17,154]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,w,h,O){const D={command:A};if(w&&Object.keys(w).length>0&&(D.arguments=w),this.s("request",D),typeof O=="number"){const f=setTimeout(()=>{clearTimeout(f);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:A,message:(0,C.localize)(0,null,O,A)};b(g)}},O)}return h&&this.f.set(D.seq,h),D.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,w){return A.type!=="event"||w.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,P.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const w=A,h=this.f.get(w.request_seq);h&&(this.f.delete(w.request_seq),h(w));break}}}}s(A,w){w.type=A,w.seq=this.d++,this.sendMessage(w)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((w,h)=>A.set(h,w)),await(0,P.timeout)(500),A.forEach((w,h)=>{w({type:"response",seq:0,request_seq:h,success:!1,command:"canceled",message:"canceled"}),this.f.delete(h)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ae[188],Re([1,0,155,31,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=f=>n.localize(51,null,f);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var R;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(R=e.State||(e.State={}));function A(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var w;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var h;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(h=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)("debugService");var D;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ae[189],Re([1,0,13,2,19,23,15,44,21,16]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function D(s,u,v){return s.replace(O,function(S,E){return u&&E.length>0&&E[0]!=="_"?S:v&&v.hasOwnProperty(E)?v[E]:S})}e.formatPII=D;function f(s){const u={};for(const v of Object.keys(s))v.startsWith("!")||(u[v]=s[v]);return u}e.filterExceptionsFromTelemetry=f;function b(s){return s.configuration.request==="attach"&&!g(s)&&(!s.parentSession||b(s.parentSession))}e.isSessionAttach=b;function g(s){let u=s.configuration.type;if(!!u)return u==="vslsShare"&&(u=s.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(u,"extensionhost")||(0,n.equalsIgnoreCase)(u,"pwa-extensionhost")?s:s.parentSession?g(s.parentSession):void 0}e.getExtensionHostDebugSession=g;function d(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=d;function t(s,u,v){let S,E=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let X=null;for(;X=W.exec(s);){const Y=X.index+1,J=Y+X[0].length;if(Y<=u&&J>=v){S=X[0],E=Y;break}}if(S){const Y=/\w+/g;let J=null;for(;(J=Y.exec(S))&&!(J.index+1+E+J[0].length>=v););J&&(S=S.substring(0,Y.lastIndex))}return S?{start:E,end:E+S.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(s,u,v,S){if(s.evaluatableExpressionProvider.has(u)){const E=s.evaluatableExpressionProvider.ordered(u),W=(0,h.coalesce)(await Promise.all(E.map(async X=>{try{return await X.provideEvaluatableExpression(u,v,S??w.CancellationToken.None)}catch{return}})));if(W.length>0){let X=W[0].expression;const Y=W[0].range;return X||(X=u.getLineContent(v.lineNumber).substring(Y.startColumn-1,Y.endColumn-1)),{range:Y,matchingExpression:X}}}else{const E=u.getLineContent(v.lineNumber),{start:W,end:X}=t(E,v.column,v.column),Y=E.substring(W-1,X);return{matchingExpression:Y,range:new A.Range(v.lineNumber,W,v.lineNumber,W+Y.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function y(s){return!!(s&&s.match(m))}e.isUri=y;function T(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(y(s.path))return P.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return P.URI.file(s.path)}return s.path}function p(s){if(typeof s.path=="object"){const u=P.URI.revive(s.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return s.path}function i(s,u){const v=u?T:p,S=(0,M.deepClone)(s);return r(S,(E,W)=>{E&&W&&(W.path=v(W))}),S}e.convertToDAPaths=i;function l(s,u){const v=u?T:p,S=(0,M.deepClone)(s);return r(S,(E,W)=>{!E&&W&&(W.path=v(W))}),S}e.convertToVSCPaths=l;function r(s,u){switch(s.type){case"event":{const v=s;switch(v.event){case"output":u(!1,v.body.source);break;case"loadedSource":u(!1,v.body.source);break;case"breakpoint":u(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=s;switch(v.command){case"setBreakpoints":u(!0,v.arguments.source);break;case"breakpointLocations":u(!0,v.arguments.source);break;case"source":u(!0,v.arguments.source);break;case"gotoTargets":u(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(S=>u(!1,S));break;default:break}break}case"response":{const v=s;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(S=>u(!1,S.source));break;case"loadedSources":v.body.sources.forEach(S=>u(!1,S));break;case"scopes":v.body.scopes.forEach(S=>u(!1,S.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(S=>u(!1,S.source));break;case"setBreakpoints":v.body.breakpoints.forEach(S=>u(!1,S.source));break;case"disassemble":v.body?.instructions.forEach(E=>u(!1,E.location));break;default:break}break}}}function c(s){return s.filter(u=>!u.presentation?.hidden).sort((u,v)=>u.presentation?v.presentation?u.presentation.group?v.presentation.group?u.presentation.group!==v.presentation.group?u.presentation.group.localeCompare(v.presentation.group):o(u.presentation.order,v.presentation.order):-1:v.presentation.group?1:o(u.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=c;function o(s,u){return typeof s!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:s-u}async function I(s,u){const v=s.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(v!=="none"&&(await u.saveAll(),v==="allEditorsInActiveGroup")){const S=u.activeEditorPane;S&&S.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:S.input,groupId:S.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Ae[72],Re([1,0,25,36,190,65,15,19,20,31]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var f;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(f=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var m;(function($){$.scheme=R.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${B.join("")}]+`),he=7;function Ee(re,V){const L=V.toString(he),me=`${L.length<B.length?B[L.length-1]:"z"}${L}s${(0,n.encodeBase64)(n.VSBuffer.fromString(re.scheme),!0,!0)}`;return re.with({scheme:$.scheme,fragment:me})}$.generate=Ee;function ie(re){if(re.scheme!==$.scheme)return;const V=re.fragment.indexOf("s");if(V<0)return;const L=parseInt(re.fragment.substring(0,V).replace(q,""),he),K=(0,n.decodeBase64)(re.fragment.substring(V+1)).toString();if(!isNaN(L))return{handle:L,notebook:re.with({scheme:K,fragment:null})}}$.parse=ie;function ce(re,V){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${V??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}$.generateCellOutputUri=ce;function de(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const V=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!V)return;const L=V[1]&&V[1]!==""?V[1]:void 0,K=V[2];return{outputId:L,notebook:re.with({scheme:K||R.Schemas.file,fragment:null})}}$.parseCellOutputUri=de;function Te(re,V,L){return $.generate(re,V).with({scheme:L})}$.generateCellPropertyUri=Te;function le(re,V){if(re.scheme===V)return $.parse(re.with({scheme:$.scheme}))}$.parseCellPropertyUri=le})(m=e.CellUri||(e.CellUri={}));const y=$=>w.isWindows?$.replace(/\//g,"\\"):$;class T{constructor(B=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.e=q,this.d=[...new Set(B)].map(he=>({pattern:he,matches:P.parse(y(he))}))}sort(B){const q=new Map(C.Iterable.map(B,Ee=>[Ee,y(Ee)]));let he=[];for(const{matches:Ee}of this.d)for(const[ie,ce]of q)if(Ee(ce)){he.push(ie),q.delete(ie);break}return q.size&&(he=he.concat([...q.keys()].sort((Ee,ie)=>this.e.indexOf(Ee)-this.e.indexOf(ie)))),he}prioritize(B,q){const he=this.f(B);if(he===-1){this.d.unshift({pattern:B,matches:P.parse(y(B))});return}const Ee=new Set(q.map(ce=>this.f(ce,he)));Ee.delete(-1);const ie=Array.from(Ee).sort();this.d.splice(he+1,0,...ie.map(ce=>this.d[ce]));for(let ce=ie.length-1;ce>=0;ce--)this.d.splice(ie[ce],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,q=this.d.length){const he=y(B);for(let Ee=0;Ee<q;Ee++)if(this.d[Ee].matches(he))return Ee;return-1}}e.MimeTypeDisplayOrder=T;function p($,B,q,he=(Ee,ie)=>Ee===ie){const Ee=[];function ie(Te,le,re){if(le===0&&re.length===0)return;const V=Ee[Ee.length-1];V&&V.start+V.deleteCount===Te?(V.deleteCount+=le,V.toInsert.push(...re)):Ee.push({start:Te,deleteCount:le,toInsert:re})}let ce=0,de=0;for(;;){if(ce===$.length){ie(ce,0,B.slice(de));break}if(de===B.length){ie(ce,$.length-ce,[]);break}const Te=$[ce],le=B[de];if(he(Te,le)){ce+=1,de+=1;continue}q(le)?(ie(ce,1,[]),ce+=1):(ie(ce,0,[le]),de+=1)}return Ee}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function($){$.default="default",$.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l($){const B=$;return!!((typeof B.include=="string"||P.isRelativePattern(B.include))&&(typeof B.exclude=="string"||P.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=l;function r($,B,q){if(Array.isArray($.viewType)&&$.viewType.indexOf(B)>=0||$.viewType===B)return!0;if($.filenamePattern){const he=l($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,Ee=l($.filenamePattern)?$.filenamePattern.exclude:void 0;if(P.match(he,(0,A.basename)(q.fsPath).toLowerCase()))return!(Ee&&P.match(Ee,(0,A.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",textOutputLineLimit:"notebook.output.textLineLimit",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var c;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(B){return`${o.d}${B}`}static parse(B){if(B.startsWith(o.d))return B.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function I($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=I;const s=new TextDecoder;function u($){const B=[];let q=!1;for(const he of $)(B.length===0||q)&&(B.push(he),q=!0);return W(B),U(n.VSBuffer.concat(B.map(he=>n.VSBuffer.wrap(he))))}e.compressOutputItemStreams=u;const v=`${String.fromCharCode(27)}[A`,S=v.split("").map($=>$.charCodeAt(0)),E=10;function W($){$.forEach((B,q)=>{if(q===0||B.length<v.length)return;const he=$[q-1],Ee=B.subarray(0,v.length);if(Ee[0]===S[0]&&Ee[1]===S[1]&&Ee[2]===S[2]){const ie=he.lastIndexOf(E);if(ie===-1)return;$[q-1]=he.subarray(0,ie),$[q]=B.subarray(v.length)}})}function X($){let B=$;do $=B,B=$.replace(/[^\n]\x08/gm,"");while(B.length<$.length);return $}function Y($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const B=$.match(/^(.*)\r+/m)[1];let q=$.match(/\r+(.*)$/m)[1];q=q+B.slice(q.length,B.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return $}const J="\b".charCodeAt(0),j="\r".charCodeAt(0);function U($){return!$.buffer.includes(J)&&!$.buffer.includes(j)?$:n.VSBuffer.fromString(Y(X(s.decode($.buffer))))}}),define(Ae[191],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(P=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var P;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(P=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(R,A,w=R.parent){if(R._isRoot)return new C([A]);const h=[R.id];for(let O=w;O&&O.id!==A;O=O.parent)h.push(O.id);return h.push(A),new C(h.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const A=R.indexOf("\0");return A===-1?R:R.slice(0,A)}static fromString(R){return new C(R.split("\0"))}static join(R,A){return new C([...R.path,A])}static joinToString(R,A){return R.toString()+"\0"+A}static parentId(R){const A=R.lastIndexOf("\0");return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf("\0");return A===-1?R:R.slice(A+1)}static compare(R,A){return R===A?0:A.startsWith(R+"\0")?2:R.startsWith(A+"\0")?3:1}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.TestId=C}),define(Ae[56],Re([1,0,2,44,45]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var R;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable",s[s.SupportsContinuousRun=64]="SupportsContinuousRun"})(R=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=s=>"runId"in s;e.isStartControllerTests=A;var w;(function(s){s.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),s.deserialize=u=>({range:P.Range.lift(u.range),uri:n.URI.revive(u.uri)})})(w=e.IRichLocation||(e.IRichLocation={}));var h;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(h=e.TestMessageType||(e.TestMessageType={}));var O;(function(s){s.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&w.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&w.deserialize(u.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const D=(s,u)=>`${u?"s":"e"}${s}`;e.getMarkId=D;var f;(function(s){s.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&w.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&w.deserialize(u.location)})})(f=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(s){s.serialize=u=>u.type===0?O.serialize(u):f.serialize(u),s.deserialize=u=>u.type===0?O.deserialize(u):f.deserialize(u)})(b=e.ITestMessage||(e.ITestMessage={}));var g;(function(s){s.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),s.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.serialize)}),s.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.deserialize)})})(g=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",t=(s,u)=>s+d+u;e.namespaceTestTag=t;const a=s=>{const u=s.indexOf(d);return{ctrlId:s.slice(0,u),tagId:s.slice(u+1)}};e.denamespaceTestTag=a;var m;(function(s){s.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),s.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?n.URI.revive(u.uri):void 0,range:u.range?P.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(m=e.ITestItem||(e.ITestItem={}));var y;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));var T;(function(s){s.serialize=u=>({expand:u.expand,item:m.serialize(u.item)}),s.deserialize=u=>({controllerId:C.TestId.root(u.item.extId),expand:u.expand,item:m.deserialize(u.item)})})(T=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(s){s.serialize=u=>{let v;return u.item&&(v={},u.item.label!==void 0&&(v.label=u.item.label),u.item.tags!==void 0&&(v.tags=u.item.tags),u.item.busy!==void 0&&(v.busy=u.item.busy),u.item.uri!==void 0&&(v.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(v.range=u.item.range?.toJSON()),u.item.description!==void 0&&(v.description=u.item.description),u.item.error!==void 0&&(v.error=u.item.error),u.item.sortText!==void 0&&(v.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:v}},s.deserialize=u=>{let v;return u.item&&(v={},u.item.label!==void 0&&(v.label=u.item.label),u.item.tags!==void 0&&(v.tags=u.item.tags),u.item.busy!==void 0&&(v.busy=u.item.busy),u.item.range!==void 0&&(v.range=u.item.range?P.Range.lift(u.item.range):null),u.item.description!==void 0&&(v.description=u.item.description),u.item.error!==void 0&&(v.error=u.item.error),u.item.sortText!==void 0&&(v.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:v}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(s,u)=>{u.expand!==void 0&&(s.expand=u.expand),u.item!==void 0&&(s.item=s.item?Object.assign(s.item,u.item):u.item)};e.applyTestItemUpdate=i;var l;(function(s){s.serializeWithoutMessages=u=>({...T.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serializeWithoutMessages),retired:u.retired}),s.serialize=u=>({...T.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.serialize),retired:u.retired}),s.deserialize=u=>({...T.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(g.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(s){s.deserialize=u=>u.op===0?{op:u.op,item:T.deserialize(u.item)}:u.op===1?{op:u.op,item:p.deserialize(u.item)}:u.op===2?{op:u.op,uri:n.URI.revive(u.uri),docv:u.docv}:u,s.serialize=u=>u.op===0?{op:u.op,item:T.serialize(u.item)}:u.op===1?{op:u.op,item:p.serialize(u.item)}:u})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const v=this.o();for(const S of u)switch(S.op){case 0:this.j(T.deserialize(S.item),v);break;case 1:this.k(p.deserialize(S.item),v);break;case 3:this.l(S.itemId,v);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}v.complete?.()}j(u,v){const S=C.TestId.parentId(u.item.extId)?.toString();let E;if(!S)E=this.p(u),this.f.add(E),this.d.set(u.item.extId,E);else if(this.d.has(S)){const W=this.d.get(S);W.children.add(u.item.extId),E=this.p(u,W),this.d.set(u.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return v.add?.(E),u.expand===2&&this.g++,E}k(u,v){const S=this.d.get(u.extId);if(!!S)return u.expand!==void 0&&(S.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(S,u),v.update?.(S),S}l(u,v){const S=this.d.get(u);if(!S)return;const E=C.TestId.parentId(S.item.extId)?.toString();E?this.d.get(E).children.delete(S.item.extId):this.f.delete(S);const W=[[u]];for(;W.length;)for(const X of W.pop()){const Y=this.d.get(X);Y&&(W.push(Y.children),this.d.delete(X),v.remove?.(Y,Y!==S),Y.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=I}),define(Ae[73],Re([1,0,17,5,6,49,56,45]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const h=(m,y)=>m===y,D=Object.entries({range:(m,y)=>m===y?!0:!m||!y?!1:m.equalsRange(y),busy:h,label:h,description:h,error:h,sortText:h,tags:(m,y)=>!(m.length!==y.length||m.some(T=>!y.includes(T)))}),f=(m,y)=>{let T;for(const[p,i]of D)i(m[p],y[p])||(T?T[p]=y[p]:T={[p]:y[p]});return T};class b extends C.Disposable{get root(){return this.m.root}constructor(y){super(),this.m=y,this.f=this.D(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.D(new P.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.s(this.root,void 0)}set resolveHandler(y){this.h=y;for(const T of this.tree.values())this.G(T)}get resolveHandler(){return this.h}collectDiff(){const y=this.k;return this.k=[],y}pushDiff(y){switch(y.op){case 2:{for(const T of this.k)if(T.op===2&&T.uri===y.uri){T.docv=y.docv;return}break}case 1:{const T=this.k[this.k.length-1];if(T){if(T.op===1&&T.item.extId===y.item.extId){(0,R.applyTestItemUpdate)(T.item,y.item);return}if(T.op===0&&T.item.item.extId===y.item.extId){(0,R.applyTestItemUpdate)(T.item,y.item);return}}break}}this.k.push(y),this.f.isScheduled()||this.f.schedule()}expand(y,T){const p=this.tree.get(y);if(!!p){if((p.expandLevels===void 0||T>p.expandLevels)&&(p.expandLevels=T),p.expand===1){const i=this.I(p);return i.isOpen()?this.H(p,T-1):i.wait().then(()=>this.H(p,T-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,T-1)):this.H(p,T-1)}}dispose(){for(const y of this.tree.values())this.m.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(y,T){switch(T.op){case 3:this.L(A.TestId.joinToString(y.fullId,T.id));break;case 0:this.s(T.item,y);break;case 5:for(const p of T.ops)this.p(y,p);break;case 1:this.u(T.new,T.old,y.fullId.toString());break;case 2:this.G(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:T.update}});break;case 6:this.q(y.actual.uri);break;default:(0,M.assertNever)(T)}}q(y){y&&this.pushDiff({op:2,uri:y,docv:this.m.getDocumentVersion(y)})}s(y,T){const p=A.TestId.fromExtHostTestItem(y,this.root.id,T?.actual),i=this.m.getApiFor(y);i.parent&&i.parent!==T?.actual&&this.m.getChildren(i.parent).delete(y.id);let l=this.tree.get(p.toString());if(!l){l={fullId:p,actual:y,expandLevels:T?.expandLevels?T.expandLevels-1:void 0,expand:0},y.tags.forEach(this.w,this),this.tree.set(l.fullId.toString(),l),this.z(y,T),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(y)}}),this.F(y,l,T);return}if(l.actual===y){this.C(y,l,T);return}if(l.actual.uri?.toString()!==y.uri?.toString())return this.L(p.toString()),this.s(y,T);const r=this.m.getChildren(l.actual),c=l.actual,o=f(this.m.toITestItem(c),this.m.toITestItem(y));this.m.getApiFor(c).listener=void 0,l.actual=y,l.expand=0,o&&(o.hasOwnProperty("tags")&&(this.u(y.tags,c.tags,p.toString()),delete o.tags),this.p(l,{op:4,update:o})),this.F(y,l,T);for(const[I,s]of r)this.m.getChildren(y).get(s.id)||this.L(A.TestId.joinToString(p,s.id));this.q(l.actual.uri)}u(y,T,p){const i=new Set(T.map(l=>l.id));for(const l of y)i.delete(l.id)||this.w(l);this.pushDiff({op:1,item:{extId:p,item:{tags:y.map(l=>(0,R.namespaceTestTag)(this.m.controllerId,l.id))}}}),i.forEach(this.y,this)}w(y){const T=this.j.get(y.id);T?T.refCount++:(this.j.set(y.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.m.controllerId,y.id)}}))}y(y){const T=this.j.get(y);T&&!--T.refCount&&(this.j.delete(y),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.m.controllerId,y)}))}z(y,T){this.m.getApiFor(y).parent=T&&T.actual!==this.root?T.actual:void 0}C(y,T,p){this.z(y,p);const i=this.m.getApiFor(y);i.parent=p?.actual,i.listener=l=>this.p(T,l),this.G(T)}F(y,T,p){this.C(y,T,p);for(const[i,l]of this.m.getChildren(y))this.s(l,T)}G(y){let T;this.h?y.resolveBarrier?T=y.resolveBarrier.isOpen()?3:2:T=y.actual.canResolveChildren?1:0:T=0,T!==y.expand&&(y.expand=T,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:T}}),T===1&&y.expandLevels!==void 0&&this.I(y))}H(y,T){if(T<0)return;const p=[];for(const[i,l]of this.m.getChildren(y.actual)){const r=this.expand(A.TestId.joinToString(y.fullId,l.id),T);(0,n.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this.h){const l=new n.Barrier;return l.open(),l}y.expand=2,this.J(y);const T=y.resolveBarrier=new n.Barrier,p=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let i;try{i=this.h(y.actual===this.root?void 0:y.actual)}catch(l){p(l)}return(0,n.isThenable)(i)?i.catch(p).then(()=>{T.open(),this.G(y)}):(T.open(),this.G(y)),y.resolveBarrier}J(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}L(y){const T=this.tree.get(y);if(!T)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:y});const p=[T];for(;p.length;){const i=p.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const l of i.actual.tags)this.y(l.id);this.tree.delete(i.fullId.toString());for(const[l,r]of this.m.getChildren(i.actual))p.push(this.tree.get(A.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.g.fire(y)}}e.TestItemCollection=b;class g extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=g;class d extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class t extends Error{constructor(y,T,p){super(`TestItem with ID "${y}" is from controller "${T}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=t;const a=(m,y,T)=>{let p=new Map;return{get size(){return p.size},forEach(i,l){for(const r of p.values())i.call(l,r,this)},[Symbol.iterator](){return p.entries()},replace(i){const l=new Map,r=new Set(p.keys()),c={op:5,ops:[]};for(const o of i){if(!(o instanceof T))throw new d(o.id);const I=y(o).controllerId;if(I!==m.controllerId)throw new t(o.id,I,m.controllerId);if(l.has(o.id))throw new g(o.id);l.set(o.id,o),r.delete(o.id),c.ops.push({op:0,item:o})}for(const o of r.keys())c.ops.push({op:3,id:o});m.listener?.(c),p=l},add(i){if(!(i instanceof T))throw new d(i.id);p.set(i.id,i),m.listener?.({op:0,item:i})},delete(i){p.delete(i)&&m.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=a}),define(Ae[98],Re([1,0,73]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,C=(R,A)=>{const w={controllerId:A};return P.set(R,w),w};e.createPrivateApiFor=C;const M=R=>{const A=P.get(R);if(!A)throw new n.InvalidTestItemError(R?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ae[74],Re([1,0,15,2]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(A,w){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(w&&w.authority&&w.isRemote&&A.scheme===n.Schemas.file&&(A=P.URI.from({scheme:n.Schemas.vscodeRemote,authority:w.authority,path:A.path})),P.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=C;function M(A){return A.replace(/./g,w=>{const h=w.charCodeAt(0);return h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57?w:"-"+h.toString(16).padStart(4,"0")})}function R(A){return A.replace(/-([0-9a-f]{4})/g,(w,h)=>String.fromCharCode(parseInt(h,16)))}e.decodeAuthority=R}),define(Ae[192],Re([1,0,5,6,74]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,w,h){this.d=A,this.e=w,this.f=h,this.a=0,this.b=new P.DisposableStore,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const O=w.getVisibleTextEditors();for(const D of this.c.values())O.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,w,h,O,D){let f;for(const y of this.e.getVisibleTextEditors(!0))if(y.value===A){f=y;break}if(!f)throw new Error("not a visible editor");const b=this,g=this.a++,d=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(y){return(0,C.asWebviewUri)(y,b.f)}get cspSource(){return C.webviewGenericCspSource}set options(y){this.b=y,b.d.$setOptions(g,y)}get options(){return this.b}set html(y){this.a=y,b.d.$setHtml(g,y)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(y){return b.d.$postMessage(g,y)}},m=new class{constructor(){this.editor=A,this.line=w,this.height=h,this.webview=a,this.onDidDispose=t.event}dispose(){b.c.has(g)&&(b.c.delete(g),b.d.$disposeEditorInset(g),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset(g,f.id,f.value.document.uri,w+1,h,O||{},D.identifier,D.extensionLocation),this.c.set(g,{editor:A,inset:m,onDidReceiveMessage:d}),m}$onDidDispose(A){const w=this.c.get(A);w&&w.inset.dispose()}$onDidReceiveMessage(A,w){this.c.get(A)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=M}),define(Ae[193],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var P;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(P=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(R,A){super(A),this.variable=R}}e.VariableError=C}),define(Ae[194],Re([1,0,19,51,9,23,20,88,158,193,13]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(b,g,d,t){this.g=new Map,this.a=b,this.b=g,this.d=d,t&&(this.c=t.then(a=>this.h(a)))}h(b){if(R.isWindows){const g=Object.create(null);return Object.keys(b).forEach(d=>{g[d.toLowerCase()]=b[d]}),g}return b}resolveWithEnvironment(b,g,d){return this.j({env:this.h(b),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(b,g){const d={env:await this.c,userHome:await this.d};return this.j(d,b?b.uri:void 0,g)}async i(b,g,d,t){const a=M.deepClone(g);R.isWindows&&a.windows?Object.keys(a.windows).forEach(y=>a[y]=a.windows[y]):R.isMacintosh&&a.osx?Object.keys(a.osx).forEach(y=>a[y]=a.osx[y]):R.isLinux&&a.linux&&Object.keys(a.linux).forEach(y=>a[y]=a.linux[y]),delete a.windows,delete a.osx,delete a.linux;const m={env:await this.c,userHome:await this.d};return this.j(m,b?b.uri:void 0,a,d,t)}async resolveAnyAsync(b,g,d){return this.i(b,g,d)}async resolveAnyMap(b,g,d){const t=new Map;return{newConfig:await this.i(b,g,d,t),resolvedVariables:t}}resolveWithInteractionReplace(b,g,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,g,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,g){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,g)}async j(b,g,d,t,a){if(C.isString(d))return this.l(b,g,d,t,a);if(Array.isArray(d))return Promise.all(d.map(m=>this.j(b,g,m,t,a)));if(C.isObject(d)){const m=Object.create(null),y=await Promise.all(Object.keys(d).map(async T=>[await this.l(b,g,T,t,a),await this.j(b,g,d[T],t,a)]));for(const[T,p]of y)m[T]=p;return m}return d}l(b,g,d,t,a){return(0,O.replaceAsync)(d,D.VARIABLE_REGEXP,async(m,y)=>{if(y.includes(D.VARIABLE_LHS))return m;let T=await this.n(b,m,y,g,t);return a?.set(y,T),T!==m&&C.isString(T)&&T.match(D.VARIABLE_REGEXP)&&(T=await this.l(b,g,T,t,a)),T})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,g,d,t,a){let m;const y=d.split(":");y.length>1&&(d=y[0],m=y[1]);const T=l=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new h.VariableError(l,(0,w.localize)(0,null,g))},p=l=>{const r=T(l);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,A.normalizeDriveLetter)(c)}throw new h.VariableError(l,(0,w.localize)(1,null,g,n.basename(r)))},i=l=>{if(m){const r=this.a.getFolderUri(m);if(r)return r;throw new h.VariableError(l,(0,w.localize)(2,null,g,m))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new h.VariableError(l,(0,w.localize)(3,null,g)):new h.VariableError(l,(0,w.localize)(4,null,g))};switch(d){case"env":if(m){if(b.env){const l=b.env[R.isWindows?m.toLowerCase():m];if(C.isString(l))return l}return""}throw new h.VariableError(h.VariableKind.Env,(0,w.localize)(5,null,g));case"config":if(m){const l=this.a.getConfigurationValue(t,m);if(C.isUndefinedOrNull(l))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(6,null,g,m));if(C.isObject(l))throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(7,null,g,m));return l}throw new h.VariableError(h.VariableKind.Config,(0,w.localize)(8,null,g));case"command":return this.o(h.VariableKind.Command,g,m,a,"command");case"input":return this.o(h.VariableKind.Input,g,m,a,"input");case"extensionInstallFolder":if(m){const l=await this.a.getExtension(m);if(!l)throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,g,m));return this.m(l.extensionLocation)}throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(h.VariableKind.WorkspaceFolder)));case"cwd":return t||m?(0,A.normalizeDriveLetter)(this.m(i(h.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.m(i(h.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new h.VariableError(h.VariableKind.UserHome,(0,w.localize)(11,null,g))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new h.VariableError(h.VariableKind.LineNumber,(0,w.localize)(12,null,g))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new h.VariableError(h.VariableKind.SelectedText,(0,w.localize)(13,null,g))}case"file":return T(h.VariableKind.File);case"fileWorkspaceFolder":return p(h.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||m?n.relative(this.m(i(h.VariableKind.RelativeFile)),T(h.VariableKind.RelativeFile)):T(h.VariableKind.RelativeFile);case"relativeFileDirname":{const l=n.dirname(T(h.VariableKind.RelativeFileDirname));if(t||m){const r=n.relative(this.m(i(h.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return n.dirname(T(h.VariableKind.FileDirname));case"fileExtname":return n.extname(T(h.VariableKind.FileExtname));case"fileBasename":return n.basename(T(h.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=n.basename(T(h.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-n.extname(l).length)}case"fileDirnameBasename":return n.basename(n.dirname(T(h.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||g}case"execInstallFolder":{const l=this.a.getAppRoot();return l||g}case"pathSeparator":return n.sep;default:try{const l=m?`${d}:${m}`:d;return this.o(h.VariableKind.Unknown,g,l,a,void 0)}catch{return g}}}}o(b,g,d,t,a){if(d&&t){const m=a===void 0?t[d]:t[a+":"+d];if(typeof m=="string")return m;throw new h.VariableError(b,(0,w.localize)(14,null,g))}return g}}D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=D}),define(Ae[99],Re([1,0,3,97]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var M;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function h(g){const d=g;return(0,P.isEditorInput)(d?.editor)&&(0,P.isEditorInput)(d?.replacement)}e.isEditorReplacement=h;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function f(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=f;function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ae[195],Re([1,0,3,99]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(M){const R=M;return typeof M=="number"||(0,P.isEditorGroup)(R)}e.isPreferredGroup=C}),define(Ae[196],Re([1,0,3,164]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(P.IEnvironmentService)}),define(Ae[100],Re([1,0,24,5,19,6]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class A{static isHostExtension(t,a,m){if(a.getExtensionDescription(t))return!1;const y=m.getExtensionDescription(t);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(t,a){this.h=t,this.c=new P.Emitter,this.onDidChange=this.c.event,this.d=a,this.j()}j(){this.d.sort(b),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const a=this.h.readActivationEvents(t);if(Array.isArray(a))for(let m of a)m==="onUri"&&(m=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,a){this.d=g(this.d,a),this.d=this.d.concat(t);const m=A.k(this.d);return this.d=g(this.d,m.map(y=>y.identifier)),this.j(),this.c.fire(void 0),new R(m)}static k(t){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,l){this.addNode(i),this.addNode(l),this.c.has(i)?this.c.get(i).push(l):this.c.set(i,[l])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,l){const r=a.getArcs(i);for(let c=0;c<r.length;c++)if(!l.has(r[c]))return!1;return!0}getNodes(){return this.e}},m=new n.ExtensionIdentifierMap;for(const i of t)if(m.set(i.identifier,i),i.extensionDependencies)for(const l of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(l));const y=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>y.add(i));const T=a.getNodes().filter(i=>!y.has(i));let p;do{p=!1;for(let i=0;i<T.length;i++){const l=T[i];a.hasOnlyGoodArcs(l,y)&&(T.splice(i,1),i--,y.add(l),p=!0)}}while(p);return T.map(i=>m.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this.g.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const a=this.e.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this.f)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:d=>d.activationEvents};class w{constructor(t){this.d=new D,this.c=new A(t,[])}async acquireLock(t){const a=await this.d.acquire(t);return new h(this,a)}deltaExtensions(t,a,m){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,m)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this.c.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=w;class h extends M.Disposable{constructor(t,a){super(),this.f=t,this.c=!1,this.D(a)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=h;class O{constructor(t){this.name=t,this.promise=new Promise((a,m)=>{this.c=a})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const a=new O(t);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let a=!0;const m=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{!a||(clearTimeout(m),a=!1,this.d=!1,this.e())};t.resolve((0,M.toDisposable)(y))}}var f;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(f||(f={}));function b(d,t){const a=d.isBuiltin?0:d.isUnderDevelopment?2:1,m=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==m)return a-m;const y=C.posix.basename(d.extensionLocation.path),T=C.posix.basename(t.extensionLocation.path);return y<T?-1:y>T?1:0}function g(d,t){const a=new n.ExtensionIdentifierSet(t);return d.filter(m=>!a.has(m.identifier))}}),define(Ae[75],Re([1,0,25]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var C;(function(h){h[h.VersionMismatch=55]="VersionMismatch",h[h.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(h){h[h.Initialized=0]="Initialized",h[h.Ready=1]="Ready",h[h.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function R(h){const O=n.VSBuffer.alloc(1);switch(h){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=R;function A(h,O){if(h.byteLength!==1)return!1;switch(h.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var w;(function(h){h.Start="START_NATIVE_LOG",h.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ae[57],Re([1,0,3,5,14,27,75,50,52,23,2,6,148]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends D.Disposable{constructor(a,m){super(),this.m=a,this.n=m,this.a=this.D(new P.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.D(new P.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=m.createLogger(this.j,{id:w.extensionTelemetryLogChannelId,name:(0,f.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.D(m.onDidChangeLogLevel(y=>{(0,C.isLogLevel)(y)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,m,y){const T=this.getTelemetryDetails(),p=new g(m,y,a,this.k,this.i,this.getBuiltInCommonProperties(a),{isUsageEnabled:T.isUsageEnabled,isErrorsEnabled:T.isErrorsEnabled});return this.l.set(a.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(a,m,y){this.f=a,this.g=m,this.c=y??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(a){const m={};switch(m["common.extname"]=`${a.publisher}.${a.name}`,m["common.extversion"]=a.version,m["common.vscodemachineid"]=this.m.telemetryInfo.machineId,m["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,m["common.vscodeversion"]=this.m.version,m["common.isnewappinstall"]=d(this.m.telemetryInfo.firstSessionDate),m["common.product"]=this.m.environment.appHost,this.m.uiKind){case R.UIKind.Web:m["common.uikind"]="web";break;case R.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,A.getRemoteName)((0,w.cleanRemoteAuthority)(this.m.remote.authority)),m}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const m=this.getTelemetryDetails();this.l.forEach((y,T)=>{y.isDisposed&&this.l.delete(T)}),this.l.forEach(y=>{y.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(a,m){const y=this.l.get(a.value);return y&&y.isDisposed?(this.l.delete(a.value),!1):!y||y.ignoreUnhandledExtHostErrors?!1:(y.logError(m),!0)}};b=je([Ve(0,M.IExtHostInitDataService),Ve(1,C.ILoggerService)],b),e.ExtHostTelemetry=b;class g{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,m,y,T,p,i,l){this.g=y,this.h=T,this.i=p,this.j=i,this.a=new P.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(a,m){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let m=a.properties??a;return m=(0,w.cleanData)(m,[]),this.c&&(m=(0,h.mixin)(m,this.c)),this.b||(m=(0,h.mixin)(m,this.j)),a.properties?a.properties=m:a=m,a}k(a,m){!this.f||(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(a,m),this.h.trace(a,m))}logUsage(a,m){!this.d.isUsageEnabled||this.k(a,m)}logError(a,m){!this.d.isErrorsEnabled||!this.f||(typeof a=="string"?this.k(a,m):this.f.sendErrorData(a,m))}get apiTelemetryLogger(){if(!this.e){const a=this,m={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function d(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=d,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,174,96,24,3]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var h;(function(T){T[T.EagerAutoStart=1]="EagerAutoStart",T[T.EagerManualStart=2]="EagerManualStart",T[T.Lazy=3]="Lazy"})(h=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:M.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,i){const l=[],r=[],c=[],o=[],I=D(this.c),s=D(p),u=(X,Y)=>X.extensionLocation.toString()===Y.extensionLocation.toString()||X.isBuiltin===Y.isBuiltin||X.isUserBuiltin===Y.isUserBuiltin||X.isUnderDevelopment===Y.isUnderDevelopment;for(const X of this.c){const Y=s.get(X.identifier);if(!Y){l.push(X.identifier),I.delete(X.identifier);continue}if(!u(X,Y)){l.push(X.identifier),I.delete(X.identifier);continue}}for(const X of p){const Y=I.get(X.identifier);if(!Y){r.push(X);continue}if(!u(Y,X)){l.push(Y.identifier),I.delete(Y.identifier);continue}}const v=new R.ExtensionIdentifierSet(this.d),S=new R.ExtensionIdentifierSet(i);for(const X of this.d)S.has(X)||c.push(X);for(const X of i)v.has(X)||o.push(X);const E=M.ImplicitActivationEvents.createActivationEventsMap(r),W={toRemove:l,toAdd:r,addActivationEvents:E,myToRemove:c,myToAdd:o};return this.delta(W),W}delta(p){const{toRemove:i,toAdd:l,myToRemove:r,myToAdd:c}=p,o=new R.ExtensionIdentifierSet(i),I=new R.ExtensionIdentifierSet(r);for(let s=0;s<this.c.length;s++)o.has(this.c[s].identifier)&&(this.c.splice(s,1),s--);for(let s=0;s<this.d.length;s++)I.has(this.d[s])&&(this.d.splice(s,1),s--);for(const s of l)this.c.push(s);for(const s of c)this.d.push(s)}containsExtension(p){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,p))return!0;return!1}}e.ExtensionHostExtensions=O;function D(T){const p=new R.ExtensionIdentifierMap;for(const i of T)p.set(i.identifier,i);return p}function f(T,p){return T.enabledApiProposals?T.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=f;function b(T,p){if(!f(T,p))throw new Error(`Extension '${T.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${T.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${T.identifier.value}`)}e.checkProposedApiEnabled=b;class g{constructor(p,i,l,r){this.codeLoadingTime=p,this.activateCallTime=i,this.activateResolvedTime=l,this.activationReason=r}}e.ActivationTimes=g;class d{constructor(p,i){this.description=p,this.value=i}}e.ExtensionPointContribution=d;var t;(function(T){T[T.Normal=0]="Normal",T[T.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(T){return{type:T.isBuiltin?0:1,isBuiltin:T.isBuiltin||T.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(T.publisher,T.name),uuid:T.uuid},manifest:T,location:T.extensionLocation,targetPlatform:T.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function m(T,p){return{identifier:new R.ExtensionIdentifier((0,C.getExtensionId)(T.manifest.publisher,T.manifest.name)),isBuiltin:T.type===0,isUserBuiltin:T.type===1&&T.isBuiltin,isUnderDevelopment:!!p,extensionLocation:T.location,...T.manifest,uuid:T.identifier.uuid,targetPlatform:T.targetPlatform,browserNlsBundleUris:T.browserNlsBundleUris}}e.toExtensionDescription=m;class y{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=y}),define(Ae[197],Re([1,0,10,100,24,26,14,17]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class w{constructor(a,m,y,T){this.startup=a,this.codeLoadingTime=m,this.activateCallTime=y,this.activateResolvedTime=T}}w.NONE=new w(!1,-1,-1,-1),e.ExtensionActivationTimes=w;class h{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,m){return a===-1||m===-1?-1:m-a}build(){return new w(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=h;class O{constructor(a,m,y,T,p,i){this.activationFailed=a,this.activationFailedError=m,this.activationTimes=y,this.module=T,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=O;class D extends O{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class f extends O{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=f;class b extends O{constructor(a){super(!0,a,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(a,m,y,T){this.g=T,this.a=a,this.b=m,this.c=y,this.d=new C.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[a,m]of this.d)m.dispose()}isActivated(a){const m=this.d.get(a);return Boolean(m&&m.value)}getActivatedExtension(a){const m=this.d.get(a);if(!m||!m.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return m.value}async activateByEvent(a,m){if(this.f[a])return;const y=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(y.map(T=>({id:T.identifier,reason:{startup:m,extensionId:T.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,m){const y=this.a.getExtensionDescription(a);if(!y)throw new Error(`Extension '${a}' is not known`);return this.h([{id:y.identifier,reason:m}])}async h(a){const m=a.filter(y=>!this.isActivated(y.id)).map(y=>this.j(y));await Promise.all(m.map(y=>y.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const m=this.a.getExtensionDescription(a.id);if(!m){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new b(p));return this.c.onExtensionActivationError(a.id,p,new M.MissingExtensionDependency(a.id.value)),i}const y=[],T=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const p of T){if(this.m(p))continue;const i=this.d.get(p);if(i){y.push(i);continue}if(this.l(p)){y.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:a.reason}));continue}const l=this.a.getExtensionDescription(p);if(l){if(!l.main&&!l.browser)continue;y.push(this.j({id:l.identifier,reason:a.reason}));continue}const r=m.displayName||m.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),o=this.k(a,m.displayName,[],new b(c));return this.c.onExtensionActivationError(m.identifier,c,new M.MissingExtensionDependency(p)),o}return this.k(a,m.displayName,y,null)}k(a,m,y,T){const p=new d(a.id,m,a.reason,y,T,this.c,this.g);return this.d.set(a.id,p),p}l(a){return P.ExtensionDescriptionRegistry.isHostExtension(a,this.a,this.b)}m(a){const m=this.b.getExtensionDescription(a);return m?!m.main&&!m.browser:!1}};g=je([Ve(3,R.ILogService)],g),e.ExtensionsActivator=g;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,m,y,T,p,i,l){this.c=a,this.d=m,this.f=y,this.g=T,this.h=p,this.j=i,this.k=l,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const m=this.g[a];if(m.value&&!m.value.activationFailed){this.g.splice(a,1),a--;continue}if(m.value&&m.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);y.detail=m.value.activationFailedError,this.h=new b(y),this.j.onExtensionActivationError(this.c,y,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const m=new Error;if(a&&a.name&&(m.name=a.name),a&&a.message?m.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(m.stack=a.stack),this.h=new b(m),this.b&&n.isCancellationError(a))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};d=je([Ve(6,R.ILogService)],d)});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[7],Re([1,0,16,10,87,28,65,13,9,2,35,43,95,72,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g){"use strict";var d,t,a,m,y,T,p,i,l,r,c,o,I,s,u,v,S,E,W,X,Y,J,j,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...ye]=arguments;return Reflect.construct(z,ye,ne.constructor)}}})}var q;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(q=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var he;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(he=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let Ee=i=class{static from(...N){let ne=N;return new i(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}constructor(N){d.set(this,void 0),Je(this,d,N,"f")}dispose(){typeof Ne(this,d,"f")=="function"&&(Ne(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,Ee=i=je([B],Ee),e.Disposable=Ee;let ie=l=class{static Min(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let ye=1;ye<N.length;ye++){const qe=N[ye];qe.isBefore(ne)&&(ne=qe)}return ne}static Max(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let ye=1;ye<N.length;ye++){const qe=N[ye];qe.isAfter(ne)&&(ne=qe)}return ne}static isPosition(N){if(!N)return!1;if(N instanceof l)return!0;const{line:ne,character:ye}=N;return typeof ne=="number"&&typeof ye=="number"}static of(N){if(N instanceof l)return N;if(this.isPosition(N))return new l(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ne){if(N<0)throw(0,P.illegalArgument)("line must be non-negative");if(ne<0)throw(0,P.illegalArgument)("character must be non-negative");this.c=N,this.e=ne}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ne=0){if(N===null||ne===null)throw(0,P.illegalArgument)();let ye;return typeof N>"u"?ye=0:typeof N=="number"?ye=N:(ye=typeof N.lineDelta=="number"?N.lineDelta:0,ne=typeof N.characterDelta=="number"?N.characterDelta:0),ye===0&&ne===0?this:new l(this.line+ye,this.character+ne)}with(N,ne=this.character){if(N===null||ne===null)throw(0,P.illegalArgument)();let ye;return typeof N>"u"?ye=this.line:typeof N=="number"?ye=N:(ye=typeof N.line=="number"?N.line:this.line,ne=typeof N.character=="number"?N.character:this.character),ye===this.line&&ne===this.character?this:new l(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};ie=l=je([B],ie),e.Position=ie;let ce=r=class{static isRange(N){return N instanceof r?!0:N?ie.isPosition(N.start)&&ie.isPosition(N.end):!1}static of(N){if(N instanceof r)return N;if(this.isRange(N))return new r(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ne,ye,qe){let _e,st;if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(N,ne),st=new ie(ye,qe)):ie.isPosition(N)&&ie.isPosition(ne)&&(_e=ie.of(N),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");_e.isBefore(st)?(this.c=_e,this.e=st):(this.c=st,this.e=_e)}contains(N){return r.isRange(N)?this.contains(N.start)&&this.contains(N.end):ie.isPosition(N)?!(ie.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ne=ie.Max(N.start,this.c),ye=ie.Min(N.end,this.e);if(!ne.isAfter(ye))return new r(ne,ye)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ne=ie.Min(N.start,this.c),ye=ie.Max(N.end,this.end);return new r(ne,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ne=this.end){if(N===null||ne===null)throw(0,P.illegalArgument)();let ye;return N?ie.isPosition(N)?ye=N:(ye=N.start||this.start,ne=N.end||this.end):ye=this.start,ye.isEqual(this.c)&&ne.isEqual(this.end)?this:new r(ye,ne)}toJSON(){return[this.start,this.end]}};ce=r=je([B],ce),e.Range=ce;let de=c=class extends ce{static isSelection(N){return N instanceof c?!0:N?ce.isRange(N)&&ie.isPosition(N.anchor)&&ie.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ne,ye,qe){let _e,st;if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"?(_e=new ie(N,ne),st=new ie(ye,qe)):ie.isPosition(N)&&ie.isPosition(ne)&&(_e=ie.of(N),st=ie.of(ne)),!_e||!st)throw new Error("Invalid arguments");super(_e,st),this.f=_e,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};de=c=je([B],de),e.Selection=de;class Te{constructor(N,ne,ye){if(typeof N!="string"||N.length===0)throw(0,P.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,P.illegalArgument)("port");if(typeof ye<"u"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z_\-]+$/.test(ye)))throw(0,P.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=Te;class le extends Error{static NotAvailable(N,ne){return new le(N,f.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(N){return new le(N,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ne=f.RemoteAuthorityResolverErrorCode.Unknown,ye){super(N),this._message=N,this._code=ne,this._detail=ye,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var V;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let L=o=class{static isTextEdit(N){return N instanceof o?!0:N?ce.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ne){return new o(N,ne)}static insert(N,ne){return o.replace(new ce(N,N),ne)}static delete(N){return o.replace(N,"")}static setEndOfLine(N){const ne=new o(new ce(new ie(0,0),new ie(0,0)),"");return ne.newEol=N,ne}get range(){return this.c}set range(N){if(N&&!ce.isRange(N))throw(0,P.illegalArgument)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,P.illegalArgument)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,P.illegalArgument)("newEol");this.f=N}constructor(N,ne){this.c=N,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};L=o=je([B],L),e.TextEdit=L;let K=I=class{static isNotebookCellEdit(N){return N instanceof I?!0:N?Kt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ne){return new I(N,ne)}static insertCells(N,ne){return new I(new Kt(N,N),ne)}static deleteCells(N){return new I(N,[])}static updateCellMetadata(N,ne){const ye=new I(new Kt(N,N),[]);return ye.newCellMetadata=ne,ye}static updateNotebookMetadata(N){const ne=new I(new Kt(0,0),[]);return ne.newNotebookMetadata=N,ne}constructor(N,ne){this.range=N,this.newCells=ne}};K=I=je([B],K),e.NotebookEdit=K;class me{static isSnippetTextEdit(N){return N instanceof me?!0:N?ce.isRange(N.range)&&ve.isSnippetString(N.snippet):!1}static replace(N,ne){return new me(N,ne)}static insert(N,ne){return me.replace(new ce(N,N),ne)}constructor(N,ne){this.range=N,this.snippet=ne}}e.SnippetTextEdit=me;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie=e.FileEditType||(e.FileEditType={}));let we=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ne,ye,qe){this.c.push({_type:1,from:N,to:ne,options:ye,metadata:qe})}createFile(N,ne,ye){this.c.push({_type:1,from:void 0,to:N,options:ne,metadata:ye})}deleteFile(N,ne,ye){this.c.push({_type:1,from:N,to:void 0,options:ne,metadata:ye})}e(N,ne,ye){this.c.push({_type:3,metadata:ye,uri:N,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(N,ne,ye,qe){const _e=ne.start,st=ne.end;(_e!==st||ye.length>0)&&this.c.push({_type:5,uri:N,index:_e,count:st-_e,cells:ye,metadata:qe})}g(N,ne,ye,qe){this.c.push({_type:3,metadata:qe,uri:N,edit:{editType:8,index:ne,metadata:ye}})}replace(N,ne,ye,qe){this.c.push({_type:2,uri:N,edit:new L(ne,ye),metadata:qe})}insert(N,ne,ye,qe){this.replace(N,new ce(ne,ne),ye,qe)}delete(N,ne,ye){this.replace(N,ne,"",ye)}has(N){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===N.toString())}set(N,ne){if(ne)for(const ye of ne){if(!ye)continue;let qe,_e;Array.isArray(ye)?(qe=ye[0],_e=ye[1]):qe=ye,K.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(N,qe.range.start,qe.newCellMetadata,_e):qe.newNotebookMetadata?this.e(N,qe.newNotebookMetadata,_e):this.f(N,qe.range,qe.newCells,_e):me.isSnippetTextEdit(qe)?this.c.push({_type:6,uri:N,range:qe.range,edit:qe.snippet,metadata:_e}):this.c.push({_type:2,uri:N,edit:qe,metadata:_e})}else{for(let ye=0;ye<this.c.length;ye++){const qe=this.c[ye];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===N.toString()&&(this.c[ye]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(N){const ne=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===N.toString()&&ne.push(ye.edit);return ne}entries(){const N=new M.ResourceMap;for(const ne of this.c)if(ne._type===2){let ye=N.get(ne.uri);ye||(ye=[ne.uri,[]],N.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};we=je([B],we),e.WorkspaceEdit=we;let ve=s=class{static isSnippetString(N){return N instanceof s?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=s.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ne=this.e++){if(typeof N=="function"){const ye=new s;ye.e=this.e,N(ye),this.e=ye.e,N=ye.value}else N=s.c(N);return this.value+="${",this.value+=ne,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ne=this.e++){const ye=N.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(N,ne){if(typeof ne=="function"){const ye=new s;ye.e=this.e,ne(ye),this.e=ye.e,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ve=s=je([B],ve),e.SnippetString=ve;var Ce;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Ce=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=u=class{static isLocation(N){return N instanceof u?!0:N?ce.isRange(N.range)&&h.URI.isUri(N.uri):!1}constructor(N,ne){if(this.uri=N,ne)if(ce.isRange(ne))this.range=ce.of(ne);else if(ie.isPosition(ne))this.range=new ce(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ae=u=je([B],ae),e.Location=ae;let Z=class{static is(N){return N?typeof N.message=="string"&&N.location&&ce.isRange(N.location.range)&&h.URI.isUri(N.location.uri):!1}constructor(N,ne){this.location=N,this.message=ne}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.location.range.isEqual(ne.location.range)&&N.location.uri.toString()===ne.location.uri.toString()}};Z=je([B],Z),e.DiagnosticRelatedInformation=Z;let k=class{constructor(N,ne,ye=se.Error){if(!ce.isRange(N))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=N,this.message=ne,this.severity=ye}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.severity===ne.severity&&N.code===ne.code&&N.severity===ne.severity&&N.source===ne.source&&N.range.isEqual(ne.range)&&(0,n.equals)(N.tags,ne.tags)&&(0,n.equals)(N.relatedInformation,ne.relatedInformation,Z.isEqual)}};k=je([B],k),e.Diagnostic=k;let F=class{constructor(N,ne){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ne}};F=je([B],F),e.Hover=F;var H;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(H=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let x=class{constructor(N,ne=H.Text){this.range=N,this.kind=ne}toJSON(){return{range:this.range,kind:H[this.kind]}}};x=je([B],x),e.DocumentHighlight=x;var te;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(te=e.SymbolKind||(e.SymbolKind={}));var pe;(function(z){z[z.Deprecated=1]="Deprecated"})(pe=e.SymbolTag||(e.SymbolTag={}));let ke=v=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ne,ye,qe,_e){this.name=N,this.kind=ne,this.containerName=_e,typeof ye=="string"&&(this.containerName=ye),qe instanceof ae?this.location=qe:ye instanceof ce&&(this.location=new ae(qe,ye)),v.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};ke=v=je([B],ke),e.SymbolInformation=ke;let ue=S=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(S.validate)}constructor(N,ne,ye,qe,_e){this.name=N,this.detail=ne,this.kind=ye,this.range=qe,this.selectionRange=_e,this.children=[],S.validate(this)}};ue=S=je([B],ue),e.DocumentSymbol=ue;var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Se=class{constructor(N,ne){this.title=N,this.kind=ne}};Se=je([B],Se),e.CodeAction=Se;let $e=E=class{constructor(N){this.value=N}append(N){return new E(this.value?this.value+E.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+E.c)}};$e.c=".",$e=E=je([B],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let He=class{constructor(N,ne){if(this.range=N,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};He=je([B],He),e.SelectionRange=He;class et{constructor(N,ne,ye,qe,_e,st){this.kind=N,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.CallHierarchyItem=et;class Xe{constructor(N,ne){this.fromRanges=ne,this.from=N}}e.CallHierarchyIncomingCall=Xe;class tt{constructor(N,ne){this.fromRanges=ne,this.to=N}}e.CallHierarchyOutgoingCall=tt;var rt;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(rt=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(N,ne){this.range=N,this.command=ne}get isResolved(){return!!this.command}};Me=je([B],Me),e.CodeLens=Me;let it=W=class{static isMarkdownString(N){return N instanceof W?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ne=!1){t.set(this,void 0),Je(this,t,new C.MarkdownString(N,{supportThemeIcons:ne}),"f")}get value(){return Ne(this,t,"f").value}set value(N){Ne(this,t,"f").value=N}get isTrusted(){return Ne(this,t,"f").isTrusted}set isTrusted(N){Ne(this,t,"f").isTrusted=N}get supportThemeIcons(){return Ne(this,t,"f").supportThemeIcons}set supportThemeIcons(N){Ne(this,t,"f").supportThemeIcons=N}get supportHtml(){return Ne(this,t,"f").supportHtml}set supportHtml(N){Ne(this,t,"f").supportHtml=N}get baseUri(){return Ne(this,t,"f").baseUri}set baseUri(N){Ne(this,t,"f").baseUri=N}appendText(N){return Ne(this,t,"f").appendText(N),this}appendMarkdown(N){return Ne(this,t,"f").appendMarkdown(N),this}appendCodeblock(N,ne){return Ne(this,t,"f").appendCodeblock(ne??"",N),this}};t=new WeakMap,it=W=je([B],it),e.MarkdownString=it;let Q=class{constructor(N,ne){this.label=N,this.documentation=ne}};Q=je([B],Q),e.ParameterInformation=Q;let _=class{constructor(N,ne){this.label=N,this.documentation=ne,this.parameters=[]}};_=je([B],_),e.SignatureInformation=_;let be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};be=je([B],be),e.SignatureHelp=be;var We;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(We=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(N){this.value=N}};Qe=je([B],Qe),e.InlayHintLabelPart=Qe;let Ye=class{constructor(N,ne,ye){this.position=N,this.label=ne,this.kind=ye}};Ye=je([B],Ye),e.InlayHint=Ye;var Ge;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var Dt;(function(z){z[z.Deprecated=1]="Deprecated"})(Dt=e.CompletionItemTag||(e.CompletionItemTag={}));let Tt=class{constructor(N,ne){this.label=N,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Tt=je([B],Tt),e.CompletionItem=Tt;let It=class{constructor(N=[],ne=!1){this.items=N,this.isIncomplete=ne}};It=je([B],It),e.CompletionList=It;let Et=class{constructor(N,ne,ye){this.insertText=N,this.range=ne,this.command=ye}};Et=je([B],Et),e.InlineSuggestion=Et;let Mt=class{constructor(N){this.commands=void 0,this.items=N}};Mt=je([B],Mt),e.InlineSuggestionList=Mt;var zt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(zt=e.ViewColumn||(e.ViewColumn={}));var Xt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Xt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ht;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ht=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Lt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Lt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function N(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=N}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ct=class{constructor(N,ne){if(ne&&!h.URI.isUri(ne))throw(0,P.illegalArgument)("target");if(!ce.isRange(N)||N.isEmpty)throw(0,P.illegalArgument)("range");this.range=N,this.target=ne}};Ct=je([B],Ct),e.DocumentLink=Ct;let Pt=class{constructor(N,ne,ye,qe){this.red=N,this.green=ne,this.blue=ye,this.alpha=qe}};Pt=je([B],Pt),e.Color=Pt;let $t=class{constructor(N,ne){if(ne&&!(ne instanceof Pt))throw(0,P.illegalArgument)("color");if(!ce.isRange(N)||N.isEmpty)throw(0,P.illegalArgument)("range");this.range=N,this.color=ne}};$t=je([B],$t),e.ColorInformation=$t;let Ke=class{constructor(N){if(!N||typeof N!="string")throw(0,P.illegalArgument)("label");this.label=N}};Ke=je([B],Ke),e.ColorPresentation=Ke;var Wt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Wt=e.ColorFormat||(e.ColorFormat={}));var Pe;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Le;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Le=e.TerminalExitReason||(e.TerminalExitReason={}));class fe{constructor(N,ne,ye){if(this.startIndex=N,this.length=ne,this.tooltip=ye,typeof N!="number"||N<0)throw(0,P.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,P.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=fe;class G{constructor(N){this.uri=N}}e.TerminalQuickFixOpener=G;class Oe{constructor(N){this.terminalCommand=N}}e.TerminalQuickFixCommand=Oe;var Be;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Be=e.TerminalLocation||(e.TerminalLocation={}));class Ze{constructor(N){if(this.options=N,typeof N!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Ze;var xe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var ot;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ot=e.TaskPanelKind||(e.TaskPanelKind={}));let ft=X=class{static from(N){switch(N){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(N,ne){if(this.label=ne,typeof N!="string"||typeof ne!="string")throw(0,P.illegalArgument)("name");this.c=N}get id(){return this.c}};ft.Clean=new X("clean","Clean"),ft.Build=new X("build","Build"),ft.Rebuild=new X("rebuild","Rebuild"),ft.Test=new X("test","Test"),ft=X=je([B],ft),e.TaskGroup=ft;function mt(z){let N="";for(let ne=0;ne<z.length;ne++)N+=z[ne].replace(/,/g,",,")+",";return N}let lt=class{constructor(N,ne,ye){if(typeof N!="string")throw(0,P.illegalArgument)("process");this.e=[],this.c=N,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ye):this.f=ne)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,P.illegalArgument)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)N.push(ne);return mt(N)}};lt=je([B],lt),e.ProcessExecution=lt;let ct=class{constructor(N,ne,ye){if(this.f=[],Array.isArray(ne)){if(!N)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,P.illegalArgument)("command");this.e=N,this.f=ne,this.g=ye}else{if(typeof N!="string")throw(0,P.illegalArgument)("commandLine");this.c=N,this.g=ne}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,P.illegalArgument)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,P.illegalArgument)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)N.push(typeof ne=="string"?ne:ne.value);return mt(N)}};ct=je([B],ct),e.ShellExecution=ct;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Ht{constructor(N){this.c=N}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(N){this.c=N}get callback(){return this.c}}e.CustomExecution=Ht;let Nt=Y=class{constructor(N,ne,ye,qe,_e,st){this.j=!1,this.k=this.definition=N;let ut;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=ye,this.execution=qe,ut=_e,this.j=!0):ne===kt.Global||ne===kt.Workspace?(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st):(this.target=ne,this.m=this.name=ye,this.t=this.source=qe,this.execution=_e,ut=st),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:Y.e,id:this.n.computeId()}:this.n instanceof ct?this.k={type:Y.f,id:this.n.computeId()}:this.n instanceof Ht?this.k={type:Y.c,id:this.n.computeId()}:this.k={type:Y.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=N}get scope(){return this.l}set target(N){this.y(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,P.illegalArgument)("name");this.y(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.y(),this.n=N;const ne=this.k.type;(Y.g===ne||Y.e===ne||Y.f===ne||Y.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.y(),this.o=N,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.y(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.y(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.y(),this.u=N}get detail(){return this.x}set detail(N){N===null&&(N=void 0),this.x=N}get presentationOptions(){return this.v}set presentationOptions(N){N==null&&(N=Object.create(null)),this.y(),this.v=N}get runOptions(){return this.w}set runOptions(N){N==null&&(N=Object.create(null)),this.y(),this.w=N}};Nt.c="customExecution",Nt.e="process",Nt.f="shell",Nt.g="$empty",Nt=Y=je([B],Nt),e.Task=Nt;var ai;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ai=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(z){function N(ne){const ye=ne;return(0,w.isNumber)(ye.value)?ye.tooltip&&!(0,w.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=N})(At=e.ViewBadge||(e.ViewBadge={}));let yi=J=class{static isTreeItem(N,ne){const ye=N;if(ye.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(ne,"treeItemCheckbox");const qe=(0,w.isNumber)(ye.checkboxState)?ye.checkboxState:(0,w.isObject)(ye.checkboxState)&&(0,w.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,_e=!(0,w.isNumber)(ye.checkboxState)&&(0,w.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(qe===void 0||qe!==yt.Checked&&qe!==yt.Unchecked||_e!==void 0&&!(0,w.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(N instanceof J)return!0;if(ye.label!==void 0&&!(0,w.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,w.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,w.isString)(ye.iconPath)&&!h.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,w.isString)(ye.iconPath.id))){const qe=ye.iconPath;if(!qe||!(0,w.isString)(qe.light)&&!h.URI.isUri(qe.light)&&!(0,w.isString)(qe.dark)&&!h.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,w.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!h.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,w.isString)(ye.tooltip)&&!(ye.tooltip instanceof it)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<ci.None&&ye.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,w.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(N,ne=ci.None){this.collapsibleState=ne,h.URI.isUri(N)?this.resourceUri=N:this.label=N}};yi=J=je([B],yi),e.TreeItem=yi;var ci;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ci=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var yt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(yt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ui=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N,ne){this.value=N,this.id=ne??(0,O.generateUuid)()}};ui=je([B],ui),e.DataTransferItem=ui;let li=class{constructor(N){a.add(this),m.set(this,new Map);for(const[ne,ye]of N??[]){const qe=Ne(this,m,"f").get(Ne(this,a,"m",y).call(this,ne));qe?qe.push(ye):Ne(this,m,"f").set(Ne(this,a,"m",y).call(this,ne),[ye])}}get(N){return Ne(this,m,"f").get(Ne(this,a,"m",y).call(this,N))?.[0]}set(N,ne){Ne(this,m,"f").set(Ne(this,a,"m",y).call(this,N),[ne])}forEach(N,ne){for(const[ye,qe]of Ne(this,m,"f"))for(const _e of qe)N.call(ne,_e,ye,this)}*[(m=new WeakMap,a=new WeakSet,Symbol.iterator)](){for(const[N,ne]of Ne(this,m,"f"))for(const ye of ne)yield[N,ye]}};y=function(N){return N.toLowerCase()},li=je([B],li),e.DataTransfer=li;let Zt=class{constructor(N){this.insertText=N}};Zt=je([B],Zt),e.DocumentDropEdit=Zt;let Di=class{constructor(N){this.insertText=N}};Di=je([B],Di),e.DocumentPasteEdit=Di;let wt=class{constructor(N,ne){this.id=N,this.color=ne}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};wt=je([B],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let di=class{constructor(N){this.id=N}};di=je([B],di),e.ThemeColor=di;var Bi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Bi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(N){this.c=N,this.e=h.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ne){if(typeof N!="string"&&(!N||!h.URI.isUri(N)&&!h.URI.isUri(N.uri)))throw(0,P.illegalArgument)("base");if(typeof ne!="string")throw(0,P.illegalArgument)("pattern");typeof N=="string"?this.baseUri=h.URI.file(N):h.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=je([B],ei),e.RelativePattern=ei;const ii=new WeakMap;function dt(z,N){ii.set(z,N)}e.setBreakpointId=dt;let ti=class{constructor(N,ne,ye,qe){this.enabled=typeof N=="boolean"?N:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this.c||(this.c=ii.get(this)??(0,O.generateUuid)()),this.c}};ti=je([B],ti),e.Breakpoint=ti;let jt=class extends ti{constructor(N,ne,ye,qe,_e){if(super(ne,ye,qe,_e),N===null)throw(0,P.illegalArgument)("location");this.location=N}};jt=je([B],jt),e.SourceBreakpoint=jt;let Qt=class extends ti{constructor(N,ne,ye,qe,_e){super(ne,ye,qe,_e),this.functionName=N}};Qt=je([B],Qt),e.FunctionBreakpoint=Qt;let hi=class extends ti{constructor(N,ne,ye,qe,_e,st,ut){if(super(qe,_e,st,ut),!ne)throw(0,P.illegalArgument)("dataId");this.label=N,this.dataId=ne,this.canPersist=ye}};hi=je([B],hi),e.DataBreakpoint=hi;let Ii=class{constructor(N,ne,ye){this.command=N,this.args=ne||[],this.options=ye}};Ii=je([B],Ii),e.DebugAdapterExecutable=Ii;let Ci=class{constructor(N,ne){this.port=N,this.host=ne}};Ci=je([B],Ci),e.DebugAdapterServer=Ci;let fi=class{constructor(N){this.path=N}};fi=je([B],fi),e.DebugAdapterNamedPipeServer=fi;let ki=class{constructor(N){this.implementation=N}};ki=je([B],ki),e.DebugAdapterInlineImplementation=ki;let mi=class{constructor(N,ne){this.range=N,this.expression=ne}};mi=je([B],mi),e.EvaluatableExpression=mi;var gi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ti=class{constructor(N,ne){this.range=N,this.text=ne}};Ti=je([B],Ti),e.InlineValueText=Ti;let ni=class{constructor(N,ne,ye=!0){this.range=N,this.variableName=ne,this.caseSensitiveLookup=ye}};ni=je([B],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(N,ne){this.range=N,this.expression=ne}};ri=je([B],ri),e.InlineValueEvaluatableExpression=ri;let Pi=class{constructor(N,ne){this.frameId=N,this.stoppedLocation=ne}};Pi=je([B],Pi),e.InlineValueContext=Pi;var zi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(zi=e.FileChangeType||(e.FileChangeType={}));let Yt=j=class extends Error{static FileExists(N){return new j(N,D.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(N){return new j(N,D.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(N){return new j(N,D.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(N){return new j(N,D.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(N){return new j(N,D.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(N){return new j(N,D.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(N,ne=D.FileSystemProviderErrorCode.Unknown,ye){super(h.URI.isUri(N)?N.toString(!0):N),this.code=ye?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};Yt=j=je([B],Yt),e.FileSystemError=Yt;let Ai=class{constructor(N,ne,ye){this.start=N,this.end=ne,this.kind=ye}};Ai=je([B],Ai),e.FoldingRange=Ai;var Wi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Hi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ni;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ni=e.CommentMode||(e.CommentMode={}));var Vi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Vi=e.CommentThreadState||(e.CommentThreadState={}));class ji{constructor(N,ne=[]){this.tokenTypes=N,this.tokenModifiers=ne}}e.SemanticTokensLegend=ji;function qi(z){return typeof z>"u"||(0,w.isStringArray)(z)}class si{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let ne=0,ye=N.tokenTypes.length;ne<ye;ne++)this.j.set(N.tokenTypes[ne],ne);for(let ne=0,ye=N.tokenModifiers.length;ne<ye;ne++)this.k.set(N.tokenModifiers[ne],ne)}}push(N,ne,ye,qe,_e){if(typeof N=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof qe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(N,ne,ye,qe,_e);if(ce.isRange(N)&&typeof ne=="string"&&qi(ye))return this.m(N,ne,ye);throw(0,P.illegalArgument)()}m(N,ne,ye){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const qe=N.start.line,_e=N.start.character,st=N.end.character-N.start.character,ut=this.j.get(ne);let Ft=0;if(ye)for(const Vt of ye){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Vt);Ft|=1<<qt>>>0}this.n(qe,_e,st,ut,Ft)}n(N,ne,ye,qe,_e){if(this.f&&(N<this.c||N===this.c&&ne<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,qt=0;for(let Gt=0;Gt<Ft;Gt++){let _t=this.g[5*Gt],Oi=this.g[5*Gt+1];_t===0?(_t=Vt,Oi+=qt):_t+=Vt,this.g[5*Gt]=_t,this.g[5*Gt+1]=Oi,Vt=_t,qt=Oi}}let st=N,ut=ne;this.f&&this.h>0&&(st-=this.c,st===0&&(ut-=this.e)),this.g[this.h++]=st,this.g[this.h++]=ut,this.g[this.h++]=ye,this.g[this.h++]=qe,this.g[this.h++]=_e,this.c=N,this.e=ne}static o(N){const ne=[],ye=N.length/5|0;for(let ut=0;ut<ye;ut++)ne[ut]=ut;ne.sort((ut,Ft)=>{const Vt=N[5*ut],qt=N[5*Ft];if(Vt===qt){const Gt=N[5*ut+1],_t=N[5*Ft+1];return Gt-_t}return Vt-qt});const qe=new Uint32Array(N.length);let _e=0,st=0;for(let ut=0;ut<ye;ut++){const Ft=5*ne[ut],Vt=N[Ft+0],qt=N[Ft+1],Gt=N[Ft+2],_t=N[Ft+3],Oi=N[Ft+4],un=Vt-_e,Ln=un===0?qt-st:qt,Li=5*ut;qe[Li+0]=un,qe[Li+1]=Ln,qe[Li+2]=Gt,qe[Li+3]=_t,qe[Li+4]=Oi,_e=Vt,st=qt}return qe}build(N){return this.f?new pi(new Uint32Array(this.g),N):new pi(si.o(this.g),N)}}e.SemanticTokensBuilder=si;class pi{constructor(N,ne){this.resultId=ne,this.data=N}}e.SemanticTokens=pi;class Fi{constructor(N,ne,ye){this.start=N,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=Fi;class Ue{constructor(N,ne){this.resultId=ne,this.edits=N}}e.SemanticTokensEdits=Ue;var xt;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let oi=class{constructor(){}};oi.Back={iconPath:new wt("arrow-left")},oi=je([B],oi),e.QuickInputButtons=oi;var vt;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(vt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ki;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ki=e.ExtensionKind||(e.ExtensionKind={}));class Mi{static validate(N){if(typeof N.badge=="string"){let ne=(0,A.nextCharLength)(N.badge,0);if(ne<N.badge.length&&(ne+=(0,A.nextCharLength)(N.badge,ne)),N.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!wt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ne,ye){this.badge=N,this.tooltip=ne,this.color=ye}}e.FileDecoration=Mi;let Ri=class{constructor(N){this.kind=N}};Ri=je([B],Ri),e.ColorTheme=Ri;var vi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(vi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(N){return N instanceof Kt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ne){if(N<0)throw(0,P.illegalArgument)("start must be positive");if(ne<0)throw(0,P.illegalArgument)("end must be positive");N<=ne?(this.c=N,this.e=ne):(this.c=ne,this.e=N)}with(N){let ne=this.c,ye=this.e;return N.start!==void 0&&(ne=N.start),N.end!==void 0&&(ye=N.end),ne===this.c&&ye===this.e?this:new Kt(ne,ye)}}e.NotebookRange=Kt;class bi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(N){return!0}constructor(N,ne,ye,qe,_e,st,ut){this.kind=N,this.value=ne,this.languageId=ye,this.mime=qe,this.outputs=_e??[],this.metadata=st,this.executionSummary=ut,bi.validate(this)}}e.NotebookCellData=bi;class Gi{constructor(N){this.cells=N}}e.NotebookData=Gi;class Bt{static isNotebookCellOutputItem(N){return N instanceof Bt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ne={name:N.name,message:N.message,stack:N.stack};return Bt.json(ne,"application/vnd.code.notebook.error")}static stdout(N){return Bt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Bt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ne="application/octet-stream"){return new Bt(N,ne)}static text(N,ne=R.Mimes.text){const ye=Ne(Bt,T,"f",p).encode(String(N));return new Bt(ye,ne)}static json(N,ne="text/x-json"){const ye=JSON.stringify(N,void 0,"	");return Bt.text(ye,ne)}constructor(N,ne){this.data=N,this.mime=ne;const ye=(0,R.normalizeMimeType)(ne,!0);if(!ye)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}T=Bt,p={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class Ei{static isNotebookCellOutput(N){return N instanceof Ei?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ne=!1){const ye=new Set,qe=new Set;for(let _e=0;_e<N.length;_e++){const st=N[_e],ut=(0,R.normalizeMimeType)(st.mime);if(!ye.has(ut)||(0,b.isTextStreamMime)(ut)){ye.add(ut);continue}qe.add(_e),ne&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?N:N.filter((_e,st)=>!qe.has(st))}constructor(N,ne,ye){this.items=Ei.ensureUniqueMimeTypes(N,!0),typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,O.generateUuid)(),this.metadata=ne??ye)}}e.NotebookCellOutput=Ei;var Xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Yi;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Yi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ji{constructor(N,ne){this.text=N,this.alignment=ne}}e.NotebookCellStatusBarItem=Ji;var Zi;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Zi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var oe;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ge{constructor(N,ne=[]){this.uri=N,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=ge;class Fe{constructor(N){this.label=N}}e.NotebookKernelSourceAction=Fe;let nt=class{constructor(N,ne){this.label=N,this.timestamp=ne}};nt=je([B],nt),e.TimelineItem=nt;var St;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(St=e.ExtensionMode||(e.ExtensionMode={}));var Rt;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(N,ne){this.ranges=N,this.wordPattern=ne}}e.LinkedEditingRanges=gn;class pn{constructor(N,ne){this.c=N,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=pn;var vn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(vn=e.TestResultState||(e.TestResultState={}));var bn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(bn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ui=class{constructor(N=void 0,ne=void 0,ye=void 0){this.include=N,this.exclude=ne,this.profile=ye}};Ui=je([B],Ui),e.TestRunRequest=Ui;let en=class extends Ui{constructor(N=void 0,ne=void 0,ye=void 0,qe=!1){super(N,ne,ye),this.continuous=qe}};en=je([B],en),e.TestRunRequest2=en;let tn=U=class{static diff(N,ne,ye){const qe=new U(N);return qe.expectedOutput=ne,qe.actualOutput=ye,qe}constructor(N){this.message=N}};tn=U=je([B],tn),e.TestMessage=tn;let nn=class{constructor(N){this.id=N}};nn=je([B],nn),e.TestTag=nn;let wi=class{constructor(N,ne){this.covered=N,this.total=ne}};wi=je([B],wi),e.CoveredCount=wi;let rn=$=class{static fromDetails(N,ne){const ye=new wi(0,0),qe=new wi(0,0),_e=new wi(0,0);for(const ut of ne)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const Ft of ut.branches)qe.total+=1,qe.covered+=Ft.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const st=new $(N,ye,qe.total>0?qe:void 0,_e.total>0?_e:void 0);return st.detailedCoverage=ne,st}constructor(N,ne,ye,qe){this.uri=N,this.statementCoverage=ne,this.branchCoverage=ye,this.functionCoverage=qe}};rn=$=je([B],rn),e.FileCoverage=rn;let sn=class{constructor(N,ne,ye=[]){this.executionCount=N,this.location=ne,this.branches=ye}};sn=je([B],sn),e.StatementCoverage=sn;let on=class{constructor(N,ne){this.executionCount=N,this.location=ne}};on=je([B],on),e.BranchCoverage=on;let an=class{constructor(N,ne){this.executionCount=N,this.location=ne}};an=je([B],an),e.FunctionCoverage=an;var En;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(En=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Sn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class yn{constructor(N,ne,ye,qe,_e,st){this.kind=N,this.name=ne,this.detail=ye,this.uri=qe,this.range=_e,this.selectionRange=st}}e.TypeHierarchyItem=yn;class Dn{constructor(N){this.uri=N}}e.TextTabInput=Dn;class In{constructor(N,ne){this.original=N,this.modified=ne}}e.TextDiffTabInput=In;class Cn{constructor(N,ne,ye,qe){this.base=N,this.input1=ne,this.input2=ye,this.result=qe}}e.TextMergeTabInput=Cn;class kn{constructor(N,ne){this.uri=N,this.viewType=ne}}e.CustomEditorTabInput=kn;class Tn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=Tn;class Pn{constructor(N,ne){this.uri=N,this.notebookType=ne}}e.NotebookEditorTabInput=Pn;class An{constructor(N,ne,ye){this.original=N,this.modified=ne,this.notebookType=ye}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class On{constructor(N,ne){this.uri=N,this.inputBoxUri=ne}}e.InteractiveWindowInput=On}),define(Ae[101],Re([1,0,49,15,13,264,133,7,16]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const h=new Map;function O(g,d){d?h.set(g,d):h.delete(g)}e.setWordDefinitionFor=O;function D(g){return h.get(g)}class f extends M.MirrorTextModel{constructor(d,t,a,m,y,T,p,i){super(t,a,m,y),this.m=d,this.p=T,this.q=p,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,w.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===P.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,a){return d.y(t,a)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,n.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,n.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.d[t.start.line].substring(t.start.character,t.end.character);const a=this.f,m=t.start.line,y=t.end.line,T=[];T.push(this.d[m].substring(t.start.character));for(let p=m+1;p<y;p++)T.push(this.d[p]);return T.push(this.d[y].substring(0,t.end.character)),T.join(a)}t(d){let t;if(d instanceof A.Position?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.d.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.d[t],t===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const t=this.h.getIndexOf(d),a=this.d[t.index].length;return new A.Position(t.index,Math.min(t.remainder,a))}w(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const t=this.x(d.start),a=this.x(d.end);return t===d.start&&a===d.end?d:new A.Range(t.line,t.character,a.line,a.character)}x(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:t,character:a}=d,m=!1;if(t<0)t=0,a=0,m=!0;else if(t>=this.d.length)t=this.d.length-1,a=this.d[t].length,m=!0;else{const y=this.d[t].length;a<0?(a=0,m=!0):a>y&&(a=y,m=!0)}return m?new A.Position(t,a):d}y(d,t){const a=this.x(d);if(!t)t=D(this.p);else if((0,C.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const m=(0,R.getWordAtText)(a.character+1,(0,R.ensureValidWordDefinition)(t),this.d[a.line],0);if(m)return new A.Range(a.line,m.startColumn-1,a.line,m.endColumn-1)}}e.ExtHostDocumentData=f;class b{constructor(d,t,a){this.a=d,this.b=t,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ae[198],Re([1,0,7,18,5]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new C.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let w;switch(A){case"light":w=n.ColorThemeKind.Light;break;case"hcDark":w=n.ColorThemeKind.HighContrast;break;case"hcLight":w=n.ColorThemeKind.HighContrastLight;break;default:w=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=je([Ve(0,P.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ae[8],Re([1,0,16,25,118,199,87,28,114,66,65,23,9,2,44,76,92,98,97,72,45,56,195,7]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Pe){function Le(G){const{selectionStartLineNumber:Oe,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:xe}=G,ot=new l.Position(Oe-1,Be-1),ft=new l.Position(Ze-1,xe-1);return new l.Selection(ot,ft)}Pe.to=Le;function fe(G){const{anchor:Oe,active:Be}=G;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Pe.from=fe})(r=e.Selection||(e.Selection={}));var c;(function(Pe){function Le(G){if(!G)return;const{start:Oe,end:Be}=G;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Pe.from=Le;function fe(G){if(!G)return;const{startLineNumber:Oe,startColumn:Be,endLineNumber:Ze,endColumn:xe}=G;return new l.Range(Oe-1,Be-1,Ze-1,xe-1)}Pe.to=fe})(c=e.Range||(e.Range={}));var o;(function(Pe){function Le(fe){switch(fe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Pe.to=Le})(o=e.TokenType||(e.TokenType={}));var I;(function(Pe){function Le(G){return new l.Position(G.lineNumber-1,G.column-1)}Pe.to=Le;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Pe.from=fe})(I=e.Position||(e.Position={}));var s;(function(Pe){function Le(Oe,Be){return(0,n.coalesce)((0,n.asArray)(Oe).map(Ze=>fe(Ze,Be)))}Pe.from=Le;function fe(Oe,Be){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:G(Oe.scheme,Be),pattern:be.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function G(Oe,Be){return Be&&typeof Oe=="string"?Be.transformOutgoingScheme(Oe):Oe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(Pe){function Le(G){switch(G){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function fe(G){switch(G){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Pe.to=fe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Pe){function Le(G){let Oe;return G.code&&((0,f.isString)(G.code)||(0,f.isNumber)(G.code)?Oe=String(G.code):Oe={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:Oe,severity:E.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(S.from),tags:Array.isArray(G.tags)?(0,n.coalesce)(G.tags.map(u.from)):void 0}}Pe.from=Le;function fe(G){const Oe=new l.Diagnostic(c.to(G),G.message,E.to(G.severity));return Oe.source=G.source,Oe.code=(0,f.isString)(G.code)?G.code:G.code?.value,Oe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(S.to),Oe.tags=G.tags&&(0,n.coalesce)(G.tags.map(u.to)),Oe}Pe.to=fe})(v=e.Diagnostic||(e.Diagnostic={}));var S;(function(Pe){function Le(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}Pe.from=Le;function fe(G){return new l.DiagnosticRelatedInformation(new l.Location(G.resource,c.to(G)),G.message)}Pe.to=fe})(S=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var E;(function(Pe){function Le(G){switch(G){case l.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=Le;function fe(G){switch(G){case t.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Pe.to=fe})(E=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var W;(function(Pe){function Le(G){return typeof G=="number"&&G>=l.ViewColumn.One?G-1:G===l.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Pe.from=Le;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=fe})(W=e.ViewColumn||(e.ViewColumn={}));function X(Pe){return typeof Pe.range<"u"}function Y(Pe){return Pe.length===0?!0:!!X(Pe[0])}e.isDecorationOptionsArr=Y;var J;(function(Pe){function Le(xe){return xe.map(Pe.from)}Pe.fromMany=Le;function fe(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function G(xe){let ot;if(fe(xe)){const{language:ct,value:bt}=xe;ot={value:"```"+ct+`
`+bt+"\n```\n"}}else l.MarkdownString.isMarkdownString(xe)?ot={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?ot={value:xe}:ot={value:""};const ft=Object.create(null);ot.uris=ft;const mt=ct=>{try{let bt=b.URI.parse(ct,!0);bt=bt.with({query:Oe(bt.query,ft)}),ft[ct]=bt}catch{}return""},lt=new w.marked.Renderer;return lt.link=mt,lt.image=ct=>typeof ct=="string"?mt(R.parseHrefAndDimensions(ct).href):"",(0,w.marked)(ot.value,{renderer:lt}),ot}Pe.from=G;function Oe(xe,ot){if(!xe)return xe;let ft;try{ft=(0,h.parse)(xe)}catch{}if(!ft)return xe;let mt=!1;return ft=(0,D.cloneAndChange)(ft,lt=>{if(b.URI.isUri(lt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ct]=lt,mt=!0,ct}else return}),mt?JSON.stringify(ft):xe}function Be(xe){const ot=new l.MarkdownString(xe.value,xe.supportThemeIcons);return ot.isTrusted=xe.isTrusted,ot.supportHtml=xe.supportHtml,ot.baseUri=xe.baseUri?b.URI.from(xe.baseUri):void 0,ot}Pe.to=Be;function Ze(xe){if(!!xe)return typeof xe=="string"?xe:Pe.from(xe)}Pe.fromStrict=Ze})(J=e.MarkdownString||(e.MarkdownString={}));function j(Pe){return Y(Pe)?Pe.map(Le=>({range:c.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?J.fromMany(Le.hoverMessage):Le.hoverMessage?J.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:c.from(Le)}))}e.fromRangeOrRangeWithMessage=j;function U(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?b.URI.file(Pe):Pe}e.pathOrURIToURI=U;var $;(function(Pe){function Le(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?U(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Pe.from=Le})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Pe){function Le(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Pe.from=Le})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(Pe){function Le(fe){if(typeof fe>"u")return fe;switch(fe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var he;(function(Pe){function Le(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?q.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?B.from(fe.light):void 0,dark:fe.dark?B.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?U(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?$.from(fe.before):void 0,after:fe.after?$.from(fe.after):void 0}}Pe.from=Le})(he=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Ee;(function(Pe){function Le(G){return{text:G.newText,eol:G.newEol&&rt.from(G.newEol),range:c.from(G.range)}}Pe.from=Le;function fe(G){const Oe=new l.TextEdit(c.to(G.range),G.text);return Oe.newEol=typeof G.eol>"u"?void 0:rt.to(G.eol),Oe}Pe.to=fe})(Ee=e.TextEdit||(e.TextEdit={}));var ie;(function(Pe){function Le(G,Oe){const Be={edits:[]};if(G instanceof l.WorkspaceEdit){const Ze=new A.ResourceSet;for(const xe of G._allEntries())xe._type===1&&b.URI.isUri(xe.to)&&xe.from===void 0&&Ze.add(xe.to);for(const xe of G._allEntries())xe._type===1?Be.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,P.encodeBase64)(P.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?Be.edits.push({resource:xe.uri,textEdit:Ee.from(xe.edit),versionId:Ze.has(xe.uri)?void 0:Oe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?Be.edits.push({resource:xe.uri,textEdit:{range:c.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(xe.uri)?void 0:Oe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Be.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Be.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Dt.from)}})}return Be}Pe.from=Le;function fe(G){const Oe=new l.WorkspaceEdit;for(const Be of G.edits)Be.textEdit?Oe.replace(b.URI.revive(Be.resource),c.to(Be.textEdit.range),Be.textEdit.text):Oe.renameFile(b.URI.revive(Be.oldResource),b.URI.revive(Be.newResource),Be.options);return Oe}Pe.to=fe})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(Pe){const Le=Object.create(null);Le[l.SymbolKind.File]=0,Le[l.SymbolKind.Module]=1,Le[l.SymbolKind.Namespace]=2,Le[l.SymbolKind.Package]=3,Le[l.SymbolKind.Class]=4,Le[l.SymbolKind.Method]=5,Le[l.SymbolKind.Property]=6,Le[l.SymbolKind.Field]=7,Le[l.SymbolKind.Constructor]=8,Le[l.SymbolKind.Enum]=9,Le[l.SymbolKind.Interface]=10,Le[l.SymbolKind.Function]=11,Le[l.SymbolKind.Variable]=12,Le[l.SymbolKind.Constant]=13,Le[l.SymbolKind.String]=14,Le[l.SymbolKind.Number]=15,Le[l.SymbolKind.Boolean]=16,Le[l.SymbolKind.Array]=17,Le[l.SymbolKind.Object]=18,Le[l.SymbolKind.Key]=19,Le[l.SymbolKind.Null]=20,Le[l.SymbolKind.EnumMember]=21,Le[l.SymbolKind.Struct]=22,Le[l.SymbolKind.Event]=23,Le[l.SymbolKind.Operator]=24,Le[l.SymbolKind.TypeParameter]=25;function fe(Oe){return typeof Le[Oe]=="number"?Le[Oe]:6}Pe.from=fe;function G(Oe){for(const Be in Le)if(Le[Be]===Oe)return Number(Be);return l.SymbolKind.Property}Pe.to=G})(ce=e.SymbolKind||(e.SymbolKind={}));var de;(function(Pe){function Le(G){switch(G){case l.SymbolTag.Deprecated:return 1}}Pe.from=Le;function fe(G){switch(G){case 1:return l.SymbolTag.Deprecated}}Pe.to=fe})(de=e.SymbolTag||(e.SymbolTag={}));var Te;(function(Pe){function Le(G){return{name:G.name,kind:ce.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:K.from(G.location)}}Pe.from=Le;function fe(G){const Oe=new l.SymbolInformation(G.name,ce.to(G.kind),G.containerName,K.to(G.location));return Oe.tags=G.tags&&G.tags.map(de.to),Oe}Pe.to=fe})(Te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Pe){function Le(G){const Oe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:ce.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Oe.children=G.children.map(Le)),Oe}Pe.from=Le;function fe(G){const Oe=new l.DocumentSymbol(G.name,G.detail,ce.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,n.isNonEmptyArray)(G.tags)&&(Oe.tags=G.tags.map(de.to)),G.children&&(Oe.children=G.children.map(fe)),Oe}Pe.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(Pe){function Le(G){const Oe=new l.CallHierarchyItem(ce.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Pe.to=Le;function fe(G,Oe,Be){if(Oe=Oe??G._sessionId,Be=Be??G._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,name:G.name,detail:G.detail,kind:ce.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=fe})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var V;(function(Pe){function Le(fe){return new l.CallHierarchyIncomingCall(re.to(fe.from),fe.fromRanges.map(G=>c.to(G)))}Pe.to=Le})(V=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(Pe){function Le(fe){return new l.CallHierarchyOutgoingCall(re.to(fe.to),fe.fromRanges.map(G=>c.to(G)))}Pe.to=Le})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(Pe){function Le(G){return{range:G.range&&c.from(G.range),uri:G.uri}}Pe.from=Le;function fe(G){return new l.Location(b.URI.revive(G.uri),c.to(G.range))}Pe.to=fe})(K=e.location||(e.location={}));var me;(function(Pe){function Le(G){const Oe=G,Be=G;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Be.uri,range:c.from(Oe.targetRange?Oe.targetRange:Be.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Pe.from=Le;function fe(G){return{targetUri:b.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}Pe.to=fe})(me=e.DefinitionLink||(e.DefinitionLink={}));var Ie;(function(Pe){function Le(G){return{range:c.from(G.range),contents:J.fromMany(G.contents)}}Pe.from=Le;function fe(G){return new l.Hover(G.contents.map(J.to),c.to(G.range))}Pe.to=fe})(Ie=e.Hover||(e.Hover={}));var we;(function(Pe){function Le(G){return{range:c.from(G.range),expression:G.expression}}Pe.from=Le;function fe(G){return new l.EvaluatableExpression(c.to(G.range),G.expression)}Pe.to=fe})(we=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Pe){function Le(G){if(G instanceof l.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof l.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function fe(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}Pe.to=fe})(ve=e.InlineValue||(e.InlineValue={}));var Ce;(function(Pe){function Le(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}Pe.from=Le;function fe(G){return new l.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}Pe.to=fe})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Pe){function Le(G){return{range:c.from(G.range),kind:G.kind}}Pe.from=Le;function fe(G){return new l.DocumentHighlight(c.to(G.range),G.kind)}Pe.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Pe){function Le(fe){switch(fe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Pe.to=Le})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Le(fe){return{triggerKind:ae.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Pe.to=Le})(Z=e.CompletionContext||(e.CompletionContext={}));var k;(function(Pe){function Le(G){switch(G){case l.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function fe(G){switch(G){case 1:return l.CompletionItemTag.Deprecated}}Pe.to=fe})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(Pe){const Le=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function fe(Be){return Le.get(Be)??9}Pe.from=fe;const G=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Oe(Be){return G.get(Be)??l.CompletionItemKind.Property}Pe.to=Oe})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(Pe){function Le(fe,G){const Oe=new l.CompletionItem(fe.label);return Oe.insertText=fe.insertText,Oe.kind=F.to(fe.kind),Oe.tags=fe.tags?.map(k.to),Oe.detail=fe.detail,Oe.documentation=R.isMarkdownString(fe.documentation)?J.to(fe.documentation):fe.documentation,Oe.sortText=fe.sortText,Oe.filterText=fe.filterText,Oe.preselect=fe.preselect,Oe.commitCharacters=fe.commitCharacters,g.Range.isIRange(fe.range)?Oe.range=c.to(fe.range):typeof fe.range=="object"&&(Oe.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Oe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Oe.insertText=new l.SnippetString(fe.insertText):(Oe.insertText=fe.insertText,Oe.textEdit=Oe.range instanceof l.Range?new l.TextEdit(Oe.range,Oe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Oe.additionalTextEdits=fe.additionalTextEdits.map(Be=>Ee.to(Be))),Oe.command=G&&fe.command?G.fromInternal(fe.command):void 0,Oe}Pe.to=Le})(H=e.CompletionItem||(e.CompletionItem={}));var x;(function(Pe){function Le(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:J.fromStrict(G.documentation)}}Pe.from=Le;function fe(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?J.to(G.documentation):G.documentation}}Pe.to=fe})(x=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(Pe){function Le(G){return{label:G.label,documentation:J.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(x.from):[],activeParameter:G.activeParameter}}Pe.from=Le;function fe(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?J.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(x.to):[],activeParameter:G.activeParameter}}Pe.to=fe})(te=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(Pe){function Le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.from):[]}}Pe.from=Le;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(te.to):[]}}Pe.to=fe})(pe=e.SignatureHelp||(e.SignatureHelp={}));var ke;(function(Pe){function Le(fe,G){const Oe=new l.InlayHint(I.to(G.position),typeof G.label=="string"?G.label:G.label.map(ue.to.bind(void 0,fe)),G.kind&&De.to(G.kind));return Oe.textEdits=G.textEdits&&G.textEdits.map(Ee.to),Oe.tooltip=R.isMarkdownString(G.tooltip)?J.to(G.tooltip):G.tooltip,Oe.paddingLeft=G.paddingLeft,Oe.paddingRight=G.paddingRight,Oe}Pe.to=Le})(ke=e.InlayHint||(e.InlayHint={}));var ue;(function(Pe){function Le(fe,G){const Oe=new l.InlayHintLabelPart(G.label);return Oe.tooltip=R.isMarkdownString(G.tooltip)?J.to(G.tooltip):G.tooltip,d.Command.is(G.command)&&(Oe.command=fe.fromInternal(G.command)),G.location&&(Oe.location=K.to(G.location)),Oe}Pe.to=Le})(ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Pe){function Le(G){return G}Pe.from=Le;function fe(G){return G}Pe.to=fe})(De=e.InlayHintKind||(e.InlayHintKind={}));var Se;(function(Pe){function Le(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}Pe.from=Le;function fe(G){let Oe;if(G.url)try{Oe=typeof G.url=="string"?b.URI.parse(G.url,!0):b.URI.revive(G.url)}catch{}return new l.DocumentLink(c.to(G.range),Oe)}Pe.to=fe})(Se=e.DocumentLink||(e.DocumentLink={}));var $e;(function(Pe){function Le(G){const Oe=new l.ColorPresentation(G.label);return G.textEdit&&(Oe.textEdit=Ee.to(G.textEdit)),G.additionalTextEdits&&(Oe.additionalTextEdits=G.additionalTextEdits.map(Be=>Ee.to(Be))),Oe}Pe.to=Le;function fe(G){return{label:G.label,textEdit:G.textEdit?Ee.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Oe=>Ee.from(Oe)):void 0}}Pe.from=fe})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(Pe){function Le(G){return new l.Color(G[0],G[1],G[2],G[3])}Pe.to=Le;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Pe.from=fe})(He=e.Color||(e.Color={}));var et;(function(Pe){function Le(G){return{range:c.from(G.range)}}Pe.from=Le;function fe(G){return new l.SelectionRange(c.to(G.range))}Pe.to=fe})(et=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Pe){function Le(fe){switch(fe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Pe){function Le(G){switch(G){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function fe(G){switch(G){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Pe.to=fe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Pe){function Le(G){if(G===l.EndOfLine.CRLF)return 1;if(G===l.EndOfLine.LF)return 0}Pe.from=Le;function fe(G){if(G===1)return l.EndOfLine.CRLF;if(G===0)return l.EndOfLine.LF}Pe.to=fe})(rt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(Pe){function Le(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(Me=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Pe){function Le(G){const Oe={start:G.start+1,end:G.end+1};return G.kind&&(Oe.kind=Q.from(G.kind)),Oe}Pe.from=Le;function fe(G){const Oe={start:G.start-1,end:G.end-1};return G.kind&&(Oe.kind=Q.to(G.kind)),Oe}Pe.to=fe})(it=e.FoldingRange||(e.FoldingRange={}));var Q;(function(Pe){function Le(G){if(G)switch(G){case l.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Pe.from=Le;function fe(G){if(G)switch(G.value){case d.FoldingRangeKind.Comment.value:return l.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports.value:return l.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region.value:return l.FoldingRangeKind.Region}}Pe.to=fe})(Q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(Pe){function Le(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Le})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var be;(function(Pe){function Le(Be){return Be instanceof l.RelativePattern?Be.toJSON():typeof Be=="string"?Be:fe(Be)||G(Be)?new l.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Pe.from=Le;function fe(Be){const Ze=Be;return Ze?b.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe(Be){return typeof Be=="string"?Be:new l.RelativePattern(b.URI.revive(Be.baseUri),Be.pattern)}Pe.to=Oe})(be=e.GlobPattern||(e.GlobPattern={}));var We;(function(Pe){function Le(fe){if(fe){if(Array.isArray(fe))return fe.map(Le);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:be.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Pe.from=Le})(We=e.LanguageSelector||(e.LanguageSelector={}));var ze;(function(Pe){function Le(G){return{start:G.start,end:G.end}}Pe.from=Le;function fe(G){return new l.NotebookRange(G.start,G.end)}Pe.to=fe})(ze=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Pe){function Le(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Pe.to=Le;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Pe.from=fe})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(Pe){function Le(fe){if(fe===y.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(fe===y.NotebookCellExecutionState.Pending)return;if(fe===y.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Pe.to=Le})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Pe){function Le(G){switch(G){case l.NotebookCellKind.Markup:return y.CellKind.Markup;case l.NotebookCellKind.Code:default:return y.CellKind.Code}}Pe.from=Le;function fe(G){switch(G){case y.CellKind.Markup:return l.NotebookCellKind.Markup;case y.CellKind.Code:default:return l.NotebookCellKind.Code}}Pe.to=fe})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Pe){function Le(G){const Oe={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)l.NotebookCellData.validate(Be),Oe.cells.push(Dt.from(Be));return Oe}Pe.from=Le;function fe(G){const Oe=new l.NotebookData(G.cells.map(Dt.to));return(0,f.isEmptyObject)(G.metadata)||(Oe.metadata=G.metadata),Oe}Pe.to=fe})(at=e.NotebookData||(e.NotebookData={}));var Dt;(function(Pe){function Le(G){return{cellKind:Ge.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(It.from):[]}}Pe.from=Le;function fe(G){return new l.NotebookCellData(Ge.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(It.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Pe.to=fe})(Dt=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(Pe){function Le(G){return{mime:G.mime,valueBytes:P.VSBuffer.wrap(G.data)}}Pe.from=Le;function fe(G){return new l.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Pe.to=fe})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(Pe){function Le(G){return{outputId:G.id,items:G.items.map(Tt.from),metadata:G.metadata}}Pe.from=Le;function fe(G){const Oe=G.items.map(Tt.to);return new l.NotebookCellOutput(Oe,G.outputId,G.metadata)}Pe.to=fe})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Pe){function Le(Oe){return G(Oe)?{include:(0,f.withNullAsUndefined)(be.from(Oe.include)),exclude:(0,f.withNullAsUndefined)(be.from(Oe.exclude))}:(0,f.withNullAsUndefined)(be.from(Oe))}Pe.from=Le;function fe(Oe){return G(Oe)?{include:be.to(Oe.include),exclude:be.to(Oe.exclude)}:be.to(Oe)}Pe.to=fe;function G(Oe){const Be=Oe;return Be?!(0,f.isUndefinedOrNull)(Be.include)&&!(0,f.isUndefinedOrNull)(Be.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Mt;(function(Pe){function Le(fe,G,Oe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Oe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Pe.from=Le})(Mt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var zt;(function(Pe){function Le(fe,G,Oe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Be,Oe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Pe.from=Le})(zt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Xt;(function(Pe){function Le(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Pe.from=Le})(Xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ht;(function(Pe){function Le(G){return{uri:G.uri,provides:G.provides}}Pe.from=Le;function fe(G){return new l.NotebookRendererScript(b.URI.revive(G.uri),G.provides)}Pe.to=fe})(ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Pe){function Le(G){return{message:J.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:c.from(G.location.range),uri:G.location.uri}}}Pe.from=Le;function fe(G){const Oe=new l.TestMessage(typeof G.message=="string"?G.message:J.to(G.message));return Oe.actualOutput=G.actual,Oe.expectedOutput=G.expected,Oe.location=G.location?K.to(G.location):void 0,Oe}Pe.to=fe})(gt=e.TestMessage||(e.TestMessage={}));var Ot;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(Ot=e.TestTag||(e.TestTag={}));var Ut;(function(Pe){function Le(G){const Oe=(0,a.getPrivateApiFor)(G).controllerId;return{extId:T.TestId.fromExtHostTestItem(G,Oe).toString(),label:G.label,uri:b.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Ot.namespace(Oe,Be.id)),range:g.Range.lift(c.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&J.fromStrict(G.error)||null}}Pe.from=Le;function fe(G){return{parent:void 0,error:void 0,id:T.TestId.fromString(G.extId).localId,label:G.label,uri:b.URI.revive(G.uri),tags:(G.tags||[]).map(Oe=>{const{tagId:Be}=Ot.denamespace(Oe);return new l.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Pe.toPlain=fe})(Ut=e.TestItem||(e.TestItem={})),function(Pe){function Le(G){return{id:G.id}}Pe.from=Le;function fe(G){return new l.TestTag(G.id)}Pe.to=fe}(Ot=e.TestTag||(e.TestTag={}));var Lt;(function(Pe){const Le=(G,Oe)=>{const Be=[];for(const[xe,ot]of Oe)T.TestId.compare(ot.item.extId,xe)===2&&(Oe.delete(xe),Be.push(ot));const Ze={...Ut.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(ot=>ot.type===0).map(gt.to)})),children:Be.map(xe=>Le(xe,Oe))};for(const xe of Ze.children)xe.parent=Ze;return Ze};function fe(G){const Oe=[],Be=new Map;for(const Ze of G.items){Be.set(Ze.item.extId,Ze);const xe=T.TestId.root(Ze.item.extId);G.request.targets.some(ot=>ot.controllerId===xe&&ot.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:G.completedAt,results:Oe.map(Ze=>Le(Ze,Be))}}Pe.to=fe})(Lt=e.TestResults||(e.TestResults={}));var pt;(function(Pe){function Le(Be){return{covered:Be.covered,total:Be.covered}}function fe(Be){return"line"in Be?I.from(Be):c.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:fe(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&fe(Ze.location)})):void 0}:{type:0,count:Be.executionCount,location:fe(Be.location)}}Pe.fromDetailed=G;function Oe(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Pe.fromFile=Oe})(pt=e.TestCoverage||(e.TestCoverage={}));var Ct;(function(Pe){function Le(fe){switch(fe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Pe){function Le(G){const Oe=new l.TypeHierarchyItem(ce.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Oe._sessionId=G._sessionId,Oe._itemId=G._itemId,Oe}Pe.to=Le;function fe(G,Oe,Be){if(Oe=Oe??G._sessionId,Be=Be??G._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,kind:ce.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=fe})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var $t;(function(Pe){function Le(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Pe.from=Le})($t=e.ViewBadge||(e.ViewBadge={}));var Ke;(function(Pe){function Le(Be,Ze,xe){const ot=Ze.fileData;return ot?new class extends l.DataTransferItem{asFile(){return{name:ot.name,uri:b.URI.revive(ot.uri),data:(0,M.once)(()=>xe())}}}("",Ze.id):Be===O.Mimes.uriList&&Ze.uriListData?new l.DataTransferItem(Oe(Ze.uriListData)):new l.DataTransferItem(Ze.asString)}Pe.to=Le;async function fe(Be,Ze){const xe=await Ze.asString();if(Be===O.Mimes.uriList)return{id:Ze.id,asString:xe,fileData:void 0,uriListData:G(xe)};const ot=Ze.asFile();return{id:Ze.id,asString:xe,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}}Pe.from=fe;function G(Be){return C.UriList.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return b.URI.parse(Ze)}catch{}return Ze})}function Oe(Be){return C.UriList.create(Be.map(Ze=>typeof Ze=="string"?Ze:b.URI.revive(Ze)))}})(Ke=e.DataTransferItem||(e.DataTransferItem={}));var Wt;(function(Pe){function Le(G,Oe){const Be=G.items.map(([Ze,xe])=>[Ze,Ke.to(Ze,xe,()=>Oe(xe.id))]);return new l.DataTransfer(Be)}Pe.toDataTransfer=Le;async function fe(G){const Oe={items:[]},Be=[];return G.forEach((Ze,xe)=>{Be.push((async()=>{Oe.items.push([xe,await Ke.from(xe,Ze)])})())}),await Promise.all(Be),Oe}Pe.toDataTransferDTO=fe})(Wt=e.DataTransfer||(e.DataTransfer={}))}),define(Ae[200],Re([1,0,2,10,7,8,166]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(h,O,D,f={timeout:1500,errors:3}){this.c=h,this.d=O,this.f=D,this.g=f,this.a=new R.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(h){return(O,D,f)=>{const g={dispose:this.a.push([O,D,h])};return Array.isArray(f)&&f.push(g),g}}async $participateInSave(h,O){const D=n.URI.revive(h);let f=!1;const b=setTimeout(()=>f=!0,this.g.timeout),g=[];try{for(const d of[...this.a]){if(f)break;const t=this.d.getDocument(D),a=await this.h(d,{document:t,reason:M.TextDocumentSaveReason.to(O)});g.push(a)}}finally{clearTimeout(b)}return g}h([h,O,D],f){const b=this.b.get(h);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,h,O,f).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this.b.get(h);this.b.set(h,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(h,O,D,f){const b=[],g=Date.now(),{document:d,reason:t}=f,{version:a}=d,m=Object.freeze({document:d,reason:t,waitUntil(y){if(Object.isFrozen(b))throw(0,P.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(y))}});try{O.apply(D,[m])}catch(y){return Promise.reject(y)}return Object.freeze(b),new Promise((y,T)=>{const p=setTimeout(()=>T(new Error("timeout")),this.g.timeout);return Promise.all(b).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(p),y(i)}).catch(i=>{clearTimeout(p),T(i)})}).then(y=>{const T={edits:[]};for(const p of y)if(Array.isArray(p)&&p.every(i=>i instanceof C.TextEdit))for(const{newText:i,newEol:l,range:r}of p)T.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:i,eol:l&&M.EndOfLine.from(l)}});if(T.edits.length!==0)return a===d.version?this.f.$tryApplyWorkspaceEdit(T):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ae[201],Re([1,0,15,2,8,7,72]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(D,f,b,g){this.start=D,this.deletedCount=f,this.deletedItems=b,this.items=g}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(D,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,f,b){this.notebook=D,this.h=f,this.j=b,this.handle=b.handle,this.uri=P.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return D.g},set mime(g){D.g=g},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,f,b){const g=b.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===D);if(d&&(f||(d.items.length=0),d.items.push(...g),d.items.length>1&&d.items.every(t=>R.isTextStreamMime(t.mime)))){const t=new Map,a=[];d.items.forEach(m=>{let y;t.has(m.mime)?y=t.get(m.mime):(y=[],t.set(m.mime,y),a.push(m.mime)),y.push(m.data)}),d.items.length=0,a.forEach(m=>{const y=R.compressOutputItemStreams(t.get(m));d.items.push({mime:m,data:y.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=w;class h{constructor(D,f,b,g,d){this.k=D,this.l=f,this.m=b,this.uri=g,this.handle=h.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,f={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===n.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(d=>d.apiCell)},save(){return D.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,f,b){this.g=D.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:b});const g={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},d=[];for(const a of D.rawEvents)a.kind===R.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,g.contentChanges):a.kind===R.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,g.contentChanges):a.kind===R.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),d.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),d.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<d.length;a++){const m=d[a],y=t.get(m.cell);if(y===void 0){const T=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});t.set(m.cell,T-1)}else g.cellChanges[y]={...g.cellChanges[y],...m}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let f=D.start|0,b=D.end|0;return f<0&&(f=0),b>this.b.length&&(b=this.b.length),D.with({start:f,end:b})}p(D){D=this.o(D);const f=[];for(let b=D.start;b<D.end;b++)f.push(this.b[b]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,f,b){if(this.j)return;const g=[],d=[],t=[];if(D.reverse().forEach(a=>{const y=a[2].map(i=>{const l=new w(this,this.l,i);return f||d.push(w.asModelAddData(this.apiNotebook,i)),l}),T=new A(a[0],a[1],[],y),p=this.b.splice(a[0],a[1],...y);for(const i of p)t.push(i.uri),T.deletedItems.push(i.apiCell);g.push(T)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),b)for(const a of g)b.push(a.asApiEvent())}s(D,f,b,g){const d=this.b.splice(D,f);this.b.splice(b,0,...d);const t=[new A(D,f,d.map(a=>a.apiCell),[]),new A(b,0,[],d)];for(const a of t)g.push(a.asApiEvent())}t(D,f){this.b[D].setOutputs(f)}u(D,f,b,g){this.b[D].setOutputItems(f,b,g)}v(D,f){const b=this.b[D];b.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(b.uri,f)}w(D,f){const b=this.b[D];b.apiCell.mime=f}x(D,f){this.b[D].setMetadata(f)}y(D,f){this.b[D].setInternalMetadata(f)}getCellFromApiCell(D){return this.b.find(f=>f.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(f=>f.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}h.a=0,e.ExtHostNotebookDocument=h}),define(Ae[102],Re([1,0,10,8,7]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,w,h,O,D,f){this.id=A,this.f=w,this.notebookData=h,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=O,this.c=f}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(w){this.selections=[w]},get selections(){return A.a},set selections(w){if(!Array.isArray(w)||!w.every(C.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=w,A.g(w)},get visibleRanges(){return A.b},revealRange(w,h){A.f.$tryRevealRange(A.id,P.NotebookRange.from(w),h??C.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(P.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Ae[202],Re([1,0,10,5,14,8]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(w,h){this.c=w,this.d=h,this.a=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.b=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,h){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,h);const O=this.d.getEditorById(w);h.visibleRanges&&O._acceptVisibleRanges(h.visibleRanges.ranges.map(M.NotebookRange.to)),h.selections&&O._acceptSelections(h.selections.selections.map(M.NotebookRange.to)),h.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),h.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const h in w)this.d.getEditorById(h)._acceptViewColumn(M.ViewColumn.to(w[h]))}};R=je([Ve(0,C.ILogService)],R),e.ExtHostNotebookEditors=R}),define(Ae[203],Re([1,0,8,170,146,21,64,10]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,b,g){const d=this.b++,{title:t,location:a,cancellable:m}=b,y={label:(0,C.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(d,{location:n.ProgressLocation.from(a),title:t,source:y,cancellable:m},f.isUnderDevelopment?void 0:f.identifier.value).catch(A.onUnexpectedExternalError),this.d(d,g,!!m)}d(f,b,g){let d;g&&(d=new M.CancellationTokenSource,this.c.set(f,d));const t=m=>{this.a.$progressEnd(m),this.c.delete(m),d?.dispose()};let a;try{a=b(new O(this.a,f),g&&d?d.token:M.CancellationToken.None)}catch(m){throw t(f),m}return a.then(m=>t(f),m=>t(f)),a}$acceptProgressCanceled(f){const b=this.c.get(f);b&&(b.cancel(),this.c.delete(f))}}e.ExtHostProgress=w;function h(D,f){return D.message=f.message,typeof f.increment=="number"&&(typeof D.increment=="number"?D.increment+=f.increment:D.increment=f.increment),D}class O extends P.Progress{constructor(f,b){super(g=>this.throttledReport(g)),this.c=f,this.d=b}throttledReport(f){this.c.$progressReport(this.d,f)}}je([(0,R.throttle)(100,(D,f)=>h(D,f),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ae[103],Re([1,0,44,98,45,73,56,8,2]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const h=(y,T,p,i)=>{let l=T;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!p(l,r)){const c=l;l=r,y.listener?.(i(r,c))}}}},O=(y,T)=>y===T,D={range:(y,T)=>y===T?!0:!y||!T?!1:y.isEqual(T),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(y,T)=>!(y.length!==T.length||y.some(p=>!T.find(i=>p.id===i.id)))},f=y=>T=>({op:4,update:y(T)}),b=(y,T)=>({range:(()=>{let p;const i=f(l=>({range:n.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return p},set(l){y.listener?.({op:6}),D.range(p,l)||(p=l,y.listener?.(i(l)))}}})(),label:h(y,T,D.label,f(p=>({label:p}))),description:h(y,void 0,D.description,f(p=>({description:p}))),sortText:h(y,void 0,D.sortText,f(p=>({sortText:p}))),canResolveChildren:h(y,!1,D.canResolveChildren,p=>({op:2,state:p})),busy:h(y,!1,D.busy,f(p=>({busy:p}))),error:h(y,void 0,D.error,f(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:h(y,[],D.tags,(p,i)=>({op:1,new:p.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),g=y=>{const T=C.TestId.fromString(y.extId),p=new t(T.controllerId,T.localId,y.label,w.URI.revive(y.uri)||void 0);return p.range=A.Range.to(y.range||void 0),p.description=y.description||void 0,p.sortText=y.sortText||void 0,p.tags=y.tags.map(i=>A.TestTag.to({id:(0,R.denamespaceTestTag)(i).tagId})),p},d=y=>{let T;for(const p of y.tests){const i=g(p.item);(0,P.getPrivateApiFor)(i).parent=T,T=i}return T};e.toItemFromContext=d;class t{constructor(T,p,i,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,P.createPrivateApiFor)(this,T);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,P.getPrivateApiFor,t),enumerable:!0,writable:!1},...b(r,i)})}}e.TestItemImpl=t;class a extends t{constructor(T,p){super(T,T,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class m extends M.TestItemCollection{constructor(T,p,i){super({controllerId:T,getDocumentVersion:l=>l&&i.getDocument(l)?.version,getApiFor:P.getPrivateApiFor,getChildren:l=>l.children,root:new a(T,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(Ae[104],Re([1,0,49,10,84,8,7]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(f,b,g){const d=A.c.nextId();f.$registerTextEditorDecorationType(b.identifier,d,M.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){f.$removeTextEditorDecorationType(d)}})}}A.c=new C.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class w{constructor(f,b){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,b){this.k();let g=null;if(f instanceof R.Position)g=new R.Range(f,f);else if(f instanceof R.Range)g=f;else throw new Error("Unrecognized location");this.l(g,b,!1)}insert(f,b){this.k(),this.l(new R.Range(f,f),b,!0)}delete(f){this.k();let b=null;if(f instanceof R.Range)b=f;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(f,b,g){const d=this.c.validateRange(f);this.g.push({range:d,text:b,forceMoveMarkers:g})}setEndOfLine(f){if(this.k(),f!==R.EndOfLine.LF&&f!==R.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this.h=f}}class h{constructor(f,b,g,d){this.c=f,this.d=b,this._accept(g),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(a){t.m(a)},get indentSize(){return t.g},set indentSize(a){t.o(a)},get insertSpaces(){return t.h},set insertSpaces(a){t.q(a)},get cursorStyle(){return t.j},set cursorStyle(a){t.s(a)},get lineNumbers(){return t.k},set lineNumbers(a){t.t(a)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}m(f){const b=this.l(f);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const b=Math.floor(f);return b>0?b:null}if(typeof f=="string"){const b=parseInt(f,10);return isNaN(b)?null:b>0?b:null}return null}o(f){const b=this.n(f);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}q(f){const b=this.p(f);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(f)})))}assign(f){const b={};let g=!1;if(typeof f.tabSize<"u"){const d=this.l(f.tabSize);d==="auto"?(g=!0,b.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,g=!0,b.tabSize=d)}if(typeof f.indentSize<"u"){const d=this.n(f.indentSize);d==="tabSize"?(g=!0,b.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,g=!0,b.indentSize=d)}if(typeof f.insertSpaces<"u"){const d=this.p(f.insertSpaces);d==="auto"?(g=!0,b.insertSpaces=d):this.h!==d&&(this.h=d,g=!0,b.insertSpaces=d)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,g=!0,b.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,g=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(f.lineNumbers)),g&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(f,b){b.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(g)})}}e.ExtHostTextEditorOptions=h;class O{constructor(f,b,g,d,t,a,m,y){this.id=f,this.j=b,this.k=g,this.g=!1,this.h=new Set,this.c=t,this.d=new h(this.j,this.id,a,g),this.e=m,this.f=y;const T=this;this.value=Object.freeze({get document(){return d.value},set document(p){throw(0,P.readonly)("document")},get selection(){return T.c&&T.c[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,P.illegalArgument)("selection");T.c=[p],T.l()},get selections(){return T.c},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof R.Selection)))throw(0,P.illegalArgument)("selections");T.c=p,T.l()},get visibleRanges(){return T.e},set visibleRanges(p){throw(0,P.readonly)("visibleRanges")},get options(){return T.d.value},set options(p){T.g||T.d.assign(p)},get viewColumn(){return T.f},set viewColumn(p){throw(0,P.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new w(d.value,i);return p(l),T.m(l)},insertSnippet(p,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=T.c.map(c=>M.Range.from(c));else if(i instanceof R.Position){const{lineNumber:c,column:o}=M.Position.from(i);r=[{startLineNumber:c,startColumn:o,endLineNumber:c,endColumn:o}]}else if(i instanceof R.Range)r=[M.Range.from(i)];else{r=[];for(const c of i)if(c instanceof R.Range)r.push(M.Range.from(c));else{const{lineNumber:o,column:I}=M.Position.from(c);r.push({startLineNumber:o,startColumn:I,endLineNumber:o,endColumn:I})}}return b.$tryInsertSnippet(f,d.value.version,p.value,r,l)},setDecorations(p,i){const l=i.length===0;l&&!T.h.has(p.key)||(l?T.h.delete(p.key):T.h.add(p.key),T.n(()=>{if(M.isDecorationOptionsArr(i))return b.$trySetDecorations(f,p.key,M.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let c=0,o=i.length;c<o;c++){const I=i[c];r[4*c]=I.start.line+1,r[4*c+1]=I.start.character+1,r[4*c+2]=I.end.line+1,r[4*c+3]=I.end.character+1}return b.$trySetDecorationsFast(f,p.key,r)}}))},revealRange(p,i){T.n(()=>b.$tryRevealRange(f,M.Range.from(p),i||R.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(f,M.ViewColumn.from(p))},hide(){b.$tryHideEditor(f)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,n.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,n.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,n.ok)(!this.g),this.f=f}_acceptSelections(f){(0,n.ok)(!this.g),this.c=f}async l(){const f=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const b=f.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(t=>t.range);g.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=g.length-1;t<a;t++){const m=g[t].end;if(g[t+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,d,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=O}),define(Ae[204],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribEditorLineNumberMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorLineNumberMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[205],Re([1,0,159,10,29,90,70,30,24,204,169,96]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const f=A.Registry.as(R.Extensions.JSONContribution);class b{constructor(p,i,l){this.a=p,this.b=i,this.c=l}d(p,i){this.a({type:p,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(C.default.Error,p)}warn(p){this.d(C.default.Warning,p)}info(p){this.d(C.default.Info,p)}}e.ExtensionMessageCollector=b;class g{static a(p){const i=new w.ExtensionIdentifierSet;for(let l=0,r=p.length;l<r;l++)i.add(p[l].description.identifier);return i}static compute(p,i){if(!p||!p.length)return new g(i,[]);if(!i||!i.length)return new g([],p);const l=this.a(p),r=this.a(i),c=i.filter(I=>!l.has(I.description.identifier)),o=p.filter(I=>!r.has(I.description.identifier));return new g(c,o)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=g;class d{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=g.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,P.onUnexpectedError)(p)}}}e.ExtensionPoint=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class m{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new d(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,i),p.activationEventsGenerator&&D.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,f.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=m;const y={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(y.ExtensionsRegistry,new m),e.ExtensionsRegistry=A.Registry.as(y.ExtensionsRegistry),f.registerSchema(a,e.schema),f.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}}]}}}})}),define(Ae[206],Re([1,0,156,9,23,205,31,5]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var h;(function(f){function b(g,d,t){if(!g)return;const a=P.isString(g.type)?g.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const m=[];if(Array.isArray(g.required))for(const y of g.required)P.isString(y)&&m.push(y);return{extensionId:d.value,taskType:a,required:m,properties:g.properties?C.deepClone(g.properties):{},when:g.when?R.ContextKeyExpr.deserialize(g.when):void 0}}f.from=b})(h||(h={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,b)=>{for(const g of f)g.type&&b.push(`onTaskType:${g.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:w}});class D{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,g)=>{O.setHandler((d,t)=>{this.c=void 0;try{for(const a of t.removed){const m=a.value;for(const y of m)this.a&&y.type&&this.a[y.type]&&delete this.a[y.type]}for(const a of t.added){const m=a.value;for(const y of m){const T=h.from(y,a.description.identifier,a.collector);T&&(this.a[T.taskType]=T)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const g of this.all()){const d={type:"object",additionalProperties:!1};g.required.length>0&&(d.required=g.required.slice(0)),g.properties!==void 0?d.properties=C.deepClone(g.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[g.taskType]},b.push(d)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ae[207],Re([1,0,157,9,22,23,31,206]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var w;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function $(B){if(!B)return U.Strong;switch(B.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=$}(w=e.ShellQuoting||(e.ShellQuoting={}));var h;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(h=e.CommandOptions||(e.CommandOptions={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(U){function $(B){switch(B.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var D;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function $(B){switch(B.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=$}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var f;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(f=e.PanelKind||(e.PanelKind={})),function(U){function $(B){switch(B.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=$}(f=e.PanelKind||(e.PanelKind={}));var b;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:D.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(U){function $(q){switch(q.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=$;function B(q){switch(q){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=B}(g=e.RuntimeType||(e.RuntimeType={}));var d;(function(U){function $(B){return P.isString(B)?B:B.value}U.value=$})(d=e.CommandString||(e.CommandString={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function $(q){return q===U.Clean._id||q===U.Build._id||q===U.Rebuild._id||q===U.Test._id}U.is=$;function B(q){if(q!==void 0)return P.isString(q)?$(q)?{_id:q,isDefault:!1}:void 0:q}U.from=B})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var m;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function $(B){switch(B){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=$})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var y;(function(U){U.parallel="parallel",U.sequence="sequence"})(y=e.DependsOrder||(e.DependsOrder={}));var T;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(T=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:T.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor($,B,q,he,Ee,ie){this._label="",this._id=$,B&&(this._label=B),q&&(this.type=q),this.runOptions=he,this.configurationProperties=Ee,this._source=ie}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,B=!1){if($===void 0)return!1;if(P.isString($))return $===this._label||$===this.configurationProperties.identifier||B&&$===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class l extends i{constructor($,B,q,he,Ee,ie,ce,de){super($,q,void 0,ce,de,B),this.command={},this._source=B,this.hasDefinedMatchers=ie,Ee&&(this.command=Ee)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case g.Shell:B="shell";break;case g.Process:B="process";break;case g.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is($){return $ instanceof l}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let B=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(B+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:B};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new l($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=l;class r extends i{constructor($,B,q,he,Ee,ie,ce){super($,q,he,ie,ce,B),this._source=B,this.configures=Ee}static is($){return $ instanceof r}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let B=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(B+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:B};return JSON.stringify(q)}}e.ConfiguringTask=r;class c extends i{constructor($,B,q,he,Ee,ie,ce,de,Te){super($,q,he,de,Te,B),this.defines=Ee,this.hasDefinedMatchers=ce,this.command=ie,this.icon=Te.icon,this.hide=Te.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof c}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new c($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=c;class o extends i{constructor($,B,q,he,Ee,ie){super($,q,he,Ee,ie,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new o($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=o;var I;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(I=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(I=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor($){this.c=new Map;for(let B=0;B<$.length;B++)this.c.set($[B].uri.toString(),B)}compare($,B){const q=$.getWorkspaceFolder(),he=B.getWorkspaceFolder();if(q&&he){let Ee=this.c.get(q.uri.toString());Ee=Ee===void 0?0:Ee+1;let ie=this.c.get(he.uri.toString());return ie=ie===void 0?0:ie+1,Ee===ie?$._label.localeCompare(B._label):Ee-ie}else return!q&&he?-1:q&&!he?1:0}}e.TaskSorter=u;var v;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(U){U.SingleRun="singleRun",U.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var E;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(E=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(U){function $(B,q,he,Ee){if(q){const ie={kind:B,taskId:q._id,taskName:q.configurationProperties.name,runType:q.configurationProperties.isBackground?"background":"singleRun",group:q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:he,__task:q};return B==="start"?ie.resolvedVariables=Ee:B==="processStarted"?ie.processId=Ee:B==="processEnded"&&(ie.exitCode=Ee),Object.freeze(ie)}else return Object.freeze({kind:"changed"})}U.create=$})(W=e.TaskEvent||(e.TaskEvent={}));var X;(function(U){function $(q){const he=Object.keys(q).sort();let Ee="";for(const ie of he){let ce=q[ie];ce instanceof Object?ce=$(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),Ee+=ie+","+ce+","}return Ee}function B(q){const Ee={_key:$(q),type:q.taskType};return Object.assign(Ee,q),Ee}U.create=B})(X=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Y;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(Y=e.TaskSettingId||(e.TaskSettingId={}));var J;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(J=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var j;(function(U){function $(B,q){const he=A.TaskDefinitionRegistry.get(B.type);if(he===void 0){const de=M.deepClone(B);return delete de._key,X.create(de)}const Ee=Object.create(null);Ee.type=he.taskType;const ie=new Set;he.required.forEach(de=>ie.add(de));const ce=he.properties;for(const de of Object.keys(ce)){const Te=B[de];if(Te!=null)Ee[de]=Te;else if(ie.has(de)){const le=ce[de];if(le.default!==void 0)Ee[de]=M.deepClone(le.default);else switch(le.type){case"boolean":Ee[de]=!1;break;case"number":case"integer":Ee[de]=0;break;case"string":Ee[de]="";break;default:q.error(n.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return X.create(Ee)}U.createTaskIdentifier=$})(j=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ae[208],Re([1,0,10]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,A)=>{this.b=R,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,n.onUnexpectedError)(R))}then(R,A){return this.j().then(R,A)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.LazyPromise=P;class C extends P{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=C}),define(Ae[46],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const P=[];function C(A){const w=new n(A);return P[w.nid]=w,w}e.createProxyIdentifier=C;function M(A){return P[A].sid}e.getStringIdentifierForProxy=M;class R{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=R}),define(Ae[4],Re([1,0,46]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var M;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var h;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(h=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(t){return t._id=D.a++,t}}D.a=0,e.IdObject=D;var f;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ae[77],Re([1,0,3,14,4,18]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(w,h){this.c=h,this.a=new Set,this.b=w.getProxy(C.MainContext.MainThreadTelemetry)}report(w,h,O){const D=this.d(w,h);this.a.has(D)||(this.a.add(D),h.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:h.identifier.value,apiId:w}))}d(w,h){return`${w}-${h.identifier.value}`}};R=je([Ve(0,M.IExtHostRpcService),Ve(1,P.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(A,w,h){}})}),define(Ae[209],Re([1,0,5,4,7,24]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=w.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,h,O,D={}){const f=M.ExtensionIdentifier.toKey(w.identifier),b=this.f.get(f)||[],g=[...O].sort().join(" ");let d=b.find(t=>t.providerId===h&&t.scopes===g);if(d)return d.result;{const t=this.g(w,f,h,O,D);d={providerId:h,scopes:g,result:t},b.push(d),this.f.set(f,b);try{await t}finally{const a=b.findIndex(m=>m.providerId===h&&m.scopes===g);a>-1&&(b.splice(a),this.f.set(f,b))}return t}}async g(w,h,O,D,f={}){await this.a.$ensureProvider(O);const b=w.displayName||w.name;return this.a.$getSession(O,D,h,b,f)}async removeSession(w,h){const O=this.b.get(w);return O?O.provider.removeSession(h):this.a.$removeSession(w,h)}registerAuthenticationProvider(w,h,O,D){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:h,provider:O,options:D??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:h});const f=O.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,h,D?.supportsMultipleAccounts??!1),new C.Disposable(()=>{f.dispose(),this.b.delete(w);const b=this.c.findIndex(g=>g.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.createSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.removeSession(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,h){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.getSessions(h));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,h){return this.d.fire({provider:{id:w,label:h}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(Ae[210],Re([1,0,4,18,8]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,w){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:h=>w.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,w,h){const O=C.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,h?.isRefactoring??!1)}};M=je([Ve(0,P.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ae[211],Re([1,0,4]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(M){const R=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(A){return R.$writeText(A)}})}}e.ExtHostClipboard=P});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[38],Re([1,0,9,7,8,23,4,16,14,66,44,265,2,6,3,18,103,25,46,40,78,52,57]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i){"use strict";var l,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(E,W,X){l.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),Je(this,l,E.getProxy(R.MainContext.MainThreadCommands),"f"),this.d=W,Je(this,c,X,"f"),Je(this,r,E.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,Y=>{const J=this.c.get(Y);return J?.result===u.Void?J:void 0},W),this.f=[{processArgument(Y){return(0,h.revive)(Y)}},{processArgument(Y){return(0,M.cloneAndChange)(Y,function(J){if(O.Range.isIRange(J))return C.Range.to(J);if(D.Position.isIPosition(J))return C.Position.to(J);if(O.Range.isIRange(J.range)&&f.URI.isUri(J.uri))return C.location.to(J);if(J instanceof a.VSBuffer)return J.buffer.buffer;if(!Array.isArray(J))return J})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const W=this.registerCommand(!1,E.id,async(...X)=>{const Y=E.args.map((j,U)=>{if(!j.validate(X[U]))throw new Error(`Invalid argument '${j.name}' when running '${E.id}', received: ${X[U]}`);return j.convert(X[U])}),J=await this.executeCommand(E.internalId,...Y);return E.result.convert(J,X,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new P.Disposable(()=>{W.dispose(),this.c.delete(E.id)})}registerCommand(E,W,X,Y,J,j){if(this.d.trace("ExtHostCommands#registerCommand",W),!W.trim().length)throw new Error("invalid id");if(this.b.has(W))throw new Error(`command '${W}' already exists`);return this.b.set(W,{callback:X,thisArg:Y,description:J,extension:j}),E&&Ne(this,l,"f").$registerCommand(W),new P.Disposable(()=>{this.b.delete(W)&&E&&Ne(this,l,"f").$unregisterCommand(W)})}executeCommand(E,...W){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,W,!0)}async g(E,W,X){if(this.b.has(E))return Ne(this,l,"f").$fireCommandActivationEvent(E),this.h(E,W,!1);{let Y=!1;const J=(0,M.cloneAndChange)(W,function(j){if(j instanceof P.Position)return C.Position.from(j);if(j instanceof P.Range)return C.Range.from(j);if(j instanceof P.Location)return C.location.from(j);if(P.NotebookRange.isNotebookRange(j))return C.NotebookRange.from(j);if(j instanceof ArrayBuffer)return Y=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return Y=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return Y=!0,j;if(!Array.isArray(j))return j});try{const j=await Ne(this,l,"f").$executeCommand(E,Y?new m.SerializableObjectWithBuffers(J):J,X);return(0,h.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(E,W,!1);throw j}}}async h(E,W,X){const Y=this.b.get(E);if(!Y)throw new Error("Unknown command");const{callback:J,thisArg:j,description:U}=Y;if(U)for(let B=0;B<U.args.length;B++)try{(0,n.validateConstraint)(W[B],U.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${U.args[B].name}' - ${U.args[B].description}`)}const $=T.StopWatch.create();try{return await J.apply(j,W)}catch(B){if(E===this.converter.delegatingCommandId){const q=this.converter.getActualCommand(...W);q&&(E=q.command)}if(this.d.error(B,E,Y.extension?.identifier),!X)throw B;if(Y.extension?.identifier){const q=Ne(this,c,"f").onExtensionError(Y.extension.identifier,B);this.d.trace("forwarded error to extension?",q,Y.extension?.identifier)}throw new class extends Error{constructor(){super((0,y.toErrorMessage)(B)),this.id=E,this.source=Y.extension?.displayName??Y.extension?.name}}}finally{this.j(Y,E,$.elapsed())}}j(E,W,X){!E.extension||Ne(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new p.TelemetryTrustedValue(W),duration:X})}$executeContributedCommand(E,...W){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const X=this.b.get(E);return X?(W=W.map(Y=>this.f.reduce((J,j)=>j.processArgument(J,X.extension?.identifier),Y)),this.h(E,W,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),Ne(this,l,"f").$getCommands().then(W=>(E&&(W=W.filter(X=>X[0]!=="_")),W))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[W,X]of this.b){const{description:Y}=X;Y&&(E[W]=Y)}return Promise.resolve(E)}};l=new WeakMap,r=new WeakMap,c=new WeakMap,o=je([Ve(0,d.IExtHostRpcService),Ve(1,w.ILogService),Ve(2,i.IExtHostTelemetry)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class I{constructor(E,W,X){this.d=E,this.f=W,this.g=X,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,W){if(!E)return;const X={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return X;const Y=this.f(E.command);if(Y)X.id=Y.internalId,X.arguments=Y.args.map((J,j)=>J.convert(E.arguments&&E.arguments[j]));else if((0,A.isNonEmptyArray)(E.arguments)){const J=`${E.command}/${++this.c}`;this.b.set(J,E),W.add((0,b.toDisposable)(()=>{this.b.delete(J),this.g.trace("CommandsConverter#DISPOSE",J)})),X.$ident=J,X.id=this.delegatingCommandId,X.arguments=[J],this.g.trace("CommandsConverter#CREATE",E.command,J)}return X}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const W=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],W?W.command:"MISSING"),W?this.d.executeCommand(W.command,...W.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.CommandsConverter=I;class s{constructor(E,W,X,Y){this.name=E,this.description=W,this.validate=X,this.convert=Y}optional(){return new s(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,W){return new s(E??this.name,W??this.description,this.validate,this.convert)}}s.Uri=new s("uri","Uri of a text document",S=>f.URI.isUri(S),S=>S),s.Position=new s("position","A position in a text document",S=>P.Position.isPosition(S),C.Position.from),s.Range=new s("range","A range in a text document",S=>P.Range.isRange(S),C.Range.from),s.Selection=new s("selection","A selection in a text document",S=>P.Selection.isSelection(S),C.Selection.from),s.Number=new s("number","",S=>typeof S=="number",S=>S),s.String=new s("string","",S=>typeof S=="string",S=>S),s.CallHierarchyItem=new s("item","A call hierarchy item",S=>S instanceof P.CallHierarchyItem,C.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",S=>S instanceof P.TypeHierarchyItem,C.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",S=>S instanceof t.TestItemImpl,C.TestItem.from),e.ApiCommandArgument=s;class u{constructor(E,W){this.description=E,this.convert=W}}u.Void=new u("no result",S=>S),e.ApiCommandResult=u;class v{constructor(E,W,X,Y,J){this.id=E,this.internalId=W,this.description=X,this.args=Y,this.result=J}}e.ApiCommand=v}),define(Ae[212],Re([1,0,16,15,2,76,89,31,93,38,8,7]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const f=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(O.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,a)=>{if((0,n.isFalsyOrEmpty)(t))return;class m extends D.SymbolInformation{static to(T){const p=new m(T.name,O.SymbolKind.to(T.kind),T.containerName||"",new D.Location(a[0],O.Range.to(T.range)));return p.detail=T.detail,p.range=p.location.range,p.selectionRange=O.Range.to(T.selectionRange),p.children=T.children?T.children.map(m.to):[],p}}return t.map(m.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(O.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(O.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(O.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(a=>D.Position.isPosition(a)),t=>t.map(O.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(a=>{let m;for(const y of a.reverse())m=new D.SelectionRange(O.Range.to(y),m);return m}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(O.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(O.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(O.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(O.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:O.Range.to(t.range),placeholder:t.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return O.WorkspaceEdit.to(t)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(O.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new D.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const a=(0,R.decodeSemanticTokensDto)(t);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,a,m)=>{if(!t)return new D.CompletionList([]);const y=t.suggestions.map(T=>O.CompletionItem.to(T,m));return new D.CompletionList(y,t.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return O.SignatureHelp.to(t)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,a,m)=>g(y=>new D.CodeLens(O.Range.to(y.range),y.command&&m.fromInternal(y.command)))(t))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.Range.isRange(t),t=>D.Selection.isSelection(t)?O.Selection.from(t):O.Range.from(t)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,a,m)=>g(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(y.command)}else{const T=new D.CodeAction(y.title,y.kind?new D.CodeActionKind(y.kind):void 0);return y.edit&&(T.edit=O.WorkspaceEdit.to(y.edit)),y.command&&(T.command=m.fromInternal(y.command)),T.isPreferred=y.isPreferred,T}})(t))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(a=>new D.ColorInformation(O.Range.to(a.range),O.Color.to(a.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",t=>t instanceof D.Color,O.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:O.Range.from(t.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(O.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,a,m)=>t.map(O.InlayHint.to.bind(void 0,m)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,a)=>{if(t)return t.map(O.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(a=>O.NotebookExclusiveDocumentPattern.to(a))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(O.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,w.matchesSomeScheme)(t,P.Schemas.http,P.Schemas.https),t=>t),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],h.ApiCommandResult.Void)];class b{static register(a){f.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=b;function g(t){return a=>{if(Array.isArray(a))return a.map(t)}}function d(t){if(!Array.isArray(t))return;const a=[];for(const m of t)M.isLocationLink(m)?a.push(O.DefinitionLink.to(m)):a.push(O.location.to(m));return a}}),define(Ae[213],Re([1,0,17,64,5,6,2,76,24,8,7,4]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(b,g,d){const t=b.getProxy(D.MainContext.MainThreadComments);class a{constructor(){this.b=new Map,this.c=new w.ExtensionIdentifierMap,g.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const I=this.b.get(o.handle);return I?I.value:o}else if(o&&o.$mid===7){const I=this.b.get(o.commentControlHandle);if(!I)return o;const s=I.getCommentThread(o.commentThreadHandle);return s?s.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const s=I.getCommentThread(o.thread.commentThreadHandle);return s?o.$mid===8?s.value:{thread:s.value,text:o.text}:o}else if(o&&o.$mid===10){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const s=I.getCommentThread(o.thread.commentThreadHandle);if(!s)return o;const u=o.commentUniqueId,v=s.getCommentByUniqueId(u);return v||o}else if(o&&o.$mid===11){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const s=I.getCommentThread(o.thread.commentThreadHandle);if(!s)return o;const u=o.text,v=o.commentUniqueId,S=s.getCommentByUniqueId(v);return S?(typeof S.body=="string"?S.body=u:S.body=new O.MarkdownString(u),S):o}return o}})}createCommentController(o,I,s){const u=a.a++,v=new y(o,u,I,s);this.b.set(v.handle,v);const S=this.c.get(o.identifier)||[];return S.push(v),this.c.set(o.identifier,S),v.value}$createCommentThreadTemplate(o,I,s){const u=this.b.get(o);!u||u.$createCommentThreadTemplate(I,s)}async $updateCommentThreadTemplate(o,I,s){const u=this.b.get(o);!u||u.$updateCommentThreadTemplate(I,s)}$deleteCommentThread(o,I){this.b.get(o)?.$deleteCommentThread(I)}$provideCommentingRanges(o,I,s){const u=this.b.get(o);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const v=d.getDocument(R.URI.revive(I));return(0,n.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(v,s)).then(S=>S?S.map(E=>h.Range.from(E)):void 0)}$toggleReaction(o,I,s,u,v){const S=this.b.get(o);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const E=S.getCommentThread(I);if(E){const W=E.getCommentByUniqueId(u.uniqueIdInThread);if(S!==void 0&&W&&S.reactionHandler)return S.reactionHandler(W,i(v))}return Promise.resolve(void 0)})}dispose(){}}a.a=0;class m{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){o.isEqual(this.p)||(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return this.h}set state(o){this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,I,s,u,v,S,E,W){this.m=I,this.n=s,this.o=u,this.p=v,this.q=S,this.extensionDescription=E,this.r=W,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${o}.${this.handle}`),t.$createCommentThread(I,this.handle,this.n,this.o,h.Range.from(this.p),E.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{t.$deleteCommentThread(I,this.handle)}});const X=this;this.value={get uri(){return X.uri},get range(){return X.range},set range(Y){X.range=Y},get comments(){return X.comments},set comments(Y){X.comments=Y},get collapsibleState(){return X.collapsibleState},set collapsibleState(Y){X.collapsibleState=Y},get canReply(){return X.canReply},set canReply(Y){X.canReply=Y},get contextValue(){return X.contextValue},set contextValue(Y){X.contextValue=Y},get label(){return X.label},set label(Y){X.label=Y},get state(){return X.state},set state(Y){X.state=Y},dispose:()=>{X.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const o=s=>Object.prototype.hasOwnProperty.call(this.b,s),I={};o("range")&&(I.range=h.Range.from(this.p)),o("label")&&(I.label=this.label),o("contextValue")&&(I.contextValue=this.contextValue??null),o("comments")&&(I.comments=this.q.map(s=>T(this,s,this.k))),o("collapsibleState")&&(I.collapseState=l(this.g)),o("canReply")&&(I.canReply=this.canReply),o("state")&&(I.state=r(this.h)),o("isTemplate")&&(I.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(o){for(const I of this.k){const s=I[0],u=I[1];if(o===u)return s}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}m.a=0,je([(0,P.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class y{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,I,s,u){this.f=o,this.g=I,this.h=s,this.i=u,this.a=new Map,t.$registerCommentController(this.handle,s,u);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(S){v.options=S},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(S){v.commentingRangeProvider=S},get reactionHandler(){return v.reactionHandler},set reactionHandler(S){v.reactionHandler=S},createCommentThread(S,E,W){return v.createCommentThread(S,E,W).value},dispose:()=>{v.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(o,I,s,u){if(typeof o=="string"){const v=new m(this.id,this.handle,o,I,s,u,this.f,!1);return this.a.set(v.handle,v),v}else{const v=new m(this.id,this.handle,void 0,o,I,s,this.f,!1);return this.a.set(v.handle,v),v}}$createCommentThreadTemplate(o,I){const s=new m(this.id,this.handle,void 0,R.URI.revive(o),h.Range.to(I),[],this.f,!0);return s.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(s.handle,s),s}$updateCommentThreadTemplate(o,I){const s=this.a.get(o);s&&(s.range=h.Range.to(I))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function T(c,o,I){let s=I.get(o);s||(s=++c.commentHandle,I.set(o,s));const u=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:s,body:typeof o.body=="string"?o.body:h.MarkdownString.from(o.body),userName:o.author.name,userIconPath:u,label:o.label,commentReactions:o.reactions?o.reactions.map(v=>p(v)):void 0,timestamp:o.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?h.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function i(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function l(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new a}e.createExtHostComments=f}),define(Ae[214],Re([1,0,23,4,27,18]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(O,D){this.a=O.getProxy(P.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,D){const f=this,b=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){f.e(O,D,b,arguments)}})}e(O,D,f,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:w(b,this.b)}),this.c&&this.f(O,f,b)}};R=je([Ve(0,M.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],R),e.AbstractExtHostConsoleForwarder=R;const A=1e5;function w(h,O){const D=[];if(h.length)for(let f=0;f<h.length;f++){let b=h[f];if(typeof b>"u")b="undefined";else if(b instanceof Error){const g=b;g.stack?b=g.stack:b=g.toString()}D.push(b)}if(O){const f=new Error().stack;f&&D.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,n.safeStringify)(D);return f.length>A?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ae[105],Re([1,0,2,4,7,3,18,14,16,13,19,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let f=class $i{constructor(g,d){this.h=d,this.f=new Map,this.g=g.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,d){const t=$i.c++;this.f.set(t,{provider:g,extensionDescription:d}),this.g.$registerDecorationProvider(t,d.identifier.value);const a=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(t,null);return}const y=(0,w.asArray)(m);if(y.length<=$i.d){this.g.$onDidChange(t,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,y.length);const T=y.map(l=>({uri:l,rank:(0,h.count)(l.path,"/")})),p=(0,w.groupBy)(T,(l,r)=>l.rank-r.rank||(0,h.compare)(l.uri.path,r.uri.path)),i=[];e:for(const l of p){let r;for(const c of l){const o=(0,O.dirname)(c.uri.path);if(r!==o&&(r=o,i.push(c.uri)>=$i.d))break e}}this.g.$onDidChange(t,i)});return new C.Disposable(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(g,d,t){if(!this.f.has(g))return Object.create(null);const a=Object.create(null),{provider:m,extensionDescription:y}=this.f.get(g);return await Promise.all(d.map(async T=>{try{const{uri:p,id:i}=T,l=await Promise.resolve(m.provideFileDecoration(n.URI.revive(p),t));if(!l)return;try{C.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,D.checkProposedApiEnabled)(y,"codiconDecoration"),a[i]=[l.propagate,l.tooltip,l.badge,l.color]}catch(r){this.h.warn(`INVALID decoration from extension '${y}': ${r}`)}}catch(p){this.h.error(p)}})),a}};f.c=0,f.d=250,f=je([Ve(0,R.IExtHostRpcService),Ve(1,A.ILogService)],f),e.ExtHostDecorations=f,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[215],Re([1,0,143,92,2,4,7,8,5,14,28,37]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";var f,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(m,y,T,p,i,l,r){this.d=m,this.e=y,this.f=T,this.g=p,f.set(this,void 0),b.set(this,void 0),g.set(this,void 0),this.c=!1,Je(this,g,new O.ResourceMap(c=>i.getComparisonKey(c)),"f"),Je(this,f,l,"f"),Je(this,b,r,"f")}dispose(){this.c||(Ne(this,b,"f").fire([...Ne(this,g,"f").keys()]),Ne(this,f,"f")?.$clear(this.e),Ne(this,g,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(m,y){if(!m){this.clear();return}this.h();let T=[];if(C.URI.isUri(m)){if(!y){this.delete(m);return}Ne(this,g,"f").set(m,y.slice()),T=[m]}else if(Array.isArray(m)){T=[];let i;m=[...m].sort(d.j);for(const l of m){const[r,c]=l;if((!i||r.toString()!==i.toString())&&(i&&Ne(this,g,"f").get(i).length===0&&Ne(this,g,"f").delete(i),i=r,T.push(r),Ne(this,g,"f").set(r,[])),c)Ne(this,g,"f").get(r)?.push(...c);else{const o=Ne(this,g,"f").get(r);o&&(o.length=0)}}}if(Ne(this,b,"f").fire(T),!Ne(this,f,"f"))return;const p=[];for(const i of T){let l=[];const r=Ne(this,g,"f").get(i);if(r)if(r.length>this.f){l=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const I of r)if(I.severity===c[o]&&l.push({...A.Diagnostic.from(I),modelVersionId:this.g(i)})===this.f)break e;l.push({severity:P.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=r.map(c=>({...A.Diagnostic.from(c),modelVersionId:this.g(i)}));p.push([i,l])}Ne(this,f,"f").$changeMany(this.e,p)}delete(m){this.h(),Ne(this,b,"f").fire([m]),Ne(this,g,"f").delete(m),Ne(this,f,"f")?.$changeMany(this.e,[[m,void 0]])}clear(){this.h(),Ne(this,b,"f").fire([...Ne(this,g,"f").keys()]),Ne(this,g,"f").clear(),Ne(this,f,"f")?.$clear(this.e)}forEach(m,y){this.h();for(const[T,p]of this)m.call(y,T,p,this)}*[(f=new WeakMap,b=new WeakMap,g=new WeakMap,Symbol.iterator)](){this.h();for(const m of Ne(this,g,"f").keys())yield[m,this.get(m)]}get(m){this.h();const y=Ne(this,g,"f").get(m);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(m){return this.h(),Array.isArray(Ne(this,g,"f").get(m))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(m,y){return m[0].toString()<y[0].toString()?-1:m[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=d;let t=class Si{static _mapper(m){const y=new O.ResourceMap;for(const T of m)y.set(T,T);return{uris:Object.freeze(Array.from(y.values()))}}constructor(m,y,T,p){this.h=y,this.j=T,this.k=p,this.f=new Map,this.g=new w.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.g.event,Si._mapper),this.e=m.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,y){const{f:T,e:p,g:i,h:l,j:r,k:c}=this,o=new class{$changeMany(u,v){p.$changeMany(u,v),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,u,v.length===0?"CLEARING":v)}$clear(u){p.$clear(u),l.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,u)}dispose(){p.dispose()}};let I;if(!y)y="_generated_diagnostic_collection_name_#"+Si.c++,I=y;else if(!T.has(y))I=y;else{this.h.warn(`DiagnosticCollection with name '${y}' does already exist.`);do I=y+Si.c++;while(T.has(I))}return new class extends d{constructor(){super(y,I,Si.d,u=>c.getDocument(u)?.version,r.extUri,o,i),T.set(I,this)}dispose(){super.dispose(),T.delete(I)}}}getDiagnostics(m){if(m)return this.l(m);{const y=new Map,T=[];for(const p of this.f.values())p.forEach((i,l)=>{let r=y.get(i.toString());typeof r>"u"&&(r=T.length,y.set(i.toString(),r),T.push([i,[]])),T[r][1]=T[r][1].concat(...l)});return T}}l(m){let y=[];for(const T of this.f.values())T.has(m)&&(y=y.concat(T.get(m)));return y}$acceptMarkersChange(m){if(!this.m){const y="_generated_mirror",T=new d(y,y,Si.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(y,T),this.m=T}for(const[y,T]of m)this.m.set(C.URI.revive(y),T.map(A.Diagnostic.to))}};t.c=0,t.d=1e3,t=je([Ve(1,h.ILogService),Ve(2,D.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Ae[216],Re([1,0,2,4,26]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(A){this.a=A.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(A,w){return w?.allowUIResources&&(0,C.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(w).then(h=>h?h.map(O=>n.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(w=>w?n.URI.revive(w):void 0)}}e.ExtHostDialogs=M}),define(Ae[217],Re([1,0,10,2,7,4,15,21,13]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class h{constructor(D,f,b){this.d=f,this.e=b,this.b=new Map,this.c=D.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,f){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=h.a++;this.b.set(b,f),this.c.$registerTextContentProvider(b,D);let g;return typeof f.onDidChange=="function"&&(g=f.onDidChange(d=>{if(d.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(b,d).then(t=>{if(!t&&typeof t!="string")return;const a=this.d.getDocument(d);if(!a)return;const m=(0,w.splitLines)(t);if(!a.equalLines(m))return this.c.$onVirtualDocumentChange(d,t)},n.onUnexpectedError)})),new C.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,f){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(P.URI.revive(f),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}h.a=0,e.ExtHostDocumentContentProvider=h}),define(Ae[218],Re([1,0,5,6,2,4,101,8,9,23,7]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(d=>{for(const t of d)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const t of d)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const g=this.g.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this.g.getDocument(b);if(g)return Promise.resolve(g);let d=this.h.get(b.toString());return d||(d=this.f.$tryOpenDocument(b).then(t=>{this.h.delete(b.toString());const a=C.URI.revive(t);return(0,w.assertIsDefined)(this.g.getDocument(a))},t=>(this.h.delete(b.toString()),Promise.reject(t))),this.h.set(b.toString(),d)),d}createDocumentData(b){return this.f.$tryCreateDocument(b).then(g=>C.URI.revive(g))}$acceptModelLanguageChanged(b,g){const d=C.URI.revive(b),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(g),this.a.fire(t.document)}$acceptModelSaved(b){const g=C.URI.revive(b),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(b,g){const d=C.URI.revive(b),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");t._acceptIsDirty(g),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,d){const t=C.URI.revive(b),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(g);let m;g.isUndoing?m=O.TextDocumentChangeReason.Undo:g.isRedoing&&(m=O.TextDocumentChangeReason.Redo),this.c.fire((0,h.deepFreeze)({document:a.document,contentChanges:g.changes.map(y=>({range:A.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:m}))}setWordDefinitionFor(b,g){(0,R.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=D}),define(Ae[58],Re([1,0,49,5,6,2,3,4,101,18,104,8,14,28,15,190,86]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(T){this.value=T,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(T,p){this.h=T,this.i=p,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new P.Emitter,this.e=new P.Emitter,this.f=new P.Emitter,this.g=new P.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(T){this.acceptDocumentsAndEditorsDelta(T)}acceptDocumentsAndEditorsDelta(T){const p=[],i=[],l=[];if(T.removedDocuments)for(const r of T.removedDocuments){const c=M.URI.revive(r),o=this.c.get(c);o?.unref()&&(this.c.delete(c),p.push(o.value))}if(T.addedDocuments)for(const r of T.addedDocuments){const c=M.URI.revive(r.uri);let o=this.c.get(c);if(o&&c.scheme!==g.Schemas.vscodeNotebookCell&&c.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);o||(o=new a(new w.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(c,o),i.push(o.value)),o.ref()}if(T.removedEditors)for(const r of T.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&l.push(c)}if(T.addedEditors)for(const r of T.addedEditors){const c=M.URI.revive(r.documentUri);n.ok(this.c.has(c),`document '${c}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const o=this.c.get(c).value,I=new O.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>o.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(s=>D.Range.to(s)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,I)}T.newActiveEditor!==void 0&&(n.ok(T.newActiveEditor===null||this.b.has(T.newActiveEditor),`active editor '${T.newActiveEditor}' does not exist`),this.a=T.newActiveEditor),(0,C.dispose)(p),(0,C.dispose)(l),T.removedDocuments&&this.e.fire(p),T.addedDocuments&&this.d.fire(i),(T.removedEditors||T.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),T.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(T){return this.c.get(T)?.value}allDocuments(){return d.Iterable.map(this.c.values(),T=>T.value)}getEditor(T){return this.b.get(T)}activeEditor(T){if(!this.a)return;const p=this.b.get(this.a);return T?p:p?.value}allEditors(){return[...this.b.values()]}};m=je([Ve(0,h.IExtHostRpcService),Ve(1,f.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ae[59],Re([1,0,8,4,2,5,3,7,18,9,63]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class D{constructor(t,a,m){this.e=m,this.d=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(C.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class f{constructor(t,a){this.c=[],this.d="",this.b=t,this.e=a;for(const m of t.tabs)m.isActive&&(this.d=m.id),this.c.push(new D(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(m=>m.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(m=>m.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const m=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,m),t.tabDto.isActive&&(this.d=m.tabId),m}else if(t.kind===1){const m=this.c.splice(t.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(t.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,m),m}const a=this.c.find(m=>m.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=t.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,a={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(m=>m.apiObject))},get activeTabGroup(){const m=t.d;return(0,h.assertIsDefined)(t.e.find(T=>T.groupId===m)?.apiObject)},close:async(m,y)=>{const T=Array.isArray(m)?m:[m];return T.length?g(T[0])?this.j(T,y):this.i(T,y):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(t){const a=new Set(this.e.map(r=>r.groupId)),m=new Set(t.map(r=>r.groupId)),y=(0,O.diffSets)(a,m),T=this.e.filter(r=>y.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],i=[];this.e=t.map(r=>{const c=new f(r,()=>this.d);return y.added.includes(c.groupId)?p.push(c.apiObject):i.push(c.apiObject),c});const l=(0,h.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:p,closed:T,changed:i}))}$acceptTabGroupUpdate(t){const a=this.e.find(m=>m.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this.e.find(y=>y.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const m=a.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(t){for(const a of this.e)for(const m of a.tabs)if(m.apiObject===t)return m}h(t){return this.e.find(a=>a.apiObject===t)}async i(t,a){const m=[];for(const y of t){const T=this.g(y);if(!T)throw new Error("Tab close: Invalid tab not found!");m.push(T.tabId)}return this.a.$closeTab(m,a)}async j(t,a){const m=[];for(const y of t){const T=this.h(y);if(!T)throw new Error("Group close: Invalid group not found!");m.push(T.groupId)}return this.a.$closeGroup(m,a)}};b=je([Ve(0,w.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function g(d){return d.tabs!==void 0}}),define(Ae[219],Re([1,0,2,4,6,7,8,266,13,25,26]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const d=this.a.indexOf(g);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),d=[];let t,a,m=14,y=14;for(const T of g){let p=t?(0,w.commonPrefixLength)(t,T):0;for(p===0?a=1:a=y;p<T.length;p++)p+1===T.length?(m=y,y=9):y+=1,d.push([a,T.toUpperCase().charCodeAt(p),y]),d.push([a,T.toLowerCase().charCodeAt(p),y]),a=y;t=T,y=m}d.push([9,58,10]),d.push([10,47,12]),this.b=new A.StateMachine(d)}}provideDocumentLinks(g){this.c();const d=[],t=A.LinkComputer.computeLinks({getLineContent(a){return g.lineAt(a-1).text},getLineCount(){return g.lineCount}},this.b);for(const a of t){const m=R.DocumentLink.to(a);m.target&&d.push(m)}return d}}class f{constructor(g,d){this.i=d,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,d,t,a={}){if(f.j(t),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const m=this.h++;this.b.add(d),this.d.add(d),this.c.set(m,t);let y=2;a.isCaseSensitive&&(y+=1024),a.isReadonly&&(y+=2048),typeof t.copy=="function"&&(y+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,O.checkProposedApiEnabled)(g,"fsChunks"),y+=4),this.a.$registerFileSystemProvider(m,d,y).catch(p=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(p)});const T=t.onDidChangeFile(p=>{const i=[];for(const l of p){const{uri:r,type:c}=l;if(r.scheme!==d)continue;let o;switch(c){case M.FileChangeType.Changed:o=0;break;case M.FileChangeType.Created:o=1;break;case M.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:o})}this.a.$onFileSystemChange(m,i)});return(0,C.toDisposable)(()=>{T.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:d,ctime:t,mtime:a,size:m,permissions:y}=g;return{type:d,ctime:t,mtime:a,size:m,permissions:y}}$stat(g,d){return Promise.resolve(this.l(g).stat(n.URI.revive(d))).then(t=>f.k(t))}$readdir(g,d){return Promise.resolve(this.l(g).readDirectory(n.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this.l(g).readFile(n.URI.revive(d))).then(t=>h.VSBuffer.wrap(t))}$writeFile(g,d,t,a){return Promise.resolve(this.l(g).writeFile(n.URI.revive(d),t.buffer,a))}$delete(g,d,t){return Promise.resolve(this.l(g).delete(n.URI.revive(d),t))}$rename(g,d,t,a){return Promise.resolve(this.l(g).rename(n.URI.revive(d),n.URI.revive(t),a))}$copy(g,d,t,a){const m=this.l(g);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(n.URI.revive(d),n.URI.revive(t),a))}$mkdir(g,d){return Promise.resolve(this.l(g).createDirectory(n.URI.revive(d)))}$watch(g,d,t,a){const m=this.l(g).watch(n.URI.revive(t),a);this.f.set(d,m)}$unwatch(g,d){const t=this.f.get(d);t&&(t.dispose(),this.f.delete(d))}$open(g,d,t){const a=this.l(g);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(d),t))}$close(g,d){const t=this.l(g);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(d))}$read(g,d,t,a){const m=this.l(g);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const y=h.VSBuffer.alloc(a);return Promise.resolve(m.read(d,t,y.buffer,0,a)).then(T=>y.slice(0,T))}$write(g,d,t,a){const m=this.l(g);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(d,t,a.buffer,0,a.byteLength))}l(g){const d=this.c.get(g);if(!d){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return d}}e.ExtHostFileSystem=f}),define(Ae[60],Re([1,0,4,43,7,25,3,18,37,6]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Jt{constructor(f,b){this.b=new Map,this.a=f.getProxy(n.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{const t=g.b.get(d.scheme);if(!t)return await g.a.$stat(d);await g.a.$ensureActivation(d.scheme);const a=await t.stat(d);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){Jt.c(t)}},async readDirectory(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readDirectory(d)).slice()):await g.a.$readdir(d)}catch(t){return Jt.c(t)}},async createDirectory(d){try{return await g.a.$mkdir(d)}catch(t){return Jt.c(t)}},async readFile(d){try{const t=g.b.get(d.scheme);return t?(await g.a.$ensureActivation(d.scheme),(await t.readFile(d)).slice()):(await g.a.$readFile(d)).buffer}catch(t){return Jt.c(t)}},async writeFile(d,t){try{return await g.a.$writeFile(d,M.VSBuffer.wrap(t))}catch(a){return Jt.c(a)}},async delete(d,t){try{const a=g.b.get(d.scheme);return a?(await g.a.$ensureActivation(d.scheme),await a.delete(d,{recursive:!1,...t})):await g.a.$delete(d,{recursive:!1,useTrash:!1,...t})}catch(a){return Jt.c(a)}},async rename(d,t,a){try{return await g.a.$rename(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},async copy(d,t,a){try{return await g.a.$copy(d,t,{overwrite:!1,...a})}catch(m){return Jt.c(m)}},isWritableFileSystem(d){const t=b.getCapabilities(d);if(typeof t=="number")return!(t&2048)}})}static c(f){if(f instanceof C.FileSystemError)throw f;if(!(f instanceof Error))throw new C.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw C.FileSystemError.Unavailable(f.message);switch(f.name){case P.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(f.message);case P.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(f.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(f.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(f.message);case P.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(f.message);case P.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(f.message);default:throw new C.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,b){return this.b.set(f,b),(0,h.toDisposable)(()=>this.b.delete(f))}};O=je([Ve(0,A.IExtHostRpcService),Ve(1,w.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(Ae[220],Re([1,0,5,36,2,4,8,7]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,f,b,g,d,t,a,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const y=this.h(D,b,d);this.g=0,t&&(this.g+=1),a&&(this.g+=2),m&&(this.g+=4);const T=(0,P.parse)(d),p=typeof d=="string",i=g(l=>{if(!t)for(const r of l.created){const c=C.URI.revive(r);T(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.a.fire(c)}if(!a)for(const r of l.changed){const c=C.URI.revive(r);T(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.b.fire(c)}if(!m)for(const r of l.deleted){const c=C.URI.revive(r);T(c.fsPath)&&(!p||f.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=A.Disposable.from(y,this.a,this.b,this.c,i)}h(D,f,b){const g=A.Disposable.from();if(typeof b=="string")return g;const d=D.getProxy(M.MainContext.MainThreadFileSystem);let t=!1;(b.pattern.includes(P.GLOBSTAR)||b.pattern.includes(P.GLOB_SPLIT))&&(t=!0);const a=Math.random();return d.$watch(f.identifier.value,a,b.baseUri,{recursive:t,excludes:[]}),A.Disposable.from({dispose:()=>d.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class h{constructor(D,f,b){this.j=D,this.k=f,this.l=b,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,f,b,g,d,t){return new w(this.j,D,f,this.a.event,R.GlobPattern.from(b),g,d,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,f){switch(D){case 2:this.b.fire(Object.freeze({files:f.map(b=>({oldUri:C.URI.revive(b.source),newUri:C.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(b=>C.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(b=>C.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,f){return(b,g,d)=>{const t=function(m){b.call(g,m)};return t.extension=D,f.event(t,void 0,d)}}async $onWillRunFileOperation(D,f,b,g){switch(D){case 2:return await this.n(this.g,{files:f.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},b,g);case 1:return await this.n(this.i,{files:f.map(d=>C.URI.revive(d.target))},b,g);case 0:case 3:return await this.n(this.h,{files:f.map(d=>C.URI.revive(d.target))},b,g)}}async n(D,f,b,g){const d=new Set,t=[];if(await D.fireAsync(f,g,async(m,y)=>{const T=Date.now(),p=await Promise.resolve(m);p instanceof A.WorkspaceEdit&&(t.push([y.extension,p]),d.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-T>b&&this.k.warn("SLOW file-participant",y.extension.identifier)}),g.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,m]of t){const{edits:y}=R.WorkspaceEdit.from(m,{getTextDocumentVersion:T=>this.l.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(y)}return{edit:a,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=h}),define(Ae[221],Re([1,0,2,38]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(R,A,w,h,O){this.a=A,this.b=w,this.c=h;const D=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",f=>!0,f=>f),new P.ApiCommandArgument("resource","Interactive resource Uri",f=>!0,f=>f),new P.ApiCommandArgument("controllerId","Notebook controller Id",f=>!0,f=>f),new P.ApiCommandArgument("title","Interactive editor title",f=>!0,f=>f)],new P.ApiCommandResult("Notebook and input URI",f=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const b=this.a.getEditorById(f.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri),notebookEditor:b.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:n.URI.revive(f.notebookUri),inputUri:n.URI.revive(f.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,A,w,h){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:w,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(h))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=C}),define(Ae[222],Re([1,0,6,2,4,8]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class R{constructor(h,O){this.extension=h,this.provider=O,this.handle=R.a++}}R.a=0;class A{constructor(h,O,D){this.e=O,this.f=D,this.b=new Map,this.c=new Map,this.d=h.getProxy(C.MainContext.MainThreadInteractiveEditor)}registerProvider(h,O){const D=new R(h,O);return this.b.set(D.handle,D),this.d.$registerInteractiveEditorProvider(D.handle,h.identifier.value),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(D.handle),this.b.delete(D.handle)})}async $prepareInteractiveSession(h,O,D,f){const b=this.b.get(h);if(!b){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const g=this.e.getDocument(P.URI.revive(O)),d=await b.provider.prepareInteractiveEditorSession({document:g,selection:M.Selection.to(D)},f);if(!d)return;const t=A.a++;return this.c.set(t,d),{id:t,placeholder:d.placeholder}}async $provideResponse(h,O,D,f){const b=this.b.get(h);if(!b)return;const g=this.c.get(O.id);if(!g)return;const d=await b.provider.provideInteractiveEditorResponse({session:g,prompt:D.prompt,selection:M.Selection.to(D.selection),wholeRange:M.Range.to(D.wholeRange)},f);if(!!d)return{edits:d.edits.map(M.TextEdit.from),placeholder:d.placeholder}}$releaseSession(h,O){const D=this.c.get(O),f=this.b.get(h);D&&f&&f.provider.releaseInteractiveEditorSession?.(D),this.c.delete(O)}}A.a=0,e.ExtHostInteractiveEditor=A}),define(Ae[223],Re([1,0,6,9,4]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class M{constructor(w,h){this.extension=w,this.provider=h,this.handle=M.a++}}M.a=0;class R{constructor(w,h){this.b=new Map,this.c=new Map,this.d=w.getProxy(C.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(w,h,O){const D=new M(w,O);return this.b.set(D.handle,D),this.d.$registerInteractiveSessionProvider(D.handle,h),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveSessionProvider(D.handle),this.b.delete(D.handle)})}addInteractiveSessionRequest(w){this.d.$addInteractiveSessionRequest(w)}async $prepareInteractiveSession(w,h,O){const D=this.b.get(w);if(!D)return;const f=await D.provider.prepareSession(h,O);if(!f)return;const b=R.a++;return this.c.set(b,f),{id:b}}async $resolveInteractiveRequest(w,h,O,D){const f=this.b.get(w);if(!f)return;const b=this.c.get(h);if(!b||!f.provider.resolveRequest)return;const g=await f.provider.resolveRequest(b,O,D);if(g)return{message:g.message}}async $provideInitialSuggestions(w,h){const O=this.b.get(w);if(!!O&&!!O.provider.provideInitialSuggestions)return(0,P.withNullAsUndefined)(await O.provider.provideInitialSuggestions(h))}async $provideInteractiveReply(w,h,O,D){const f=this.b.get(w);if(!f)return;const b=this.c.get(h);if(!b)return;const g={session:b,message:O.message};if(f.provider.provideResponse){const d=await f.provider.provideResponse(g,D);if(b.saveState){const t=b.saveState();this.d.$acceptInteractiveSessionState(h,t)}return d?(this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:d.content}),{followups:d.followups}):void 0}else if(f.provider.provideResponseWithProgress){const d={report:a=>this.d.$acceptInteractiveResponseProgress(w,h,{responsePart:a.content})},t=await f.provider.provideResponseWithProgress(g,d,D);if(b.saveState){const a=b.saveState();this.d.$acceptInteractiveSessionState(h,a)}return t?{followups:t.followups}:void 0}throw new Error("provider must implement either provideResponse or provideResponseWithProgress")}$releaseSession(w){this.c.delete(w)}}R.a=0,e.ExtHostInteractiveSession=R}),define(Ae[224],Re([1,0,6,4]),function(ee,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,R),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=C}),define(Ae[225],Re([1,0,2,23,8,7,76,4,13,44,16,9,267,21,6,89,84,54,78,10,17,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(k,F){this.d=k,this.e=F}async provideDocumentSymbols(k,F){const H=this.d.getDocument(k),x=await this.e.provideDocumentSymbols(H,F);if(!(0,O.isFalsyOrEmpty)(x))return x[0]instanceof M.DocumentSymbol?x.map(C.DocumentSymbol.from):i.f(x)}static f(k){k=k.slice(0).sort((x,te)=>{let pe=x.location.range.start.compareTo(te.location.range.start);return pe===0&&(pe=te.location.range.end.compareTo(x.location.range.end)),pe});const F=[],H=[];for(const x of k){const te={name:x.name||"!!MISSING: name!!",kind:C.SymbolKind.from(x.kind),tags:x.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:C.Range.from(x.location.range),selectionRange:C.Range.from(x.location.range),children:[]};for(;;){if(H.length===0){H.push(te),F.push(te);break}const pe=H[H.length-1];if(h.Range.containsRange(pe.range,te.range)&&!h.Range.equalsRange(pe.range,te.range)){pe.children?.push(te),H.push(te);break}H.pop()}}return F}}class l{constructor(k,F,H){this.g=k,this.h=F,this.j=H,this.e=new a.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(k,F){const H=this.g.getDocument(k),x=await this.j.provideCodeLenses(H,F);if(!x||F.isCancellationRequested)return;const te=this.e.add(x),pe=new g.DisposableStore;this.f.set(te,pe);const ke={cacheId:te,lenses:[]};for(let ue=0;ue<x.length;ue++)ke.lenses.push({cacheId:[te,ue],range:C.Range.from(x[ue].range),command:this.h.toInternal(x[ue].command,pe)});return ke}async resolveCodeLens(k,F){const H=k.cacheId&&this.e.get(...k.cacheId);if(!H)return;let x;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?x=H:x=await this.j.resolveCodeLens(H,F),x||(x=H),F.isCancellationRequested)return;const te=k.cacheId&&this.f.get(k.cacheId[0]);if(!!te)return k.command=this.h.toInternal(x.command??l.d,te),k}releaseCodeLenses(k){this.f.get(k)?.dispose(),this.f.delete(k),this.e.delete(k)}}l.d={command:"missing",title:"!!MISSING: command!!"};function r(Z){return Array.isArray(Z)?Z.map(C.DefinitionLink.from):Z?[C.DefinitionLink.from(Z)]:[]}class c{constructor(k,F){this.d=k,this.e=F}async provideDefinition(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideDefinition(x,te,H);return r(pe)}}class o{constructor(k,F){this.d=k,this.e=F}async provideDeclaration(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideDeclaration(x,te,H);return r(pe)}}class I{constructor(k,F){this.d=k,this.e=F}async provideImplementation(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideImplementation(x,te,H);return r(pe)}}class s{constructor(k,F){this.d=k,this.e=F}async provideTypeDefinition(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideTypeDefinition(x,te,H);return r(pe)}}class u{constructor(k,F){this.d=k,this.e=F}async provideHover(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideHover(x,te,H);if(!(!pe||(0,O.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=x.getWordRangeAtPosition(te)),pe.range||(pe.range=new M.Range(te,te)),C.Hover.from(pe)}}class v{constructor(k,F){this.d=k,this.e=F}async provideEvaluatableExpression(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideEvaluatableExpression(x,te,H);if(pe)return C.EvaluatableExpression.from(pe)}}class S{constructor(k,F){this.d=k,this.e=F}async provideInlineValues(k,F,H,x){const te=this.d.getDocument(k),pe=await this.e.provideInlineValues(te,C.Range.to(F),C.InlineValueContext.to(H),x);if(Array.isArray(pe))return pe.map(ke=>C.InlineValue.from(ke))}}class E{constructor(k,F){this.d=k,this.e=F}async provideDocumentHighlights(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideDocumentHighlights(x,te,H);if(Array.isArray(pe))return pe.map(C.DocumentHighlight.from)}}class W{constructor(k,F){this.d=k,this.e=F}async provideLinkedEditingRanges(k,F,H){const x=this.d.getDocument(k),te=C.Position.to(F),pe=await this.e.provideLinkedEditingRanges(x,te,H);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,O.coalesce)(pe.ranges.map(C.Range.from)),wordPattern:pe.wordPattern}}}class X{constructor(k,F){this.d=k,this.e=F}async provideReferences(k,F,H,x){const te=this.d.getDocument(k),pe=C.Position.to(F),ke=await this.e.provideReferences(te,pe,H,x);if(Array.isArray(ke))return ke.map(C.location.from)}}class Y{constructor(k,F,H,x,te,pe,ke){this.g=k,this.h=F,this.j=H,this.k=x,this.l=te,this.m=pe,this.n=ke,this.e=new a.Cache("CodeAction"),this.f=new Map}async provideCodeActions(k,F,H,x){const te=this.g.getDocument(k),pe=f.Selection.isISelection(F)?C.Selection.to(F):C.Range.to(F),ke=[];for(const et of this.j.getDiagnostics(k))if(pe.intersection(et.range)&&ke.push(et)>Y.d)break;const ue={diagnostics:ke,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},De=await this.k.provideCodeActions(te,pe,ue,x);if(!(0,O.isNonEmptyArray)(De)||x.isCancellationRequested)return;const Se=this.e.add(De),$e=new g.DisposableStore;this.f.set(Se,$e);const He=[];for(let et=0;et<De.length;et++){const Xe=De[et];!Xe||(Y.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,$e)})):(ue.only&&(Xe.kind?ue.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Se,et],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,$e),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(C.Diagnostic.from),edit:Xe.edit&&C.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Se,actions:He}}async resolveCodeAction(k,F){const[H,x]=k,te=this.e.get(H,x);if(!te||Y.o(te)||!this.k.resolveCodeAction)return;const pe=await this.k.resolveCodeAction(te,F)??te;return pe?.edit?C.WorkspaceEdit.from(pe.edit,void 0):void 0}releaseCodeActions(k){this.f.get(k)?.dispose(),this.f.delete(k),this.e.delete(k)}static o(k){return typeof k.command=="string"&&typeof k.title=="string"}}Y.d=1e3;class J{constructor(k,F,H,x){this.d=k,this.e=F,this.f=H,this.g=x}async prepareDocumentPaste(k,F,H,x){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(k),pe=F.map(ue=>C.Range.to(ue)),ke=C.DataTransfer.toDataTransfer(H,()=>{throw new y.NotImplementedError});return await this.f.prepareDocumentPaste(te,pe,ke,x),C.DataTransfer.toDataTransferDTO(ke)}async providePasteEdits(k,F,H,x,te){const pe=this.e.getDocument(F),ke=H.map(Se=>C.Range.to(Se)),ue=C.DataTransfer.toDataTransfer(x,async Se=>(await this.d.$resolvePasteFileData(this.g,k,Se)).buffer),De=await this.f.provideDocumentPasteEdits(pe,ke,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?C.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class j{constructor(k,F){this.d=k,this.e=F}async provideDocumentFormattingEdits(k,F,H){const x=this.d.getDocument(k),te=await this.e.provideDocumentFormattingEdits(x,F,H);if(Array.isArray(te))return te.map(C.TextEdit.from)}}class U{constructor(k,F){this.d=k,this.e=F}async provideDocumentRangeFormattingEdits(k,F,H,x){const te=this.d.getDocument(k),pe=C.Range.to(F),ke=await this.e.provideDocumentRangeFormattingEdits(te,pe,H,x);if(Array.isArray(ke))return ke.map(C.TextEdit.from)}}class ${constructor(k,F){this.d=k,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,F,H,x,te){const pe=this.d.getDocument(k),ke=C.Position.to(F),ue=await this.e.provideOnTypeFormattingEdits(pe,ke,H,x,te);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class B{constructor(k,F){this.e=k,this.f=F,this.d=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,F){const H=await this.e.provideWorkspaceSymbols(k,F);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const x=this.d.add(H),te={cacheId:x,symbols:[]};for(let pe=0;pe<H.length;pe++){const ke=H[pe];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}te.symbols.push({...C.WorkspaceSymbol.from(ke),cacheId:[x,pe]})}return te}async resolveWorkspaceSymbol(k,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const H=this.d.get(...k.cacheId);if(H){const x=await this.e.resolveWorkspaceSymbol(H,F);return x&&(0,P.mixin)(k,C.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(k){this.d.delete(k)}}class q{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,F,H){this.d=k,this.e=F,this.f=H}async provideRenameEdits(k,F,H,x){const te=this.d.getDocument(k),pe=C.Position.to(F);try{const ke=await this.e.provideRenameEdits(te,pe,H,x);return ke?C.WorkspaceEdit.from(ke):void 0}catch(ke){const ue=q.g(ke);return ue?{rejectReason:ue,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(k,F,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(k),te=C.Position.to(F);try{const pe=await this.e.prepareRename(x,te,H);let ke,ue;if(M.Range.isRange(pe)?(ke=pe,ue=x.getText(pe)):(0,D.isObject)(pe)&&(ke=pe.range,ue=pe.placeholder),!ke||!ue)return;if(ke.start.line>te.line||ke.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ke),text:ue}}catch(pe){const ke=q.g(pe);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(pe)}}static g(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class he{constructor(k,F){this.resultId=k,this.tokens=F}}class Ee{constructor(k,F){this.f=k,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(k,F,H){const x=this.f.getDocument(k),te=F!==0?this.d.get(F):null;let pe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,te.resultId,H):await this.g.provideDocumentSemanticTokens(x,H);return te&&this.d.delete(F),pe?(pe=Ee.h(pe),this.o(Ee.n(te,pe),pe)):null}async releaseDocumentSemanticColoring(k){this.d.delete(k)}static h(k){return Ee.j(k)?Ee.k(k)?k:new M.SemanticTokens(new Uint32Array(k.data),k.resultId):Ee.l(k)?Ee.m(k)?k:new M.SemanticTokensEdits(k.edits.map(F=>new M.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),k.resultId):k}static j(k){return k&&!!k.data}static k(k){return k.data instanceof Uint32Array}static l(k){return k&&Array.isArray(k.edits)}static m(k){for(const F of k.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(k,F){if(!Ee.j(F)||!k||!k.tokens)return F;const H=k.tokens,x=H.length,te=F.data,pe=te.length;let ke=0;const ue=Math.min(x,pe);for(;ke<ue&&H[ke]===te[ke];)ke++;if(ke===x&&ke===pe)return new M.SemanticTokensEdits([],F.resultId);let De=0;const Se=ue-ke;for(;De<Se&&H[x-De-1]===te[pe-De-1];)De++;return new M.SemanticTokensEdits([{start:ke,deleteCount:x-ke-De,data:te.subarray(ke,pe-De)}],F.resultId)}o(k,F){if(Ee.j(k)){const H=this.e++;return this.d.set(H,new he(k.resultId,k.data)),(0,d.encodeSemanticTokensDto)({id:H,type:"full",data:k.data})}if(Ee.l(k)){const H=this.e++;return Ee.j(F)?this.d.set(H,new he(F.resultId,F.data)):this.d.set(H,new he(k.resultId)),(0,d.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(k.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ie{constructor(k,F){this.d=k,this.e=F}async provideDocumentRangeSemanticTokens(k,F,H){const x=this.d.getDocument(k),te=await this.e.provideDocumentRangeSemanticTokens(x,C.Range.to(F),H);return te?this.f(te):null}f(k){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}class ce{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,F,H,x,te){this.f=k,this.g=F,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(k,F,H,x){const te=this.f.getDocument(k),pe=C.Position.to(F),ke=te.getWordRangeAtPosition(pe)||new M.Range(pe,pe),ue=ke.with({end:pe}),De=new m.StopWatch(!0),Se=await this.h.provideCompletionItems(te,pe,x,C.CompletionContext.to(H));if(!Se||x.isCancellationRequested)return;const $e=Array.isArray(Se)?new M.CompletionList(Se):Se,He=ce.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),et=new g.DisposableStore;this.e.set(He,et);const Xe=[],tt={x:He,b:Xe,a:{replace:C.Range.from(ke),insert:C.Range.from(ue)},c:$e.isIncomplete||void 0,d:De.elapsed()};for(let rt=0;rt<$e.items.length;rt++){const Me=$e.items[rt],it=this.l(Me,[He,rt],ue,ke);Xe.push(it)}return tt}async resolveCompletionItem(k,F){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...k);if(!H)return;const x=await this.h.resolveCompletionItem(H,F);if(!!x)return this.l(x,k)}releaseCompletionItems(k){this.e.get(k)?.dispose(),this.e.delete(k),this.d.delete(k)}l(k,F,H,x){const te=this.e.get(F[0]);if(!te)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(k.command,te),ke={x:F,a:k.label,b:k.kind!==void 0?C.CompletionItemKind.from(k.kind):void 0,m:k.tags&&k.tags.map(C.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:C.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters?.join(""),l:k.additionalTextEdits&&k.additionalTextEdits.map(C.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};k.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke.h=k.textEdit.newText):typeof k.insertText=="string"?ke.h=k.insertText:k.insertText instanceof M.SnippetString&&(ke.h=k.insertText.value,ke.i|=4);let ue;return k.textEdit?ue=k.textEdit.range:k.range&&(ue=k.range),M.Range.isRange(ue)?ke.j=C.Range.from(ue):ue&&(!H?.isEqual(ue.inserting)||!x?.isEqual(ue.replacing))&&(ke.j={insert:C.Range.from(ue.inserting),replace:C.Range.from(ue.replacing)}),ke}}class de{async provideInlineCompletions(k,F,H,x){}disposeCompletions(k){}handleDidShowCompletionItem(k,F){}handlePartialAccept(k,F,H){}}class Te extends de{constructor(k,F,H,x){super(),this.f=k,this.g=F,this.h=H,this.j=x,this.d=new le,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(k,F,H,x){const te=this.g.getDocument(k),pe=C.Position.to(F),ke=await this.h.provideInlineCompletionItems(te,pe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},x);if(!ke||x.isCancellationRequested)return;const ue=Array.isArray(ke)?ke:ke.items,De=this.e?Array.isArray(ke)?[]:ke.commands||[]:[];let Se;return{pid:this.d.createReferenceId({dispose(){Se?.dispose()},items:ue}),items:ue.map((He,et)=>{let Xe;He.command&&(Se||(Se=new g.DisposableStore),Xe=this.j.toInternal(He.command,Se));const tt=He.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:He.filterText,range:He.range?C.Range.from(He.range):void 0,command:Xe,idx:et,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:De.map(He=>(Se||(Se=new g.DisposableStore),this.j.toInternal(He,Se)))}}disposeCompletions(k){this.d.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,F){const H=this.d.get(k)?.items[F];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}handlePartialAccept(k,F,H){const x=this.d.get(k)?.items[F];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(k){const F=this.e++;return this.d.set(F,k),F}disposeReferenceId(k){const F=this.d.get(k);return this.d.delete(k),F}get(k){return this.d.get(k)}}class re{constructor(k,F){this.e=k,this.f=F,this.d=new a.Cache("SignatureHelp")}async provideSignatureHelp(k,F,H,x){const te=this.e.getDocument(k),pe=C.Position.to(F),ke=this.g(H),ue=await this.f.provideSignatureHelp(te,pe,x,ke);if(ue){const De=this.d.add([ue]);return{...C.SignatureHelp.from(ue),id:De}}}g(k){let F;if(k.activeSignatureHelp){const H=C.SignatureHelp.to(k.activeSignatureHelp),x=this.d.get(k.activeSignatureHelp.id,0);x?(F=x,F.activeSignature=H.activeSignature,F.activeParameter=H.activeParameter):F=H}return{...k,activeSignatureHelp:F}}releaseSignatureHelp(k){this.d.delete(k)}}class V{constructor(k,F,H,x,te){this.f=k,this.g=F,this.h=H,this.j=x,this.k=te,this.d=new a.Cache("InlayHints"),this.e=new Map}async provideInlayHints(k,F,H){const x=this.f.getDocument(k),te=C.Range.to(F),pe=await this.h.provideInlayHints(x,te,H);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${F}`);return}if(H.isCancellationRequested)return;const ke=this.d.add(pe);this.e.set(ke,new g.DisposableStore);const ue={hints:[],cacheId:ke};for(let De=0;De<pe.length;De++)this.l(pe[De],te)&&ue.hints.push(this.m(pe[De],[ke,De]));return this.j.trace(`[InlayHints] ${ue.hints.length} inlay hints from '${this.k.identifier.value}' for ${F}`),ue}async resolveInlayHint(k,F){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...k);if(!H)return;const x=await this.h.resolveInlayHint(H,F);if(!!x&&!!this.l(x))return this.m(x,k)}releaseHints(k){this.e.get(k)?.dispose(),this.e.delete(k),this.d.delete(k)}l(k,F){return k.label.length===0||Array.isArray(k.label)&&k.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(F&&!F.contains(k.position))}m(k,F){const H=this.e.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const x={label:"",cacheId:F,tooltip:C.MarkdownString.fromStrict(k.tooltip),position:C.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(C.TextEdit.from),kind:k.kind&&C.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?x.label=k.label:x.label=k.label.map(te=>{const pe={label:te.value};return pe.tooltip=C.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(pe.location=C.location.from(te.location)),te.command&&(pe.command=this.g.toInternal(te.command,H)),pe}),x}}class L{constructor(k,F){this.e=k,this.f=F,this.d=new a.Cache("DocumentLink")}async provideLinks(k,F){const H=this.e.getDocument(k),x=await this.f.provideDocumentLinks(H,F);if(!(!Array.isArray(x)||x.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(L.g).map(C.DocumentLink.from)};{const te=this.d.add(x),pe={links:[],cacheId:te};for(let ke=0;ke<x.length;ke++){if(!L.g(x[ke]))continue;const ue=C.DocumentLink.from(x[ke]);ue.cacheId=[te,ke],pe.links.push(ue)}return pe}}}static g(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,F){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...k);if(!H)return;const x=await this.f.resolveDocumentLink(H,F);if(!(!x||!L.g(x)))return C.DocumentLink.from(x)}releaseLinks(k){this.d.delete(k)}}class K{constructor(k,F){this.d=k,this.e=F}async provideColors(k,F){const H=this.d.getDocument(k),x=await this.e.provideDocumentColors(H,F);return Array.isArray(x)?x.map(pe=>({color:C.Color.from(pe.color),range:C.Range.from(pe.range)})):[]}async provideColorPresentations(k,F,H){const x=this.d.getDocument(k),te=C.Range.to(F.range),pe=C.Color.to(F.color),ke=await this.e.provideColorPresentations(pe,{document:x,range:te},H);if(!!Array.isArray(ke))return ke.map(C.ColorPresentation.from)}}class me{constructor(k,F){this.d=k,this.e=F}async provideFoldingRanges(k,F,H){const x=this.d.getDocument(k),te=await this.e.provideFoldingRanges(x,F,H);if(!!Array.isArray(te))return te.map(C.FoldingRange.from)}}class Ie{constructor(k,F,H){this.d=k,this.e=F,this.f=H}async provideSelectionRanges(k,F,H){const x=this.d.getDocument(k),te=F.map(C.Position.to),pe=await this.e.provideSelectionRanges(x,te,H);if(!(0,O.isNonEmptyArray)(pe))return[];if(pe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let ue=0;ue<te.length;ue++){const De=[];ke.push(De);let Se=te[ue],$e=pe[ue];for(;;){if(!$e.range.contains(Se))throw new Error("INVALID selection range, must contain the previous range");if(De.push(C.SelectionRange.from($e)),!$e.parent)break;Se=$e.range,$e=$e.parent}}return ke}}class we{constructor(k,F){this.f=k,this.g=F,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(k,F,H){const x=this.f.getDocument(k),te=C.Position.to(F),pe=await this.g.prepareCallHierarchy(x,te,H);if(!pe)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(pe)?pe.map(ue=>this.h(ke,ue)):[this.h(ke,pe)]}async provideCallsTo(k,F,H){const x=this.j(k,F);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(x,H);if(!!te)return te.map(pe=>({from:this.h(k,pe.from),fromRanges:pe.fromRanges.map(ke=>C.Range.from(ke))}))}async provideCallsFrom(k,F,H){const x=this.j(k,F);if(!x)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(x,H);if(!!te)return te.map(pe=>({to:this.h(k,pe.to),fromRanges:pe.fromRanges.map(ke=>C.Range.from(ke))}))}releaseSession(k){this.e.delete(k)}h(k,F){const H=this.e.get(k),x=C.CallHierarchyItem.from(F,k,H.size.toString(36));return H.set(x._itemId,F),x}j(k,F){return this.e.get(k)?.get(F)}}class ve{constructor(k,F){this.f=k,this.g=F,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(k,F,H){const x=this.f.getDocument(k),te=C.Position.to(F),pe=await this.g.prepareTypeHierarchy(x,te,H);if(!pe)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(pe)?pe.map(ue=>this.h(ke,ue)):[this.h(ke,pe)]}async provideSupertypes(k,F,H){const x=this.j(k,F);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(x,H);if(!!te)return te.map(pe=>this.h(k,pe))}async provideSubtypes(k,F,H){const x=this.j(k,F);if(!x)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(x,H);if(!!te)return te.map(pe=>this.h(k,pe))}releaseSession(k){this.e.delete(k)}h(k,F){const H=this.e.get(k),x=C.TypeHierarchyItem.from(F,k,H.size.toString(36));return H.set(x._itemId,F),x}j(k,F){return this.e.get(k)?.get(F)}}class Ce{constructor(k,F,H,x){this.d=k,this.e=F,this.f=H,this.g=x}async provideDocumentOnDropEdits(k,F,H,x,te){const pe=this.e.getDocument(F),ke=C.Position.to(H),ue=C.DataTransfer.toDataTransfer(x,async Se=>(await this.d.$resolveDocumentOnDropFileData(this.g,k,Se)).buffer),De=await this.f.provideDocumentDropEdits(pe,ke,ue,te);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?C.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class se{constructor(k,F){this.adapter=k,this.extension=F}}class ae{constructor(k,F,H,x,te,pe,ke,ue){this.g=F,this.h=H,this.j=x,this.k=te,this.l=pe,this.m=ke,this.n=ue,this.f=new Map,this.e=k.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(k){return C.DocumentSelector.from(k,this.g)}p(k){return new M.Disposable(()=>{this.f.delete(k),this.e.$unregister(k)})}q(){return ae.d++}async s(k,F,H,x,te,pe=!1){const ke=this.f.get(k);if(!ke||!(ke.adapter instanceof F))return x;const ue=Date.now();pe||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const De=H(ke.adapter,ke.extension);return Promise.resolve(De).catch(Se=>{(0,y.isCancellationError)(Se)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(Se),this.n.onExtensionError(ke.extension.identifier,Se))}).finally(()=>{pe||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-ue}ms`)}),b.CancellationToken.isCancellationToken(te)?(0,T.raceCancellationError)(De,te):De}t(k,F){const H=this.q();return this.f.set(H,new se(k,F)),H}static u(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,F,H,x){const te=this.t(new i(this.h,H),k),pe=x&&x.label||ae.u(k);return this.e.$registerDocumentSymbolProvider(te,this.o(F),pe),this.p(te)}$provideDocumentSymbols(k,F,H){return this.s(k,i,x=>x.provideDocumentSymbols(n.URI.revive(F),H),void 0,H)}registerCodeLensProvider(k,F,H){const x=this.q(),te=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new se(new l(this.h,this.j.converter,H),k)),this.e.$registerCodeLensSupport(x,this.o(F),te);let pe=this.p(x);if(te!==void 0){const ke=H.onDidChangeCodeLenses(ue=>this.e.$emitCodeLensEvent(te));pe=M.Disposable.from(pe,ke)}return pe}$provideCodeLenses(k,F,H){return this.s(k,l,x=>x.provideCodeLenses(n.URI.revive(F),H),void 0,H)}$resolveCodeLens(k,F,H){return this.s(k,l,x=>x.resolveCodeLens(F,H),void 0,void 0)}$releaseCodeLenses(k,F){this.s(k,l,H=>Promise.resolve(H.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(k,F,H){const x=this.t(new c(this.h,H),k);return this.e.$registerDefinitionSupport(x,this.o(F)),this.p(x)}$provideDefinition(k,F,H,x){return this.s(k,c,te=>te.provideDefinition(n.URI.revive(F),H,x),[],x)}registerDeclarationProvider(k,F,H){const x=this.t(new o(this.h,H),k);return this.e.$registerDeclarationSupport(x,this.o(F)),this.p(x)}$provideDeclaration(k,F,H,x){return this.s(k,o,te=>te.provideDeclaration(n.URI.revive(F),H,x),[],x)}registerImplementationProvider(k,F,H){const x=this.t(new I(this.h,H),k);return this.e.$registerImplementationSupport(x,this.o(F)),this.p(x)}$provideImplementation(k,F,H,x){return this.s(k,I,te=>te.provideImplementation(n.URI.revive(F),H,x),[],x)}registerTypeDefinitionProvider(k,F,H){const x=this.t(new s(this.h,H),k);return this.e.$registerTypeDefinitionSupport(x,this.o(F)),this.p(x)}$provideTypeDefinition(k,F,H,x){return this.s(k,s,te=>te.provideTypeDefinition(n.URI.revive(F),H,x),[],x)}registerHoverProvider(k,F,H,x){const te=this.t(new u(this.h,H),k);return this.e.$registerHoverProvider(te,this.o(F)),this.p(te)}$provideHover(k,F,H,x){return this.s(k,u,te=>te.provideHover(n.URI.revive(F),H,x),void 0,x)}registerEvaluatableExpressionProvider(k,F,H,x){const te=this.t(new v(this.h,H),k);return this.e.$registerEvaluatableExpressionProvider(te,this.o(F)),this.p(te)}$provideEvaluatableExpression(k,F,H,x){return this.s(k,v,te=>te.provideEvaluatableExpression(n.URI.revive(F),H,x),void 0,x)}registerInlineValuesProvider(k,F,H,x){const te=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new S(this.h,H),k);this.e.$registerInlineValuesProvider(pe,this.o(F),te);let ke=this.p(pe);if(te!==void 0){const ue=H.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(te));ke=M.Disposable.from(ke,ue)}return ke}$provideInlineValues(k,F,H,x,te){return this.s(k,S,pe=>pe.provideInlineValues(n.URI.revive(F),H,x,te),void 0,te)}registerDocumentHighlightProvider(k,F,H){const x=this.t(new E(this.h,H),k);return this.e.$registerDocumentHighlightProvider(x,this.o(F)),this.p(x)}$provideDocumentHighlights(k,F,H,x){return this.s(k,E,te=>te.provideDocumentHighlights(n.URI.revive(F),H,x),void 0,x)}registerLinkedEditingRangeProvider(k,F,H){const x=this.t(new W(this.h,H),k);return this.e.$registerLinkedEditingRangeProvider(x,this.o(F)),this.p(x)}$provideLinkedEditingRanges(k,F,H,x){return this.s(k,W,async te=>{const pe=await te.provideLinkedEditingRanges(n.URI.revive(F),H,x);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?ae.w(pe.wordPattern):void 0}},void 0,x)}registerReferenceProvider(k,F,H){const x=this.t(new X(this.h,H),k);return this.e.$registerReferenceSupport(x,this.o(F)),this.p(x)}$provideReferences(k,F,H,x,te){return this.s(k,X,pe=>pe.provideReferences(n.URI.revive(F),H,x,te),void 0,te)}registerCodeActionProvider(k,F,H,x){const te=new g.DisposableStore,pe=this.t(new Y(this.h,this.j.converter,this.k,H,this.l,k,this.m),k);return this.e.$registerQuickFixSupport(pe,this.o(F),{providedKinds:x?.providedCodeActionKinds?.map(ke=>ke.value),documentation:x?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,te)}))},ae.u(k),Boolean(H.resolveCodeAction)),te.add(this.p(pe)),te}$provideCodeActions(k,F,H,x,te){return this.s(k,Y,pe=>pe.provideCodeActions(n.URI.revive(F),H,x,te),void 0,te)}$resolveCodeAction(k,F,H){return this.s(k,Y,x=>x.resolveCodeAction(F,H),void 0,void 0)}$releaseCodeActions(k,F){this.s(k,Y,H=>Promise.resolve(H.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(k,F,H){const x=this.t(new j(this.h,H),k);return this.e.$registerDocumentFormattingSupport(x,this.o(F),k.identifier,k.displayName||k.name),this.p(x)}$provideDocumentFormattingEdits(k,F,H,x){return this.s(k,j,te=>te.provideDocumentFormattingEdits(n.URI.revive(F),H,x),void 0,x)}registerDocumentRangeFormattingEditProvider(k,F,H){const x=this.t(new U(this.h,H),k);return this.e.$registerRangeFormattingSupport(x,this.o(F),k.identifier,k.displayName||k.name),this.p(x)}$provideDocumentRangeFormattingEdits(k,F,H,x,te){return this.s(k,U,pe=>pe.provideDocumentRangeFormattingEdits(n.URI.revive(F),H,x,te),void 0,te)}registerOnTypeFormattingEditProvider(k,F,H,x){const te=this.t(new $(this.h,H),k);return this.e.$registerOnTypeFormattingSupport(te,this.o(F),x,k.identifier),this.p(te)}$provideOnTypeFormattingEdits(k,F,H,x,te,pe){return this.s(k,$,ke=>ke.provideOnTypeFormattingEdits(n.URI.revive(F),H,x,te,pe),void 0,pe)}registerWorkspaceSymbolProvider(k,F){const H=this.t(new B(F,this.l),k);return this.e.$registerNavigateTypeSupport(H,typeof F.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(k,F,H){return this.s(k,B,x=>x.provideWorkspaceSymbols(F,H),{symbols:[]},H)}$resolveWorkspaceSymbol(k,F,H){return this.s(k,B,x=>x.resolveWorkspaceSymbol(F,H),void 0,void 0)}$releaseWorkspaceSymbols(k,F){this.s(k,B,H=>H.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(k,F,H){const x=this.t(new q(this.h,H,this.l),k);return this.e.$registerRenameSupport(x,this.o(F),q.supportsResolving(H)),this.p(x)}$provideRenameEdits(k,F,H,x,te){return this.s(k,q,pe=>pe.provideRenameEdits(n.URI.revive(F),H,x,te),void 0,te)}$resolveRenameLocation(k,F,H,x){return this.s(k,q,te=>te.resolveRenameLocation(n.URI.revive(F),H,x),void 0,x)}registerDocumentSemanticTokensProvider(k,F,H,x){const te=this.t(new Ee(this.h,H),k),pe=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(F),x,pe);let ke=this.p(te);if(pe){const ue=H.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(pe));ke=M.Disposable.from(ke,ue)}return ke}$provideDocumentSemanticTokens(k,F,H,x){return this.s(k,Ee,te=>te.provideDocumentSemanticTokens(n.URI.revive(F),H,x),null,x)}$releaseDocumentSemanticTokens(k,F){this.s(k,Ee,H=>H.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,F,H,x){const te=this.t(new ie(this.h,H),k);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(F),x),this.p(te)}$provideDocumentRangeSemanticTokens(k,F,H,x){return this.s(k,ie,te=>te.provideDocumentRangeSemanticTokens(n.URI.revive(F),H,x),null,x)}registerCompletionItemProvider(k,F,H,x){const te=this.t(new ce(this.h,this.j.converter,H,this.m,k),k);return this.e.$registerCompletionsProvider(te,this.o(F),x,ce.supportsResolving(H),`${k.identifier.value}(${x.join("")})`),this.p(te)}$provideCompletionItems(k,F,H,x,te){return this.s(k,ce,pe=>pe.provideCompletionItems(n.URI.revive(F),H,x,te),void 0,te)}$resolveCompletionItem(k,F,H){return this.s(k,ce,x=>x.resolveCompletionItem(F,H),void 0,H)}$releaseCompletionItems(k,F){this.s(k,ce,H=>H.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(k,F,H){const x=new Te(k,this.h,H,this.j.converter),te=this.t(x,k);return this.e.$registerInlineCompletionsSupport(te,this.o(F),x.supportsHandleEvents),this.p(te)}$provideInlineCompletions(k,F,H,x,te){return this.s(k,de,pe=>pe.provideInlineCompletions(n.URI.revive(F),H,x,te),void 0,te)}$handleInlineCompletionDidShow(k,F,H){this.s(k,de,async x=>{x.handleDidShowCompletionItem(F,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(k,F,H,x){this.s(k,de,async te=>{te.handlePartialAccept(F,H,x)},void 0,void 0)}$freeInlineCompletionsList(k,F){this.s(k,de,async H=>{H.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(k,F,H,x){const te=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,pe=this.t(new re(this.h,H),k);return this.e.$registerSignatureHelpProvider(pe,this.o(F),te),this.p(pe)}$provideSignatureHelp(k,F,H,x,te){return this.s(k,re,pe=>pe.provideSignatureHelp(n.URI.revive(F),H,x,te),void 0,te)}$releaseSignatureHelp(k,F){this.s(k,re,H=>H.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(k,F,H){const x=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new V(this.h,this.j.converter,H,this.l,k),k);this.e.$registerInlayHintsProvider(te,this.o(F),typeof H.resolveInlayHint=="function",x,ae.u(k));let pe=this.p(te);if(x!==void 0){const ke=H.onDidChangeInlayHints(ue=>this.e.$emitInlayHintsEvent(x));pe=M.Disposable.from(pe,ke)}return pe}$provideInlayHints(k,F,H,x){return this.s(k,V,te=>te.provideInlayHints(n.URI.revive(F),H,x),void 0,x)}$resolveInlayHint(k,F,H){return this.s(k,V,x=>x.resolveInlayHint(F,H),void 0,H)}$releaseInlayHints(k,F){this.s(k,V,H=>H.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(k,F,H){const x=this.t(new L(this.h,H),k);return this.e.$registerDocumentLinkProvider(x,this.o(F),typeof H.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(k,F,H){return this.s(k,L,x=>x.provideLinks(n.URI.revive(F),H),void 0,H,F.scheme==="output")}$resolveDocumentLink(k,F,H){return this.s(k,L,x=>x.resolveLink(F,H),void 0,void 0,!0)}$releaseDocumentLinks(k,F){this.s(k,L,H=>H.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(k,F,H){const x=this.t(new K(this.h,H),k);return this.e.$registerDocumentColorProvider(x,this.o(F)),this.p(x)}$provideDocumentColors(k,F,H){return this.s(k,K,x=>x.provideColors(n.URI.revive(F),H),[],H)}$provideColorPresentations(k,F,H,x){return this.s(k,K,te=>te.provideColorPresentations(n.URI.revive(F),H,x),void 0,x)}registerFoldingRangeProvider(k,F,H){const x=this.q(),te=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new se(new me(this.h,H),k)),this.e.$registerFoldingRangeProvider(x,this.o(F),k.identifier,te);let pe=this.p(x);if(te!==void 0){const ke=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));pe=M.Disposable.from(pe,ke)}return pe}$provideFoldingRanges(k,F,H,x){return this.s(k,me,te=>te.provideFoldingRanges(n.URI.revive(F),H,x),void 0,x)}registerSelectionRangeProvider(k,F,H){const x=this.t(new Ie(this.h,H,this.l),k);return this.e.$registerSelectionRangeProvider(x,this.o(F)),this.p(x)}$provideSelectionRanges(k,F,H,x){return this.s(k,Ie,te=>te.provideSelectionRanges(n.URI.revive(F),H,x),[],x)}registerCallHierarchyProvider(k,F,H){const x=this.t(new we(this.h,H),k);return this.e.$registerCallHierarchyProvider(x,this.o(F)),this.p(x)}$prepareCallHierarchy(k,F,H,x){return this.s(k,we,te=>Promise.resolve(te.prepareSession(n.URI.revive(F),H,x)),void 0,x)}$provideCallHierarchyIncomingCalls(k,F,H,x){return this.s(k,we,te=>te.provideCallsTo(F,H,x),void 0,x)}$provideCallHierarchyOutgoingCalls(k,F,H,x){return this.s(k,we,te=>te.provideCallsFrom(F,H,x),void 0,x)}$releaseCallHierarchy(k,F){this.s(k,we,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(k,F,H){const x=this.t(new ve(this.h,H),k);return this.e.$registerTypeHierarchyProvider(x,this.o(F)),this.p(x)}$prepareTypeHierarchy(k,F,H,x){return this.s(k,ve,te=>Promise.resolve(te.prepareSession(n.URI.revive(F),H,x)),void 0,x)}$provideTypeHierarchySupertypes(k,F,H,x){return this.s(k,ve,te=>te.provideSupertypes(F,H,x),void 0,x)}$provideTypeHierarchySubtypes(k,F,H,x){return this.s(k,ve,te=>te.provideSubtypes(F,H,x),void 0,x)}$releaseTypeHierarchy(k,F){this.s(k,ve,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(k,F,H){const x=this.q();return this.f.set(x,new se(new Ce(this.e,this.h,H,x),k)),this.e.$registerDocumentOnDropEditProvider(x,this.o(F)),this.p(x)}$provideDocumentOnDropEdits(k,F,H,x,te,pe){return this.s(k,Ce,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(F,n.URI.revive(H),x,te,pe)),void 0,void 0)}registerDocumentPasteEditProvider(k,F,H,x){const te=this.q();return this.f.set(te,new se(new J(this.e,this.h,H,te),k)),this.e.$registerPasteEditProvider(te,this.o(F),!!H.prepareDocumentPaste,x.pasteMimeTypes),this.p(te)}$prepareDocumentPaste(k,F,H,x,te){return this.s(k,J,pe=>pe.prepareDocumentPaste(n.URI.revive(F),H,x,te),void 0,te)}$providePasteEdits(k,F,H,x,te,pe){return this.s(k,J,ke=>ke.providePasteEdits(F,n.URI.revive(H),x,te,pe),void 0,pe)}static w(k){return{pattern:k.source,flags:(0,w.regExpFlags)(k)}}static y(k){return{decreaseIndentPattern:ae.w(k.decreaseIndentPattern),increaseIndentPattern:ae.w(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?ae.w(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?ae.w(k.unIndentedLinePattern):void 0}}static z(k){return{beforeText:ae.w(k.beforeText),afterText:k.afterText?ae.w(k.afterText):void 0,previousLineText:k.previousLineText?ae.w(k.previousLineText):void 0,action:k.action}}static B(k){return k.map(ae.z)}setLanguageConfiguration(k,F,H){const{wordPattern:x}=H;if(x&&(0,w.regExpLeadsToEndlessLoop)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(F,x):this.h.setWordDefinitionFor(F,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const te=this.q(),pe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(te,F,pe),this.p(te)}$setWordDefinitions(k){for(const F of k)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(Ae[226],Re([1,0,4,8,7,29,17,6]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(O,D,f,b){this.c=D,this.d=f,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,D){await this.a.$changeLanguage(O,D);const f=this.c.getDocumentData(O);if(!f)throw new Error(`document '${O.toString()}' NOT found`);return f.document}async tokenAtPosition(O,D){const f=O.version,b=P.Position.from(D),g=await this.a.$tokensAtPosition(O.uri,b),d={type:C.StandardTokenType.Other,range:O.getWordRangeAtPosition(D)??new C.Range(D.line,D.character,D.line,D.character)};if(!g)return d;const t={range:P.Range.to(g.range),type:P.TokenType.to(g.type)};return!t.range.contains(D)||f!==O.version?d:t}createLanguageStatusItem(O,D,f){const b=this.f++,g=this.a,d=this.g,t=`${O.identifier.value}/${D}`;if(d.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(t);const a={selector:f,id:D,name:O.displayName??O.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const y=new A.DisposableStore,T=()=>{m?.dispose(),m=(0,R.disposableTimeout)(()=>{y.clear(),this.a.$setLanguageStatus(b,{id:t,name:a.name??O.displayName??O.name,source:O.displayName??O.name,selector:P.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?M.default.Error:a.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this.d.toInternal(a.command,y),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},p={dispose(){y.dispose(),m?.dispose(),g.$removeLanguageStatus(b),d.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,T()},get selector(){return a.selector},set selector(i){a.selector=i,T()},get text(){return a.text},set text(i){a.text=i,T()},get detail(){return a.detail},set detail(i){a.detail=i,T()},get severity(){return a.severity},set severity(i){a.severity=i,T()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,T()},get command(){return a.command},set command(i){a.command=i,T()},get busy(){return a.busy},set busy(i){a.busy=i,T()}};return T(),p}}e.ExtHostLanguages=w}),define(Ae[79],Re([1,0,20,13,2,3,14,4,27,18]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(f,b,g){this.f=g,this.d=new Map,this.a=b.getProxy(A.MainContext.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(f,b){const{message:g,args:d,comment:t}=b;if(this.c)return(0,P.format2)(g,d??{});let a=g;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const m=this.d.get(f)?.contents[a];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,P.format2)(m??g,d??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let b;const g=await this.g(f);if(!g){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(g),t=JSON.parse(d);b=f.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${f.identifier.value} from ${g}: ${d.message}`);return}b&&this.d.set(f.identifier.value,{contents:b,uri:g})}async g(f){if(f.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return C.URI.revive(b)}return f.l10n?C.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=je([Ve(0,w.IExtHostInitDataService),Ve(1,h.IExtHostRpcService),Ve(2,R.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ae[227],Re([1,0,14,4,27,18,2,66]),function(ee,e,n,P,C,M,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(D,f){super(f.logLevel,f.logsLocation,f.loggers.map(b=>(0,A.revive)(b))),this.n=D.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(D,f){f?this.setLogLevel(R.URI.revive(f),D):this.setLogLevel(D)}setVisibility(D,f){super.setVisibility(D,f),this.n.$setVisibility(D,f)}m(D,f,b){return new h(this.n,D,f,b)}};w=je([Ve(0,M.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],w),e.ExtHostLoggerService=w;class h extends n.AbstractMessageLogger{constructor(D,f,b,g){super(g?.logLevel==="always"),this.m=D,this.n=f,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(f,g).then(()=>{this.q(this.l),this.k=!0})}g(D,f){const b=[[D,f]];this.k?this.q(b):this.l.push(...b)}q(D){this.m.$log(this.n,D)}}}),define(Ae[228],Re([1,0,4,14,26]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let R=class{constructor(w,h){this.b=h,this.a=w.getProxy(n.MainContext.MainThreadMessageService)}showMessage(w,h,O,D,f){const b={source:{identifier:w.identifier,label:w.displayName||w.name}};let g;typeof D=="string"||M(D)?g=[D,...f]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,g=f),b.useCustom&&(0,C.checkProposedApiEnabled)(w,"resolvers");const d=[];for(let t=0;t<g.length;t++){const a=g[t];if(typeof a=="string")d.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:m,isCloseAffordance:y}=a;d.push({title:m,isCloseAffordance:!!y,handle:t})}else this.b.warn("Invalid message item:",a)}return this.a.$showMessage(h,O,b,d).then(t=>{if(typeof t=="number")return g[t]})}};R=je([Ve(1,P.ILogService)],R),e.ExtHostMessageService=R}),define(Ae[229],Re([1,0,25,5,6,28,13,9,2,54,4,38,8,7,46,201,102,10]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(T=>T.apiEditor)}constructor(T,p,i,l){this.q=i,this.r=l,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=T.getProxy(O.MainContext.MainThreadNotebook),this.c=T.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=T.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const c=r.notebookEditor?.notebookUri,o=r.cell.handle,s=this.g.get(c)?.getCell(o);if(s)return s.apiCell}if(r&&r.$mid===14){const c=r.uri,o=this.g.get(c);if(o)return o.apiNotebook}return r}}),m.x(p)}getEditorById(T){const p=this.h.get(T);if(!p)throw new Error(`unknown text editor: ${T}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(T){for(const[p,i]of this.h)if(i.apiEditor===T)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(T,p){const i=this.g.get(T);if(!i&&!p)throw new Error(`NO notebook document for '${T}'`);return i}static s(T,p){if(!p)return;const i=p.filenamePattern.map(l=>f.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(p.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:T.identifier,providerDisplayName:T.displayName||T.name,displayName:p.displayName,filenamePattern:i,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(T,p,i){const l=m.a++,r=typeof i.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(l,i),this.b.$registerNotebookCellStatusBarItemProvider(l,r,p);let c;return r!==void 0&&(c=i.onDidChangeCellStatusBarItems(o=>this.b.$emitCellStatusBarEvent(r))),new b.Disposable(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,r),c?.dispose()})}async createNotebookDocument(T){const p=await this.c.$tryCreateNotebook({viewType:T.viewType,content:T.content&&f.NotebookData.from(T.content)});return w.URI.revive(p)}async openNotebookDocument(T){const p=this.g.get(T);if(p)return p.apiNotebook;const i=await this.c.$tryOpenNotebook(T),l=this.g.get(w.URI.revive(i));return(0,A.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(T,p){w.URI.isUri(T)&&(T=await this.openNotebookDocument(T));let i;typeof p=="object"?i={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(f.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:i={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(T.uri,T.notebookType,i),r=l&&this.h.get(l)?.apiEditor;if(r)return r;throw l?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(T,p,i,l){const r=this.f.get(T),c=w.URI.revive(p),o=this.g.get(c);if(!o||!r)return;const I=o.getCellFromIndex(i);if(!I)return;const s=await r.provideCellStatusBarItems(I.apiCell,l);if(!s)return;const u=new C.DisposableStore,v=this.p.add([u]),E=(Array.isArray(s)?s:[s]).map(W=>f.NotebookStatusBarItem.from(W,this.i,u));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(T){this.p.delete(T)}registerNotebookSerializer(T,p,i,l,r){if((0,R.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,i),this.b.$registerNotebookSerializer(c,{id:T.identifier,location:T.extensionLocation},p,f.NotebookDocumentContentOptions.from(l),m.s(T,r)),(0,C.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(T,p,i){const l=this.u.get(T);if(!l)throw new Error("NO serializer found");const r=await l.deserializeNotebook(p.buffer,i);return new g.SerializableObjectWithBuffers(f.NotebookData.from(r))}async $notebookToData(T,p,i){const l=this.u.get(T);if(!l)throw new Error("NO serializer found");const r=await l.serializeNotebook(f.NotebookData.to(p.value),i);return n.VSBuffer.wrap(r)}w(T,p,i){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const l=new t.ExtHostNotebookEditor(p,this.d,T,i.visibleRanges.map(f.NotebookRange.to),i.selections.map(f.NotebookRange.to),typeof i.viewColumn=="number"?f.ViewColumn.to(i.viewColumn):void 0);this.h.set(p,l)}$acceptDocumentAndEditorsDelta(T){if(T.value.removedDocuments)for(const i of T.value.removedDocuments){const l=w.URI.revive(i),r=this.g.get(l);r&&(r.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(r.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===l.toString()&&this.h.delete(c.id)}if(T.value.addedDocuments){const i=[];for(const l of T.value.addedDocuments){const r=w.URI.revive(l.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const c=new d.ExtHostNotebookDocument(this.c,this.q,this.r,r,l);i.push(...l.cells.map(o=>d.ExtHostCell.asModelAddData(c.apiNotebook,o))),this.g.get(r)?.dispose(),this.g.set(r,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this.m.fire(c.apiNotebook)}}if(T.value.addedEditors)for(const i of T.value.addedEditors){if(this.h.has(i.id))return;const l=w.URI.revive(i.documentUri),r=this.g.get(l);r&&this.w(r,i.id,i)}const p=[];if(T.value.removedEditors)for(const i of T.value.removedEditors){const l=this.h.get(i);l&&(this.h.delete(i),this.k?.id===l.id&&(this.k=void 0),p.push(l))}if(T.value.visibleEditors){this.l=T.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const i=new Set;this.l.forEach(l=>i.add(l.id));for(const l of this.h.values()){const r=i.has(l.id);l._acceptVisibility(r)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}T.value.newActiveEditor===null?this.k=void 0:T.value.newActiveEditor&&(this.h.get(T.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${T.value.newActiveEditor}`),this.k=this.h.get(T.value.newActiveEditor)),T.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(T){const p=D.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>f.NotebookData.to(r.value))),l=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new g.SerializableObjectWithBuffers(f.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));T.registerApiCommand(i),T.registerApiCommand(l)}}m.a=0,e.ExtHostNotebookController=m}),define(Ae[230],Re([1,0,16,17,21,5,6,28,2,24,14,54,4,38,8,7,74,191,26,46]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let T=class{constructor(o,I,s,u,v){this.k=I,this.l=s,this.m=u,this.n=v,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(f.MainContext.MainThreadNotebookKernels);const S=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const W=this.l.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:W}}else if(E&&"notebookEditor"in E){const W=this.l.getIdByEditor(E.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return E})],b.ApiCommandResult.Void);this.m.registerApiCommand(S)}createNotebookController(o,I,s,u,v,S){for(const de of this.h.values())if(de.controller.id===I&&h.ExtensionIdentifier.equals(o.identifier,de.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const E=this.i++,W=this;this.n.trace(`NotebookController[${E}], CREATED by ${o.identifier.value}, ${I}`);const X=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${o.identifier}'`);let Y=!1;const J=new R.DisposableStore,j=new M.Emitter,U=new M.Emitter,$={id:r(o.identifier,I),notebookType:s,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:u||o.identifier.value,preloads:S?S.map(g.NotebookRendererScript.from):[]};let B=v??X,q;this.a.$addKernel(E,$).catch(de=>{console.log(de),Y=!0});let he=0;const Ee=()=>{if(Y)return;const de=++he;Promise.resolve().then(()=>{de===he&&this.a.$updateKernel(E,$)})},ie=new A.ResourceMap,ce={get id(){return I},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return $.label},set label(de){$.label=de??o.displayName??o.name,Ee()},get detail(){return $.detail??""},set detail(de){$.detail=de,Ee()},get description(){return $.description??""},set description(de){$.description=de,Ee()},get kind(){return(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind??""},set kind(de){(0,m.checkProposedApiEnabled)(o,"notebookControllerKind"),$.kind=de,Ee()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(de){$.supportedLanguages=de,Ee()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(de){$.supportsExecutionOrder=de,Ee()},get rendererScripts(){return $.preloads?$.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(de){B=de??X},get interruptHandler(){return q},set interruptHandler(de){q=de,$.supportsInterrupt=Boolean(de),Ee()},createNotebookCellExecution(de){if(Y)throw new Error("notebook controller is DISPOSED");if(!ie.has(de.notebook.uri))throw W.n.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(Te=>Te.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return W._createNotebookCellExecution(de,r(o.identifier,this.id))},dispose:()=>{Y||(this.n.trace(`NotebookController[${E}], DISPOSED`),Y=!0,this.h.delete(E),J.dispose(),j.dispose(),U.dispose(),this.a.$removeKernel(E))},updateNotebookAffinity(de,Te){Te===d.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(E,de.uri,Te)},onDidReceiveMessage:U.event,postMessage(de,Te){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),W.a.$postMessage(E,Te&&W.l.getIdByEditor(Te),de)},asWebviewUri(de){return(0,m.checkProposedApiEnabled)(o,"notebookMessaging"),(0,t.asWebviewUri)(de,W.k.remote)}};return this.h.set(E,{extensionId:o.identifier,controller:ce,onDidReceiveMessage:U,onDidChangeSelection:j,associatedNotebooks:ie}),ce}getIdByController(o){for(const[I,s]of this.h)if(s.controller===o)return r(s.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,I){const s=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${s}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(s,I);const v={dispose:()=>{this.c.delete(s),u.a.$removeKernelDetectionTask(s)}};return this.c.set(s,v),v}registerKernelSourceActionProvider(o,I,s){const u=this.f++,v=typeof s.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,S=this;this.e.set(u,s),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let E;return v!==void 0&&(E=s.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.e.delete(u),S.a.$removeKernelSourceActionProvider(u,u),E?.dispose()}}}async $provideKernelSourceActions(o,I){const s=this.e.get(o);if(s){const u=new R.DisposableStore;return this.g.add([u]),(await s.provideNotebookKernelSourceActions(I)??[]).map(S=>g.NotebookKernelSourceAction.from(S,this.m.converter,u))}return[]}$acceptNotebookAssociation(o,I,s){const u=this.h.get(o);if(u){const v=this.l.getNotebookDocument(w.URI.revive(I));s?u.associatedNotebooks.set(v.uri,!0):u.associatedNotebooks.delete(v.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,v.uri.toString(),s),u.onDidChangeSelection.fire({selected:s,notebook:v.apiNotebook})}}async $executeCells(o,I,s){const u=this.h.get(o);if(!u)return;const v=this.l.getNotebookDocument(w.URI.revive(I)),S=[];for(const E of s){const W=v.getCell(E);W&&S.push(W.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,v.uri.toString(),S.length),await u.controller.executeHandler.call(u.controller,S,v.apiNotebook,u.controller)}catch(E){this.n.error(`NotebookController[${o}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(o,I,s){const u=this.h.get(o);if(!u)return;const v=this.l.getNotebookDocument(w.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,v.apiNotebook);else for(const S of s){const E=v.getCell(S);E&&this.b.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,I,s){const u=this.h.get(o);if(!u)return;const v=this.l.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:s}))}$cellExecutionChanged(o,I,s){const v=this.l.getNotebookDocument(w.URI.revive(o)).getCell(I);if(v){const S=s?g.NotebookCellExecutionState.to(s):d.NotebookCellExecutionState.Idle;S!==void 0&&this.j.fire({cell:v.apiCell,state:S})}}_createNotebookCellExecution(o,I){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const v=new i(I,u,this.a);this.b.set(u.uri,v);const S=v.onDidChangeState(()=>{v.state===p.Resolved&&(v.dispose(),S.dispose(),this.b.delete(u.uri))});return v.asApiObject()}};T=je([Ve(4,O.ILogService)],T),e.ExtHostNotebookKernels=T;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class i extends R.Disposable{get state(){return this.f}constructor(o,I,s){super(),this.j=I,this.k=s,this.b=i.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.D(new C.CancellationTokenSource),this.h=new l(10,u=>this.m(u)),this.i=I.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const I=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new y.SerializableObjectWithBuffers(I))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}q(o){let I=this.j;if(o&&(I=this.j.notebook.getCellFromApiCell(o)),!I)throw new Error("INVALID cell");return I.handle}r(o){return o.map(I=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return s===I.items?g.NotebookCellOutput.from(I):g.NotebookCellOutput.from({items:s,id:I.id,metadata:I.metadata})})}async s(o,I,s){const u=this.q(I),v=this.r((0,n.asArray)(o));return this.l({editType:a.CellExecutionUpdateType.Output,cellHandle:u,append:s,outputs:v})}async t(o,I,s){return o=d.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(o),!0),this.l({editType:a.CellExecutionUpdateType.OutputItems,items:o.map(g.NotebookCellOutputItem.from),outputId:I.id,append:s})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(s){o.i=s,o.m([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(s){if(o.f===p.Resolved||o.f===p.Started)throw new Error("Cannot call start again");o.f=p.Started,o.c.fire(),o.m({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,u){if(o.f===p.Resolved)throw new Error("Cannot call resolve twice");o.f=p.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new y.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:s}))},clearOutput(s){return o.n(),o.s([],s,!1)},appendOutput(s,u){return o.n(),o.s(s,u,!0)},replaceOutput(s,u){return o.n(),o.s(s,u,!1)},appendOutputItems(s,u){return o.n(),o.t(s,u,!0)},replaceOutputItems(s,u){return o.n(),o.t(s,u,!1)}})}}i.a=0;class l{constructor(o,I){this.d=o,this.e=I,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new P.DeferredPromise,this.b=Date.now(),(0,P.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const I=this.a;return this.a=[],this.e(I).finally(()=>o.complete())}}function r(c,o){return`${c.value}/${o}`}e.createKernelId=r}),define(Ae[231],Re([1,0,5,4,102]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,w){this.c=w,this.a=new Map,this.b=A.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,w,h){const O=this.c.getEditorById(A);this.a.get(w)?.fire({editor:O.apiEditor,message:h})}createRendererMessaging(A,w){if(!A.contributes?.notebookRenderer?.some(O=>O.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(O,D,f)=>this.d(w).event(O,D,f),postMessage:(O,D)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,D]=[D,O]);const f=D&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(f?.id,w,O)}}}d(A){let w=this.a.get(A);return w||(w=new n.Emitter({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(A)}}),this.a.set(A,w),w)}}e.ExtHostNotebookRenderers=M}),define(Ae[232],Re([1,0,6,9,2,26,4]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(h){this.b=new Map,this.a=h.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(h,O,D){if((0,M.checkProposedApiEnabled)(h,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,D),this.a.$registerProfileContentHandler(O,D.name,D.description,h.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(h,O,D,f){const b=this.b.get(h);if(!b)throw new Error(`Unknown handler with id: ${h}`);return b.saveProfile(O,D,f)}async $readProfile(h,O,D){const f=this.b.get(h);if(!f)throw new Error(`Unknown handler with id: ${h}`);return f.readProfile((0,P.isString)(O)?O:C.URI.revive(O),D)}}e.ExtHostProfileContentHandlers=A}),define(Ae[233],Re([1,0,2,4,17,8]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(w,h){this.d=h,this.c=new Map,this.b=w.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(w,h,O){const D=n.URI.revive(h),f=this.c.get(w);return f?(0,C.asPromise)(()=>f.provideOriginalResource(D,O)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(w,h,O,D){const f=R.a++;return this.c.set(f,h),this.b.$registerQuickDiffProvider(f,M.DocumentSelector.from(w,this.d),O,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}R.a=0,e.ExtHostQuickDiff=R}),define(Ae[234],Re([1,0,21,5,6,4,2,7,10,16,29,39,26,8]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(d,t,a){const m=d.getProxy(M.MainContext.MainThreadQuickOpen);class y{constructor(s,u){this.e=new Map,this.f=0,this.a=s,this.b=u}showQuickPick(s,u,v,S=n.CancellationToken.None){this.c=void 0;const E=Promise.resolve(u),W=++this.f,X=m.$show(W,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},S),Y={},J=X.then(()=>Y);return Promise.race([J,E]).then(j=>{if(j===Y)return;const U=(0,f.isProposedApiEnabled)(s,"quickPickItemTooltip");return E.then($=>{const B=[];for(let q=0;q<$.length;q++){const he=$[q];typeof he=="string"?B.push({label:he,handle:q}):he.kind===A.QuickPickItemKind.Separator?B.push({type:"separator",label:he.label}):(he.tooltip&&!U&&console.warn(`Extension '${s.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`),B.push({label:he.label,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:U?b.MarkdownString.fromStrict(he.tooltip):void 0,handle:q}))}return v&&typeof v.onDidSelectItem=="function"&&(this.c=q=>{v.onDidSelectItem($[q])}),m.$setItems(W,B),X.then(q=>{if(typeof q=="number")return $[q];if(Array.isArray(q))return q.map(he=>$[he])})})}).then(void 0,j=>{if(!(0,w.isCancellationError)(j))return m.$setError(W,j),Promise.reject(j)})}$onItemSelected(s){this.c?.(s)}showInput(s,u=n.CancellationToken.None){return this.d=s?.validateInput,m.$input(s,typeof this.d=="function",u).then(void 0,v=>{if(!(0,w.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(s){if(!this.d)return;const u=await this.d(s);if(!u||typeof u=="string")return u;let v;switch(u.severity){case A.InputBoxValidationSeverity.Info:v=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:v=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:v=O.default.Error;break;default:v=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:v}}async showWorkspaceFolderPick(s,u=n.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!v)return;const S=await this.a.getWorkspaceFolders2();if(!!S)return S.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(s){const u=new c(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(s){const u=new o(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(s,u){this.e.get(s)?._fireDidChangeValue(u)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,u){const v=this.e.get(s);v instanceof c&&v._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const v=this.e.get(s);v instanceof c&&v._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){this.e.get(s)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(s,u,v){const S=this.e.get(s);S instanceof c&&S._fireDidTriggerItemButton(u,v)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class T{constructor(s,u){this.x=s,this.y=u,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.Emitter,this.q=new P.Emitter,this.r=new P.Emitter,this.s=new P.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((u,v)=>{const S=u===A.QuickInputButtons.Back?-1:v;this.o.set(S,u)}),this.z({buttons:s.map((u,v)=>({...r(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const u=this.o.get(s);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(s){if(!this.v){for(const u of Object.keys(s)){const v=s[u];this.u[u]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}T.a=1;function p(I){if(I instanceof A.ThemeIcon)return{id:I.id};const s=l(I),u=i(I);return{dark:typeof s=="string"?R.URI.file(s):s,light:typeof u=="string"?R.URI.file(u):u}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function l(I){return typeof I=="object"&&"dark"in I?I.dark:I}function r(I){const s=p(I.iconPath);let u,v;return"id"in s?v=D.ThemeIcon.asClassName(s):u=s,{iconPath:u,iconClass:v}}class c extends T{constructor(s,u){super(s.identifier,u),this.O=s,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.Emitter,this.L=[],this.M=new P.Emitter,this.N=new P.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((S,E)=>{this.C.set(E,S),this.D.set(S,E)});const u=(0,f.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),v=[];for(let S=0;S<s.length;S++){const E=s[S];E.kind===A.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):(E.tooltip&&!u&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),v.push({handle:S,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:u?b.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((W,X)=>({...r(W),tooltip:W.tooltip,handle:X}))}))}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(s){const u=(0,h.coalesce)(s.map(v=>this.C.get(v)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(s){const u=(0,h.coalesce)(s.map(v=>this.C.get(v)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(s,u){const v=this.C.get(s);if(!v||!v.buttons||!v.buttons.length)return;const S=v.buttons[u];S&&this.N.fire({button:S,item:v})}}class o extends T{constructor(s,u){super(s.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:O.default.Error}):this.z({validationMessage:s.message,severity:s.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new y(t,a)}e.createExtHostQuickOpen=g});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Ae[235],Re([1,0,2,5,64,6,17,4,16,125,14,24,39,8,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g){"use strict";var d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(u){if(u)return typeof u.iconPath=="string"?n.URI.file(u.iconPath):n.URI.isUri(u.iconPath)||f.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function m(u,v){if(!u.iconPath&&!v.iconPath)return 0;if(u.iconPath){if(!v.iconPath)return 1}else return-1;const S=typeof u.iconPath=="string"?u.iconPath:n.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,E=typeof v.iconPath=="string"?v.iconPath:n.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,h.comparePaths)(S,E)}function y(u,v){let S=0;if(u.strikeThrough!==v.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==v.faded)return u.faded?1:-1;if(u.tooltip!==v.tooltip)return(u.tooltip||"").localeCompare(v.tooltip||"");if(S=m(u,v),S!==0)return S;if(u.light&&v.light)S=m(u.light,v.light);else{if(u.light)return 1;if(v.light)return-1}if(S!==0)return S;if(u.dark&&v.dark)S=m(u.dark,v.dark);else{if(u.dark)return 1;if(v.dark)return-1}return S}function T(u,v){if(u.command!==v.command)return u.command<v.command?-1:1;if(u.title!==v.title)return u.title<v.title?-1:1;if(u.tooltip!==v.tooltip){if(u.tooltip!==void 0&&v.tooltip!==void 0)return u.tooltip<v.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(u.arguments===v.arguments)return 0;if(u.arguments)if(v.arguments){if(u.arguments.length!==v.arguments.length)return u.arguments.length-v.arguments.length}else return 1;else return-1;for(let S=0;S<u.arguments.length;S++){const E=u.arguments[S],W=v.arguments[S];if(E!==W)return E<W?-1:1}return 0}function p(u,v){let S=(0,h.comparePaths)(u.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(S!==0)return S;if(u.command&&v.command)S=T(u.command,v.command);else{if(u.command)return 1;if(v.command)return-1}if(S!==0)return S;if(u.decorations&&v.decorations)S=y(u.decorations,v.decorations);else{if(u.decorations)return 1;if(v.decorations)return-1}return S}function i(u,v){for(let S=0;S<u.length;S++)if(u[S]!==v[S])return!1;return!0}function l(u,v){return u.command===v.command&&u.title===v.title&&u.tooltip===v.tooltip&&(u.arguments&&v.arguments?i(u.arguments,v.arguments):u.arguments===v.arguments)}function r(u,v){return(0,w.equals)(u,v,l)}class c{get value(){return this.d}set value(v){v=v??"",Ne(this,d,"f").$setInputBoxValue(this.l,v),this.m(v)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(v){Ne(this,d,"f").$setInputBoxPlaceholder(this.l,v),this.f=v}get validateInput(){return(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(v){if((0,g.checkProposedApiEnabled)(this.k,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=v,Ne(this,d,"f").$setValidationProviderIsEnabled(this.l,!!v)}get enabled(){return this.h}set enabled(v){v=!!v,this.h!==v&&(this.h=v,Ne(this,d,"f").$setInputBoxEnablement(this.l,v))}get visible(){return this.j}set visible(v){v=!!v,this.j!==v&&(this.j=v,Ne(this,d,"f").$setInputBoxVisibility(this.l,v))}constructor(v,S,E){this.k=v,this.l=E,d.set(this,void 0),this.d="",this.e=new P.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,S,"f")}showValidationMessage(v,S){(0,g.checkProposedApiEnabled)(this.k,"scmValidation"),Ne(this,d,"f").$showValidationMessage(this.l,v,S)}$onInputBoxValueChange(v){this.m(v)}m(v){this.d=v,this.e.fire(v)}}e.ExtHostSCMInputBox=c,d=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(v){this.v=v,this.q.$updateGroupLabel(this.t,this.handle,v)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(v){this.p=v,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(v){this.f=[...v],this.k.fire()}constructor(v,S,E,W,X){this.q=v,this.s=S,this.t=E,this.u=W,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(v){return this.g.get(v)}$executeResourceCommand(v,S){const E=this.h.get(v);return E?(0,R.asPromise)(()=>this.s.executeCommand(E.command,...E.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this.f].sort(p),E=(0,w.sortedDiff)(this.o,v,p).map(Y=>{const J=Y.toInsert.map(j=>{const U=this.e++;this.g.set(U,j);const $=j.resourceUri;let B;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const V=new M.DisposableStore;B=this.s.converter.toInternal(j.command,V),this.j.set(U,V)}else this.h.set(U,j.command);const q=a(j.decorations),he=j.decorations&&a(j.decorations.light)||q,Ee=j.decorations&&a(j.decorations.dark)||q,ie=[he,Ee],ce=j.decorations&&j.decorations.tooltip||"",de=j.decorations&&!!j.decorations.strikeThrough,Te=j.decorations&&!!j.decorations.faded,le=j.contextValue||"";return{rawResource:[U,$,ie,ce,de,Te,le,B],handle:U}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:J}}),W=E.map(({start:Y,deleteCount:J,toInsert:j})=>[Y,J,j.map(U=>U.rawResource)]),X=E.reverse();for(const{start:Y,deleteCount:J,toInsert:j}of X){const U=j.map(B=>B.handle),$=this.n.splice(Y,J,...U);for(const B of $)this.g.delete(B),this.h.delete(B),this.j.get(B)?.dispose(),this.j.delete(B)}return this.o=v,W}dispose(){this.l=!0,this.m.fire()}}o.d=0;class I{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(v){this.g!==v&&(this.g=v,Ne(this,t,"f").$updateSourceControl(this.t,{count:v}))}get quickDiffProvider(){return this.h}set quickDiffProvider(v){this.h=v,v?.label&&(0,g.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Ne(this,t,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!v,quickDiffLabel:v?.label})}get commitTemplate(){return this.j}set commitTemplate(v){v!==this.j&&(this.j=v,Ne(this,t,"f").$updateSourceControl(this.t,{commitTemplate:v}))}get acceptInputCommand(){return this.l}set acceptInputCommand(v){this.k.value=new M.DisposableStore,this.l=v;const S=this.v.converter.toInternal(v,this.k.value);Ne(this,t,"f").$updateSourceControl(this.t,{acceptInputCommand:S})}get actionButton(){return(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(v){(0,g.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=v;const S=v!==void 0?{command:this.v.converter.toInternal(v.command,this.m.value),secondaryCommands:v.secondaryCommands?.map(E=>E.map(W=>this.v.converter.toInternal(W,this.m.value))),description:v.description,enabled:v.enabled}:void 0;Ne(this,t,"f").$updateSourceControl(this.t,{actionButton:S??null})}get statusBarCommands(){return this.p}set statusBarCommands(v){if(this.p&&v&&r(this.p,v))return;this.o.value=new M.DisposableStore,this.p=v;const S=(v||[]).map(E=>this.v.converter.toInternal(E,this.o.value));Ne(this,t,"f").$updateSourceControl(this.t,{statusBarCommands:S})}get selected(){return this.q}constructor(v,S,E,W,X,Y){this.u=v,this.v=E,this.w=W,this.x=X,this.y=Y,t.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new P.Emitter,this.onDidChangeSelection=this.s.event,this.t=I.d++,this.z=new Map,this.A=new Set,Je(this,t,S,"f"),this.f=new c(v,Ne(this,t,"f"),this.t),Ne(this,t,"f").$registerSourceControl(this.t,W,X,Y)}createResourceGroup(v,S){const E=new o(Ne(this,t,"f"),this.v,this.t,v,S),W=P.Event.once(E.onDidDispose)(()=>this.z.delete(E));return this.z.set(E,W),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const v=[],S=[];for(const[E,W]of this.z){W.dispose();const X=E.onDidUpdateResourceStates(()=>{this.A.add(E),this.eventuallyUpdateResourceStates()});P.Event.once(E.onDidDispose)(()=>{this.A.delete(E),X.dispose(),this.e.delete(E.handle),Ne(this,t,"f").$unregisterGroup(this.t,E.handle)}),v.push([E.handle,E.id,E.label,E.features]);const Y=E._takeResourceStateSnapshot();Y.length>0&&S.push([E.handle,Y]),this.e.set(E.handle,E)}Ne(this,t,"f").$registerGroups(this.t,v,S),this.z.clear()}eventuallyUpdateResourceStates(){const v=[];this.A.forEach(S=>{const E=S._takeResourceStateSnapshot();E.length!==0&&v.push([S.handle,E])}),v.length>0&&Ne(this,t,"f").$spliceResourceStates(this.t,v),this.A.clear()}getResourceGroup(v){return this.e.get(v)}setSelectionState(v){this.q=v,this.s.fire(v)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(v=>v.dispose()),Ne(this,t,"f").$unregisterSourceControl(this.t)}}t=new WeakMap,I.d=0,je([(0,C.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let s=class ln{get onDidChangeActiveProvider(){return this.j.event}constructor(v,S,E){this.l=S,this.m=E,this.g=new Map,this.h=new D.ExtensionIdentifierMap,this.j=new P.Emitter,this.e=v.getProxy(A.MainContext.MainThreadSCM),this.f=v.getProxy(A.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const X=this.g.get(W.sourceControlHandle);if(!X)return W;const Y=X.getResourceGroup(W.groupHandle);return Y?Y.getResourceState(W.handle):W}else if(W&&W.$mid===4){const X=this.g.get(W.sourceControlHandle);return X?X.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const X=this.g.get(W.handle);return X||W}return W}})}createSourceControl(v,S,E,W){this.m.trace("ExtHostSCM#createSourceControl",v.identifier.value,S,E,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const X=ln.d++,Y=new I(v,this.e,this.l,S,E,W);this.g.set(X,Y);const J=this.h.get(v.identifier)||[];return J.push(Y),this.h.set(v.identifier,J),Y}getLastInputBox(v){this.m.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const S=this.h.get(v.identifier),E=S&&S[S.length-1];return E&&E.inputBox}$provideOriginalResource(v,S,E){const W=n.URI.revive(S);this.m.trace("ExtHostSCM#$provideOriginalResource",v,W.toString());const X=this.g.get(v);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>X.quickDiffProvider.provideOriginalResource(W,E)).then(Y=>Y||null)}$onInputBoxValueChange(v,S){this.m.trace("ExtHostSCM#$onInputBoxValueChange",v);const E=this.g.get(v);return E&&E.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(v,S,E,W){this.m.trace("ExtHostSCM#$executeResourceCommand",v,S,E);const X=this.g.get(v);if(!X)return Promise.resolve(void 0);const Y=X.getResourceGroup(S);return Y?Y.$executeResourceCommand(E,W):Promise.resolve(void 0)}$validateInput(v,S,E){this.m.trace("ExtHostSCM#$validateInput",v);const W=this.g.get(v);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>W.inputBox.validateInput(S,E)).then(X=>{if(!X)return Promise.resolve(void 0);const Y=b.MarkdownString.fromStrict(X.message);return Y?Promise.resolve([Y,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this.g.get(v)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=v,Promise.resolve(void 0)}};s.d=0,s=je([Ve(2,O.ILogService)],s),e.ExtHostSCM=s}),define(Ae[80],Re([1,0,4,5,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this.b=new P.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,w){return this.a.$getPassword(A,w)}store(A,w,h){return this.a.$setPassword(A,w,h)}delete(A,w){return this.a.$deletePassword(A,w)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[236],Re([1,0,7,4,147,6,8,9]),function(ee,e,n,P,C,M,R,A){"use strict";var w,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(g,d,t,a,m=n.StatusBarAlignment.Left,y){w.set(this,void 0),h.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,w,g,"f"),Je(this,h,d,"f"),this.c=O.a++,this.e=t,this.f=a,this.g=m,this.h=this.u(y)}u(g){if(!!(0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!O.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof g=="string"?this.r={fromApi:g,internal:Ne(this,h,"f").toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:Ne(this,h,"f").toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,w,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let d;this.m?d=this.m:d=(0,C.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=O.b.get(this.o.id));const a=R.MarkdownString.fromStrict(this.l);Ne(this,w,"f").$setEntry(this.c,g,d,this.k,a,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}w=new WeakMap,h=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class D{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const d={message:g};return this.b.unshift(d),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(d);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(g,d){this.a=g.getProxy(P.MainContext.MainThreadStatusBar),this.b=d,this.c=new D(this)}createStatusBarEntry(g,d,t,a){return new O(this.a,this.b,g,d,t,a)}setStatusBarMessage(g,d){const t=this.c.setMessage(g);let a;return typeof d=="number"?a=setTimeout(()=>t.dispose(),d):typeof d<"u"&&d.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=f}),define(Ae[81],Re([1,0,4,5,3]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,w){this.c=w,this.b=new P.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,w){this.a.$registerExtensionStorageKeysToSync(A,w)}async initializeExtensionStorage(A,w,h){const O=await this.a.$initializeExtensionStorage(A,w);let D;return O&&(D=this.d(A,w,O)),D||h}setValue(A,w,h){return this.a.$setValue(A,w,h)}$acceptValue(A,w,h){const O=this.d(A,w,h);O&&this.b.fire({shared:A,key:w,value:O})}d(A,w,h){try{return JSON.parse(h)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${A}): ${O}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(Ae[82],Re([1,0,3,27,14,60,2]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=class{constructor(h,O,D){this.d=O,this.f=D,this.a=h.workspace??void 0,this.b=h.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(h){return R.URI.joinPath(this.b.workspaceStorageHome,h)}async h(){if(!this.a)return Promise.resolve(void 0);const h=this.a.id,O=await this.g(h);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(h){if(this.c)return R.URI.joinPath(this.c,h.identifier.value)}globalValue(h){return R.URI.joinPath(this.b.globalStorageHome,h.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=je([Ve(0,P.IExtHostInitDataService),Ve(1,C.ILogService),Ve(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ae[61],Re([1,0,5,4,3,2,18,6,7,149,10,175,21,35,176,39,9,17,8]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class y{constructor(s,u,v,S){this.k=s,this._id=u,this.l=v,this.m=S,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(W=>this.f=W);const E=this;this.value={get name(){return E.m||""},get processId(){return E.b},get creationOptions(){return E.l},get exitStatus(){return E.h},get state(){return E.j},sendText(W,X=!0){E.o(),E.k.$sendText(E._id,W,X)},show(W){E.o(),E.k.$show(E._id,W)},hide(){E.o(),E.k.$hide(E._id)},dispose(){E.a||(E.a=!0,E.k.$dispose(E._id))},get dimensions(){if(!(E.d===void 0||E.g===void 0))return{columns:E.d,rows:E.g}}}}async create(s,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:s.name,shellPath:(0,t.withNullAsUndefined)(s.shellPath),shellArgs:(0,t.withNullAsUndefined)(s.shellArgs),cwd:(0,t.withNullAsUndefined)(s.cwd),env:(0,t.withNullAsUndefined)(s.env),icon:(0,t.withNullAsUndefined)(c(s.iconPath)),color:d.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,t.withNullAsUndefined)(s.message),strictEnv:(0,t.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(s.location,u?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,u,v,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:d.ThemeColor.isThemeColor(S)?S.id:void 0,location:this.n(s,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(s,u){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in s?{viewColumn:m.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.m=s}setExitStatus(s,u){this.h=Object.freeze({code:s,reason:u})}setDimensions(s,u){return s===this.d&&u===this.g||s===0||u===0?!1:(this.d=s,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(u=>{u!==s&&(this.b=Promise.resolve(s))})}}e.ExtHostTerminal=y;class T{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,u){this.g.setDimensions?.({columns:s,rows:u})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:""})}}let p=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}get onDidWriteTerminalData(){return this.I.event}constructor(s,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new n.Emitter,this.onDidCloseTerminal=this.z.event,this.C=new n.Emitter,this.onDidOpenTerminal=this.C.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(P.MainContext.MainThreadTerminalService),this.q=new g.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(s),this.D({dispose:()=>{for(const[v,S]of this.g)S.shutdown(!0)}})}getDefaultShell(s){return(s?this.n:this.m)?.path||""}getDefaultShellArgs(s){return(s?this.n:this.m)?.args||[]}createExtensionTerminal(s,u){const v=new y(this.a,(0,b.generateUuid)(),s,s.name),S=new T(s.pty);return v.createExtensionTerminal(s.location,this.L(s,u).resolvedExtHostIdentifier,c(s.iconPath),o(s.color)).then(E=>{const W=this.M(E,S);this.h[E]=W}),this.f.push(v),v.value}L(s,u){if(u=u||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const v=s.location.parentTerminal;if(v){const S=this.f.find(E=>E.value===v);S&&(u.resolvedExtHostIdentifier=S._id)}}else s.location&&typeof s.location!="object"?u.location=s.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(s,u){if(!this.O(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const S=new T(u),E=this.M(s,S);this.h[s]=E}async $acceptActiveTerminalChanged(s){const u=this.b;if(s===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const v=this.O(s);v&&(this.b=v,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(s,u){const v=this.O(s);v&&this.I.fire({terminal:v.value,data:u})}async $acceptTerminalDimensions(s,u,v){const S=this.O(s);S&&S.setDimensions(u,v)&&this.G.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptTerminalMaximumDimensions(s,u,v){this.g.get(s)?.resize(u,v)}async $acceptTerminalTitleChange(s,u){const v=this.O(s);v&&(v.name=u)}async $acceptTerminalClosed(s,u,v){const S=this.Q(this.f,s);if(S!==null){const E=this.f.splice(S,1)[0];E.setExitStatus(u,v),this.z.fire(E.value)}}$acceptTerminalOpened(s,u,v,S){if(u){const X=this.Q(this.f,u);if(X!==null){this.f[X]._id=s,this.C.fire(this.terminals[X]),this.f[X].isOpen=!0;return}}const E={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:M.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},W=new y(this.a,s,E,v);this.f.push(W),this.C.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(s,u){this.O(s)?._setProcessId(u)}async $startExtensionTerminal(s,u){const v=this.O(s);if(!v)return{message:(0,h.localize)(0,null,s)};v.isOpen||await new Promise(E=>{const W=this.onDidOpenTerminal(async X=>{X===v.value&&(W.dispose(),E())})});const S=this.g.get(s);S?S.startSendingEvents(u):this.j[s]={initialDimensions:u}}M(s,u){const v=new A.DisposableStore;v.add(u.onProcessReady(E=>this.a.$sendProcessReady(s,E.pid,E.cwd))),v.add(u.onDidChangeProperty(E=>this.a.$sendProcessProperty(s,E))),this.q.startBuffering(s,u.onProcessData),v.add(u.onProcessExit(E=>this.N(s,E))),this.g.set(s,u);const S=this.j[s];return S&&u instanceof T&&(u.startSendingEvents(S.initialDimensions),delete this.j[s]),v}$acceptProcessAckDataEvent(s,u){this.g.get(s)?.acknowledgeDataEvent(u)}$acceptProcessInput(s,u){this.g.get(s)?.input(u)}$acceptTerminalInteraction(s){const u=this.O(s);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(s,u,v){try{this.g.get(s)?.resize(u,v)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(s,u){this.g.get(s)?.shutdown(u)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(u=>this.a.$sendProcessProperty(s,{type:"cwd",value:u}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.s.add(s),this.s.size===1&&this.a.$startLinkProvider(),new w.Disposable(()=>{this.s.delete(s),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,u,v){if(this.u.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.u.set(u,v),this.a.$registerProfileProvider(u,s.identifier.value),new w.Disposable(()=>{this.u.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(s,u,v){if(this.v.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.v.set(s,v),this.a.$registerQuickFixProvider(s,u),new w.Disposable(()=>{this.v.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,u){const v=new f.CancellationTokenSource().token;if(v.isCancellationRequested)return;const S=this.v.get(s);if(!S)return;const E=await S.provideTerminalQuickFixes(u,v);if(E!==null)return E}async $createContributedProfileTerminal(s,u){const v=new f.CancellationTokenSource().token;let S=await this.u.get(s)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,u);return}this.createTerminalFromOptions(S.options,u)}}async $provideLinks(s,u){const v=this.O(s);if(!v)return[];this.w.delete(s),this.y.get(s)?.dispose(!0);const E=new f.CancellationTokenSource;this.y.set(s,E);const W=[],X={terminal:v.value,line:u},Y=[];for(const U of this.s)Y.push(a.Promises.withAsyncBody(async $=>{E.token.onCancellationRequested(()=>$({provider:U,links:[]}));const B=await U.provideTerminalLinks(X,E.token)||[];E.token.isCancellationRequested||$({provider:U,links:B})}));const J=await Promise.all(Y);if(E.token.isCancellationRequested)return[];const j=new Map;for(const U of J)U&&U.links.length>0&&W.push(...U.links.map($=>{const B={id:p++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return j.set(B.id,{provider:U.provider,link:$}),B}));return this.w.set(s,j),W}$activateLink(s,u){const v=this.w.get(s)?.get(u);!v||v.provider.handleTerminalLink(v.link)}N(s,u){this.q.stopBuffering(s),this.g.delete(s),delete this.j[s];const v=this.h[s];v&&(v.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,u)}O(s){return this.P(this.f,s)}P(s,u){const v=this.Q(s,u);return v!==null?s[v]:null}Q(s,u){let v=null;return s.some((S,E)=>S._id===u?(v=E,!0):!1),v}getEnvironmentVariableCollection(s){let u=this.l.get(s.identifier.value);return u||(u=new l,this.S(s.identifier.value,u)),u}R(s,u){const v=(0,D.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(s,u.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(s){s.forEach(u=>{const v=u[0],S=new l(u[1]);this.S(v,S)})}$acceptDefaultProfile(s,u){const v=this.m;this.m=s,this.n=u,v?.path!==s.path&&this.J.fire(s.path)}S(s,u){this.l.set(s,u),u.onDidChangeCollection(()=>{this.R(s,u)})}};i=je([Ve(1,R.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class l{get persistent(){return this.a}set persistent(s){this.a=s,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(s){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,u){this.d(s,{value:u,type:w.EnvironmentVariableMutatorType.Replace})}append(s,u){this.d(s,{value:u,type:w.EnvironmentVariableMutatorType.Append})}prepend(s,u){this.d(s,{value:u,type:w.EnvironmentVariableMutatorType.Prepend})}d(s,u){const v=this.map.get(s);(!v||v.value!==u.value||v.type!==u.type)&&(this.map.set(s,u),this.b.fire())}get(s){return this.map.get(s)}forEach(s,u){this.map.forEach((v,S)=>s.call(u,S,v,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends i{constructor(s){super(!1,s)}createTerminal(s,u,v){throw new O.NotSupportedError}createTerminalFromOptions(s,u){throw new O.NotSupportedError}};r=je([Ve(0,R.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function o(I){return d.ThemeColor.isThemeColor(I)?I:void 0}});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n};define(Ae[237],Re([1,0,16,17,25,21,5,199,91,6,23,9,35,4,18,103,8,7,45,73,56,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p){"use strict";var i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,$,B){this.j=B,this.c=new R.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(b.MainContext.MainThreadTesting),this.h=new X(this.f),this.g=new s(this.f),$.registerArgumentProcessor({processArgument:q=>{if(q?.$mid!==15)return q;const he=q,Ee=he.tests[he.tests.length-1].item.extId;return this.d.get(m.TestId.root(Ee))?.collection.tree.get(Ee)?.actual??(0,d.toItemFromContext)(q)}})}createTestController(U,$,B,q){if(this.d.has($))throw new Error(`Attempt to insert a duplicate controller with ID "${$}"`);const he=new h.DisposableStore,Ee=he.add(new d.ExtHostTestItemCollection($,B,this.j));Ee.root.label=B;const ie=new Map,ce=this.f,de={items:Ee.root.children,get label(){return B},set label(le){B=le,Ee.root.label=le,ce.$updateController($,{label:B})},get refreshHandler(){return q},set refreshHandler(le){q=le,ce.$updateController($,{canRefresh:!!le})},get id(){return $},createRunProfile:(le,re,V,L,K,me)=>{let Ie=(0,w.hash)(le);for(;ie.has(Ie);)Ie++;return me!==void 0&&(0,p.checkProposedApiEnabled)(U,"testContinuousRun"),new Y(this.f,ie,$,Ie,le,re,V,L,K,me)},createTestItem(le,re,V){return new d.TestItemImpl($,le,re,V)},createTestRun:(le,re,V=!0)=>this.g.createTestRun($,Ee,le,re,V),set resolveHandler(le){Ee.resolveHandler=le},get resolveHandler(){return Ee.resolveHandler},dispose:()=>{he.dispose()}};ce.$registerTestController($,B,!!q),he.add((0,h.toDisposable)(()=>ce.$unregisterTestController($)));const Te={controller:de,collection:Ee,profiles:ie};return this.d.set($,Te),he.add((0,h.toDisposable)(()=>this.d.delete($))),he.add(Ee.onDidGenerateDiff(le=>ce.$publishDiff($,le.map(T.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(U,$=M.CancellationToken.None){const B=u(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.d.get(B.controllerId);if(!q)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(he=>m.TestId.fromExtHostTestItem(he,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:J[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(he=>he.id)},$)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,$,B){return(0,n.mapFind)(this.g.trackers,he=>he.id===U?he.getCoverage($):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(U,$,B,q){return(0,n.mapFind)(this.g.trackers,Ee=>Ee.id===U?Ee.getCoverage($):void 0)?.resolveFileCoverage(B,q)??Promise.resolve([])}$configureRunProfile(U,$){this.d.get(U)?.profiles.get($)?.configureHandler?.()}async $refreshTests(U,$){await this.d.get(U)?.controller.refreshHandler?.($)}$publishTestResults(U){this.results=Object.freeze(U.map($=>(0,O.deepFreeze)(t.TestResults.to($))).concat(this.results).sort(($,B)=>B.completedAt-$.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,$){const B=this.d.get(m.TestId.fromString(U).controllerId)?.collection;B&&(await B.expand(U,$<0?1/0:$),B.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(T.TestsDiffOp.deserialize))}async $runControllerTests(U,$){return Promise.all(U.map(B=>this.k(B,!1,$)))}async $startContinuousRun(U,$){const B=new M.CancellationTokenSource($),q=await Promise.all(U.map(he=>this.k(he,!0,B.token)));return!$.isCancellationRequested&&!q.some(he=>he.error)&&await new Promise(he=>$.onCancellationRequested(he)),B.dispose(!0),q}async k(U,$,B){const q=this.d.get(U.controllerId);if(!q)return{};const{collection:he,profiles:Ee}=q,ie=Ee.get(U.profileId);if(!ie)return{};const ce=U.testIds.map(re=>he.tree.get(re)).filter(D.isDefined),de=U.excludeExtIds.map(re=>q.collection.tree.get(re)).filter(D.isDefined).filter(re=>ce.some(V=>V.fullId.compare(re.fullId)===2));if(!ce.length)return{};const Te=new a.TestRunRequest2(ce.some(re=>re.actual instanceof d.TestItemRootImpl)?void 0:ce.map(re=>re.actual),de.map(re=>re.actual),ie,$),le=(0,T.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(Te,v.fromInternal(U,q.collection),B);try{return await ie.runHandler(Te,B),{}}catch(re){return{error:String(re)}}finally{le&&(le.hasRunningTasks&&!B.isCancellationRequested&&await R.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};r=je([Ve(0,g.IExtHostRpcService)],r),e.ExtHostTesting=r;const c=1e4;var o;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(o||(o={}));class I extends h.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,$,B){super(),this.k=U,this.l=$,this.c=0,this.f=new Map,this.g=new Set,this.j=this.D(new R.Emitter),this.onEnd=this.j.event,this.h=this.D(new M.CancellationTokenSource(B));const q=this.D(new P.RunOnceScheduler(()=>this.m(),c));this.D(this.h.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const $=this.k.id,B=this.k.controllerId,q=(0,f.generateUuid)(),he=new S(this.l,$,q),Ee=Te=>(le,...re)=>{if(ce){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(le)||(this.q(le),Te(le,...re))},ie=(Te,le)=>{const re=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Te.uri&&Te.range){const V={range:t.Range.from(Te.range),uri:Te.uri};for(const L of re)L.location=L.location||V}this.l.$appendTestMessagesInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),re)};let ce=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return he.coverageProvider},set coverageProvider(Te){he.coverageProvider=Te},enqueued:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),1)}),skipped:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),5)}),started:Ee(Te=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),2)}),errored:Ee((Te,le,re)=>{ie(Te,le),this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),6,re)}),failed:Ee((Te,le,re)=>{ie(Te,le),this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,B).toString(),4,re)}),passed:Ee((Te,le)=>{this.l.$updateTestStateInRun($,q,m.TestId.fromExtHostTestItem(Te,this.k.controllerId).toString(),3,le)}),appendOutput:(Te,le,re)=>{ce||(re&&(this.k.isIncluded(re)?this.q(re):re=void 0),this.l.$appendOutputToRun($,q,C.VSBuffer.fromString(Te),le&&t.location.from(le),re&&m.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{ce||(ce=!0,this.l.$finishedTestRunTask($,q),this.f.delete(q),this.f.size||this.p())}};return this.f.set(q,{run:de,coverage:he}),this.l.$startedTestRunTask($,{id:q,name:U,running:!0}),de}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}q(U){if(!(U instanceof d.TestItemImpl))throw new y.InvalidTestItemError(U.id);if(this.g.has(m.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const $=[],B=this.k.colllection.root;for(;;){const q=t.TestItem.from(U);if($.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),U===B))break;U=U.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,$)}}class s{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,$,B){return this.f(U,$,B)}cancelRunById(U){for(const $ of this.c.values())if($.id===U){$.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,$,B,q,he){const Ee=this.c.get(B);if(Ee)return Ee.createRun(q);const ie=v.fromPublic(U,$,B,he),ce=u(B);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!B.continuous,profile:ce&&{group:J[ce.kind],id:ce.profileId},exclude:B.exclude?.map(Te=>m.TestId.fromExtHostTestItem(Te,$.root.id).toString())??[],id:ie.id,include:B.include?.map(Te=>m.TestId.fromExtHostTestItem(Te,$.root.id).toString())??[$.root.id],persist:he});const de=this.f(B,ie);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),de.dispose()}),de.createRun(q)}f(U,$,B){const q=new I($,this.d,B);return this.c.set(U,q),q.onEnd(()=>this.c.delete(U)),q}}e.TestRunCoordinator=s;const u=j=>{if(!!j.profile){if(!(j.profile instanceof Y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class v{static fromPublic(U,$,B,q){return new v(U,(0,f.generateUuid)(),B.include?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[U],B.exclude?.map(he=>m.TestId.fromExtHostTestItem(he,U).toString())??[],q,$)}static fromInternal(U,$){return new v(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,$)}constructor(U,$,B,q,he,Ee){this.controllerId=U,this.id=$,this.isPersisted=he,this.colllection=Ee,this.c=B.map(ie=>ie+"\0"),this.d=q.map(ie=>ie+"\0")}isIncluded(U){const $=m.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if($===B||$.startsWith(B))return!1;for(const B of this.c)if($===B||$.startsWith(B))return!0;return!1}}e.TestRunDto=v;class S{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,$,B){this.f=U,this.g=$,this.h=B}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch($){throw this.d=void 0,$}}async resolveFileCoverage(U,$){const B=await this.d;let q=B?.[U];return!this.c||!B||!q?[]:(q.detailedCoverage||(q=B[U]=await this.c.resolveFileCoverage?.(q,$)??q),q.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const $=m.TestId.parentId(U.item.extId);if($&&this.g.has($.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:$,f:B}=this;return{get added(){return[...U].map(q=>q.revived)},get updated(){return[...$].map(q=>q.revived)},get removed(){return[...B].map(q=>q.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class W extends T.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new R.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,$){return{...U,revived:t.TestItem.toPlain(U.item),depth:$?$.depth+1:0,children:new Set}}o(){return new E(this.q)}}class X{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map($=>$.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new W;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class Y{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ne(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ne(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ne(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ne(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ne(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,$,B,q,he,Ee,ie,ce=!1,de=void 0,Te=!1){this.controllerId=B,this.profileId=q,this.d=he,this.kind=Ee,this.runHandler=ie,this.f=ce,this._tag=de,this.g=Te,i.set(this,void 0),l.set(this,void 0),Je(this,i,U,"f"),Je(this,l,$,"f"),$.set(q,this);const le=J[Ee];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Ee}`);Ne(this,i,"f").$publishTestRunProfile({profileId:q,controllerId:B,tag:de?t.TestTag.namespace(this.controllerId,de.id):null,label:he,group:le,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:Te})}dispose(){Ne(this,l,"f")?.delete(this.profileId)&&(Je(this,l,void 0,"f"),Ne(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Y,i=new WeakMap,l=new WeakMap;const J={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ae[238],Re([1,0,16,10,5,4,104,8,7]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(D,f){this.i=f,this.a=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.b=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.c=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.d=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.f=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.g=new C.Emitter({onListenerError:P.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const f=this.i.allEditors();return D?f:f.map(b=>b.value)}async showTextDocument(D,f,b){let g;typeof f=="number"?g={position:A.ViewColumn.from(f),preserveFocus:b}:typeof f=="object"?g={position:A.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?A.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:g={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(D.uri,g),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,f){return new R.TextEditorDecorationType(this.h,D,f).value}$acceptEditorPropertiesChanged(D,f){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(f.options&&b._acceptOptions(f.options),f.selections){const g=f.selections.selections.map(A.Selection.to);b._acceptSelections(g)}if(f.visibleRanges){const g=n.coalesce(f.visibleRanges.map(A.Range.to));b._acceptVisibleRanges(g)}if(f.options&&this.b.fire({textEditor:b.value,options:{...f.options,lineNumbers:A.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const g=w.TextEditorSelectionChangeKind.fromValue(f.selections.source),d=f.selections.selections.map(A.Selection.to);this.a.fire({textEditor:b.value,selections:d,kind:g})}if(f.visibleRanges){const g=n.coalesce(f.visibleRanges.map(A.Range.to));this.c.fire({textEditor:b.value,visibleRanges:g})}}$acceptEditorPositionData(D){for(const f in D){const b=this.i.getEditor(f);if(!b)throw new Error("Unknown text editor");const g=A.ViewColumn.to(D[f]);b.value.viewColumn!==g&&(b._acceptViewColumn(g),this.d.fire({textEditor:b.value,viewColumn:g}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.ExtHostEditors=h}),define(Ae[239],Re([1,0,2,3,4,6,7,8,24,9]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class O{constructor(b,g){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&w.ExtensionIdentifier.equals(t,this.b.get(d.source)?.extension)){const a=d.uri===void 0?void 0:n.URI.revive(d.uri);return this.c.get(d.source)?.get(D(a))?.get(d.handle)}else return;return d}})}async $getTimeline(b,g,d,t){return this.b.get(b)?.provider.provideTimeline(n.URI.revive(g),d,t)}registerTimelineProvider(b,g,d,t){const a=new M.DisposableStore,m=this.d(g.id,t,a).bind(this);let y;g.onDidChange&&(y=g.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const T=this.c;return this.f({...g,scheme:b,onDidChange:void 0,async provideTimeline(p,i,l){i?.resetCache&&(a.clear(),T.get(g.id)?.clear());const r=await g.provideTimeline(p,i,l);if(r==null)return;const c=m(p,i);return{...r,source:g.id,items:r.items.map(c)}},dispose(){for(const p of T.values())p.get(g.id)?.clear();y?.dispose(),a.dispose()}},d)}d(b,g,d){return(t,a)=>{let m;if(a?.cacheResults){let y=this.c.get(b);y===void 0&&(y=new Map,this.c.set(b,y));const T=D(t);m=y.get(T),m===void 0&&(m=new Map,y.set(T,m))}return y=>{const{iconPath:T,...p}=y,i=`${b}|${y.id??y.timestamp}`;m?.set(i,y);let l,r,c;y.iconPath&&(T instanceof R.ThemeIcon?c={id:T.id,color:T.color}:n.URI.isUri(T)?(l=T,r=T):{light:l,dark:r}=T);let o;return R.MarkdownString.isMarkdownString(p.tooltip)?o=A.MarkdownString.from(p.tooltip):(0,h.isString)(p.tooltip)?o=p.tooltip:R.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=A.MarkdownString.from(p.detail)):(0,h.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=p.detail),{...p,id:p.id??void 0,handle:i,source:b,command:y.command?g.toInternal(y.command,d):void 0,icon:l,iconDark:r,themeIcon:c,tooltip:o,accessibilityInformation:y.accessibilityInformation}}}}f(b,g){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:g}),(0,M.toDisposable)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=O;function D(f){return f?.toString()}}),define(Ae[240],Re([1,0,6,15,2,4]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(w){this.c=new Map,this.b=w.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,h,O,D){if(this.c.has(h))throw new Error(`Opener with id '${h}' already registered`);const f=D.schemes.find(b=>!R.a.has(b));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(h,O),this.b.$registerUriOpener(h,D.schemes,w,D.label),(0,n.toDisposable)(()=>{this.c.delete(h),this.b.$unregisterUriOpener(h)})}async $canOpenUri(w,h,O){const D=this.c.get(w);if(!D)throw new Error(`Unknown opener with id: ${w}`);const f=C.URI.revive(h);return D.canOpenExternalUri(f,O)}async $openUri(w,h,O){const D=this.c.get(w);if(!D)throw new Error(`Unknown opener id: '${w}'`);return D.openExternalUri(C.URI.revive(h.resolvedUri),{sourceUri:C.URI.revive(h.sourceUri)},O)}}R.a=new Set([P.Schemas.http,P.Schemas.https]),e.ExtHostUriOpeners=R}),define(Ae[241],Re([1,0,4,2,6,10,24]),function(ee,e,n,P,C,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(h){this.c=new R.ExtensionIdentifierSet,this.d=new Map,this.b=h.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(h,O){if(this.c.has(h))throw new Error(`Protocol handler already registered for extension ${h}`);const D=A.a++;return this.c.add(h),this.d.set(D,O),this.b.$registerUriHandler(D,h),(0,C.toDisposable)(()=>{this.c.delete(h),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(h,O){const D=this.d.get(h);if(!D)return Promise.resolve(void 0);try{D.handleUri(P.URI.revive(O))}catch(f){(0,M.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(h){return P.URI.revive(await this.b.$createAppUri(h))}}A.a=0,e.ExtHostUrls=A});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[62],Re([1,0,5,15,23,2,162,185,74,4]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";var O,D,f,b,g,d,t,a,m,y,T,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(E,W,X,Y,J,j,U){O.set(this,void 0),D.set(this,void 0),f.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,""),a.set(this,void 0),m.set(this,!1),y.set(this,!1),T.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Ne(this,i,"f").event,Je(this,O,E,"f"),Je(this,D,W,"f"),Je(this,a,X,"f"),Je(this,b,Y,"f"),Je(this,g,J,"f"),Je(this,d,j,"f"),Je(this,T,r(j),"f"),Je(this,p,c(j),"f"),Je(this,f,U,"f")}dispose(){Je(this,m,!0,"f"),Ne(this,i,"f").fire(),Ne(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return Je(this,y,!0,"f"),(0,w.asWebviewUri)(E,Ne(this,b,"f"))}get cspSource(){const E=Ne(this,d,"f").extensionLocation;if(E.scheme===P.Schemas.https||E.scheme===P.Schemas.http){let W=E.toString();return W.endsWith("/")||(W+="/"),W+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.a(),Ne(this,t,"f")}set html(E){this.a(),Ne(this,t,"f")!==E&&(Je(this,t,E,"f"),Ne(this,p,"f")&&!Ne(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(Je(this,y,!0,"f"),Ne(this,f,"f").report("Webview vscode-resource: uris",Ne(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,D,"f").$setHtml(Ne(this,O,"f"),this.b(E)))}get options(){return this.a(),Ne(this,a,"f")}set options(E){this.a(),C.equals(Ne(this,a,"f"),E)||Ne(this,D,"f").$setOptions(Ne(this,O,"f"),s(Ne(this,d,"f"),Ne(this,g,"f"),E)),Je(this,a,E,"f")}async postMessage(E){if(Ne(this,m,"f"))return!1;const W=(0,A.serializeWebviewMessage)(E,{serializeBuffersForPostMessage:Ne(this,T,"f")});return Ne(this,D,"f").$postMessage(Ne(this,O,"f"),W.message,...W.buffers)}a(){if(Ne(this,m,"f"))throw new Error("Webview is disposed")}b(E){if(!Ne(this,p,"f"))return E;const W=Ne(this,d,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,X=Ne(this,d,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ne(this,d,"f").extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,J,j,U,$,B)=>{const q=M.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(q,{isRemote:W,authority:X}).toString();return`${J}${he}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Y,J,j,U,$,B)=>{const q=M.URI.from({scheme:U||"file",path:decodeURIComponent($)}),he=(0,w.asWebviewUri)(q,{isRemote:W,authority:X}).toString();return`${J}${he}${B}`})}}e.ExtHostWebview=l,O=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,y=new WeakMap,T=new WeakMap,p=new WeakMap,i=new WeakMap;function r(S){try{const E=(0,R.normalizeVersion)((0,R.parseVersion)(S.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(S){try{const E=(0,R.normalizeVersion)((0,R.parseVersion)(S.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class o{constructor(E,W,X,Y,J){this.c=W,this.d=X,this.e=Y,this.f=J,this.b=new Map,this.a=E.getProxy(h.MainContext.MainThreadWebviews)}$onMessage(E,W,X){const Y=this.g(E);if(Y){const{message:J}=(0,A.deserializeWebviewMessage)(W,X.value);Y._onMessageEmitter.fire(J)}}$onMissingCsp(E,W){this.e.warn(`${W} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,W,X){const Y=new l(E,this.a,u(W),this.c,this.d,X,this.f);return this.b.set(E,Y),Y._onDidDispose(()=>{this.b.delete(E)}),Y}deleteWebview(E){this.b.delete(E)}g(E){return this.b.get(E)}}e.ExtHostWebviews=o;function I(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=I;function s(S,E,W){return{enableCommandUris:W.enableCommandUris,enableScripts:W.enableScripts,enableForms:W.enableForms,portMapping:W.portMapping,localResourceRoots:W.localResourceRoots||v(S,E)}}e.serializeWebviewOptions=s;function u(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(E=>M.URI.from(E))}}function v(S,E){return[...(E?.getWorkspaceFolders()||[]).map(W=>W.uri),S.extensionLocation]}}),define(Ae[242],Re([1,0,21,91,6,15,22,2,8,62,54,4,7]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this.a++;return(0,R.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class g{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,c){const o=this.b(l,r.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const I=new b(r,c);return this.a.set(o,I),I}delete(l,r){const c=this.b(l,r.uri);this.a.delete(c)}b(l,r){return`${l}@@@${r}`}}var d;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(l,r,c){return this.b(0,l,r,c)}addCustomProvider(l,r,c){return this.b(1,l,r,c)}get(l){return this.a.get(l)}b(l,r,c,o){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:c,provider:o}),new f.Disposable(()=>this.a.delete(r))}}class a{constructor(l,r,c,o,I){this.d=r,this.f=c,this.g=o,this.h=I,this.b=new t,this.c=new g,this.a=l.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,c,o){const I=new C.DisposableStore;return y(c)?(I.add(this.b.addTextProvider(r,l,c)),this.a.$registerTextEditorProvider((0,h.toExtensionData)(l),r,o.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,h.shouldSerializeBuffersForPostMessage)(l))):(I.add(this.b.addCustomProvider(r,l,c)),m(c)&&I.add(c.onDidChangeCustomDocument(s=>{const u=this.i(r,s.document.uri);if(T(s)){const v=u.addEdit(s);this.a.$onDidEdit(s.document.uri,r,v,s.label)}else this.a.$onContentChange(s.document.uri,r)})),this.a.$registerCustomEditorProvider((0,h.toExtensionData)(l),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,h.shouldSerializeBuffersForPostMessage)(l))),f.Disposable.from(I,new f.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,c,o,I){const s=this.b.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${r}'`);const u=A.URI.revive(l),v=await s.provider.openCustomDocument(u,{backupId:c,untitledDocumentData:o?.buffer},I);let S;return m(s.provider)&&this.f&&(S=this.f.workspaceValue(s.extension)??this.f.globalValue(s.extension)),this.c.add(r,v,S),{editable:m(s.provider)}}async $disposeCustomDocument(l,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=A.URI.revive(l),{document:I}=this.i(r,o);this.c.delete(r,I),I.dispose()}async $resolveCustomEditor(l,r,c,o,I,s){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);const v=w.ViewColumn.to(I),S=this.g.createNewWebview(r,o.contentOptions,u.extension),E=this.h.createNewWebviewPanel(r,c,o.title,v,o.options,S,!0),W=A.URI.revive(l);switch(u.type){case 1:{const{document:X}=this.i(c,W);return u.provider.resolveCustomEditor(X,E,s)}case 0:{const X=this.d.getDocument(W);return u.provider.resolveCustomTextEditor(X,E,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,c){this.i(r,l).disposeEdits(c)}async $onMoveCustomEditor(l,r,c){const o=this.b.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const I=this.h.getWebviewPanel(l);if(!I)throw new Error("No webview found");const s=A.URI.revive(r),u=this.d.getDocument(s);await o.provider.moveCustomTextEditor(u,I,n.CancellationToken.None)}async $undo(l,r,c,o){return this.i(r,l).undo(c,o)}async $redo(l,r,c,o){return this.i(r,l).redo(c,o)}async $revert(l,r,c){const o=this.i(r,l);await this.j(r).revertCustomDocument(o.document,c),o.disposeBackup()}async $onSave(l,r,c){const o=this.i(r,l);await this.j(r).saveCustomDocument(o.document,c),o.disposeBackup()}async $onSaveAs(l,r,c,o){const I=this.i(r,l);return this.j(r).saveCustomDocumentAs(I.document,A.URI.revive(c),o)}async $backup(l,r,c){const o=this.i(r,l),s=await this.j(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},c);return o.updateBackup(s),s.id}i(l,r){const c=this.c.get(l,A.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(l){const c=this.b.get(l)?.provider;if(!c||!m(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=a;function m(i){return!!i.onDidChangeCustomDocument}function y(i){return typeof i.resolveCustomTextEditor=="function"}function T(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const l=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,P.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[243],Re([1,0,5,6,2,35,8,62,4,7]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";var O,D,f,b,g,d,t,a,m,y,T,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends P.Disposable{constructor(I,s,u,v){super(),O.set(this,void 0),D.set(this,void 0),f.set(this,void 0),b.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,void 0),m.set(this,!0),y.set(this,void 0),T.set(this,!1),p.set(this,this.D(new n.Emitter)),this.onDidDispose=Ne(this,p,"f").event,i.set(this,this.D(new n.Emitter)),this.onDidChangeViewState=Ne(this,i,"f").event,Je(this,O,I,"f"),Je(this,D,s,"f"),Je(this,b,u,"f"),Je(this,f,v.viewType,"f"),Je(this,g,v.panelOptions,"f"),Je(this,a,v.viewColumn,"f"),Je(this,d,v.title,"f"),Je(this,y,v.active,"f")}dispose(){Ne(this,T,"f")||(Je(this,T,!0,"f"),Ne(this,p,"f").fire(),Ne(this,D,"f").$disposeWebview(Ne(this,O,"f")),Ne(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,b,"f")}get viewType(){return this.c(),Ne(this,f,"f")}get title(){return this.c(),Ne(this,d,"f")}set title(I){this.c(),Ne(this,d,"f")!==I&&(Je(this,d,I,"f"),Ne(this,D,"f").$setTitle(Ne(this,O,"f"),I))}get iconPath(){return this.c(),Ne(this,t,"f")}set iconPath(I){this.c(),Ne(this,t,"f")!==I&&(Je(this,t,I,"f"),Ne(this,D,"f").$setIconPath(Ne(this,O,"f"),C.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Ne(this,g,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,a,"f")=="number"&&Ne(this,a,"f")<0))return Ne(this,a,"f")}get active(){return this.c(),Ne(this,y,"f")}get visible(){return this.c(),Ne(this,m,"f")}_updateViewState(I){Ne(this,T,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Je(this,y,I.active,"f"),Je(this,m,I.visible,"f"),Je(this,a,I.viewColumn,"f"),Ne(this,i,"f").fire({webviewPanel:this}))}reveal(I,s){this.c(),Ne(this,D,"f").$reveal(Ne(this,O,"f"),{viewColumn:typeof I>"u"?void 0:R.ViewColumn.from(I),preserveFocus:!!s})}c(){if(Ne(this,T,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap,y=new WeakMap,T=new WeakMap,p=new WeakMap,i=new WeakMap;class r{static c(){return(0,M.generateUuid)()}constructor(I,s,u){this.g=s,this.h=u,this.e=new Map,this.f=new Map,this.d=I.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,s,u,v,S={}){const E=typeof v=="object"?v.viewColumn:v,W={viewColumn:R.ViewColumn.from(E),preserveFocus:typeof v=="object"&&!!v.preserveFocus},X=(0,A.shouldSerializeBuffersForPostMessage)(I),Y=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(I),Y,s,{title:u,panelOptions:c(S),webviewOptions:(0,A.serializeWebviewOptions)(I,this.h,S),serializeBuffersForPostMessage:X},W);const J=this.g.createNewWebview(Y,S,I);return this.createNewWebviewPanel(Y,s,u,E,S,J,!0)}$onDidChangeWebviewPanelViewStates(I){const s=Object.keys(I);s.sort((u,v)=>{const S=I[u],E=I[v];return S.active?1:E.active?-1:+S.visible-+E.visible});for(const u of s){const v=this.getWebviewPanel(u);if(!v)continue;const S=I[u];v._updateViewState({active:S.active,visible:S.visible,viewColumn:R.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this.e.delete(I),this.g.deleteWebview(I)}registerWebviewPanelSerializer(I,s,u){if(this.f.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.f.set(s,{serializer:u,extension:I}),this.d.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(I)}),new h.Disposable(()=>{this.f.delete(s),this.d.$unregisterSerializer(s)})}async $deserializeWebviewPanel(I,s,u,v){const S=this.f.get(s);if(!S)throw new Error(`No serializer found for '${s}'`);const{serializer:E,extension:W}=S,X=this.g.createNewWebview(I,u.webviewOptions,W),Y=this.createNewWebviewPanel(I,s,u.title,v,u.panelOptions,X,u.active);await E.deserializeWebviewPanel(Y,u.state)}createNewWebviewPanel(I,s,u,v,S,E,W){const X=new l(I,this.d,E,{viewType:s,title:u,viewColumn:v,panelOptions:S,active:W});return this.e.set(I,X),X}getWebviewPanel(I){return this.e.get(I)}}e.ExtHostWebviewPanels=r;function c(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[244],Re([1,0,5,6,62,8,4,7]),function(ee,e,n,P,C,M,R,A){"use strict";var w,h,O,D,f,b,g,d,t,a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends P.Disposable{constructor(i,l,r,c,o,I){super(),w.set(this,void 0),h.set(this,void 0),O.set(this,void 0),D.set(this,void 0),f.set(this,!1),b.set(this,void 0),g.set(this,void 0),d.set(this,void 0),t.set(this,void 0),a.set(this,this.D(new n.Emitter)),this.onDidChangeVisibility=Ne(this,a,"f").event,m.set(this,this.D(new n.Emitter)),this.onDidDispose=Ne(this,m,"f").event,Je(this,O,r,"f"),Je(this,g,c,"f"),Je(this,w,i,"f"),Je(this,h,l,"f"),Je(this,D,o,"f"),Je(this,b,I,"f")}dispose(){Ne(this,f,"f")||(Je(this,f,!0,"f"),Ne(this,m,"f").fire(),Ne(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,g,"f")}set title(i){this.a(),Ne(this,g,"f")!==i&&(Je(this,g,i,"f"),Ne(this,h,"f").$setWebviewViewTitle(Ne(this,w,"f"),i))}get description(){return this.a(),Ne(this,d,"f")}set description(i){this.a(),Ne(this,d,"f")!==i&&(Je(this,d,i,"f"),Ne(this,h,"f").$setWebviewViewDescription(Ne(this,w,"f"),i))}get visible(){return Ne(this,b,"f")}get webview(){return Ne(this,D,"f")}get viewType(){return Ne(this,O,"f")}_setVisible(i){i===Ne(this,b,"f")||Ne(this,f,"f")||(Je(this,b,i,"f"),Ne(this,a,"f").fire())}get badge(){return this.a(),Ne(this,t,"f")}set badge(i){this.a(),!(i?.value===Ne(this,t,"f")?.value&&i?.tooltip===Ne(this,t,"f")?.tooltip)&&(Je(this,t,M.ViewBadge.from(i),"f"),Ne(this,h,"f").$setWebviewViewBadge(Ne(this,w,"f"),i))}show(i){this.a(),Ne(this,h,"f").$show(Ne(this,w,"f"),!!i)}a(){if(Ne(this,f,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,h=new WeakMap,O=new WeakMap,D=new WeakMap,f=new WeakMap,b=new WeakMap,g=new WeakMap,d=new WeakMap,t=new WeakMap,a=new WeakMap,m=new WeakMap;class T{constructor(i,l){this.d=l,this.b=new Map,this.c=new Map,this.a=i.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,l,r,c){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:r,extension:i}),this.a.$registerWebviewViewProvider((0,C.toExtensionData)(i),l,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(i,l,r,c,o){const I=this.b.get(l);if(!I)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:u}=I,v=this.d.createNewWebview(i,{},u),S=new y(i,this.a,l,r,v,!0);this.c.set(i,S),await s.resolveWebviewView(S,{state:c},o)}async $onDidChangeWebviewViewVisibility(i,l){this.e(i)._setVisible(l)}async $disposeWebviewView(i){const l=this.e(i);this.c.delete(i),l.dispose(),this.d.deleteWebview(i)}e(i){const l=this.c.get(i);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=T}),define(Ae[106],Re([1,0,5,4,2,15,13,3,18]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let h=class dn{get state(){return this.d}constructor(D){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=dn.a,this.b=D.getProxy(P.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,f){let b;if(typeof D=="string"){b=D;try{D=C.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,R.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,b,f)}async asExternalUri(D,f){if((0,R.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(D,f);return C.URI.from(b)}};h.a={focused:!0},h=je([Ve(0,w.IExtHostRpcService)],h),e.ExtHostWindow=h,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ae[245],Re([1,0,214,27,18]),function(ee,e,n,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(A,w){super(A,w)}f(A,w,h){w.apply(console,h)}};M=je([Ve(0,C.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ae[246],Re([1,0,17,25,21,10,5,6,129,208,46]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function f(S,E){try{return JSON.stringify(S,E)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class d{constructor(E,W){this.jsonString=E,this.referencedBuffers=W}}function t(S,E=null,W=!1){const X=[];return{jsonString:(W?f:JSON.stringify)(S,(J,j)=>{if(typeof j>"u")return g;if(typeof j=="object"){if(j instanceof P.VSBuffer){const U=X.push(j)-1;return{[b]:U}}if(E)return E(J,j)}return j}),referencedBuffers:X}}e.stringifyJsonWithBufferRefs=t;function a(S,E,W){return JSON.parse(S,(X,Y)=>{if(Y){const J=Y[b];if(typeof J=="number")return E[J];if(W&&Y.$mid===1)return W.transformIncoming(Y)}return Y})}e.parseJsonAndRestoreBufferRefs=a;function m(S,E){return JSON.stringify(S,E)}function y(S){return S?(E,W)=>W&&W.$mid===1?S.transformOutgoing(W):W:null}var T;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(T=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends A.Disposable{constructor(E,W=null,X=null){super(),this[D]=!0,this.b=this.D(new R.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=E,this.f=W,this.g=X,this.h=y(this.g),this.j=!1,this.k=[],this.l=[];for(let Y=0,J=O.ProxyIdentifier.count;Y<J;Y++)this.k[Y]=null,this.l[Y]=null;this.m=0,this.p=Object.create(null),this.q={},this.s=0,this.t=0,this.u=0,this.v=this.D(new n.RunOnceScheduler(()=>this.z(),1e3)),this.c.onMessage(Y=>this.G(Y))}dispose(){this.j=!0,Object.keys(this.q).forEach(E=>{this.q[E].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}w(E){this.t===0&&(this.u=Date.now()+c.a),this.t++,this.v.isScheduled()||this.v.schedule()}y(E){this.u=Date.now()+c.a,this.t--,this.t===0&&this.v.cancel(),this.C(0)}z(){this.t!==0&&(Date.now()>this.u?this.C(1):this.v.schedule())}C(E){this.s!==E&&(this.s=E,this.b.fire(this.s))}get responsiveState(){return this.s}transformIncomingURIs(E){return this.g?(0,w.transformIncomingURIs)(E,this.g):E}getProxy(E){const{nid:W,sid:X}=E;return this.l[W]||(this.l[W]=this.F(W,X)),this.l[W]}F(E,W){const X={get:(Y,J)=>(typeof J=="string"&&!Y[J]&&J.charCodeAt(0)===36&&(Y[J]=(...j)=>this.O(E,J,j)),J===r?W:Y[J])};return new Proxy(Object.create(null),X)}set(E,W){return this.k[E.nid]=W,W}assertRegistered(E){for(let W=0,X=E.length;W<X;W++){const Y=E[W];if(!this.k[Y.nid])throw new Error(`Missing proxy instance ${Y.sid}`)}}G(E){if(this.j)return;const W=E.byteLength,X=o.read(E,0),Y=X.readUInt8(),J=X.readUInt32();switch(Y){case 1:case 2:{let{rpcId:j,method:U,args:$}=s.deserializeRequestJSONArgs(X);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,j,U,$,Y===2);break}case 3:case 4:{let{rpcId:j,method:U,args:$}=s.deserializeRequestMixedArgs(X);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.H(W,J,j,U,$,Y===4);break}case 5:{this.f?.logIncoming(W,J,0,"ack"),this.y(J);break}case 6:{this.I(W,J);break}case 7:{this.J(W,J,void 0);break}case 9:{let j=s.deserializeReplyOKJSON(X);this.g&&(j=(0,w.transformIncomingURIs)(j,this.g)),this.J(W,J,j);break}case 10:{const j=s.deserializeReplyOKJSONWithBuffers(X,this.g);this.J(W,J,j);break}case 8:{const j=s.deserializeReplyOKVSBuffer(X);this.J(W,J,j);break}case 11:{let j=s.deserializeReplyErrError(X);this.g&&(j=(0,w.transformIncomingURIs)(j,this.g)),this.L(W,J,j);break}case 12:{this.L(W,J,void 0);break}default:console.error("received unexpected message"),console.error(E)}}H(E,W,X,Y,J,j){this.f?.logIncoming(E,W,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(X)}.${Y}(`,J);const U=String(W);let $,B;if(j){const he=new C.CancellationTokenSource;J.push(he.token),$=this.M(X,Y,J),B=()=>he.cancel()}else $=this.M(X,Y,J),B=i;this.p[U]=B;const q=s.serializeAcknowledged(W);this.f?.logOutgoing(q.byteLength,W,1,"ack"),this.c.send(q),$.then(he=>{delete this.p[U];const Ee=s.serializeReplyOK(W,he,this.h);this.f?.logOutgoing(Ee.byteLength,W,1,"reply:",he),this.c.send(Ee)},he=>{delete this.p[U];const Ee=s.serializeReplyErr(W,he);this.f?.logOutgoing(Ee.byteLength,W,1,"replyErr:",he),this.c.send(Ee)})}I(E,W){this.f?.logIncoming(E,W,1,"receiveCancel");const X=String(W);this.p[X]?.()}J(E,W,X){this.f?.logIncoming(E,W,0,"receiveReply:",X);const Y=String(W);if(!this.q.hasOwnProperty(Y))return;const J=this.q[Y];delete this.q[Y],J.resolveOk(X)}L(E,W,X){this.f?.logIncoming(E,W,0,"receiveReplyErr:",X);const Y=String(W);if(!this.q.hasOwnProperty(Y))return;const J=this.q[Y];delete this.q[Y];let j;X&&(X.$isError?(j=new Error,j.name=X.name,j.message=X.message,j.stack=X.stack):j=X),J.resolveErr(j)}M(E,W,X){try{return Promise.resolve(this.N(E,W,X))}catch(Y){return Promise.reject(Y)}}N(E,W,X){const Y=this.k[E];if(!Y)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(E));const J=Y[W];if(typeof J!="function")throw new Error("Unknown method "+W+" on actor "+(0,O.getStringIdentifierForProxy)(E));return J.apply(Y,X)}O(E,W,X){if(this.j)return new h.CanceledLazyPromise;let Y=null;if(X.length>0&&C.CancellationToken.isCancellationToken(X[X.length-1])&&(Y=X.pop()),Y&&Y.isCancellationRequested)return Promise.reject(M.canceled());const J=s.serializeRequestArguments(X,this.h),j=++this.m,U=String(j),$=new h.LazyPromise;Y&&Y.onCancellationRequested(()=>{const q=s.serializeCancel(j);this.f?.logOutgoing(q.byteLength,j,0,"cancel"),this.c.send(s.serializeCancel(j))}),this.q[U]=$,this.w(j);const B=s.serializeRequest(j,E,W,J,!!Y);return this.f?.logOutgoing(B.byteLength,j,0,`request: ${(0,O.getStringIdentifierForProxy)(E)}.${W}(`,X),this.c.send(B),$}}D=l,c.a=3*1e3,e.RPCProtocol=c;class o{static alloc(E,W,X){const Y=new o(P.VSBuffer.alloc(X+1+4),0);return Y.writeUInt8(E),Y.writeUInt32(W),Y}static read(E,W){return new o(E,W)}get buffer(){return this.a}constructor(E,W){this.a=E,this.b=W}static sizeUInt8(){return 1}writeUInt8(E){this.a.writeUInt8(E,this.b),this.b+=1}readUInt8(){const E=this.a.readUInt8(this.b);return this.b+=1,E}writeUInt32(E){this.a.writeUInt32BE(E,this.b),this.b+=4}readUInt32(){const E=this.a.readUInt32BE(this.b);return this.b+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this.a.writeUInt8(E.byteLength,this.b),this.b+=1,this.a.set(E,this.b),this.b+=E.byteLength}readShortString(){const E=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+E).toString();return this.b+=E,X}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readLongString(){const E=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+E).toString();return this.b+=E,X}writeBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readVSBuffer(){const E=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+E);return this.b+=E,W}static sizeMixedArray(E){let W=0;W+=1;for(let X=0,Y=E.length;X<Y;X++){const J=E[X];switch(W+=1,J.type){case 1:W+=this.sizeLongString(J.value);break;case 2:W+=this.sizeVSBuffer(J.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(J.value);for(let j=0;j<J.buffers.length;++j)W+=this.sizeVSBuffer(J.buffers[j]);break;case 4:break}}return W}writeMixedArray(E){this.a.writeUInt8(E.length,this.b),this.b+=1;for(let W=0,X=E.length;W<X;W++){const Y=E[W];switch(Y.type){case 1:this.writeUInt8(1),this.writeLongString(Y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Y.buffers.length),this.writeLongString(Y.value);for(let J=0;J<Y.buffers.length;++J)this.writeBuffer(Y.buffers[J]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this.a.readUInt8(this.b);this.b+=1;const W=new Array(E);for(let X=0;X<E;X++)switch(this.readUInt8()){case 1:W[X]=this.readLongString();break;case 2:W[X]=this.readVSBuffer();break;case 3:{const J=this.readUInt32(),j=this.readLongString(),U=[];for(let $=0;$<J;++$)U.push(this.readVSBuffer());W[X]=new O.SerializableObjectWithBuffers(a(j,U,null));break}case 4:W[X]=void 0;break}return W}}o.sizeUInt32=4;var I;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(I||(I={}));class s{static a(E){for(let W=0,X=E.length;W<X;W++)if(E[W]instanceof P.VSBuffer||E[W]instanceof O.SerializableObjectWithBuffers||typeof E[W]>"u")return!0;return!1}static serializeRequestArguments(E,W){if(this.a(E)){const X=[];for(let Y=0,J=E.length;Y<J;Y++){const j=E[Y];if(j instanceof P.VSBuffer)X[Y]={type:2,value:j};else if(typeof j>"u")X[Y]={type:4};else if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:$}=t(j.value,W);X[Y]={type:3,value:P.VSBuffer.fromString(U),buffers:$}}else X[Y]={type:1,value:P.VSBuffer.fromString(m(j,W))}}return{type:1,args:X}}return{type:0,args:m(E,W)}}static serializeRequest(E,W,X,Y,J){switch(Y.type){case 0:return this.b(E,W,X,Y.args,J);case 1:return this.c(E,W,X,Y.args,J)}}static b(E,W,X,Y,J){const j=P.VSBuffer.fromString(X),U=P.VSBuffer.fromString(Y);let $=0;$+=o.sizeUInt8(),$+=o.sizeShortString(j),$+=o.sizeLongString(U);const B=o.alloc(J?2:1,E,$);return B.writeUInt8(W),B.writeShortString(j),B.writeLongString(U),B.buffer}static deserializeRequestJSONArgs(E){const W=E.readUInt8(),X=E.readShortString(),Y=E.readLongString();return{rpcId:W,method:X,args:JSON.parse(Y)}}static c(E,W,X,Y,J){const j=P.VSBuffer.fromString(X);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(j),U+=o.sizeMixedArray(Y);const $=o.alloc(J?4:3,E,U);return $.writeUInt8(W),$.writeShortString(j),$.writeMixedArray(Y),$.buffer}static deserializeRequestMixedArgs(E){const W=E.readUInt8(),X=E.readShortString(),Y=E.readMixedArray(),J=new Array(Y.length);for(let j=0,U=Y.length;j<U;j++){const $=Y[j];typeof $=="string"?J[j]=JSON.parse($):J[j]=$}return{rpcId:W,method:X,args:J}}static serializeAcknowledged(E){return o.alloc(5,E,0).buffer}static serializeCancel(E){return o.alloc(6,E,0).buffer}static serializeReplyOK(E,W,X){if(typeof W>"u")return this.d(E);if(W instanceof P.VSBuffer)return this.e(E,W);if(W instanceof O.SerializableObjectWithBuffers){const{jsonString:Y,referencedBuffers:J}=t(W.value,X,!0);return this.g(E,Y,J)}else return this.f(E,f(W,X))}static d(E){return o.alloc(7,E,0).buffer}static e(E,W){let X=0;X+=o.sizeVSBuffer(W);const Y=o.alloc(8,E,X);return Y.writeVSBuffer(W),Y.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static f(E,W){const X=P.VSBuffer.fromString(W);let Y=0;Y+=o.sizeLongString(X);const J=o.alloc(9,E,Y);return J.writeLongString(X),J.buffer}static g(E,W,X){const Y=P.VSBuffer.fromString(W);let J=0;J+=o.sizeUInt32,J+=o.sizeLongString(Y);for(const U of X)J+=o.sizeVSBuffer(U);const j=o.alloc(10,E,J);j.writeUInt32(X.length),j.writeLongString(Y);for(const U of X)j.writeBuffer(U);return j.buffer}static deserializeReplyOKJSON(E){const W=E.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(E,W){const X=E.readUInt32(),Y=E.readLongString(),J=[];for(let j=0;j<X;++j)J.push(E.readVSBuffer());return new O.SerializableObjectWithBuffers(a(Y,J,W))}static serializeReplyErr(E,W){const X=W?f(M.transformErrorForSerialization(W),null):void 0;if(typeof X!="string")return this.h(E);const Y=P.VSBuffer.fromString(X);let J=0;J+=o.sizeLongString(Y);const j=o.alloc(11,E,J);return j.writeLongString(Y),j.buffer}static deserializeReplyErrError(E){const W=E.readLongString();return JSON.parse(W)}static h(E){return o.alloc(12,E,0).buffer}}var u;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var v;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(v||(v={}))}),define(Ae[247],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const R=A=>{globalThis.removeEventListener("message",R);const w=A.data;Object.defineProperties(globalThis,{postMessage:{value(h,O){w.postMessage(h,O)}},onmessage:{get(){return w.onmessage},set(h){w.onmessage=h}}}),w.addEventListener("message",h=>{globalThis.dispatchEvent(new MessageEvent("message",{data:h.data}))}),w.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class P extends EventTarget{constructor(M,R,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${n})('${R}'))`,h=new Blob([w],{type:"application/javascript"}),O=URL.createObjectURL(h),D=new MessageChannel,f=O,b={type:"_newWorker",id:f,port:D.port2,url:O,options:A};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:f}),URL.revokeObjectURL(O),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(g){D.port1.onmessage=g}},onmessageerror:{get(){return D.port1.onmessageerror},set(g){D.port1.onmessageerror=g}}}),D.port1.addEventListener("messageerror",g=>{const d=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(d)}),D.port1.addEventListener("message",g=>{const d=new MessageEvent("message",{data:g.data});this.dispatchEvent(d)}),D.port1.start()}}e.NestedWorker=P}),define(Ae[248],Re([1,0,5,30,31,3]),function(ee,e,n,P,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var R;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(R=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(O=>h.push(O)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}P.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(Ae[107],Re([1,0,4,3,18,24,14,248,60,27,37,123,25,9,43,5,6]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends R.AbstractMessageLogger{get disposed(){return this.l}constructor(p,i,l,r,c){super(),this.id=p,this.name=i,this.m=l,this.n=r,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.D(l.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(p,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.n.$close(this.id)}g(p,i){this.k+=f.VSBuffer.fromString(i).byteLength,(0,R.log)(this.m,p,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class m extends a{appendLine(p){this.append(p)}}let y=class{constructor(p,i,l,r,c,o){this.i=i,this.j=l,this.k=r,this.l=c,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[i,l]of this.g)l.visible=i===this.h}createOutputChannel(p,i,l){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,c=(0,b.isString)(i)?i:void 0;if((0,b.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const I=this.i.environment.extensionLogLevel?.find(([u])=>M.ExtensionIdentifier.equals(l.identifier,u))?.[1];I&&(o=(0,R.parseLogLevel)(I));const s=r?this.o(p,o,l):this.n(p,c,l);return s.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),r?this.r(p,o??this.m.getLevel(),s):this.q(p,s)}async n(p,i,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(p,c,i,l.identifier.value);return new a(I,p,o,this.a,l)}async o(p,i,l){const r=await this.p(l),c=p.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(r,`${c}.log`),I=`${l.identifier.value}.${c}`,s=this.l.createLogger(o,{id:I,name:p,logLevel:i,extensionId:l.identifier.value});return new m(I,p,s,this.a,l)}p(p){let i=this.d.get(p.identifier.value);if(!i){const l=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return i}q(p,i){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return p},append(c){r(),i.then(o=>o.append(c))},appendLine(c){r(),i.then(o=>o.appendLine(c))},clear(){r(),i.then(c=>c.clear())},replace(c){r(),i.then(o=>o.replace(c))},show(c,o){r(),i.then(I=>I.show(c,o))},hide(){r(),i.then(c=>c.hide())},dispose(){l=!0,i.then(c=>c.dispose())}}}r(p,i,l){const r=new t.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},o=r.add(new d.Emitter);function I(s){i=s,o.fire(s)}return l.then(s=>{r.add(s),s.logLevel!==i&&I(s.logLevel),r.add(s.onDidChangeLogLevel(u=>I(u)))}),{...this.q(p,l),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(s,...u){c(),l.then(v=>v.trace(s,...u))},debug(s,...u){c(),l.then(v=>v.debug(s,...u))},info(s,...u){c(),l.then(v=>v.info(s,...u))},warn(s,...u){c(),l.then(v=>v.warn(s,...u))},error(s,...u){c(),l.then(v=>v.error(s,...u))},dispose(){r.dispose()}}}};y=je([Ve(0,C.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,w.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,R.ILoggerService),Ve(5,R.ILogService)],y),e.ExtHostOutputService=y,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(Ae[249],Re([1,0,3]),function(ee,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ae[250],Re([1,0,41,15,19,20,22,2,3,180,53,196,249]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let b=class hn{constructor(d,t,a,m){this.d=d,this.e=t,this.f=a,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??d})()}hasValidBasename(d,t,a){return typeof t=="string"||typeof t>"u"?this.a.then(m=>this.h(d,m,t)):this.h(d,t,a)}h(d,t,a){return d.scheme===P.Schemas.file||d.scheme===P.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,R.basename)(d),t===1):!0}get defaultUriScheme(){return hn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,t){if(d.remoteAuthority)return P.Schemas.vscodeRemote;const a=(0,h.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const m=t.getWorkspace().folders[0];if(m)return m.uri.scheme;const y=t.getWorkspace().configuration;return y?y.scheme:P.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?C.win32:C.posix)}async fileURI(d){let t="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const m=d.indexOf("/",2);m===-1?(t=d.substring(2),d="/"):(t=d.substring(2,m),d=d.substring(m)||"/")}return A.URI.from({scheme:P.Schemas.file,authority:t,path:d,query:"",fragment:""})}};b=je([Ve(1,f.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ae[108],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(R,A){this.line=R,this.character=A}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,A){return new n(0,0)}with(R){return new n(0,0)}}e.Position=n;class P{constructor(R,A,w,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(R,A),this.end=new n(w,h)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new P(0,0,0,0)}with(R){return new P(0,0,0,0)}}e.Range=P;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ae[47],Re([1,0,16,36,23,41,13,3,19,10,108,17]),function(ee,e,n,P,C,M,R,A,w,h,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const f="\u27EA ",b=" characters skipped \u27EB",g=(f.length+b.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var d;(function(ce){ce[ce.file=0]="file",ce[ce.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(ce){ce[ce.File=1]="File",ce[ce.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(ce){return!!ce.preview}e.resultIsMatch=a;function m(ce){return!!ce.resource}e.isFileMatch=m;function y(ce){return!!ce.message}e.isProgressMessage=y;var T;(function(ce){ce[ce.Normal=0]="Normal",ce[ce.NewSearchStarted=1]="NewSearchStarted"})(T=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class i{constructor(de,Te,le){this.ranges=Te;const re=Array.isArray(Te)?Te:[Te];if(le&&le.matchLines===1&&l(re)){de=(0,R.getNLines)(de,le.matchLines);let V="",L=0,K=0;const me=Math.floor(le.charsPerLine/5),Ie=[];for(const we of re){const ve=Math.max(we.startColumn-me,0),Ce=we.startColumn+le.charsPerLine;if(ve>K+me+g){const se=f+(ve-K)+b;V+=se+de.slice(ve,Ce),L+=ve-(K+se.length)}else V+=de.slice(K,Ce);Ie.push(new c(0,we.startColumn-L,we.endColumn-L)),K=Ce}this.preview={text:V,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const V=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(Te,L=>new r(L.startLineNumber-V,L.startColumn,L.endLineNumber-V,L.endColumn))}}}}e.TextSearchMatch=i;function l(ce){const de=ce[0].startLineNumber;for(const Te of ce)if(Te.startLineNumber!==de||Te.endLineNumber!==de)return!1;return!0}class r{constructor(de,Te,le,re){this.startLineNumber=de,this.startColumn=Te,this.endLineNumber=le,this.endColumn=re}}e.SearchRange=r;class c extends r{constructor(de,Te,le){super(de,Te,de,le)}}e.OneLineRange=c;var o;(function(ce){ce.List="list",ce.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var I;(function(ce){ce.Default="default",ce.FileNames="fileNames",ce.Type="type",ce.Modified="modified",ce.CountDescending="countDescending",ce.CountAscending="countAscending"})(I=e.SearchSortOrder||(e.SearchSortOrder={}));function s(ce,de=!0){const Te=ce&&ce.files&&ce.files.exclude,le=de&&ce&&ce.search&&ce.search.exclude;if(!Te&&!le)return;if(!Te||!le)return Te||le;let re=Object.create(null);return re=C.mixin(re,C.deepClone(Te)),re=C.mixin(re,C.deepClone(le),!0),re}e.getExcludes=s;function u(ce,de){return ce.excludePattern&&P.match(ce.excludePattern,de)?!1:ce.includePattern||ce.usingSearchPaths?ce.includePattern&&P.match(ce.includePattern,de)?!0:ce.usingSearchPaths?!!ce.folderQueries&&ce.folderQueries.some(Te=>{const le=Te.folder.fsPath;if(M.isEqualOrParent(de,le)){const re=w.relative(le,de);return!Te.includePattern||!!P.match(Te.includePattern,re)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var v;(function(ce){ce[ce.unknownEncoding=1]="unknownEncoding",ce[ce.regexParseError=2]="regexParseError",ce[ce.globParseError=3]="globParseError",ce[ce.invalidLiteral=4]="invalidLiteral",ce[ce.rgProcessError=5]="rgProcessError",ce[ce.other=6]="other",ce[ce.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(de,Te){super(de),this.code=Te}}e.SearchError=S;function E(ce){const de=ce.message;if((0,h.isCancellationError)(ce))return new S(de,v.canceled);try{const Te=JSON.parse(de);return new S(Te.message,Te.code)}catch{return new S(de,v.other)}}e.deserializeSearchError=E;function W(ce){const de={message:ce.message,code:ce.code};return new Error(JSON.stringify(de))}e.serializeSearchError=W;function X(ce){return ce.type==="error"?!0:ce.type==="success"}e.isSerializedSearchComplete=X;function Y(ce){return ce.type==="success"}e.isSerializedSearchSuccess=Y;function J(ce){return!!ce.path}e.isSerializedFileMatch=J;function j(ce,de){const Te=ce.searchPath?ce.searchPath:ce.relativePath;return(0,R.fuzzyContains)(Te,de)}e.isFilePatternMatch=j;class U{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function $(ce,de){const Te={...ce||{},...de||{}};return Object.keys(Te).filter(le=>{const re=Te[le];return typeof re=="boolean"&&re})}e.resolvePatternsForProvider=$;class B{constructor(de,Te){this.c=null,this.a={...de.excludePattern||{},...Te.excludePattern||{}},this.b=P.parse(this.a);let le=de.includePattern;Te.includePattern&&(le?le={...le,...Te.includePattern}:le=Te.includePattern),le&&(this.c=P.parse(le))}matchesExcludesSync(de,Te,le){return!!(this.b&&this.b(de,Te,le))}includedInQuerySync(de,Te,le){return!(this.b&&this.b(de,Te,le)||this.c&&!this.c(de,Te,le))}includedInQuery(de,Te,le){const re=this.b(de,Te,le),V=()=>this.c?!!this.c(de,Te,le):!0;return(0,D.isThenable)(re)?re.then(L=>L?!1:V()):V()}hasSiblingExcludeClauses(){return q(this.a)}}e.QueryGlobTester=B;function q(ce){for(const de in ce)if(typeof ce[de]!="boolean")return!0;return!1}function he(ce){if(!ce)return;let de;return Te=>(de||(de=(ce()||Promise.resolve([])).then(le=>le?ie(le):{})),de.then(le=>!!le[Te]))}e.hasSiblingPromiseFn=he;function Ee(ce){if(!ce)return;let de;return Te=>{if(!de){const le=ce();de=le?ie(le):{}}return!!de[Te]}}e.hasSiblingFn=Ee;function ie(ce){const de={};for(const Te of ce)de[Te]=!0;return de}}),define(Ae[32],Re([1,0,16,17,21,5,6,48,15,115,22,13,9,2,151,3,14,168,53,37,27,18,8,7,55,47,4]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i,l,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(Y,J,j){return new O.ExtUri(U=>S(U,j)).isEqual(Y,J)}function s(Y,J,j){return I(Y.uri,J.uri,j)?0:(0,D.compare)(Y.uri.toString(),J.uri.toString())}function u(Y,J,j){return Y.index!==J.index?Y.index<J.index?-1:1:I(Y.uri,J.uri,j)?(0,D.compare)(Y.name,J.name):(0,D.compare)(Y.uri.toString(),J.uri.toString())}function v(Y,J,j,U){const $=Y.slice(0).sort((q,he)=>j(q,he,U)),B=J.slice(0).sort((q,he)=>j(q,he,U));return(0,n.delta)($,B,(q,he)=>j(q,he,U))}function S(Y,J){const j=J.getCapabilities(Y.scheme);return!(j&&j&1024)}class E extends m.Workspace{static toExtHostWorkspace(J,j,U,$){if(!J)return{workspace:null,added:[],removed:[]};const{id:B,name:q,folders:he,configuration:Ee,transient:ie,isUntitled:ce}=J,de=[],Te=j;j?he.forEach((L,K)=>{const me=b.URI.revive(L.uri),Ie=E.o(U||j,me,$);Ie?(Ie.name=L.name,Ie.index=L.index,de.push(Ie)):de.push({uri:me,name:L.name,index:K})}):de.push(...he.map(({uri:L,name:K,index:me})=>({uri:b.URI.revive(L),name:K,index:me}))),de.sort((L,K)=>L.index<K.index?-1:1);const le=new E(B,q,de,!!ie,Ee?b.URI.revive(Ee):null,!!ce,L=>S(L,$)),{added:re,removed:V}=v(Te?Te.workspaceFolders:[],le.workspaceFolders,s,$);return{workspace:le,added:re,removed:V}}static o(J,j,U){for(let $=0;$<J.folders.length;$++){const B=J.workspaceFolders[$];if(I(B.uri,j,U))return B}}constructor(J,j,U,$,B,q,he){super(J,U.map(Ee=>new m.WorkspaceFolder(Ee)),$,B,he),this.t=j,this.u=q,this.q=[],this.s=A.TernarySearchTree.forUris(he),U.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,j){return j&&this.s.get(J)&&(J=(0,O.dirname)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let W=class{constructor(J,j,U,$,B){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=$,this.s=U,this.t=B,this.j=new h.Counter,this.k=new P.Barrier,this.o=J.getProxy(o.MainContext.MainThreadWorkspace),this.q=J.getProxy(o.MainContext.MainThreadMessageService);const q=j.workspace;this.l=q?new E(q.id,q.name,[],!!q.transient,q.configuration?b.URI.revive(q.configuration):null,!!q.isUntitled,he=>S(he,U)):void 0}$initializeWorkspace(J,j){this.v=j,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:w.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,j,U,...$){const B=[];if(Array.isArray($)&&$.forEach(ce=>{b.URI.isUri(ce.uri)&&!B.some(de=>I(de.uri,ce.uri,this.s))&&B.push({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri)})}),this.n||[j,U].some(ce=>typeof ce!="number"||ce<0)||U===0&&B.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(j+U>q.length)return!1;const he=q.slice(0);he.splice(j,U,...B.map(ce=>({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<he.length;ce++){const de=he[ce];if(he.some((Te,le)=>le!==ce&&I(de.uri,Te.uri,this.s)))return!1}he.forEach((ce,de)=>ce.index=de);const{added:Ee,removed:ie}=v(q,he,u,this.s);if(Ee.length===0&&ie.length===0)return!1;if(this.o){const ce=J.displayName||J.name;this.o.$updateWorkspaceFolders(ce,j,U,B).then(void 0,de=>{this.n=void 0;const Te={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(a.Severity.Error,(0,g.localize)(0,null,ce,de.toString()),Te,[])})}return this.y(he),!0}getWorkspaceFolder(J,j){if(!!this.x)return this.x.getWorkspaceFolder(J,j)}async getWorkspaceFolder2(J,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,j)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,j){let U,$="";if(typeof J=="string"?(U=b.URI.file(J),$=J):typeof J<"u"&&(U=J,$=J.fsPath),!U)return $;const B=this.getWorkspaceFolder(U,!0);if(!B)return $;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let q=(0,O.relativePath)(B.uri,U);return j&&B.name&&(q=`${B.name}/${q}`),q}y(J){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:j,added:U,removed:$}=E.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:$}))}findFiles(J,j,U,$,B=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let q;if(j===null?q=!1:j&&(typeof j=="string"?q=j:q=j.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:Ee}=X(i.GlobPattern.from(J));return this.o.$startFileSearch((0,f.withUndefinedAsNull)(he),(0,f.withUndefinedAsNull)(Ee),(0,f.withUndefinedAsNull)(q),(0,f.withUndefinedAsNull)(U),B).then(ie=>Array.isArray(ie)?ie.map(ce=>b.URI.revive(ce)):[])}async findTextInFiles(J,j,U,$,B=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),he=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:ie}=X(i.GlobPattern.from(j.include)),ce=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,de={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:he,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:ce},Te=!1;if(this.u[q]=le=>{if(Te)return;const re=b.URI.revive(le.resource);le.results.forEach(V=>{(0,c.resultIsMatch)(V)?U({uri:re,preview:{text:V.preview.text,matches:(0,n.mapArrayOrNot)(V.preview.matches,L=>new l.Range(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))},ranges:(0,n.mapArrayOrNot)(V.ranges,L=>new l.Range(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn))}):U({uri:re,text:V.text,lineNumber:V.lineNumber})})},B.isCancellationRequested)return{};try{const le=await this.o.$startTextSearch(J,(0,f.withUndefinedAsNull)(ie),de,q,B);return delete this.u[q],le||{}}catch(le){throw delete this.u[q],le}}$handleTextSearchResult(J,j){this.u[j]?.(J)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,j){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,j);const U=this.t.transformOutgoingScheme(J),$=this.z++;return this.o.$registerEditSessionIdentityProvider($,U),(0,R.toDisposable)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(J,j){this.h.info("Getting edit session identifier for workspaceFolder",J);const U=await this.resolveWorkspaceFolder(b.URI.revive(J));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const $=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!$),!$)return;const B=await $.provideEditSessionIdentity(U,j);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(J,j,U,$){this.h.info("Getting edit session identifier for workspaceFolder",J);const B=await this.resolveWorkspaceFolder(b.URI.revive(J));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const q=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!q),!q)return;const he=await q.provideEditSessionIdentityMatch?.(j,U,$);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(J){return(j,U,$)=>{const B=function(he){j.call(U,he)};return B.extension=J,this.A.event(B,void 0,$)}}async $onWillCreateEditSessionIdentity(J,j,U){const $=await this.resolveWorkspaceFolder(b.URI.revive(J));if($===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:$},j,async(B,q)=>{const he=Date.now();await Promise.resolve(B),Date.now()-he>U&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),j.isCancellationRequested}};W=je([Ve(0,p.IExtHostRpcService),Ve(1,T.IExtHostInitDataService),Ve(2,y.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,r.IURITransformerService)],W),e.ExtHostWorkspace=W,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function X(Y){let J,j;return Y&&(typeof Y=="string"?J=Y:(J=Y.pattern,j=b.URI.revive(Y.baseUri))),{includePattern:J,folder:j}}}),define(Ae[33],Re([1,0,23,5,32,4,7,171,94,9,17,3,18,14,2]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(l,r){if(r){const c=r.split(".");let o=l;for(let I=0;o&&I<c.length;I++)o=o[c[I]];return o}}function t(l){return l instanceof g.URI}function a(l){return l&&l.uri instanceof g.URI&&l.languageId&&typeof l.languageId=="string"}function m(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function y(l){return l&&l.uri instanceof g.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function T(l){if(t(l))return{resource:l};if(a(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(m(l))return{overrideIdentifier:l.languageId};if(y(l))return{resource:l.uri};if(l===null)return{resource:null}}let p=class{constructor(r,c,o){this.a=r.getProxy(M.MainContext.MainThreadConfiguration),this.c=c,this.b=o,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,c))}};p=je([Ve(0,f.IExtHostRpcService),Ve(1,C.IExtHostWorkspace),Ve(2,b.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(r,c,o,I){this.a=new P.Emitter,this.b=r,this.f=I,this.c=c,this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,o))}getConfiguration(r,c,o){const I=T(c)||{},s=this.g(r?d(this.e.getValue(void 0,I,this.c.workspace),r):this.e.getValue(void 0,I,this.c.workspace));r&&this.h(r,I,o?.identifier);function u(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(S){return typeof d(s,S)<"u"},get:(S,E)=>{this.h(r?`${r}.${S}`:S,I,o?.identifier);let W=d(s,S);if(typeof W>"u")W=E;else{let X;const Y=(J,j)=>{let U;const $=()=>{X=X||(0,n.deepClone)(s),U=U||d(X,j)};return(0,h.isObject)(J)?new Proxy(J,{get:(B,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return $(),()=>U;if(X)return U=U||d(X,j),U[q];const he=B[q];return typeof q=="string"?Y(he,`${j}.${q}`):he},set:(B,q,he)=>($(),U&&(U[q]=he),!0),deleteProperty:(B,q)=>($(),U&&delete U[q],!0),defineProperty:(B,q,he)=>($(),U&&Object.defineProperty(U,q,he),!0)}):J};W=Y(W,S)}return W},update:(S,E,W,X)=>{S=r?`${r}.${S}`:S;const Y=u(W);return E!==void 0?this.b.$updateConfigurationOption(Y,S,E,I,X):this.b.$removeConfigurationOption(Y,S,I,X)},inspect:S=>{S=r?`${r}.${S}`:S;const E=this.e.inspect(S,I,this.c.workspace);if(E)return{key:S,defaultValue:(0,n.deepClone)(E.policy?.value??E.default?.value),globalValue:(0,n.deepClone)(E.user?.value??E.application?.value),workspaceValue:(0,n.deepClone)(E.workspace?.value),workspaceFolderValue:(0,n.deepClone)(E.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(E.default?.override),globalLanguageValue:(0,n.deepClone)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,n.deepClone)(E.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(E.workspaceFolder?.override),languageIds:(0,n.deepClone)(E.overrideIdentifiers)}}};return typeof s=="object"&&(0,n.mixin)(v,s,!1),Object.freeze(v)}g(r){const c=o=>(0,h.isObject)(o)?new Proxy(o,{get:(I,s)=>c(I[s]),set:(I,s,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(I,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(I,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return c(r)}h(r,c,o){const I=w.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),s=o?`[${o.value}] `:"";if(I===4){typeof c?.resource>"u"&&this.f.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){c?.resource&&this.f.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const o=new A.ConfigurationChangeEvent(r,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(I,s)=>o.affectsConfiguration(I,T(s))})}k(r){return r.reduce((c,o)=>(c.set(o[0],o[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[109],Re([1,0,2,17,5,4,7,32,58,33,21,61,18,27,3,15,20,14,77,207,10]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(i||(i={}));var l;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(l||(l={}));var r;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(r||(r={}));var c;(function(J){function j(B){if(B){const q=B;return q&&!!q.process}else return!1}J.is=j;function U(B){if(B==null)return;const q={process:B.process,args:B.args};return B.options&&(q.options=r.from(B.options)),q}J.from=U;function $(B){if(B!=null)return new R.ProcessExecution(B.process,B.args,B.options)}J.to=$})(c||(c={}));var o;(function(J){function j($){if($!=null)return $}J.from=j;function U($){if($!=null)return $}J.to=U})(o||(o={}));var I;(function(J){function j(B){if(B){const q=B;return q&&(!!q.commandLine||!!q.command)}else return!1}J.is=j;function U(B){if(B==null)return;const q={};return B.commandLine!==void 0?q.commandLine=B.commandLine:(q.command=B.command,q.args=B.args),B.options&&(q.options=o.from(B.options)),q}J.from=U;function $(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new R.ShellExecution(B.commandLine,B.options):new R.ShellExecution(B.command,B.args?B.args:[],B.options)}J.to=$})(I||(I={}));var s;(function(J){function j(B){if(B){const q=B;return q&&q.customExecution==="customExecution"}else return!1}J.is=j;function U(B){return{customExecution:"customExecution"}}J.from=U;function $(B,q){return q.get(B)}J.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(J){function j(U,$){let B;return U.scope!==void 0&&typeof U.scope!="number"?B=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&$&&$.workspaceFile?B=$.workspaceFile:B=y.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:B}}J.from=j})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(J){function j(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=j})(v||(v={}));var S;(function(J){function j(B,q){if(B==null)return[];const he=[];for(const Ee of B){const ie=U(Ee,q);ie&&he.push(ie)}return he}J.fromMany=j;function U(B,q){if(B==null)return;let he;B.execution instanceof R.ProcessExecution?he=c.from(B.execution):B.execution instanceof R.ShellExecution?he=I.from(B.execution):B.execution&&B.execution instanceof R.CustomExecution&&(he=s.from(B.execution));const Ee=i.from(B.definition);let ie;return B.scope?typeof B.scope=="number"?ie=B.scope:ie=B.scope.uri:ie=R.TaskScope.Workspace,!Ee||!ie?void 0:{_id:B._id,definition:Ee,name:B.name,source:{extensionId:q.identifier.value,label:B.source,scope:ie},execution:he,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:l.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}J.from=U;async function $(B,q,he){if(B==null)return;let Ee;c.is(B.execution)?Ee=c.to(B.execution):I.is(B.execution)?Ee=I.to(B.execution):s.is(B.execution)&&(Ee=s.to(B._id,he));const ie=i.to(B.definition);let ce;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ce=B.source.scope:ce=await q.resolveWorkspaceFolder(n.URI.revive(B.source.scope)):ce=R.TaskScope.Workspace),!ie||!ce)return;const de=new R.Task(ie,ce,B.name,B.source.label,Ee,B.problemMatchers);return B.isBackground!==void 0&&(de.isBackground=B.isBackground),B.group!==void 0&&(de.group=R.TaskGroup.from(B.group._id),de.group&&B.group.isDefault&&(de.group=new R.TaskGroup(de.group.id,de.group.label),B.group.isDefault===!0&&(de.group.isDefault=B.group.isDefault))),B.presentationOptions&&(de.presentationOptions=l.to(B.presentationOptions)),B._id&&(de._id=B._id),B.detail&&(de.detail=B.detail),de}J.to=$})(S=e.TaskDTO||(e.TaskDTO={}));var E;(function(J){function j($){return $}J.from=j;function U($){if(!!$)return Object.assign(Object.create(null),$)}J.to=U})(E||(E={}));class W{constructor(j,U,$){this._id=U,this.a=$,p.set(this,void 0),Je(this,p,j,"f")}get task(){return this.a}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}p=new WeakMap;let X=class{constructor(j,U,$,B,q,he,Ee,ie){this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.t=new C.Emitter,this.a=j.getProxy(M.MainContext.MainThreadTask),this.b=$,this.c=B,this.d=q,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,U,$){if(!$)return new R.Disposable(()=>{});const B=this.w();return this.j.set(B,{type:U,provider:$,extension:j}),this.a.$registerTaskProvider(B,U),new R.Disposable(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(j,U){this.a.$registerTaskSystem(j,U)}fetchTasks(j){return this.a.$fetchTasks(E.from(j)).then(async U=>{const $=[];for(const B of U){const q=await S.to(B,this.b,this.m);q&&$.push(q)}return $})}get taskExecutions(){const j=[];return this.k.forEach(U=>j.push(U)),j}terminateTask(j){if(!(j instanceof W))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,U,$){const B=this.m.get(j.id);B&&(this.o.set(j.id,B),this.e.attachPtyToTerminal(U,await B.callback($))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const U=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const U=await this.y(j.id);this.s.fire({execution:U,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const U=await this.y(j.id);this.t.fire({execution:U,exitCode:j.exitCode})}$provideTasks(j,U){const $=this.j.get(j);if(!$)return Promise.reject(new Error("no handler found"));const B=[],q=(0,P.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(he=>this.u(U,B,$,he));return new Promise(he=>{q.then(Ee=>{Promise.all(B).then(()=>{he(Ee)})})})}async $resolveTask(j,U){const $=this.j.get(j);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const B=await S.to(U,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const q=await $.provider.resolveTask(B,O.CancellationToken.None);if(!q)return;this.z(q,$);const he=S.from(q,$.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(he.execution)&&await this.x(he,q,!0),await this.v(he)}w(){return this.h++}async x(j,U,$){const B=await this.a.$createTaskId(j);!$&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,U.execution)),this.m.set(B,U.execution)}async y(j,U){if(typeof j=="string"){const q=this.l.get(j);if(!q)throw new T.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return q}const $=this.l.get(j.id);if($)return $;const B=new Promise((q,he)=>{function Ee(ie,ce,de){de?q(new W(ie,ce.id,de)):he("Unexpected: Task does not exist.")}U?Ee(this,j,U):S.to(j.task,this.b,this.m).then(ie=>Ee(this,j,ie))});return this.l.set(j.id,B),B.then(q=>(this.k.set(j.id,q),q),q=>Promise.reject(q))}z(j,U){j._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const $=this.n.values();let B=$.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=$.next()}};X=je([Ve(0,f.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],X),e.ExtHostTaskBase=X;let Y=class extends X{constructor(j,U,$,B,q,he,Ee,ie){super(j,U,$,B,q,he,Ee,ie),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(j,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=S.from(U,j);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.x($,U,!1);else throw new T.NotSupportedError;const B=await this.y(await this.a.$getTaskExecution($),U);return this.a.$executeTask($).catch(q=>{throw new Error(q)}),B}u(j,U,$,B){const q=[];if(B)for(const he of B){this.z(he,$),(!he.definition||!j[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=S.from(he,$.extension);Ee&&s.is(Ee.execution)?(q.push(Ee),U.push(this.x(Ee,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:$.extension}}async v(j){if(s.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,U,$){}};Y=je([Ve(0,f.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,m.IExtHostApiDeprecationService)],Y),e.WorkerExtHostTask=Y,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ae[251],Re([1,0,19,21,40,36,22,78,47]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class h{constructor(f,b,g){this.k=f,this.l=b,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&M.parse(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&M.parse(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const b=this.k.folderQueries||[];return new Promise((g,d)=>{const t=a=>{this.f++,f(a)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const m=a.toString(),y=n.basename(m);this.j&&this.j(m,y)||this.v(t,{base:a,basename:y})}),Promise.all(b.map(a=>this.p(a,t))).then(a=>{g({limitHit:this.e,stats:a[0]||void 0})},a=>{d(new Error((0,C.toErrorMessage)(a)))})})}async p(f,b){const g=new P.CancellationTokenSource,d=this.q(f),t=this.r(),a=new w.QueryGlobTester(this.k,f),m=!a.hasSiblingExcludeClauses();let y;try{this.h.add(g),y=A.StopWatch.create();const T=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,g.token),p=y.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(T&&T.forEach(l=>{const r=n.posix.relative(f.folder.path,l.path);if(m){const c=n.basename(l.path);this.v(b,{base:f.folder,relativePath:r,basename:c});return}this.s(t,f.folder,r,b)}),this.g&&!this.e)?null:(this.u(t,a,b),{providerTime:p,postProcessTime:i.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(f){const b=(0,w.resolvePatternsForProvider)(this.k.includePattern,f.includePattern),g=(0,w.resolvePatternsForProvider)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:g,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},b,g,d){if(g===this.a){const a=n.basename(this.a);this.v(d,{base:b,relativePath:this.a,basename:a})}function t(a){const m=n.basename(a),y=n.dirname(a);let T=f[y];T||(T=f[y]=[],t(y)),T.push({base:b,relativePath:a,basename:m})}t(g)}u({rootEntries:f,pathToEntries:b},g,d){const t=this,a=this.a;function m(y){const T=(0,w.hasSiblingFn)(()=>y.map(p=>p.basename));for(let p=0,i=y.length;p<i;p++){const l=y[p],{relativePath:r,basename:c}=l;if(g.matchesExcludesSync(r,c,a!==c?T:void 0))continue;const o=b[r];if(o)m(o);else{if(r===a)continue;t.v(d,l)}if(t.e)break}}m(f)}v(f,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(b))}}class O{constructor(){this.b=new Map}fileSearch(f,b,g,d){const t=this.c(f.cacheKey),a=new h(f,b,t&&t.token);let m=0;const y=T=>{m+=T.length,g(T.map(p=>this.d(p)))};return this.e(a,O.a,y,d).then(T=>({limitHit:T.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:T.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(!!f)return this.b.has(f)||this.b.set(f,new P.CancellationTokenSource),this.b.get(f)}d(f){return f.relativePath?{resource:R.joinPath(f.base,f.relativePath)}:{resource:f.base}}e(f,b,g,d){d.onCancellationRequested(()=>{f.cancel()});const t=m=>{m&&(a.push(m),b>0&&a.length>=b&&(g(a),a=[]))};let a=[];return f.search(t).then(m=>(a.length&&g(a),m),m=>(a.length&&g(a),Promise.reject(m)))}}O.a=512,e.FileSearchManager=O}),define(Ae[252],Re([1,0,16,63,36,88,28,15,19,22,13,9,2,268,160,42,14,53,99,250,47]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(S,E,W,X,Y){this.a=S,this.b=E,this.c=W,this.d=X,this.e=Y}text(S,E,W={}){S=this.f(S,W);const X=this.a.getValue(),Y=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(a.toWorkspaceFolder),W),type:2,contentPattern:S,previewOptions:W.previewOptions,maxFileSize:W.maxFileSize,usePCRE2:X.search.usePCRE2||Y||!1,beforeContext:W.beforeContext,afterContext:W.afterContext,userDisabledExcludesAndIgnoreFiles:W.disregardExcludeSettings&&W.disregardIgnoreFiles}}f(S,E){const W=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const X={...S,wordSeparators:W.editor.wordSeparators};return this.j(S,E)&&(X.isCaseSensitive=!0),this.k(S)&&(X.isMultiline=!0),X}file(S,E={}){return{...this.h(S,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(S,E){return S?(S=Array.isArray(S)?S.map(o):o(S),E?this.parseSearchPaths(S):{pattern:l(...Array.isArray(S)?S:[S])}):{}}h(S=[],E={}){const W=this.g(E.includePattern,E.expandPatterns),X=this.g(E.excludePattern,E.expandPatterns),Y=S.length>1,J=(W.searchPaths&&W.searchPaths.length?W.searchPaths.map($=>this.q($,E,X)):S.map($=>this.r($,E,X,Y))).filter($=>!!$),j={_reason:E._reason,folderQueries:J,usingSearchPaths:!!(W.searchPaths&&W.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:X.pattern,includePattern:W.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const $=n.coalesce(n.flatten(this.c.groups.map(he=>he.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const B=$.filter(he=>(0,T.pathIncludedInQuery)(j,he.fsPath)),q=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const U=E.extraFileResources&&E.extraFileResources.filter($=>(0,T.pathIncludedInQuery)(j,$.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(S){const E=[],W=new R.ResourceMap,X={};let Y=!1;return S.forEach(J=>{if(J.scheme===A.Schemas.walkThrough)return;if((0,h.isAbsolutePath)(J)){const U=this.b.getWorkspaceFolder(J)?.uri??J.with({path:w.dirname(J.fsPath)});let $=W.get(U);$||(Y=!0,$={folder:U,includePattern:{}},E.push($),W.set(U,$));const B=w.relative(U.fsPath,J.fsPath);(0,D.assertIsDefined)($.includePattern)[B.replace(/\\/g,"/")]=!0}else J.fsPath&&(Y=!0,X[J.fsPath]=!0)}),{folderQueries:E,includePattern:X,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}j(S,E){if(E.isSmartCase){if(S.isRegExp){if(O.containsUppercaseCharacter(S.pattern,!0))return!0}else if(O.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const E=q=>w.isAbsolute(q)||/^\.\.?([\/\\]|$)/.test(q),X=(Array.isArray(S)?S:r(S)).map(q=>{const he=this.e.resolvedUserHome;return he?(0,M.untildify)(q,he.scheme===A.Schemas.file?he.fsPath:he.path):q}),Y=P.groupBy(X,q=>E(q)?"searchPaths":"exprSegments"),J=(Y.exprSegments||[]).map(q=>O.rtrim(q,"/")).map(q=>O.rtrim(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),c(q))),j={},U=this.m(Y.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const $=n.flatten(J),B=l(...$);return B&&(j.pattern=B),j}l(S,E){return E.disregardExcludeSettings?void 0:(0,T.getExcludes)(S,!E.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const E=S.flatMap(X=>{let{pathPortion:Y,globPortion:J}=i(X);return J&&(J=I(J)),this.n(Y).flatMap(U=>this.o(U,J))}),W=new Map;return E.forEach(X=>{const Y=X.searchPath.toString(),J=W.get(Y);J?X.pattern&&(J.pattern=J.pattern||{},J.pattern[X.pattern]=!0):W.set(Y,{searchPath:X.searchPath,pattern:X.pattern?l(X.pattern):void 0})}),Array.from(W.values())}n(S){if(w.isAbsolute(S)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:S})}]:[{searchPath:f.URI.file(w.normalize(S))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(S=o(S),S.startsWith("../")||S===".."){const X=w.posix.resolve(E.path,S);return[{searchPath:E.with({path:X})}]}const W=I(S);return[{searchPath:E,pattern:W}]}else{if(S==="./"||S===".\\")return[];{const E=S.replace(/^\.[\/\\]/,""),X=this.b.getWorkspace().folders.map(Y=>{const J=E.match(new RegExp(`^${O.escapeRegExpCharacters(Y.name)}(?:/(.*)|$)`));return J?{match:J,folder:Y}:null}).filter(D.isDefined);if(X.length)return X.map(Y=>{const J=Y.match[1];return{searchPath:Y.folder.uri,pattern:J&&I(J)}});{const Y=S.match(/\.[\/\\](.+)[\/\\]?/),J=Y?Y[1]:S,j=g.localize(0,null,J);throw new Error(j)}}}}o(S,E){const W=S.pattern&&E?`${S.pattern}/${E}`:S.pattern||E,X=[{searchPath:S.searchPath,pattern:W}];return W&&!W.endsWith("**")&&X.push({searchPath:S.searchPath,pattern:W+"/**"}),X}q(S,E,W){const X=this.r((0,a.toWorkspaceFolder)(S.searchPath),E,W,!1);return X?{...X,includePattern:S.pattern}:null}r(S,E,W,X){let Y;const J=f.URI.isUri(S)?S:S.uri;if(W.searchPaths){const q=W.searchPaths.filter(he=>(0,h.isEqual)(he.searchPath,J))[0];if(q&&!q.pattern)return null;q&&(Y=q.pattern)}const j=this.a.getValue({resource:J}),$={...this.l(j,E)||{},...Y||{}},B=f.URI.isUri(S)?(0,h.basename)(S):S.name;return{folder:J,folderName:X?B:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};p=je([Ve(0,d.IConfigurationService),Ve(1,a.IWorkspaceContextService),Ve(2,m.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,y.IPathService)],p),e.QueryBuilder=p;function i(v){const S=v.match(/[\*\{\}\(\)\[\]\?]/);if(S){const E=S.index,W=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(W){let X=v.substr(0,W.index);return X.match(/[/\\]/)||(X+="/"),{pathPortion:X,globPortion:v.substr((W.index||0)+1)}}}return{pathPortion:v}}function l(...v){return v.length?v.reduce((S,E)=>(S[E]=!0,S),Object.create(null)):void 0}function r(v){return C.splitGlobAware(v,",").map(S=>S.trim()).filter(S=>!!S.length)}function c(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function I(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(v){return v.replace(/([?*[\]])/g,"[$1]")}function u(v,S){v=n.distinct(v,X=>X.toString());const E=[],W=S.getWorkspace();return v&&v.forEach(X=>{let Y;if(S.getWorkbenchState()===2)Y=(0,h.relativePath)(W.folders[0].uri,X),Y&&Y!=="."&&(Y="./"+Y);else{const J=S.getWorkspaceFolder(X);if(J){const j=J.name;if(W.folders.filter($=>$.name===j).length===1){const $=(0,h.relativePath)(J.uri,X);$===""?Y=`./${J.name}`:Y=`./${J.name}/${$}`}else Y=X.fsPath}}Y&&E.push(s(Y))}),E}e.resolveResourcesForSearchIncludes=u}),define(Ae[253],Re([1,0,22,2,21,10,3,252,47,53]),function(ee,e,n,P,C,M,R,A,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function D(d,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const m=[],y=[];for(const c of a)if(/^workspaceContains:/.test(c)){const o=c.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||d.forceUsingSearch?y.push(o):m.push(o)}if(m.length===0&&y.length===0)return Promise.resolve(void 0);let T;const p=new Promise((c,o)=>{T=c}),i=c=>T({activationEvent:c}),l=Promise.all(m.map(c=>f(d,c,i))).then(()=>{}),r=b(d,t.identifier,y,i);return Promise.all([l,r]).then(()=>{T(void 0)}),p}e.checkActivateWorkspaceContainsExtension=D;async function f(d,t,a){for(const m of d.folders)if(await d.exists(n.joinPath(P.URI.revive(m),t))){a(`workspaceContains:${t}`);return}}async function b(d,t,a,m){if(a.length===0)return Promise.resolve(void 0);const y=new C.CancellationTokenSource,T=d.checkExists(d.folders,a,y.token),p=setTimeout(async()=>{y.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},O);let i=!1;try{i=await T}catch(l){M.isCancellationError(l)||M.onUnexpectedError(l)}y.dispose(),clearTimeout(p),i&&m(`workspaceContains:${a.join(",")}`)}function g(d,t,a,m){const y=d.get(R.IInstantiationService),T=d.get(w.ISearchService),i=y.createInstance(A.QueryBuilder).file(t.map(l=>(0,h.toWorkspaceFolder)(P.URI.revive(l))),{_reason:"checkExists",includePattern:a,exists:!0});return T.fileSearch(i,m).then(l=>!!l.limitHit,l=>M.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=g});var Je=this&&this.__classPrivateFieldSet||function(ee,e,n,P,C){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?C.call(ee,n):C?C.value=n:e.set(ee,n),n},Ne=this&&this.__classPrivateFieldGet||function(ee,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(ee):P?P.value:e.get(ee)};define(Ae[34],Re([1,0,144,19,83,22,17,6,48,2,14,4,33,197,81,32,26,100,10,24,25,182,7,95,3,27,82,18,69,71,61,5,253,80,184,15,79,78,20]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i,l,r,c,o,I,s,u,v,S,E,W,X,Y,J,j,U){"use strict";var $,B,q;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let he=class fn extends A.Disposable{constructor(V,L,K,me,Ie,we,ve,Ce,se,ae,Z){super(),this.a=this.D(new S.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=L,this.g=K,this.f=ve,this.j=me,this.k=Ie,this.l=we,this.m=se,this.p=ae,this.q=Z,this.s=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.t=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.u=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.v=new R.Barrier,this.w=new R.Barrier,this.y=new R.Barrier,this.z=new R.Barrier,this.C=new le(this.f.activationEvents),this.G=new a.ExtensionDescriptionRegistry(this.C,this.f.allExtensions);const k=new y.ExtensionIdentifierSet(this.f.myExtensions);this.F=new a.ExtensionDescriptionRegistry(this.C,de(this.G,k)),this.H=new g.ExtHostStorage(this.g,this.l),this.I=new W.ExtHostSecretState(this.g),this.J=Ce,this.h=V.createChild(new s.ServiceCollection([g.IExtHostStorage,this.H],[W.IExtHostSecretState,this.I])),this.L=this.D(new b.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(F,H,x)=>{this.u.$onExtensionActivationError(F,m.transformErrorForSerialization(H),x)},actualActivateExtension:async(F,H)=>{if(a.ExtensionDescriptionRegistry.isHostExtension(F,this.F,this.G))return await this.u.$activateExtension(F,H),new b.HostExtension;const x=this.F.getExtensionDescription(F);return this.Z(x,H)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.v.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.w.open(),this.f.autoStart&&this.nb()}catch(V){m.onUnexpectedError(V)}}async R(){this.J.onWillDeactivateAll();let V=[];try{V=this.F.getAllExtensionDescriptions().map(Ie=>Ie.identifier).filter(Ie=>this.isActivated(Ie)).map(Ie=>this.Y(Ie))}catch{}await Promise.all(V)}terminate(V,L=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${V}`),this.l.flush(),this.p.dispose(),this.L.dispose(),m.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const K=this.R();Promise.race([(0,R.timeout)(5e3),K]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${L}`):this.l.info(`Extension host exiting with code ${L}`),this.l.flush(),this.l.dispose(),this.c.exit(L)})}isActivated(V){return this.y.isOpen()?this.L.isActivated(V):!1}async getExtension(V){const L=await this.u.$getExtension(V);let K;if(L?.browserNlsBundleUris){K={};for(const me of Object.keys(L.browserNlsBundleUris))K[me]=h.URI.revive(L.browserNlsBundleUris[me])}return L&&{...L,identifier:new y.ExtensionIdentifier(L.identifier.value),extensionLocation:h.URI.revive(L.extensionLocation),browserNlsBundleUris:K}}S(V,L){return this.L.activateByEvent(V,L)}U(V,L){return this.L.activateById(V,L)}activateByIdWithErrors(V,L){return this.U(V,L).then(()=>{const K=this.L.getActivatedExtension(V);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.y.wait().then(V=>this.F)}getExtensionExports(V){return this.y.isOpen()?this.L.getActivatedExtension(V).exports:null}async W(V){if(V.scheme!==Y.Schemas.file)return V;const L=await this.c.realpath(V.fsPath);return h.URI.file(L)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(V=>new Te(V))),this.M}async X(V){const L=w.TernarySearchTree.forUris(K=>M.extUriBiasedIgnorePathCase.ignorePathCasing(K));return await Promise.all(V.map(async K=>{if(this.qb(K)){const me=await this.W(K.extensionLocation);L.set(me,K)}})),L}Y(V){let L=Promise.resolve(void 0);if(!this.y.isOpen()||!this.L.isActivated(V))return L;const K=this.L.getActivatedExtension(V);if(!K)return L;try{typeof K.module.deactivate=="function"&&(L=Promise.resolve(K.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${V.value}':`),this.l.error(me)}try{(0,A.dispose)(K.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.l.error(me)}return L}async Z(V,L){return this.f.remote.isRemote?this.u.$onWillActivateExtension(V.identifier):await this.u.$onWillActivateExtension(V.identifier),this.bb(V,L).then(K=>{const me=K.activationTimes;return this.u.$onDidActivateExtension(V.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,L),this.ab(V,L,"success",me),K},K=>{throw this.ab(V,L,"failure"),K})}ab(V,L,K,me){const Ie=ie(V,L);this.t.$publicLog2("extensionActivationTimes",{...Ie,...me||{},outcome:K})}bb(V,L){const K=ie(V,L);this.t.$publicLog2("activatePlugin",K);const me=this.qb(V);if(!me)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${L.startup}, activationEvent: '${L.activationEvent}'${V.identifier.value!==L.extensionId.value?`, root cause: ${L.extensionId.value}`:""}`),this.l.flush();const Ie=new b.ExtensionActivationTimesBuilder(L.startup);return Promise.all([this.rb(V,(0,M.joinPath)(V.extensionLocation,me),Ie),this.cb(V)]).then(we=>(C.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),fn.db(this.l,V.identifier,we[0],we[1],Ie))).then(we=>(C.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),we))}cb(V){const L=new p.ExtensionGlobalMemento(V,this.H),K=new p.ExtensionMemento(V.identifier.value,!1,this.H),me=new X.ExtensionSecrets(V,this.I),Ie=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([L.whenReady,K.whenReady,this.J.whenReady]).then(()=>{const ve=this;let Ce,se;const ae=(0,t.isProposedApiEnabled)(V,"ipc")?this.f.messagePorts?.get(y.ExtensionIdentifier.toKey(V.identifier)):void 0;return Object.freeze({globalState:L,workspaceState:K,secrets:me,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Z){return P.join(V.extensionLocation.fsPath,Z)},get storagePath(){return ve.J.workspaceValue(V)?.fsPath},get globalStoragePath(){return ve.J.globalValue(V).fsPath},get logPath(){return P.join(ve.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return h.URI.joinPath(ve.f.logsLocation,V.identifier.value)},get storageUri(){return ve.J.workspaceValue(V)},get globalStorageUri(){return ve.J.globalValue(V)},get extensionMode(){return Ie},get extension(){return Ce===void 0&&(Ce=new ce(ve,V.identifier,V,we,!1)),Ce},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(V,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!se){if(!ae)return;const Z=S.Event.buffer(S.Event.fromDOMEventEmitter(ae,"message",k=>k.data));ae.start(),se={onDidReceiveMessage:Z,postMessage:ae.postMessage.bind(ae)}}return se}})})}static db(V,L,K,me,Ie){return K=K||{activate:void 0,deactivate:void 0},this.eb(V,L,K,me,Ie).then(we=>new b.ActivatedExtension(!1,null,Ie.build(),K,we,me.subscriptions))}static eb(V,L,K,me,Ie){if(typeof K.activate=="function")try{Ie.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${L.value}`);const we=typeof global=="object"?global:self,ve=K.activate.apply(we,[me]);return Ie.activateCallStop(),Ie.activateResolveStart(),Promise.resolve(ve).then(Ce=>(Ie.activateResolveStop(),Ce))}catch(we){return Promise.reject(we)}else return Promise.resolve(K)}fb(V,L){this.U(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:L}).then(void 0,K=>{this.l.error(K)})}gb(V,L=0){const me=Date.now();(0,U.setTimeout0)(()=>{for(let Ie=L;Ie<V.length;Ie+=1){const we=V[Ie];for(const ve of we.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-me>50){this.gb(V,Ie);break}else this.fb(we,ve)}})}hb(){this.u.$setPerformanceMarks(C.getMarks()),this.k.getConfigProvider().then(V=>{const L=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.F.getAllExtensionDescriptions();if(L)this.gb(K);else for(const me of K)if(me.activationEvents)for(const Ie of me.activationEvents)Ie==="onStartupFinished"&&this.fb(me,Ie)})}ib(){const V=this.S("*",!0).then(void 0,we=>{this.l.error(we)});this.D(this.j.onDidChangeWorkspace(we=>this.jb(we.added)));const L=this.j.workspace?this.j.workspace.folders:[],K=this.jb(L),me=this.lb(),Ie=Promise.all([me,V,K]).then(()=>{});return Promise.race([Ie,(0,R.timeout)(1e4)]).then(()=>{this.hb()}),Ie}jb(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(L=>this.kb(V,L))).then(()=>{})}async kb(V,L){if(this.isActivated(L.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:V.map(we=>we.uri),forceUsingSearch:K,exists:we=>this.c.exists(we.fsPath),checkExists:(we,ve,Ce)=>this.s.$checkExists(we,ve,Ce)},Ie=await(0,E.checkActivateWorkspaceContainsExtension)(me,L);if(!!Ie)return this.U(L.identifier,{startup:!0,extensionId:L.identifier,activationEvent:Ie.activationEvent}).then(void 0,we=>this.l.error(we))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.z.wait();try{return await this.mb()}catch(V){throw console.error(V),V}}async mb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:L}=this.f.environment;if(!V||!L)throw new Error(n.localize(0,null));const K=await this.rb(null,L,new b.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(n.localize(1,null,L.toString()));return new Promise((me,Ie)=>{const we=(se,ae)=>{se?Ie(se):me(typeof ae=="number"&&ae>0?1:0)},ve=(0,M.originalFSPath)(L),Ce=K.run(ve,we);Ce&&Ce.then&&Ce.then(()=>{me(0)}).catch(se=>{Ie(se instanceof Error&&se.stack?se.stack:String(se))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.w.wait().then(()=>this.y.open()).then(()=>this.ib()).then(()=>{this.z.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,L){return this.N[V]=L,(0,A.toDisposable)(()=>{delete this.N[V]})}async ob(V){const L=V.indexOf("+");if(L===-1)throw new Error("Not an authority that can be resolved!");const K=V.substr(0,L);return await this.v.wait(),await this.S(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.N[K]}}async $resolveAuthority(V,L){const K=j.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(V)},${L})][${K.elapsed()}ms] `,Ie=ae=>this.l.info(`${me()}${ae}`),we=(ae,Z=void 0)=>this.l.error(`${me()}${ae}`,Z);Ie("activating resolver...");const{authorityPrefix:ve,resolver:Ce}=await this.ob(V);if(!Ce)return we("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};const se=new R.IntervalTimer;try{Ie("setting tunnel factory..."),this.D(await this.m.setTunnelFactory(Ce)),se.cancelAndSet(()=>Ie("waiting..."),1e3),Ie("invoking resolve()..."),C.mark(`code/extHost/willResolveAuthority/${ve}`);const ae=await Ce.resolve(V,{resolveAttempt:L});C.mark(`code/extHost/didResolveAuthorityOK/${ve}`),se.dispose(),Ie(`returned ${ae.host}:${ae.port}`);const Z={authority:V,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},k={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Z,options:k,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(C.mark(`code/extHost/didResolveAuthorityError/${ve}`),se.dispose(),we("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(V,L){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(V)})`);const{resolver:K}=await this.ob(V);if(!K)return null;const me=h.URI.revive(L);if(typeof K.getCanonicalURI>"u")return me;const Ie=await(0,R.asPromise)(()=>K.getCanonicalURI(me));return Ie||me}$startExtensionHost(V){V.toAdd.forEach(me=>me.extensionLocation=h.URI.revive(me.extensionLocation));const{globalRegistry:L,myExtensions:K}=Ee(this.C,this.G,this.F,V);return this.G.set(L.getAllExtensionDescriptions()),this.F.set(K),this.nb()}$activateByEvent(V,L){return L===1?this.S(V,!1):this.y.wait().then(K=>this.S(V,!1))}async $activate(V,L){return await this.y.wait(),this.F.getExtensionDescription(V)?(await this.U(V,L),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(we=>we.extensionLocation=h.URI.revive(we.extensionLocation));const{globalRegistry:L,myExtensions:K}=Ee(this.C,this.G,this.F,V),me=await this.X(K);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(L.getAllExtensionDescriptions()),this.F.set(K),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const L=T.VSBuffer.alloc(V),K=Math.random()%256;for(let me=0;me<V;me++)L.writeUInt8(K,me);return L}async $updateRemoteConnectionData(V){this.Q=V,this.a.fire()}};he=je([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,I.IExtHostRpcService),Ve(3,d.IExtHostWorkspace),Ve(4,f.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,c.IExtHostInitDataService),Ve(7,o.IExtensionStoragePaths),Ve(8,u.IExtHostTunnelService),Ve(9,v.IExtHostTerminalService),Ve(10,J.IExtHostLocalizationService)],he),e.AbstractExtHostExtensionService=he;function Ee(re,V,L,K){re.addActivationEvents(K.addActivationEvents);const me=new a.ExtensionDescriptionRegistry(re,V.getAllExtensionDescriptions());me.deltaExtensions(K.toAdd,K.toRemove);const Ie=new y.ExtensionIdentifierSet(L.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of K.myToRemove)Ie.delete(ve);for(const ve of K.myToAdd)Ie.add(ve);const we=de(me,Ie);return{globalRegistry:me,myExtensions:we}}function ie(re,V){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ce{constructor(V,L,K,me,Ie){$.set(this,void 0),B.set(this,void 0),q.set(this,void 0),Je(this,$,V,"f"),Je(this,B,L,"f"),Je(this,q,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=P.normalize((0,M.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=me,this.isFromDifferentExtensionHost=Ie}get isActive(){return Ne(this,$,"f").isActivated(Ne(this,q,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,$,"f").getExtensionExports(Ne(this,q,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,$,"f").activateByIdWithErrors(Ne(this,q,"f"),{startup:!1,extensionId:Ne(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=ce,$=new WeakMap,B=new WeakMap,q=new WeakMap;function de(re,V){return re.getAllExtensionDescriptions().filter(L=>V.has(L.identifier))}class Te{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.ExtensionPaths=Te;class le{constructor(V){this.a=new y.ExtensionIdentifierMap,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)}addActivationEvents(V){for(const L of Object.keys(V))this.a.set(L,V[L])}}}),define(Ae[254],Re([1,0,83,2,4,33,26,24,18,27,3,34,51,14,13]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(p,i,l,r,c,o,I){this.c=p,this.d=i,this.e=l,this.f=r,this.g=c,this.h=o,this.i=I,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,p,this.i)),this.register(this.e.createInstance(m,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(y,i,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this.a.set(i,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(i=>p.alternativeModuleName(i))}};d=je([Ve(2,O.IInstantiationService),Ve(3,M.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,h.IExtHostInitDataService),Ve(6,b.ILogService)],d),e.RequireInterceptor=d;let t=class cn{constructor(p){if(p.environment.appRoot&&cn.a.size){const i=(0,g.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),l="[a-z0-9_.-]",r=`@${l}+\\/${l}+|${l}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const i=this.b.exec(this.c(p));if(!i)return;const[,l,r,c]=i,o=cn.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),l+o+c}c(p){return p.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=je([Ve(0,h.IExtHostInitDataService)],t);class a{constructor(p,i,l,r,c){this.c=p,this.d=i,this.e=l,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new A.ExtensionIdentifierMap}load(p,i){const l=this.d.findSubstr(i);if(l){let r=this.a.get(l.identifier);return r||(r=this.c(l,this.e,this.f),this.a.set(l.identifier,r)),r}if(!this.b){let r="";this.d.forEach((c,o)=>r+=`	${o} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this.b=this.c(R.nullExtensionDescription,this.e,this.f)}return this.b}}let m=class{constructor(p,i,l){this.d=p,this.nodeModuleName="keytar",this.a=i.getProxy(C.MainContext.MainThreadTelemetry);const{environment:r}=l,c=i.getProxy(C.MainContext.MainThreadKeytar);if(r.appRoot){let o=r.appRoot.fsPath;f.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,I)=>c.$getPassword(o,I),setPassword:(o,I,s)=>c.$setPassword(o,I,s),deletePassword:(o,I)=>c.$deletePassword(o,I),findPassword:o=>c.$findPassword(o),findCredentials(o){return c.$findCredentials(o)}}}load(p,i){const l=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const i=p.length;if(i<=7||!this.b)return;const l=i-7;if((p.charAt(l)==="/"||p.charAt(l)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};m=je([Ve(1,w.IExtHostRpcService),Ve(2,h.IExtHostInitDataService)],m);let y=class{constructor(p,i,l){this.e=p,this.f=i,this.nodeModuleName=["open","opn"],this.d=l.getProxy(C.MainContext.MainThreadTelemetry);const r=l.getProxy(C.MainContext.MainThreadWindow);this.c=(c,o)=>{const I=P.URI.parse(c);return o?this.g(c,o):I.scheme==="http"||I.scheme==="https"?r.$openUri(I,c,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this.f?r.$openUri(I,c,{}):this.g(c,o)}}load(p,i,l){const r=this.e.findSubstr(i);return r&&(this.a=r.identifier.value,this.h()),this.b=l(p),this.c}g(p,i){return this.i(),this.b(p,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};y=je([Ve(2,w.IExtHostRpcService)],y)}),define(Ae[110],Re([1,0,86,6,19,51,3,58,59,34,7,32,194,33]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class g extends f.AbstractVariableResolverService{constructor(a,m,y,T,p,i,l){function r(){if(y){const c=y.activeEditor();if(c)return c.document.uri;const o=T.tabGroups.all.find(I=>I.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof O.TextDiffTabInput||o.input instanceof O.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof O.TextTabInput||o.input instanceof O.NotebookEditorTabInput||o.input instanceof O.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:c=>{const o=i.folders.filter(I=>I.name===c);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,o)=>p.getConfiguration(void 0,c).get(o),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return C.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const c=r();if(c){const o=m.getWorkspaceFolder(c);if(o)return C.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(y){const c=y.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(y){const c=y.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(M.env))}}let d=class extends P.Disposable{constructor(a,m,y,T,p){super(),this.b=a,this.c=m,this.g=y,this.h=T,this.i=p,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.D(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.i,i,r,this.j())})}getResolver(){return this.a.value}j(){}};d=je([Ve(0,h.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,A.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Ae[111],Re([1,0,17,5,9,2,3,4,59,34,18,7,32,187,189,33,110]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,o,I,s,u){this.D=c,this.E=o,this.F=I,this.G=s,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new P.Emitter,this.n=new P.Emitter,this.o=new P.Emitter,this.u=new P.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new P.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new y(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(v=>{v.onDidChange(S=>{this.I(v)}),this.I(v)})}asDebugSourceUri(r,c){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let I=`debug:${encodeURIComponent(o.path||"")}`,s="?";return c&&(I+=`${s}session=${encodeURIComponent(c.id)}`,s="&"),I+=`${s}ref=${o.sourceReference}`,M.URI.parse(I)}else{if(o.path)return M.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const c=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const I=o.contributes.debuggers;if(I&&I.length>0)for(const s of I)(0,g.isDebuggerMainContribution)(s)&&c.push(s.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){this.T();const c=r.filter(s=>{const u=s.id;return this.w.has(u)?!1:(this.w.set(u,s),!0)});this.U(c,[],[]);const o=[],I=new Map;for(const s of c)if(s instanceof D.SourceBreakpoint){let u=I.get(s.location.uri.toString());u||(u={type:"sourceMulti",uri:s.location.uri,lines:[]},I.set(s.location.uri.toString(),u),o.push(u)),u.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof D.FunctionBreakpoint&&o.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){this.T();const c=r.filter(u=>this.w.delete(u.id));this.U([],c,[]);const o=c.filter(u=>u instanceof D.SourceBreakpoint).map(u=>u.id),I=c.filter(u=>u instanceof D.FunctionBreakpoint).map(u=>u.id),s=c.filter(u=>u instanceof D.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(o,I,s)}startDebugging(r,c,o){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,o){if(!c)return new D.Disposable(()=>{});const I=this.d++;return this.f.push({type:r,handle:I,provider:c}),this.k.$registerDebugConfigurationProvider(r,o,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,I),new D.Disposable(()=>{this.f=this.f.filter(s=>s.provider!==c),this.k.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(r,c,o){if(!o)return new D.Disposable(()=>{});if(!this.P(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:c,handle:I,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(c,I),new D.Disposable(()=>{this.h=this.h.filter(s=>s.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new D.Disposable(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:c}),new D.Disposable(()=>{this.j=this.j.filter(I=>I.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let o;const I=await this.W(r);return I&&(o={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,c)}J(r,c){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,c){const o=this,I=await this.V(c);return this.R(this.M(I.type),I).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const u=this.L(s),v=this.J(u,I);if(!v)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const S=v;return this.A.set(r,S),this.Q(I).then(E=>(E&&this.B.set(r,E),S.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const X=W,Y={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const J=await this.C.sign(X.arguments.value);Y.body={signature:J},S.sendResponse(Y)}else throw new Error("no signer")}catch(J){Y.success=!1,Y.message=J.message,S.sendResponse(Y)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(W),W=(0,g.convertToVSCPaths)(W,!0),o.k.$acceptDAMessage(r,W)}),S.onError(W=>{E&&E.onError&&E.onError(W),this.k.$acceptDAError(r,W.name,W.message,W.stack)}),S.onExit(W=>{E&&E.onExit&&E.onExit((0,C.withNullAsUndefined)(W),void 0),this.k.$acceptDAExit(r,(0,C.withNullAsUndefined)(W),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,c){c=(0,g.convertToDAPaths)(c,!1);const o=this.B.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(c),this.A.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.B.get(r);this.B.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const o=this.A.get(r);return this.A.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],o=[],I=[];if(r.added)for(const s of r.added){const u=s.id;if(u&&!this.w.has(u)){let v;if(s.type==="function")v=new D.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")v=new D.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const S=M.URI.revive(s.uri);v=new D.SourceBreakpoint(new D.Location(S,new D.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}(0,D.setBreakpointId)(v,u),this.w.set(u,v),c.push(v)}}if(r.removed)for(const s of r.removed){const u=this.w.get(s);u&&(this.w.delete(s),o.push(u))}if(r.changed){for(const s of r.changed)if(s.id){const u=this.w.get(s.id);if(u){if(u instanceof D.FunctionBreakpoint&&s.type==="function"){const v=u;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.functionName=s.functionName}else if(u instanceof D.SourceBreakpoint&&s.type==="source"){const v=u;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.location=new D.Location(M.URI.revive(s.uri),new D.Position(s.line,s.character))}I.push(u)}}}this.U(c,o,I)}$provideDebugConfigurations(r,c,o){return(0,n.asPromise)(async()=>{const I=this.O(r);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.W(c);return I.provideDebugConfigurations(s,o)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(r,c,o,I){return(0,n.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(c);return s.resolveDebugConfiguration(u,o,I)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,o,I){return(0,n.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(c);return s.resolveDebugConfigurationWithSubstitutedVariables(u,o,I)})}async $provideDebugAdapter(r,c){const o=this.N(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.V(c);return this.R(o,I).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.L(s)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const I={session:await this.V(r),event:c.event,body:c.body};this.u.fire(I)}L(r){if(r instanceof D.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof D.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const c=this.h.filter(o=>o.type===r);if(c.length>0)return c[0].factory}N(r){const c=this.h.filter(o=>o.handle===r);if(c.length>0)return c[0].factory}O(r){const c=this.f.filter(o=>o.handle===r);if(c.length>0)return c[0].provider}P(r,c){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const I of o)if(I.label&&I.type&&I.type===c)return!0}}return!1}Q(r){const o=r.configuration.type,I=this.j.filter(s=>s.type===o||s.type==="*").map(s=>(0,n.asPromise)(()=>s.factory.createDebugAdapterTracker(r)).then(u=>u,u=>null));return Promise.race([Promise.all(I).then(s=>{const u=s.filter(v=>!!v);if(u.length>0)return new T(u)}),new Promise(s=>setTimeout(()=>s(void 0),1e3))]).catch(s=>{})}async R(r,c){const o=c.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new D.DebugAdapterServer(o));if(r){const s=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.S(c,s))).then(u=>{if(u)return u})}const I=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,I))}S(r,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,c,o){(r.length>0||c.length>0||o.length>0)&&this.z.fire(Object.freeze({added:r,removed:c,changed:o}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const o=await this.W(r.folderUri),I=r.parent?this.l.get(r.parent):void 0;c=new m(this.k,r.id,r.type,r.name,o,r.configuration,I),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=M.URI.revive(r);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};a=je([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class m{constructor(r,c,o,I,s,u,v){this.d=r,this.f=c,this.g=o,this.h=I,this.i=s,this.j=u,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=m;class y{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=y;class T{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(o=>o.onExit?o.onExit(r,c):void 0)}}class p extends b.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(r,c,o,I,s,u){super(r,c,o,I,s,u)}};i=je([Ve(0,O.IExtHostRpcService),Ve(1,f.IExtHostWorkspace),Ve(2,h.IExtHostExtensionService),Ve(3,d.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ae[255],Re([1,0,10,83,2,4,246,14,68,69,27,165,18,55,34,57]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(y){const T=y.get(A.ILogService),i=y.get(f.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(l=>{T.error(l);const r=n.transformErrorForSerialization(l);i.$onUnexpectedError(r)})}static async installFullHandler(y){const T=y.get(A.ILogService),p=y.get(f.IExtHostRpcService),i=y.get(g.IExtHostExtensionService),l=y.get(d.IExtHostTelemetry),r=p.getProxy(M.MainContext.MainThreadExtensionService),c=p.getProxy(M.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),I=new WeakMap;function s(v,S){let E="",W,X;for(const Y of S)E+=`
	at ${Y.toString()}`,X=Y.getFileName(),!W&&X&&(W=o.findSubstr(C.URI.file(X)));return I.set(v,W?.identifier),`${v.name||"Error"}: ${v.message||""}${E}`}let u=s;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(v){u=function(S,E){return s(S,E),v.call(Error,S,E)}}}),n.setUnexpectedErrorHandler(v=>{T.error(v);const S=n.transformErrorForSerialization(v),E=I.get(v);if(!E){c.$onUnexpectedError(S);return}r.$onExtensionRuntimeError(E,S);const W=l.onExtensionError(E,v);T.trace("forwarded error to extension?",W,E)})}}Error.stackTraceLimit=100;class a{constructor(y,T,p,i,l){this.a=p,this.b=new R.RPCProtocol(y,null,i),T=a.e(T,this.b);const r=new h.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...T,messagePorts:l}),r.set(f.IExtHostRpcService,new f.ExtHostRpcService(this.b)),r.set(b.IURITransformerService,new b.URITransformerService(i)),r.set(g.IHostUtils,p);const c=new D.InstantiationService(r,!0);c.invokeFunction(t.installEarlyHandler),this.d=c.invokeFunction(o=>o.get(A.ILogService)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",T),this.c=c.invokeFunction(o=>o.get(g.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(t.installFullHandler)}async asBrowserUri(y){const T=this.b.getProxy(M.MainContext.MainThreadExtensionService);return C.URI.revive(await T.$asBrowserUri(y))}terminate(y){this.c.terminate(y)}static e(y,T){y.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(T.transformIncomingURIs(i.extensionLocation));const l={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(r=>l[r]=C.URI.revive(T.transformIncomingURIs(i.browserNlsBundleUris[r]))),i.browserNlsBundleUris=l)}),y.environment.appRoot=C.URI.revive(T.transformIncomingURIs(y.environment.appRoot));const p=y.environment.extensionDevelopmentLocationURI;return p&&(y.environment.extensionDevelopmentLocationURI=p.map(i=>C.URI.revive(T.transformIncomingURIs(i)))),y.environment.extensionTestsLocationURI=C.URI.revive(T.transformIncomingURIs(y.environment.extensionTestsLocationURI)),y.environment.globalStorageHome=C.URI.revive(T.transformIncomingURIs(y.environment.globalStorageHome)),y.environment.workspaceStorageHome=C.URI.revive(T.transformIncomingURIs(y.environment.workspaceStorageHome)),y.environment.extensionTelemetryLogResource=C.URI.revive(T.transformIncomingURIs(y.environment.extensionTelemetryLogResource)),y.nlsBaseUrl=C.URI.revive(T.transformIncomingURIs(y.nlsBaseUrl)),y.logsLocation=C.URI.revive(T.transformIncomingURIs(y.logsLocation)),y.workspace=T.transformIncomingURIs(y.workspace),y}}e.ExtensionHostMain=a}),define(Ae[256],Re([1,0,16,17,21,40,15,19,22,2,47]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(m,y,T,p){this.d=m,this.e=y,this.f=T,this.g=p,this.a=null,this.b=!1,this.c=0}search(m,y){const T=this.d.folderQueries||[],p=new C.CancellationTokenSource;return y.onCancellationRequested(()=>p.cancel()),new Promise((i,l)=>{this.a=new b(m);let r=!1;const c=(o,I)=>{if(!r&&!this.b){const s=this.h(o);d(o)&&typeof this.d.maxResults=="number"&&this.c+s>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),o=this.j(o,this.d.maxResults-this.c));const u=this.h(o);this.c+=u,(u>0||!d(o))&&this.a.add(o,I)}};Promise.all(T.map((o,I)=>this.k(o,s=>c(s,I),p.token))).then(o=>{p.dispose(),this.a.flush();const I=o.some(s=>!!s&&!!s.limitHit);i({limitHit:this.b||I,messages:(0,n.flatten)(o.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.g}})},o=>{p.dispose();const I=(0,M.toErrorMessage)(o);l(new Error(I))})})}h(m){return d(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,y){const T=Array.isArray(m.ranges)?m.ranges:[m.ranges],p=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:T.slice(0,y),preview:{matches:p.slice(0,y),text:m.preview.text},uri:m.uri}}async k(m,y,T){const p=new O.QueryGlobTester(this.d,m),i=[],l={report:o=>{if(!this.l(o))return;const I=m.folder.scheme===R.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(w.dirname(o.uri))):void 0,s=w.relativePath(m.folder,o.uri);if(s){const u=p.includedInQuery(s,A.basename(s),I);(0,P.isThenable)(u)?i.push(u.then(v=>{v&&y(o)})):u&&y(o)}}},r=this.n(m),c=await this.e.provideTextSearchResults(f(this.d.contentPattern),r,l,T);return i.length&&await Promise.all(i),c}l(m){if(d(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const y=(0,O.resolvePatternsForProvider)(this.d.includePattern,m.includePattern),T=(0,O.resolvePatternsForProvider)(this.d.excludePattern,m.excludePattern),p={folder:h.URI.from(m.folder),excludes:T,includes:y,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.f.toCanonicalName(m.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=D;function f(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class b{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new t(512,y=>this.g(y))}add(m,y){this.d&&(this.b!==y||!w.isEqual(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=y,this.d={resource:m.uri,results:[]}),this.d.results.push(g(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.TextSearchResultsCollector=b;function g(a){return d(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}e.extensionResultIsMatch=d;class t{constructor(m,y){this.g=m,this.h=y,this.c=0,this.d=[],this.e=0}addItem(m,y){!m||this.j(m,y)}addItems(m,y){!m||this.k(m,y)}j(m,y){this.d.push(m),this.e+=y,this.l()}k(m,y){this.d=this.d.concat(m),this.e+=y,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}t.a=4e3,t.b=50,e.BatchedCollector=t}),define(Ae[112],Re([1,0,6,4,3,251,18,55,14,2,256]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let D=class{constructor(d,t,a){this.k=d,this.l=t,this.n=a,this.c=this.k.getProxy(P.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const a=this.d++;return this.e.set(a,t),this.c.$registerTextSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.g.delete(d),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const a=this.d++;return this.h.set(a,t),this.c.$registerFileSearchProvider(a,this.o(d)),(0,n.toDisposable)(()=>{this.i.delete(d),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(d,t,a,m){const y=f(a),T=this.h.get(d);if(T)return this.j.fileSearch(y,T,p=>{this.c.$handleFileMatch(d,t,p.map(i=>i.resource))},m);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,a,m){const y=this.e.get(d);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const T=f(a);return this.q(T,y).search(i=>this.c.$handleTextMatch(d,t,i),m)}$enableExtensionHostSearch(){}q(d,t){return new O.TextSearchManager(d,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};D=je([Ve(0,R.IExtHostRpcService),Ve(1,A.IURITransformerService),Ve(2,w.ILogService)],D),e.ExtHostSearch=D;function f(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>h.URI.revive(d))}}e.reviveQuery=f;function b(g){return{...g,folder:h.URI.revive(g.folder)}}}),define(Ae[257],Re([1,0,68,107,32,105,33,38,58,61,109,111,112,81,71,77,106,60,37,80,57,59,227,14,110,79]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i,l,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(l.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,n.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch,0),(0,n.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(h.IExtHostTerminalService,h.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,0),(0,n.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState,0),(0,n.registerSingleton)(T.IExtHostTelemetry,T.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ae[258],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(C){if(C&&this.a.has(C)){const M=this.a.get(C);return this.a.delete(C),M}}addDragOperationTransfer(C,M){this.a.set(C,M)}getRenderedTreeElement(C){if(this.b.has(C))return this.b.get(C)}addRenderedTreeItemElement(C,M){this.b.set(C,M)}removeRenderedTreeItemElement(C){this.b.has(C)&&this.b.delete(C)}}e.TreeviewsService=n}),define(Ae[259],Re([1,0,150,7,22,2,5,6,186,17,7,9,16,8,21,258,26]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(T,p){if((0,D.isString)(T))return{label:T};if(T&&typeof T=="object"&&typeof T.label=="string"){let i;return Array.isArray(T.highlights)&&(i=T.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),i=i.length?i:void 0),{label:T.label,highlights:i}}}class m{constructor(p,i,l){this.d=p,this.e=i,this.f=l,this.a=new Map,this.b=new d.TreeviewsService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(o=>r(o)?this.i(o):o):c})}registerTreeDataProvider(p,i,l){const r=this.createTreeView(p,{treeDataProvider:i},l);return{dispose:()=>r.dispose()}}createTreeView(p,i,l){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],o=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,s=this.h(p,i,l),u=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:o,hasHandleDrop:I});return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(l,"treeItemCheckbox"),s.onDidChangeCheckboxState},get message(){return s.message},set message(v){s.message=v},get title(){return s.title},set title(v){s.title=v},get description(){return s.description},set description(v){s.description=v},get badge(){return s.badge},set badge(v){v!==void 0&&O.ViewBadge.isViewBadge(v)?s.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(s.badge=void 0)},reveal:(v,S)=>s.reveal(v,S),dispose:async()=>{await u,this.a.delete(p),s.dispose()}}}$getChildren(p,i){const l=this.a.get(p);return l?l.getChildren(i):Promise.reject(new w.NoTreeViewError(p))}async $handleDrop(p,i,l,r,c,o,I,s){const u=this.a.get(p);if(!u)return Promise.reject(new w.NoTreeViewError(p));const v=b.DataTransfer.toDataTransfer(l,async S=>(await this.d.$resolveDropFileData(p,i,S)).buffer);return I===p&&s&&await this.g(v,u,s,c,o),u.onDrop(v,r,c)}async g(p,i,l,r,c){const o=this.b.removeDragOperationTransfer(c);if(o)(await o)?.forEach((I,s)=>{I&&p.set(s,I)});else if(c&&i.handleDrag){const I=i.handleDrag(l,p,r);this.b.addDragOperationTransfer(c,I),await I}return p}async $handleDrag(p,i,l,r){const c=this.a.get(p);if(!c)return Promise.reject(new w.NoTreeViewError(p));const o=await this.g(new P.DataTransfer,c,i,r,l);if(!!o)return b.DataTransfer.toDataTransferDTO(o)}async $hasResolve(p){const i=this.a.get(p);if(!i)throw new w.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,l){const r=this.a.get(p);if(!r)throw new w.NoTreeViewError(p);return r.resolveTreeItem(i,l)}$setExpanded(p,i,l){const r=this.a.get(p);if(!r)throw new w.NoTreeViewError(p);r.setExpanded(i,l)}$setSelection(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setSelection(i)}$setFocus(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setFocus(i)}$setVisible(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setVisible(i)}$changeCheckboxState(p,i){const l=this.a.get(p);if(!l)throw new w.NoTreeViewError(p);l.setCheckboxState(i)}h(p,i,l){const r=new y(p,i,this.d,this.e.converter,this.f,l);return this.a.set(p,r),r}i(p){const i=this.a.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=m;class y extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,D.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,i,l,r,c,o){if(super(),this.z=p,this.C=l,this.F=r,this.G=c,this.H=o,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.q=this.D(new R.Emitter),this.onDidExpandElement=this.q.event,this.r=this.D(new R.Emitter),this.onDidCollapseElement=this.r.event,this.s=this.D(new R.Emitter),this.onDidChangeSelection=this.s.event,this.t=this.D(new R.Emitter),this.onDidChangeVisibility=this.t.event,this.u=this.D(new R.Emitter),this.onDidChangeCheckboxState=this.u.event,this.v=this.D(new R.Emitter),this.w=Promise.resolve(),this.y=Promise.resolve(),this.I="",this.J="",this.S=new g.CancellationTokenSource,o.contributes&&o.contributes.views)for(const u in o.contributes.views)for(const v of o.contributes.views[u])v.id===p&&(this.J=v.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.D(this.f.onDidChangeTreeData(u=>this.v.fire({message:!1,element:u})));let I,s;this.D(R.Event.debounce(this.v.event,(u,v)=>(u||(u={message:!1,elements:[]}),v.element!==!1&&(I||(I=new Promise(S=>s=S),this.w=this.w.then(()=>I)),Array.isArray(v.element)?u.elements.push(...v.element):u.elements.push(v.element)),v.message&&(u.message=!0),u),200,!0)(({message:u,elements:v})=>{v.length&&(this.y=this.y.then(()=>{const S=s;return I=null,this.U(v).then(()=>S())})),u&&this.C.$setMessage(this.z,this.I)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let l=this.Q(p);return l||(l=await this.R(i)),l?l.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const l=(0,D.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,D.isUndefinedOrNull)(i.focus)?!1:i.focus,c=(0,D.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.w.then(()=>this.N(p)).then(o=>this.P(p,o[o.length-1]).then(I=>this.C.$reveal(this.z,{item:I.item,parentChain:o.map(s=>s.item)},{select:l,focus:r,expand:c})),o=>this.G.error(o)):this.C.$reveal(this.z,void 0,{select:l,focus:r,expand:c})}get message(){return this.I}set message(p){this.I=p,this.v.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.C.$setTitle(this.z,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.C.$setTitle(this.z,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=b.ViewBadge.from(p),this.C.$setBadge(this.z,p))}setExpanded(p,i){const l=this.getExtensionElement(p);l&&(i?this.q.fire(Object.freeze({element:l})):this.r.fire(Object.freeze({element:l})))}setSelection(p){(0,f.equals)(this.l,p)||(this.l=p,this.s.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.t.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);i.forEach(l=>{l.treeItem.checkboxState=l.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.u.fire({items:i.map(l=>[l.extensionItem,l.newState])})}async handleDrag(p,i,l){const r=[];for(const c of p){const o=this.getExtensionElement(c);o&&r.push(o)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,l),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,i,l){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,h.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,i){if(!this.f.resolveTreeItem)return;const l=this.i.get(p);if(l){const r=this.j.get(l);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,l,i)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(p){return this.O(p).then(i=>i?this.N(i).then(l=>this.P(i,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}O(p){const i=this.j.get(p);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,h.asPromise)(()=>this.f.getParent(p))}P(p,i){const l=this.j.get(p);return l?Promise.resolve(l):(0,h.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const o=this.j.get(c);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let i;if(typeof p=="string"){const l=this.getExtensionElement(p);i=l?this.j.get(l):void 0}else i=p;return i&&i.children||void 0}return this.h}async R(p){this.nb(p);const i=new g.CancellationTokenSource(this.S.token);try{const l=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(i.token.isCancellationRequested)return;const c=await Promise.all((0,f.coalesce)(r||[]).map(async o=>{const I=await this.f.getTreeItem(o);return I&&!i.token.isCancellationRequested?this.Z(o,I,l):null}));return i.token.isCancellationRequested?void 0:(0,f.coalesce)(c)}finally{i.dispose()}}U(p){if(p.some(l=>!l))return this.S.dispose(!0),this.S=new g.CancellationTokenSource,this.pb(),this.C.$refresh(this.z);{const l=this.W(p);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(p){const i=new Set,l=p.map(c=>this.j.get(c));for(const c of l)if(c&&!i.has(c.item.handle)){let o=c;for(;o&&o.parent&&l.findIndex(I=>o&&o.parent&&I&&I.item.handle===o.parent.item.handle)===-1;){const I=this.i.get(o.parent.item.handle);o=I?this.j.get(I):void 0}o&&!o.parent&&i.add(c.item.handle)}const r=[];return i.forEach(c=>{const o=this.i.get(c);if(o){const I=this.j.get(o);I&&(!I.parent||!i.has(I.parent.item.handle))&&r.push(c)}}),r}X(p){const i={};return Promise.all(p.map(l=>this.Y(l).then(r=>{r&&(i[l]=r.item)}))).then(()=>Object.keys(i).length?this.C.$refresh(this.z,i):void 0)}Y(p){const i=this.getExtensionElement(p);if(i){const l=this.j.get(i);if(l)return this.nb(i),(0,h.asPromise)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const c=this.eb(i,r,l.parent);return this.lb(i,c,l,l.parent),l.dispose(),c}return null})}return Promise.resolve(null)}Z(p,i,l){const r=this.eb(p,i,l);if(i.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(p,r),this.mb(r,l),r}ab(p){return O.MarkdownString.isMarkdownString(p)?b.MarkdownString.from(p):p}bb(p,i){return i?{...this.F.toInternal(i,p),originalId:i.command}:void 0}cb(p){if(!p.checkboxState)return;let i,l;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,l=p.checkboxState.tooltip),{isChecked:i===O.TreeItemCheckboxState.Checked,tooltip:l}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,i,l){this.db(i);const r=new A.DisposableStore,c=this.gb(p,i,l),o=this.hb(i);return{item:{handle:c,parentHandle:l?l.item.handle:void 0,label:a(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(r,i.command),contextValue:i.contextValue,icon:o,iconDark:this.ib(i)||o,themeIcon:this.fb(i),collapsibleState:(0,D.isUndefinedOrNull)(i.collapsibleState)?O.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:i,label:l,resourceUri:r},c,o){if(i)return`${y.b}/${i}`;const I=a(l,this.H),s=c?c.item.handle:y.a;let u=I?I.label:r?(0,C.basename)(r):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const v=this.j.has(p)?this.j.get(p).item.handle:void 0,S=this.Q(c)||[];let E,W=0;do{if(E=`${s}/${W}:${u}`,o||!this.i.has(E)||v===E)break;W++}while(W<=S.length);return E}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return M.URI.isUri(p)?p:M.URI.file(p)}kb(p,i){this.i.set(i.item.handle,p),this.j.set(p,i)}lb(p,i,l,r){this.i.delete(i.item.handle),this.j.delete(p),i.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(p,i);const c=this.Q(r)||[],o=c.filter(I=>I.item.handle===l.item.handle)[0];o&&c.splice(c.indexOf(o),1,i)}mb(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const i=this.j.get(p);if(i){if(i.children)for(const l of i.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}i.children=void 0}}else this.pb()}ob(p){const i=this.j.get(p);if(i){if(i.children)for(const l of i.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.C.$disposeTree(this.z)}}y.a="0",y.b="1"}),define(Ae[260],Re([1,0,21,10,5,29,2,132,269,120,130,43,4,75,212,211,38,213,33,215,216,217,200,218,58,34,219,220,225,226,228,107,203,234,235,236,81,61,238,259,8,7,52,241,62,106,32,24,192,224,50,105,109,111,112,14,55,18,27,229,198,71,77,209,239,82,60,244,242,243,210,37,237,240,80,59,57,230,108,231,15,93,202,183,221,6,26,188,79,179,232,233,223,222]),function(ee,e,n,P,C,M,R,A,w,h,O,D,f,b,g,d,t,a,m,y,T,p,i,l,r,c,o,I,s,u,v,S,E,W,X,Y,J,j,U,$,B,q,he,Ee,ie,ce,de,Te,le,re,V,L,K,me,Ie,we,ve,Ce,se,ae,Z,k,F,H,x,te,pe,ke,ue,De,Se,$e,He,et,Xe,tt,rt,Me,it,Q,_,be,We,ze,Qe,Ye,Ge,at,Dt,Tt,It,Et,Mt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xt(ht){const gt=ht.get(se.IExtHostInitDataService),Ot=ht.get($e.IExtHostFileSystemInfo),Ut=ht.get(pe.IExtHostConsumerFileSystem),Lt=ht.get(c.IExtHostExtensionService),pt=ht.get(de.IExtHostWorkspace),Ct=ht.get(rt.IExtHostTelemetry),Pt=ht.get(m.IExtHostConfiguration),$t=ht.get(ve.IURITransformerService),Ke=ht.get(Ce.IExtHostRpcService),Wt=ht.get(J.IExtHostStorage),Pe=ht.get(te.IExtensionStoragePaths),Le=ht.get(we.ILoggerService),fe=ht.get(we.ILogService),G=ht.get(k.IExtHostTunnelService),Oe=ht.get(F.IExtHostApiDeprecationService),Be=ht.get(ce.IExtHostWindow),Ze=ht.get(Xe.IExtHostSecretState),xe=ht.get(tt.IExtHostEditorTabs);Ke.set(f.ExtHostContext.ExtHostFileSystemInfo,Ot),Ke.set(f.ExtHostContext.ExtHostLogLevelServiceShape,Le),Ke.set(f.ExtHostContext.ExtHostWorkspace,pt),Ke.set(f.ExtHostContext.ExtHostConfiguration,Pt),Ke.set(f.ExtHostContext.ExtHostExtensionService,Lt),Ke.set(f.ExtHostContext.ExtHostStorage,Wt),Ke.set(f.ExtHostContext.ExtHostTunnelService,G),Ke.set(f.ExtHostContext.ExtHostWindow,Be),Ke.set(f.ExtHostContext.ExtHostSecretState,Ze),Ke.set(f.ExtHostContext.ExtHostTelemetry,Ct),Ke.set(f.ExtHostContext.ExtHostEditorTabs,xe);const ot=Ke.set(f.ExtHostContext.ExtHostDecorations,ht.get(L.IExtHostDecorations)),ft=Ke.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(r.IExtHostDocumentsAndEditors)),mt=Ke.set(f.ExtHostContext.ExtHostCommands,ht.get(t.IExtHostCommands)),lt=Ke.set(f.ExtHostContext.ExtHostTerminalService,ht.get(j.IExtHostTerminalService)),ct=Ke.set(f.ExtHostContext.ExtHostDebugService,ht.get(me.IExtHostDebugService)),bt=Ke.set(f.ExtHostContext.ExtHostSearch,ht.get(Ie.IExtHostSearch)),kt=Ke.set(f.ExtHostContext.ExtHostTask,ht.get(K.IExtHostTask)),Ht=Ke.set(f.ExtHostContext.ExtHostOutputService,ht.get(S.IExtHostOutputService)),Nt=Ke.set(f.ExtHostContext.ExtHostLocalization,ht.get(Dt.IExtHostLocalizationService)),ai=Ke.set(f.ExtHostContext.ExtHostUrls,new Ee.ExtHostUrls(Ke)),At=Ke.set(f.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Ke,ft)),yi=Ke.set(f.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ke,ft,fe)),ci=Ke.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(fe,At,Ke.getProxy(f.MainContext.MainThreadBulkEdits))),yt=Ke.set(f.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,mt,ft,At)),ui=Ke.set(f.ExtHostContext.ExtHostNotebookDocuments,new ze.ExtHostNotebookDocuments(yt)),li=Ke.set(f.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(fe,yt)),Zt=Ke.set(f.ExtHostContext.ExtHostNotebookKernels,new Me.ExtHostNotebookKernels(Ke,gt,yt,mt,fe)),Di=Ke.set(f.ExtHostContext.ExtHostNotebookRenderers,new Q.ExtHostNotebookRenderers(Ke,yt)),wt=Ke.set(f.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,ft)),di=Ke.set(f.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ke.getProxy(f.MainContext.MainThreadTreeViews),mt,fe)),Bi=Ke.set(f.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ke.getProxy(f.MainContext.MainThreadEditorInsets),wt,gt.remote)),ei=Ke.set(f.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Ke,fe,Ot,ft)),ii=Ke.set(f.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,At,mt.converter,$t)),dt=Ke.set(f.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Ke,$t,At,mt,ei,fe,Oe,Ct)),ti=Ke.set(f.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ke,dt)),jt=Ke.set(f.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(Ke,fe,ft)),Qt=Ke.set(f.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ke,pt,mt)),hi=Ke.set(f.ExtHostContext.ExtHostSCM,new X.ExtHostSCM(Ke,mt,fe)),Ii=Ke.set(f.ExtHostContext.ExtHostQuickDiff,new Et.ExtHostQuickDiff(Ke,$t)),Ci=Ke.set(f.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ke,mt,At)),fi=Ke.set(f.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ke.getProxy(f.MainContext.MainThreadProgress))),ki=Ke.set(f.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(Ke)),mi=Ke.set(f.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ke)),gi=Ke.set(f.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Ke)),Ti=Ke.set(f.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Ke,mt)),ni=Ke.set(f.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ke,gt.remote,pt,fe,Oe)),ri=Ke.set(f.ExtHostContext.ExtHostWebviewPanels,new De.ExtHostWebviewPanels(Ke,ni,pt)),Pi=Ke.set(f.ExtHostContext.ExtHostCustomEditors,new ue.ExtHostCustomEditors(Ke,At,Pe,ni,ri)),zi=Ke.set(f.ExtHostContext.ExtHostWebviewViews,new ke.ExtHostWebviewViews(Ke,ni)),Yt=Ke.set(f.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ke,mt,ft)),Ai=Ke.set(f.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Wi=Ke.set(f.ExtHostContext.ExtHostProfileContentHandlers,new It.ExtHostProfileContentHandlers(Ke));Ke.set(f.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(Ke,yt,ft,mt,fe));const Hi=Ke.set(f.ExtHostContext.ExtHostInteractiveEditor,new zt.ExtHostInteractiveEditor(Ke,At,fe)),Ni=Ke.set(f.ExtHostContext.ExtHostInteractiveSession,new Mt.ExtHostInteractiveSession(Ke,fe)),Vi=Object.values(f.ExtHostContext);Ke.assertRegistered(Vi);const ji=new Se.ExtHostBulkEdits(Ke,ft),qi=new d.ExtHostClipboard(Ke),si=new v.ExtHostMessageService(Ke,fe),pi=new T.ExtHostDialogs(Ke),Fi=new Y.ExtHostStatusBar(Ke,mt.converter);return g.ExtHostApiCommands.register(mt),function(Ue,xt,oi){const vt=function(){let oe=!Ue.isUnderDevelopment;function ge(){oe||(fe.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Fe(nt){if(Array.isArray(nt))nt.forEach(Fe);else if(typeof nt=="string")ge();else{const St=nt;typeof St.scheme>"u"&&ge(),typeof St.exclusive=="boolean"&&(0,Ge.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),xi={getSession(oe,ge,Fe){return gi.getSession(Ue,oe,ge,Fe)},async hasSession(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"authSession"),!!await gi.getSession(Ue,oe,ge,{silent:!0})},get onDidChangeSessions(){return gi.onDidChangeSessions},registerAuthenticationProvider(oe,ge,Fe,nt){return gi.registerAuthenticationProvider(oe,ge,Fe,nt)}},Ki={registerCommand(oe,ge,Fe){return mt.registerCommand(!0,oe,ge,Fe,void 0,Ue)},registerTextEditorCommand(oe,ge,Fe){return mt.registerCommand(!0,oe,(...nt)=>{const St=wt.getActiveTextEditor();if(!St){fe.warn("Cannot execute "+oe+" because there is no active text editor.");return}return St.edit(Rt=>{ge.apply(Fe,[St,Rt,...nt])}).then(Rt=>{Rt||fe.warn("Edits from command "+oe+" were not applied.")},Rt=>{fe.warn("An error occurred while running command "+oe,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(oe,ge,Fe)=>((0,Ge.checkProposedApiEnabled)(Ue,"diffCommand"),mt.registerCommand(!0,oe,async(...nt)=>{const St=ft.activeEditor(!0);if(!St){fe.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Rt=await wt.getDiffInformation(St.id);ge.apply(Fe,[Rt,...nt])},void 0,void 0,Ue)),executeCommand(oe,...ge){return mt.executeCommand(oe,...ge)},getCommands(oe=!1){return mt.getCommands(oe)}},Mi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return qi.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ge.checkProposedApiEnabled)(Ue,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(oe){return rt.ExtHostTelemetryLogger.validateSender(oe),Ct.instantiateLogger(Ue,oe)},openExternal(oe,ge){return Be.openUri(oe,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===gt.environment.appUriScheme)return ai.createAppUri(oe);try{return await Be.asExternalUri(oe,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,be.matchesScheme)(oe,_.Schemas.http)||(0,be.matchesScheme)(oe,_.Schemas.https))return oe;throw ge}},get remoteName(){return(0,V.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return fe.getLevel()},get onDidChangeLogLevel(){return fe.onDidChangeLogLevel}};gt.environment.extensionTestsLocationURI||Object.freeze(Mi);const Ri={createTestController(oe,ge,Fe){return Yt.createTestController(Ue,oe,ge,Fe)},createTestObserver(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(oe)},get onDidChangeTestResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Ge.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},vi=gt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Kt={getExtension(oe,ge){(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")||(ge=!1);const Fe=xt.mine.getExtensionDescription(oe);if(Fe)return new c.Extension(Lt,Ue.identifier,Fe,vi,!1);if(ge){const nt=xt.all.getExtensionDescription(oe);if(nt)return new c.Extension(Lt,Ue.identifier,nt,vi,!0)}},get all(){const oe=[];for(const ge of xt.mine.getAllExtensionDescriptions())oe.push(new c.Extension(Lt,Ue.identifier,ge,vi,!1));return oe},get allAcrossExtensionHosts(){(0,Ge.checkProposedApiEnabled)(Ue,"extensionsAny");const oe=new Te.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of xt.all.getAllExtensionDescriptions()){const nt=!oe.has(Fe.identifier);ge.push(new c.Extension(Lt,Ue.identifier,Fe,vi,nt))}return ge},get onDidChange(){return(0,Ge.isProposedApiEnabled)(Ue,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},bi={createDiagnosticCollection(oe){return ei.createDiagnosticCollection(Ue.identifier,oe)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:oe=>ei.getDiagnostics(oe),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(oe,ge){return ii.changeLanguage(oe.uri,ge)},match(oe,ge){const Fe=At.getDocumentData(ge.uri)?.notebook;return(0,O.score)(B.LanguageSelector.from(oe),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(oe,ge,Fe){return dt.registerCodeActionProvider(Ue,vt(oe),ge,Fe)},registerDocumentPasteEditProvider(oe,ge,Fe){return(0,Ge.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,vt(oe),ge,Fe)},registerCodeLensProvider(oe,ge){return dt.registerCodeLensProvider(Ue,vt(oe),ge)},registerDefinitionProvider(oe,ge){return dt.registerDefinitionProvider(Ue,vt(oe),ge)},registerDeclarationProvider(oe,ge){return dt.registerDeclarationProvider(Ue,vt(oe),ge)},registerImplementationProvider(oe,ge){return dt.registerImplementationProvider(Ue,vt(oe),ge)},registerTypeDefinitionProvider(oe,ge){return dt.registerTypeDefinitionProvider(Ue,vt(oe),ge)},registerHoverProvider(oe,ge){return dt.registerHoverProvider(Ue,vt(oe),ge,Ue.identifier)},registerEvaluatableExpressionProvider(oe,ge){return dt.registerEvaluatableExpressionProvider(Ue,vt(oe),ge,Ue.identifier)},registerInlineValuesProvider(oe,ge){return dt.registerInlineValuesProvider(Ue,vt(oe),ge,Ue.identifier)},registerDocumentHighlightProvider(oe,ge){return dt.registerDocumentHighlightProvider(Ue,vt(oe),ge)},registerLinkedEditingRangeProvider(oe,ge){return dt.registerLinkedEditingRangeProvider(Ue,vt(oe),ge)},registerReferenceProvider(oe,ge){return dt.registerReferenceProvider(Ue,vt(oe),ge)},registerRenameProvider(oe,ge){return dt.registerRenameProvider(Ue,vt(oe),ge)},registerDocumentSymbolProvider(oe,ge,Fe){return dt.registerDocumentSymbolProvider(Ue,vt(oe),ge,Fe)},registerWorkspaceSymbolProvider(oe){return dt.registerWorkspaceSymbolProvider(Ue,oe)},registerDocumentFormattingEditProvider(oe,ge){return dt.registerDocumentFormattingEditProvider(Ue,vt(oe),ge)},registerDocumentRangeFormattingEditProvider(oe,ge){return dt.registerDocumentRangeFormattingEditProvider(Ue,vt(oe),ge)},registerOnTypeFormattingEditProvider(oe,ge,Fe,...nt){return dt.registerOnTypeFormattingEditProvider(Ue,vt(oe),ge,[Fe].concat(nt))},registerDocumentSemanticTokensProvider(oe,ge,Fe){return dt.registerDocumentSemanticTokensProvider(Ue,vt(oe),ge,Fe)},registerDocumentRangeSemanticTokensProvider(oe,ge,Fe){return dt.registerDocumentRangeSemanticTokensProvider(Ue,vt(oe),ge,Fe)},registerSignatureHelpProvider(oe,ge,Fe,...nt){return typeof Fe=="object"?dt.registerSignatureHelpProvider(Ue,vt(oe),ge,Fe):dt.registerSignatureHelpProvider(Ue,vt(oe),ge,typeof Fe>"u"?[]:[Fe,...nt])},registerCompletionItemProvider(oe,ge,...Fe){return dt.registerCompletionItemProvider(Ue,vt(oe),ge,Fe)},registerInlineCompletionItemProvider(oe,ge){return ge.handleDidShowCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ge.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,vt(oe),ge)},registerDocumentLinkProvider(oe,ge){return dt.registerDocumentLinkProvider(Ue,vt(oe),ge)},registerColorProvider(oe,ge){return dt.registerColorProvider(Ue,vt(oe),ge)},registerFoldingRangeProvider(oe,ge){return dt.registerFoldingRangeProvider(Ue,vt(oe),ge)},registerSelectionRangeProvider(oe,ge){return dt.registerSelectionRangeProvider(Ue,oe,ge)},registerCallHierarchyProvider(oe,ge){return dt.registerCallHierarchyProvider(Ue,oe,ge)},registerTypeHierarchyProvider(oe,ge){return dt.registerTypeHierarchyProvider(Ue,oe,ge)},setLanguageConfiguration:(oe,ge)=>dt.setLanguageConfiguration(Ue,oe,ge),getTokenInformationAtPosition(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"tokenInformation"),ii.tokenAtPosition(oe,ge)},registerInlayHintsProvider(oe,ge){return dt.registerInlayHintsProvider(Ue,oe,ge)},createLanguageStatusItem(oe,ge){return ii.createLanguageStatusItem(Ue,oe,ge)},registerDocumentDropEditProvider(oe,ge){return dt.registerDocumentOnDropEditProvider(Ue,oe,ge)}},Gi={get activeTextEditor(){return wt.getActiveTextEditor()},get visibleTextEditors(){return wt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(oe,ge,Fe){const nt=await(R.URI.isUri(oe)?Promise.resolve(Bt.openTextDocument(oe)):Promise.resolve(oe));return wt.showTextDocument(nt,ge,Fe)},createTextEditorDecorationType(oe){return wt.createTextEditorDecorationType(Ue,oe)},onDidChangeActiveTextEditor(oe,ge,Fe){return wt.onDidChangeActiveTextEditor(oe,ge,Fe)},onDidChangeVisibleTextEditors(oe,ge,Fe){return wt.onDidChangeVisibleTextEditors(oe,ge,Fe)},onDidChangeTextEditorSelection(oe,ge,Fe){return wt.onDidChangeTextEditorSelection(oe,ge,Fe)},onDidChangeTextEditorOptions(oe,ge,Fe){return wt.onDidChangeTextEditorOptions(oe,ge,Fe)},onDidChangeTextEditorVisibleRanges(oe,ge,Fe){return wt.onDidChangeTextEditorVisibleRanges(oe,ge,Fe)},onDidChangeTextEditorViewColumn(oe,ge,Fe){return wt.onDidChangeTextEditorViewColumn(oe,ge,Fe)},onDidCloseTerminal(oe,ge,Fe){return lt.onDidCloseTerminal(oe,ge,Fe)},onDidOpenTerminal(oe,ge,Fe){return lt.onDidOpenTerminal(oe,ge,Fe)},onDidChangeActiveTerminal(oe,ge,Fe){return lt.onDidChangeActiveTerminal(oe,ge,Fe)},onDidChangeTerminalDimensions(oe,ge,Fe){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDimensions"),lt.onDidChangeTerminalDimensions(oe,ge,Fe)},onDidChangeTerminalState(oe,ge,Fe){return lt.onDidChangeTerminalState(oe,ge,Fe)},onDidWriteTerminalData(oe,ge,Fe){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(oe,ge,Fe)},get state(){return Be.state},onDidChangeWindowState(oe,ge,Fe){return Be.onDidChangeWindowState(oe,ge,Fe)},showInformationMessage(oe,...ge){return si.showMessage(Ue,M.default.Info,oe,ge[0],ge.slice(1))},showWarningMessage(oe,...ge){return si.showMessage(Ue,M.default.Warning,oe,ge[0],ge.slice(1))},showErrorMessage(oe,...ge){return si.showMessage(Ue,M.default.Error,oe,ge[0],ge.slice(1))},showQuickPick(oe,ge,Fe){return Qt.showQuickPick(Ue,oe,ge,Fe)},showWorkspaceFolderPick(oe){return Qt.showWorkspaceFolderPick(oe)},showInputBox(oe,ge){return Qt.showInput(oe,ge)},showOpenDialog(oe){return pi.showOpenDialog(Ue,oe)},showSaveDialog(oe){return pi.showSaveDialog(oe)},createStatusBarItem(oe,ge,Fe){let nt,St,Rt;return typeof oe=="string"?(nt=oe,St=ge,Rt=Fe):(St=oe,Rt=ge),Fi.createStatusBarEntry(Ue,nt,St,Rt)},setStatusBarMessage(oe,ge){return Fi.setStatusBarMessage(oe,ge)},withScmProgress(oe){return Oe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(ge,Fe)=>oe({report(nt){}}))},withProgress(oe,ge){return fi.withProgress(Ue,oe,ge)},createOutputChannel(oe,ge){return Ht.createOutputChannel(oe,ge,Ue)},createWebviewPanel(oe,ge,Fe,nt){return ri.createWebviewPanel(Ue,oe,ge,Fe,nt)},createWebviewTextEditorInset(oe,ge,Fe,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"editorInsets"),Bi.createWebviewEditorInset(oe,ge,Fe,nt,Ue)},createTerminal(oe,ge,Fe){return typeof oe=="object"?"pty"in oe?lt.createExtensionTerminal(oe):lt.createTerminalFromOptions(oe):lt.createTerminal(oe,ge,Fe)},registerTerminalLinkProvider(oe){return lt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,ge){return lt.registerProfileProvider(Ue,oe,ge)},registerTerminalQuickFixProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),lt.registerTerminalQuickFixProvider(oe,Ue.identifier.value,ge)},registerTreeDataProvider(oe,ge){return di.registerTreeDataProvider(oe,ge,Ue)},createTreeView(oe,ge){return di.createTreeView(oe,ge,Ue)},registerWebviewPanelSerializer:(oe,ge)=>ri.registerWebviewPanelSerializer(Ue,oe,ge),registerCustomEditorProvider:(oe,ge,Fe={})=>Pi.registerCustomEditorProvider(Ue,oe,ge,Fe),registerFileDecorationProvider(oe){return ot.registerFileDecorationProvider(oe,Ue)},registerUriHandler(oe){return ai.registerUriHandler(Ue.identifier,oe)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(oe,ge,Fe){return mi.onDidChangeActiveColorTheme(oe,ge,Fe)},registerWebviewViewProvider(oe,ge,Fe){return zi.registerWebviewViewProvider(Ue,oe,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,ge,Fe){return yt.onDidChangeActiveNotebookEditor(oe,ge,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,ge,Fe){return li.onDidChangeNotebookEditorSelection(oe,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(oe,ge,Fe){return li.onDidChangeNotebookEditorVisibleRanges(oe,ge,Fe)},showNotebookDocument(oe,ge){return yt.showNotebookDocument(oe,ge)},registerExternalUriOpener(oe,ge,Fe){return(0,Ge.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ai.registerExternalUriOpener(Ue.identifier,oe,ge,Fe)},registerProfileContentHandler(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Wi.registrProfileContentHandler(Ue,oe,ge)},registerQuickDiffProvider(oe,ge,Fe,nt){return(0,Ge.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider(vt(oe),ge,Fe,nt)},get tabGroups(){return xe.tabGroups}},Bt={get rootPath(){return Oe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(oe){throw P.readonly()},getWorkspaceFolder(oe){return pt.getWorkspaceFolder(oe)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(oe){throw P.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(oe){throw P.readonly()},updateWorkspaceFolders:(oe,ge,...Fe)=>pt.updateWorkspaceFolders(Ue,oe,ge||0,...Fe),onDidChangeWorkspaceFolders:function(oe,ge,Fe){return pt.onDidChangeWorkspace(oe,ge,Fe)},asRelativePath:(oe,ge)=>pt.getRelativePath(oe,ge),findFiles:(oe,ge,Fe,nt)=>pt.findFiles(oe,ge,Fe,Ue.identifier,nt),findTextInFiles:(oe,ge,Fe,nt)=>{(0,Ge.checkProposedApiEnabled)(Ue,"findTextInFiles");let St,Rt;return typeof ge=="object"?(St=ge,Rt=Fe):(St={},Rt=ge,nt=Fe),pt.findTextInFiles(oe,St||{},Rt,Ue.identifier,nt)},saveAll:oe=>pt.saveAll(oe),applyEdit(oe,ge){return ji.applyWorkspaceEdit(oe,Ue,ge)},createFileSystemWatcher:(oe,ge,Fe,nt)=>jt.createFileSystemWatcher(pt,Ue,oe,ge,Fe,nt),get textDocuments(){return At.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw P.readonly()},openTextDocument(oe){let ge;const Fe=oe;if(typeof oe=="string")ge=Promise.resolve(R.URI.file(oe));else if(R.URI.isUri(oe))ge=Promise.resolve(oe);else if(!Fe||typeof Fe=="object")ge=At.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(nt=>At.ensureDocumentData(nt).then(St=>St.document))},onDidOpenTextDocument:(oe,ge,Fe)=>At.onDidAddDocument(oe,ge,Fe),onDidCloseTextDocument:(oe,ge,Fe)=>At.onDidRemoveDocument(oe,ge,Fe),onDidChangeTextDocument:(oe,ge,Fe)=>At.onDidChangeDocument(oe,ge,Fe),onDidSaveTextDocument:(oe,ge,Fe)=>At.onDidSaveDocument(oe,ge,Fe),onWillSaveTextDocument:(oe,ge,Fe)=>ci.getOnWillSaveTextDocumentEvent(Ue)(oe,ge,Fe),get notebookDocuments(){return yt.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,ge){let Fe;if(R.URI.isUri(oe))Fe=oe,await yt.openNotebookDocument(oe);else if(typeof oe=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:oe,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(oe,ge,Fe){return ui.onDidSaveNotebookDocument(oe,ge,Fe)},onDidChangeNotebookDocument(oe,ge,Fe){return ui.onDidChangeNotebookDocument(oe,ge,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(oe,ge,Fe,nt){return yt.registerNotebookSerializer(Ue,oe,ge,Fe,(0,Ge.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(oe,ge,Fe)=>oi.onDidChangeConfiguration(oe,ge,Fe),getConfiguration(oe,ge){return ge=arguments.length===1?void 0:ge,oi.getConfiguration(oe,ge,Ue)},registerTextDocumentContentProvider(oe,ge){return yi.registerTextDocumentContentProvider(oe,ge)},registerTaskProvider:(oe,ge)=>(Oe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ue,oe,ge)),registerFileSystemProvider(oe,ge,Fe){return(0,Ye.combinedDisposable)(ti.registerFileSystemProvider(Ue,oe,ge,Fe),Ut.addFileSystemProvider(oe,ge))},get fs(){return Ut.value},registerFileSearchProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(oe,ge)),registerTextSearchProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(oe,ge)),registerRemoteAuthorityResolver:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(oe,ge)),registerResourceLabelFormatter:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"resolvers"),ki.$registerResourceLabelFormatter(oe)),onDidCreateFiles:(oe,ge,Fe)=>jt.onDidCreateFile(oe,ge,Fe),onDidDeleteFiles:(oe,ge,Fe)=>jt.onDidDeleteFile(oe,ge,Fe),onDidRenameFiles:(oe,ge,Fe)=>jt.onDidRenameFile(oe,ge,Fe),onWillCreateFiles:(oe,ge,Fe)=>jt.getOnWillCreateFileEvent(Ue)(oe,ge,Fe),onWillDeleteFiles:(oe,ge,Fe)=>jt.getOnWillDeleteFileEvent(Ue)(oe,ge,Fe),onWillRenameFiles:(oe,ge,Fe)=>jt.getOnWillRenameFileEvent(Ue)(oe,ge,Fe),openTunnel:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.openTunnel(Ue,oe).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.getTunnels()},onDidChangeTunnels:(oe,ge,Fe)=>((0,Ge.checkProposedApiEnabled)(Ue,"tunnels"),G.onDidChangeTunnels(oe,ge,Fe)),registerPortAttributesProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"portsAttributes"),G.registerPortsAttributesProvider(oe,ge)),registerTimelineProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"timeline"),Ti.registerTimelineProvider(oe,ge,Ue.identifier,mt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:oe=>((0,Ge.checkProposedApiEnabled)(Ue,"workspaceTrust"),pt.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,ge,Fe)=>pt.onDidGrantWorkspaceTrust(oe,ge,Fe),registerEditSessionIdentityProvider:(oe,ge)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(oe,ge)),onWillCreateEditSessionIdentity:(oe,ge,Fe)=>((0,Ge.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent(Ue)(oe,ge,Fe))},Ei={get inputBox(){return Oe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Ue)},createSourceControl(oe,ge,Fe){return hi.createSourceControl(Ue,oe,ge,Fe)}},Xi={createCommentController(oe,ge){return Ci.createCommentController(Ue,oe,ge)}},Qi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(oe,ge,Fe){return ct.onDidStartDebugSession(oe,ge,Fe)},onDidTerminateDebugSession(oe,ge,Fe){return ct.onDidTerminateDebugSession(oe,ge,Fe)},onDidChangeActiveDebugSession(oe,ge,Fe){return ct.onDidChangeActiveDebugSession(oe,ge,Fe)},onDidReceiveDebugSessionCustomEvent(oe,ge,Fe){return ct.onDidReceiveDebugSessionCustomEvent(oe,ge,Fe)},onDidChangeBreakpoints(oe,ge,Fe){return ct.onDidChangeBreakpoints(oe,ge,Fe)},registerDebugConfigurationProvider(oe,ge,Fe){return ct.registerDebugConfigurationProvider(oe,ge,Fe||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,ge){return ct.registerDebugAdapterDescriptorFactory(Ue,oe,ge)},registerDebugAdapterTrackerFactory(oe,ge){return ct.registerDebugAdapterTrackerFactory(oe,ge)},startDebugging(oe,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ct.startDebugging(oe,ge,{parentSession:Fe}):ct.startDebugging(oe,ge,Fe||{})},stopDebugging(oe){return ct.stopDebugging(oe)},addBreakpoints(oe){return ct.addBreakpoints(oe)},removeBreakpoints(oe){return ct.removeBreakpoints(oe)},asDebugSourceUri(oe,ge){return ct.asDebugSourceUri(oe,ge)}},Yi={registerTaskProvider:(oe,ge)=>kt.registerTaskProvider(Ue,oe,ge),fetchTasks:oe=>kt.fetchTasks(oe),executeTask:oe=>kt.executeTask(Ue,oe),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(oe,ge,Fe)=>kt.onDidStartTask(oe,ge,Fe),onDidEndTask:(oe,ge,Fe)=>kt.onDidEndTask(oe,ge,Fe),onDidStartTaskProcess:(oe,ge,Fe)=>kt.onDidStartTaskProcess(oe,ge,Fe),onDidEndTaskProcess:(oe,ge,Fe)=>kt.onDidEndTaskProcess(oe,ge,Fe)},_i={createNotebookController(oe,ge,Fe,nt,St){return Zt.createNotebookController(Ue,oe,ge,Fe,nt,(0,Ge.isProposedApiEnabled)(Ue,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(oe,ge)=>yt.registerNotebookCellStatusBarItemProvider(Ue,oe,ge),createRendererMessaging(oe){return Di.createRendererMessaging(Ue,oe)},createNotebookControllerDetectionTask(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,oe)},registerKernelSourceActionProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,oe,ge)},onDidChangeNotebookCellExecutionState(oe,ge,Fe){return(0,Ge.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(oe,ge,Fe)}},Ji={t(...oe){if(typeof oe[0]=="string"){const ge=oe.shift(),Fe=!oe||typeof oe[0]!="object"?oe:oe[0];return Nt.getMessage(Ue.identifier.value,{message:ge,args:Fe})}return Nt.getMessage(Ue.identifier.value,oe[0])},get bundle(){return Nt.getBundle(Ue.identifier.value)},get uri(){return Nt.getBundleUri(Ue.identifier.value)}},Zi={_version:1,registerInteractiveEditorSessionProvider(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Hi.registerProvider(Ue,oe)},registerInteractiveSessionProvider(oe,ge){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Ni.registerInteractiveSessionProvider(Ue,oe,ge)},addInteractiveRequest(oe){return(0,Ge.checkProposedApiEnabled)(Ue,"interactive"),Ni.addInteractiveSessionRequest(oe)}};return{version:gt.version,authentication:xi,commands:Ki,comments:Xi,debug:Qi,env:Mi,extensions:Kt,interactive:Zi,l10n:Ji,languages:bi,notebooks:_i,scm:Ei,tasks:Yi,tests:Ri,window:Gi,workspace:Bt,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,IndentAction:h.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TerminalQuickFixType:q.TerminalQuickFixType,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItem2:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:b.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentDropEdit:q.DocumentDropEdit,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestRunRequest2:q.TestRunRequest2,TestMessage:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,CoveredCount:q.CoveredCount,FileCoverage:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,FunctionCoverage:q.FunctionCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TelemetryTrustedValue:he.TelemetryTrustedValue,LogLevel:we.LogLevel,EditSessionIdentityMatch:Tt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Xt}),define(Ae[261],Re([1,0,260,34,2,254,7,17,245]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends M.RequireInterceptor{j(){}getModule(b,g){for(const d of this.b){const t=d(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(w.ExtHostConsoleForwarder);const b=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(h,b,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(b){return b.browser}async rb(b,g,d){g=g.with({path:D(g.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=C.URI.revive(await this.u.$asBrowserUri(g)),m=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),m.status!==200)throw new Error(m.statusText);const y=await m.text(),T=`${g.toString(!0)}#vscode-extension`,p=`${y}
//# sourceURL=${T}`;let i;try{i=new Function("module","exports","require",p)}catch(o){throw console.error(t?`Loading code for extension ${t} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${g.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}b&&await this.q.initializeLocalizedMessages(b);const l={},r={exports:l},c=o=>{const I=this.r.getModule(o,g);if(I===void 0)throw new Error(`Cannot load module '${o}'`);return I};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(r,l,c),r.exports!==l?r.exports:l}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(b){}async vb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+b;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function D(f,b){return f.endsWith(b)?f:f+b}}),define(Ae[262],Re([1,0,67,68,14,34,181,82,261]),function(ee,e,n,P,C,M,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.registerSingleton)(C.ILogService,new n.SyncDescriptor(R.ExtHostLogService,[!0],!0)),(0,P.registerSingleton)(M.IExtHostExtensionService,w.ExtHostExtensionService,0),(0,P.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,0)}),define(Ae[270],Re([1,0,25,5,75,255,247,19,83,15,2,257,262]),function(ee,e,n,P,C,M,R,A,w,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const f=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(i){return/^(file|vscode-remote):/i.test(i)}const g=fetch.bind(self);function d(i){self.fetch=async function(l,r){return l instanceof Request||b(String(l))&&(l=(await i(O.URI.parse(String(l)))).toString(!0)),g(l,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,r,c,o,I){(async()=>(b(r.toString())&&(r=(await i(O.URI.parse(r.toString()))).toString(!0)),super.open(l,r,c??!0,o,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(l,r){if(/^file:/i.test(l.toString()))l=h.FileAccess.uriToBrowserUri(O.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(v){function S(X){return typeof X=="string"||X instanceof URL?String(X).replace(/^file:\/\//i,"vscode-file://vscode-app"):X}const E=fetch.bind(self);self.fetch=function(X,Y){return X instanceof Request?E(X,Y):E(S(X),Y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(X,Y,J,j,U){return super.open(X,S(Y),J??!0,j,U)}};const W=importScripts.bind(self);self.importScripts=(...X)=>{W(...X.map(S))},W(v)}.toString()}('${l}'))`;r=r||{},r.name=r.name||A.basename(l.toString());const I=new Blob([o],{type:"application/javascript"}),s=URL.createObjectURL(I);return new i(s,r)}}else self.Worker=class extends R.NestedWorker{constructor(i,l){super(f,i,{name:A.basename(i.toString()),...l})}};const t=new class{constructor(){this.pid=void 0}exit(i){D()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const l=new MessageChannel,r=new P.Emitter;let c=!1;f(l.port2,[l.port2]),l.port1.onmessage=o=>{const{data:I}=o;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const s=n.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,C.isMessageOfType)(s,2)){c=!0,y("received terminate message from renderer");return}r.fire(s)},this.protocol={onMessage:r.event,send:o=>{if(!c){const I=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);l.port1.postMessage(I,[I])}}}}}function m(i){return new Promise(l=>{const r=i.onMessage(c=>{r.dispose();const o=JSON.parse(c.toString());i.send((0,C.createMessageOfType)(0)),l({protocol:i,initData:o})});i.send((0,C.createMessageOfType)(1))})}let y=i=>D();function T(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function p(){w.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(l){!T(l)||m(i.protocol).then(r=>{w.mark("code/extHost/didWaitForInitData");const c=new M.ExtensionHostMain(r.protocol,r.initData,t,null,l.data);d(o=>c.asBrowserUri(o)),y=o=>c.terminate(o)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/06ce7933733b1ab05e410e46a6a622dfffb31927/core/vs/workbench/api/worker/extensionHostWorker.js.map
